/*******************************************************************
*
*                       T^[pf[^k
*
*                      Copyright(c) 1994 SEGA
*
*	Comment: LCu^OXL^cvnqcP
*	File   : CMPLRUND.C
*	Date   : 1994-01-28
*   Author : Y.T
*
*******************************************************************/
#include <stdio.h>
#include <ctype.h>
#include "sega_cmp.h"
#include "cmp.h"

/*    OXL^cvnqcP        */
Sint32 CMP_DecRunlenDword(void *_inp, void **_outp, Sint32 outbufsize)
{
	Uint8	*tmp;
	Uint32	*inp, *outp;
	Sint32	orgfsize,		/* kOt@CTCY[byte]			*/
			outsize,		/* o̓f[^TCY[byte] 				*/
			boundary_offset,/* o̓f[^TCYSoCgoE_	*/
							/* ɑׂɕtoCgB		*/
			outcnt,			/* o̓f[^JE^	 				*/
			runlen,         /*  								*/
			retval;         /* ߂l								*/
	Uint16	header;			/* kt@Cwb_					*/

	inp = _inp;
	outp = *_outp;
	mload_word(Uint16, header, Uint32 *, inp);
	switch (header & CMP_ORGW_MASK) {
	case CMP_ORGW_WORD:
		mload_word(Sint32, orgfsize, Uint32 *, inp);
		break;
	case CMP_ORGW_DWORD:
		mload_word(Sint32, orgfsize, Uint32 *, inp);/*skip 2 byte*/
		mload_dword(Sint32, orgfsize, Uint32 *, inp);
		break;
	}
	boundary_offset = orgfsize & CMP_BOUNDWORD;
	orgfsize = (((orgfsize+CMP_BOUNDWORD)>>2)<<2);
	if (orgfsize > outbufsize) {
		retval = CMP_DEC_STOP;
		outsize = outbufsize;
	} else {
		retval = CMP_DEC_OK;
		outsize = orgfsize;
	}
	for (outcnt = 0; outcnt < outsize;) {
		mload_dword(Sint32, runlen, Uint32 *, inp);
		if (runlen >= 0) {/* vn */
			runlen += 2;
			if (outcnt + CMP_BYTEDWORD*runlen > outsize) {
				runlen = (outsize - outcnt)/CMP_BYTEDWORD;
			}
			memset_dword(outp, *inp++, runlen);
		} else {/* svn */
			runlen *= -1;
			if (outcnt + CMP_BYTEDWORD*runlen > outsize) {
				runlen = (outsize - outcnt)/CMP_BYTEDWORD;
			}
			memmove_byte(outp, inp, CMP_BYTEDWORD*runlen);
			inp += runlen;
		}
		outp += runlen;
		outcnt += CMP_BYTEDWORD*runlen;
	}
	tmp = (Uint8 *)outp;
	tmp -= (CMP_BYTEDWORD - boundary_offset) % CMP_BYTEDWORD;
	*_outp = (void *)tmp;
	return retval;
}
