/*-----------------------------------------------------------------------------  *  FILE: dma_cpu5.c
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      CPU DMAB
 *
 *  DESCRIPTION:
 *
 *      CPU DMA]@\B
 *
 *  INTERFACE:
 *
 *      < FUNCTIONS LIST >
 *          (5) DMA_CpuResult           -   f[^]I`FbN
 *
 *  CAVEATS:
 *
 *
 *  AUTHOR(S)
 *
 *      1994-07-05  N.T Ver.1.00
 *
 *  MOD HISTORY:
 *
 *-----------------------------------------------------------------------------
 */

/*
 * C STANDARD LIBRARY FUNCTIONS/MACROS DEFINES
 */

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include "sega_xpt.h"

#if	1
	/*
	**1995-07-26	q
	**	CSH_Purge() gĂ̂Œǉ
	*/
	#include	"sega_csh.h"
#endif

/*
 * USER SUPPLIED INCLUDE FILES
 */
#include "dma_cpu0.h"
#include "dma_cpum.h"

/*
 * GLOBAL DECLARATIONS
 */

/*
 * LOCAL DEFINES/MACROS
 */

/*
 * STATIC DECLARATIONS
 */
void *dma_cpu_dis_adr;                   /* ߰ޑΏިèȰݱڽ */
Uint32 dma_cpu_cnt;                      /* ߰ޑΏިèȰݶ  */

/*
 * STATIC FUNCTION PROTOTYPE DECLARATIONS
 */


/******************************************************************************
 *
 * NAME:    DMA_CpuResult()     -   f[^]I`FbN
 *
 * PARAMETERS :
 *      (2) void *src       <i>   \[XAhX.
 *      (3) Uint32 cnt      <i>   ](0`16777215)
 *
 * DESCRIPTION:
 *      srcAhXdstAhX16oCgf[^cnt񐔕]܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Uint32 DMA_CpuMemCopy1,2,4,16()̌.
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

Uint32 DMA_CpuResult(void)
{
    DmaCpuComStatus com_status;             /* ʃXe[^X                */
    DmaCpuStatus status;                    /* Xe[^X                    */
                                            /*********************************/
    DMA_CpuGetComStatus(&com_status);       /* ʃXe[^X擾            */
    if(com_status.ae == DMA_CPU_ADR_ERR){   /* ڽװꍇ        */
        return(DMA_CPU_FAIL);               /* ُI^[            */
    }
    status = DMA_CpuGetStatus(DMA_CPU_CH0); /* Xe[^X擾                */
    if(status == DMA_CPU_TE_MV){            /* 쒆łꍇ              */
        return(DMA_CPU_BUSY);               /* s^[              */
    }
    CSH_Purge(dma_cpu_dis_adr, dma_cpu_cnt);
    return(DMA_CPU_END);                    /* I^[            */
}

