/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library:t@CVXe
 * Module :CuC^tF[X
 * File   :gfs.c
 * Date   :1996-02-01
 * Version:2.10
 * Author :H.T.
 *
 *****************************************************************************/
/* SGL̏ꍇRpCIvVɂ`邱
 * #define USE_SGL
 */

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include    <string.h>

#include    "sega_gfs.h"
#include    "gfs_def.h"
#include    "gfs_mmf.h"
#include    "gfs_cdf.h"
#include    "gfs_cdb.h"
#include    "gfs_dir.h"
#include    "gfs_trn.h"
#include    "gfs_cdc.h"

#if !defined(USE_SGL)
    #include    <sega_int.h>
#endif
#if defined(DEBUG_LIB)
#include "gfs_sf.h"
#endif

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
/* {{[fBXNv^Ɋւ萔 */
#define PVD_FAD         166             /* FAD */
#define PVD_BYTSIZ      GFS_MD1_SCTSIZ  /* 傫ioCgPʁj*/
#define PVD_SCTSIZ      1               /* 傫iZN^Pʁj */

/* rootfBNg݂FAD̉ */
#define ROOT_FAD_LOW_LIM        (150+16)

#define ROOT_RECPOS     156             /* [gfBNg̈ʒu */

/* GFS_Fread̃^CAEg(20b)  */
#define FREAD_TMOUT_COUNT       300000L

/* G[R[h */
#define SVR_NOHNDL      (-1)            /* T[oɃnho^ */

/*****************************************************************************
 *      񋓒萔
 *****************************************************************************/

/*****************************************************************************
 *      }N
 *****************************************************************************/
/* LSN -> FADϊ */
#define LSN_TO_FAD(lsn) ((lsn) += 150)

/* fBNgR[hǂݍ         */
#define DIRREC_EXT(rec)         ((rec) + 6)
#define DIRREC_LEN(rec)         ((rec) + 14)

/*****************************************************************************
 *      f[^^̒`
 *****************************************************************************/

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/

/* [gfBNgւ̈ړ   */
GFS_LOCAL Sint32        gfs_chgRoot(GfsDirTbl *dirtbl);

/* ]֐̋]I       */
GFS_LOCAL Sint32        gfs_aborttrans(GfsHn gfs, Sint32 nsct);

/* t@C֐e[ȕ */
GFS_LOCAL void  gfs_mngSetupFuncTbl(void);

/* Ǘe[ȕ */
GFS_LOCAL void  gfs_mngInitWork(Sint32 open_max);

/* t@C̃JEg */
GFS_LOCAL Sint32        gfs_mngGetNumFile(GfsDirTbl *dirtbl);

/* I[vO[v̉ */
GFS_LOCAL void  gfs_mngFreeGrp(GfsFile *gfs);

/* t@CANZX */
GFS_LOCAL void  gfs_mngTermAccess(GfsHn gfs, Bool wait_pause);

/* G[֐̌Ăт */
GFS_LOCAL Sint32        gfs_mngSetErrCode(Sint32 code);

/* ANZXT[ǒ */
GFS_LOCAL Sint32        gfs_svrSearchHndl(GfsHn gfs);

/* ANZXT[oւ̓o^ */
GFS_LOCAL void  gfs_svrAddHndl(GfsHn gfs);

/* ANZXT[o폜 */
GFS_LOCAL void  gfs_svrRemoveHndl(GfsHn gfs);

/* {[fBXNv^̓ǂݍ */
GFS_LOCAL Sint32        gfs_loadVol(Uint8 *buf);

/* [gfBNg̎擾 */
GFS_LOCAL Sint32        gfs_getRootDir(GfsDirId *dir);

/* [gfBNgR[h̓ǂݍ */
GFS_LOCAL Sint32        gfs_loadRootDir(GfsDirTbl *dirtbl);

/* f[^\[Xobt@ɗ */
GFS_LOCAL Sint32        gfs_flowIn(GfsHn gfs);

/* [Üւ̃f[^̓] */
GFS_LOCAL Sint32        gfs_transData(GfsHn gfs);

/* ǂݍ݁^݃ZN^ݒ */
GFS_LOCAL void  gfs_SetSct(GfsFlow *flow, Sint32 sct);

/* t@C̎擾 */
GFS_LOCAL void  gfs_GetFinfo(GfsFinfo *finfo, Sint32 *fid, Sint32 *fad,
                         Sint32 *sctsiz, Sint32 *nsct, Sint32 *lastsiz,
                         Sint32 *fno, Sint32 *atr);

/* t@CN[Y֐ */
GFS_LOCAL void  gfs_closeSub(GfsHn gfs);

/* o[h̎擾 */
GFS_LOCAL Sint32        gfs_getGmode(GfsHn gfs);

/* 𒲂ׂ */
GFS_LOCAL Bool  gfs_isTaskDone(GfsHn gfs);

/* flow in̏ԂG[R[hɕϊ */
GFS_LOCAL Sint32        gfs_convFinStat(GfsHn gfs, Sint32 fstat);

/*  f[^̓ǂݍ݂҂  */
GFS_LOCAL Sint32 gfs_waitRead(GfsHn gfs);

/*****************************************************************************
 *      ϐ̒`
 *****************************************************************************/

/* Ǘe[u */
GfsMng *gfs_mng_ptr;

/* t@Cgp\̎ */
/* ̕ϐɃt@C̈̐擪AhXݒ肷 */
Sint8   *GFMC_base;

/* SCU-DMAgptO  */
Bool    gfs_use_scudma;

/* o[Wԍ   */
const Sint8   gfs_version[GFS_VERSION_LEN] = GFS_VERSION_STR;

/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/

/*--- ferC^tF[X֐ ---------------------------------------------*/

/*****************************************************************************
 *  t@CVXȅACD-ROM̃}Eg
 *ḿn
 *  open_max    I[vłt@C̍ő吔
 *  work        Cu̍Ɨ̈
 *  dirtbl      fBNgǗ̈
 *món
 *  Ȃ
 *m֐ln
 *  fBNgBG[͕̒lB
 *m@\n
 *  t@CVXe̊Ǘe[uACD-ROM[gfBNg
 *  ǂݍށB
 *mln
 *  DEBUG_LIBłCDubNt@CVXegȂB
 *  CDBFSgƁAt@CfobOt@CƍȂ߁B
 *  
 *****************************************************************************/
Sint32 GFS_Init(Sint32 open_max, void *work, GfsDirTbl *dirtbl)
{
    Sint32      ndir, ret;
    
    gfs_use_scudma = FALSE;
    /* `FbN */
    if ((open_max < 1)||(GFS_OPEN_MAX < open_max)) {
        return GFS_ERR_OPENMAX;
    }
    if (((Uint32)work) & 3) {
        return GFS_ERR_ALIGN;
    }
    if (dirtbl != NULL) {
        if (((GFS_DIRTBL_TYPE(dirtbl) != GFS_DIR_ID)&&
             (GFS_DIRTBL_TYPE(dirtbl) != GFS_DIR_NAME))||
            (GFS_DIRTBL_NDIR(dirtbl) < 2)||
            (GFS_DIRTBL_DIRID(dirtbl) == NULL)) {
            return GFS_ERR_DIRTBL;
        }
    }
    /* SCU-DMA0I荞݂ */
    INT_ChgMsk(INT_MSK_DMA0, INT_MSK_NULL);

    gfs_mng_ptr = work;
    /* eW[ */
    gfs_mngInitWork(open_max);          /* }l[W */
    ret = GFCF_Init((dirtbl == NULL)? TRUE: FALSE); /* CDF */
#if defined(DEBUG_LIB)
    if (dirtbl == NULL) {
        /* DEBUG_LIBłCDubNt@CVXe𗘗płȂ */
        return gfs_mngSetErrCode(GFS_ERR_CDBFS);
    }
    /* ȈCDG~[^hCo */
    GFMF_Init();                        /* MMF */
    GFSF_Init();                        /* SCSIt@C */
#else
    if (ret != GFS_ERR_OK) {
        return gfs_mngSetErrCode(ret);
    }
    /* iłłCDK{ */
    if (!MNG_CDCON(gfs_mng_ptr)) {
        return gfs_mngSetErrCode(GFS_ERR_CDNODISC);
    }
#endif /* defined(DEBUG_LIB) */
    ndir = gfs_chgRoot(dirtbl);
    if (ndir < 0) {
        return gfs_mngSetErrCode(ndir);
    }
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return ret;
    }
    return ndir;
}


/*****************************************************************************
 *  fBNg̓ǂݍ
 *ḿn
 *  fid         fBNg̎ʎq
 *  dirtbl      fBNgǗ\
 *món
 *  Ȃ
 *m֐ln
 *  ǂݍ񂾃fBNgԂBG[͕̎̃G[R[hԂB
 *m@\n
 *  w肵fBNgdirtblɓǂݍށB
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_LoadDir(Sint32 fid, GfsDirTbl *dirtbl)
{
    GfsHn       gfs;
    Sint32      nsct;
    Sint32      readdir;

    if (dirtbl == NULL) {
        /* GFS_InitdirtblNULLݒ肵`FbN */
        if (DIRMNG_DIRID(&MNG_CURDIR(gfs_mng_ptr)) != NULL) {
            return gfs_mngSetErrCode(GFS_ERR_CDBFS);
        }
        /* CDubÑfBNgfid̂̂ݒ */
        readdir = GFDR_ChgDir(fid);
        if (readdir < 0) {
            return gfs_mngSetErrCode(readdir);
        }
        return readdir;
    }
    gfs = GFS_Open(fid);
    if (gfs == NULL) {
        return GFS_ERR_CODE(&MNG_ERROR(gfs_mng_ptr));
    }
    GFS_GetFileSize(gfs, NULL, &nsct, NULL);
    /* fBNg̓ǂݍ */
    readdir = GFDR_SetupDirTbl(gfs, dirtbl, nsct);
    GFS_Close(gfs);
    return readdir;
}


/*****************************************************************************
 *  JgfBNg̐ݒ
 *ḿn
 *  dirtbl      fBNgǗ̈
 *món
 *  Ȃ
 *m֐ln
 *  G[R[h
 *m@\n
 *  w肳ꂽfBNgJgfBNgɐݒ肷A
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_SetDir(GfsDirTbl *dirtbl)
{
    GfsDirMng   *mng;

    mng = &MNG_CURDIR(gfs_mng_ptr);
    if (dirtbl == NULL) {
        /* GFS_InitdirtblNULLݒ肵`FbN */
        if (DIRMNG_DIRID(mng) != NULL) {
            return gfs_mngSetErrCode(GFS_ERR_CDBFS);
        }
        /* CDBFSŃfBNgǗsȂ */
        DIRMNG_DIRID(mng) = NULL;
        DIRMNG_NDIR(mng) = DIRMNG_NFILE(mng) = 0;
    } else {
        /* GFSŃfBNgǗsȂ */
        DIRMNG_DIRTBL(mng) = *dirtbl;
        DIRMNG_NFILE(mng) = gfs_mngGetNumFile(dirtbl); /* t@Cݒ */
    }
    return gfs_mngSetErrCode(GFS_ERR_OK);
}


/*****************************************************************************
 *  t@Ct@Cʎqɕϊ
 *ḿn
 *  fname       t@C
 *món
 *  Ȃ
 *m֐ln
 *  ϊt@CʎqBG[͕̃G[R[hB
 *m@\n
 *  t@Ct@CʎqɕϊB
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_NameToId(Sint8 *fname)
{
    Sint32      fid;
    GfsDirMng   *cdir = &MNG_CURDIR(gfs_mng_ptr);
    Sint32      ret;

    if ((DIRMNG_DIRID(cdir) == NULL)||(DIRMNG_TYPE(cdir) != GFS_DIR_NAME)) {
        return gfs_mngSetErrCode(GFS_ERR_NONAME);
    }
    fid = GFDR_NameToId(DIRMNG_DIRNAME(cdir), fname, DIRMNG_NDIR(cdir));
    if (fid < 0) {
        return gfs_mngSetErrCode(GFS_ERR_NEXIST);
    }
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return ret;
    }
    return fid;
}


/*****************************************************************************
 *  ʎqt@Cւ̕ϊ
 *ḿn
 *  fid         t@Cʎq
 *món
 *  Ȃ
 *m֐ln
 *  ϊt@Cւ̃|C^BG[NULLB
 *m@\n
 *  t@Cʎqt@CɕϊB
 *mln
 *  
 *****************************************************************************/
Sint8 *GFS_IdToName(Sint32 fid)
{
    GfsDirName  *pdir;
    GfsDirMng   *cdir = &MNG_CURDIR(gfs_mng_ptr);
    Sint32      ret;

    /* CDubÑt@Cg */
    if ((DIRMNG_DIRID(cdir) == NULL)||(DIRMNG_TYPE(cdir) != GFS_DIR_NAME)) {
        gfs_mngSetErrCode(GFS_ERR_NONAME);
        return NULL;
    }
    /* t@Cʎq͈̔͂`FbN */
    if ((fid < 0)||(DIRMNG_NFILE(cdir) <= fid)) {
        gfs_mngSetErrCode(GFS_ERR_NEXIST);
        return NULL;
    }
    pdir = GFDR_GetInfoDirName(fid, DIRMNG_DIRNAME(cdir));
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return NULL;
    }
    return GFS_DIR_FNAME(pdir);
}


/*****************************************************************************
 *  t@CʎqfBNgR[h擾
 *ḿn
 *  fid         t@Cʎq
 *món
 *  dirrec      fBNgR[h
 *m֐ln
 *  G[R[h
 *m@\n
 *  t@CʎqfBNg擾
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_GetDirInfo(Sint32 fid, GfsDirId *dirrec)
{
    GfsDirName  *pdirn;
    GfsDirId    *pdir;
    GfsDirMng   *cdir = &MNG_CURDIR(gfs_mng_ptr);

    /* CDubÑt@Cg */
    /* ͈͊O̎ */
    if ((DIRMNG_DIRID(cdir) == NULL)||
        (fid < 0)||(fid >= DIRMNG_NFILE(cdir))) {
        return gfs_mngSetErrCode(GFS_ERR_FID);
    }
    if ((DIRMNG_TYPE(cdir) == GFS_DIR_NAME)) {
        pdirn = GFDR_GetInfoDirName(fid, DIRMNG_DIRNAME(cdir));
        memcpy(dirrec, pdirn, sizeof(GfsDirId));
    } else {
        pdir = GFDR_GetInfoDirId(fid, DIRMNG_DIRID(cdir));
        memcpy(dirrec, pdir, sizeof(GfsDirId));
    }
    return gfs_mngSetErrCode(GFS_ERR_OK);
}


/*****************************************************************************
 *  t@CVXẽZbg
 *ḿn
 *  Ȃ
 *món
 *  Ȃ
 *m֐ln
 *  Ȃ
 *m@\n
 *  t@CVXeZbg
 *mln
 *  
 *****************************************************************************/
void    GFS_Reset(void)
{
    GfsHn       gfs;
    GftrHn      gftr;
    Sint32      i;

    gfs = MNG_FILE(gfs_mng_ptr);
    for (i = 0; i < MNG_OPENMAX(gfs_mng_ptr); i++, gfs++) {
        if (GFS_FILE_USED(gfs) == TRUE) {
            gftr = &GFS_FILE_TRANS(gfs);
            /* ]֐o^Ăꍇ0Ԃ֐ɒu      */
            if (GFS_TRN_MODE(gftr) == GFS_TMODE_STM) {
                GFTR_SetTransFunc(gfs, (GfsTransFunc)gfs_aborttrans, gfs);
            }
            GFS_Close(gfs);
        }
    }
}


/*****************************************************************************
 *  t@C̃I[v
 *ḿn
 *  fid         t@Cʎq
 *món
 *  Ȃ
 *m֐ln
 *  t@CnhBG[NULLB
 *m@\n
 *  w肵t@CJB
 *mln
 *  
 *****************************************************************************/
GfsHn GFS_Open(Sint32 fid)
{
    GfsDirId    *dirrec;
    GfsHn       gfs;
    GfsDirMng   *cdir = &MNG_CURDIR(gfs_mng_ptr);
    Sint32      ret;

    if ((DIRMNG_DIRID(cdir) != NULL)&&
        ((fid < 0)||(fid >= DIRMNG_NFILE(cdir)))) {
        gfs_mngSetErrCode(GFS_ERR_FID);
        return NULL;
    }
    gfs = GFS_mngAllocGrp();            /* 󂫃O[v擾     */
    if (gfs == NULL) {                 /* 󂫗̈悪ꍇ   */
        gfs_mngSetErrCode(GFS_ERR_NOHNDL);
        return NULL;
    }
    /* t@C擾 */
    if (DIRMNG_DIRID(cdir) == NULL) {
        dirrec = NULL;
    } else if (DIRMNG_TYPE(cdir) == GFS_DIR_ID) {
        dirrec = GFDR_GetInfoDirId(fid, DIRMNG_DIRID(cdir));
    } else {
        dirrec = (GfsDirId *)GFDR_GetInfoDirName(fid, DIRMNG_DIRNAME(cdir));
    }
    gfs = GFS_OpenSub(gfs, dirrec, fid);
    if (gfs == NULL) {
        gfs_mngSetErrCode(GFS_ERR_FID);
    } else {
        ret = gfs_mngSetErrCode(GFS_ERR_OK);
        if (ret < 0) {
            return NULL;
        }
    }
    return gfs;
}


/*****************************************************************************
 *  t@C̃N[Y
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  Ȃ
 *m@\n
 *  w肵t@CB
 *mln
 *  
 *****************************************************************************/
void GFS_Close(GfsHn gfs)
{
    if (gfs != NULL) {
        gfs_mngTermAccess(gfs, TRUE);         /* ANZXI */
        gfs_closeSub(gfs);
    }
    gfs_mngSetErrCode(GFS_ERR_OK);
}


/*****************************************************************************
 *  ANZX|C^̈ړ
 *ḿn
 *  gfs         t@Cnh
 *  ofs         ړItZbg
 *  org         ʒu
 *món
 *  Ȃ
 *m֐ln
 *  ړ̃ANZX|C^ԂB
 *m@\n
 *  ANZX|C^ړB
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_Seek(GfsHn gfs, Sint32 ofs, Sint32 org)
{
    GfsFileFunc *func;
    Sint32      nsct;
    GfsFlow     *flow;
    GfsDtsrc    *dts;
    Sint32      ret;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    flow = &GFS_FILE_FLOW(gfs);
    dts = &GFS_FLW_DTSRC(flow);
    func = &MNG_FUNCTBL(gfs_mng_ptr, GFS_DTS_FTYPE(dts));
    GFS_GetFileSize(gfs, NULL, &nsct, NULL);
    if (org == GFS_SEEK_CUR) {          /* ݈ʒuV[N */
        ofs += (FUNC_TELL(func))(flow);
    } else if (org == GFS_SEEK_END) {   /* I[V[N */
        ofs = nsct + ofs;
    } else if (org != GFS_SEEK_SET) {
        /* sȊʒu */
        return gfs_mngSetErrCode(GFS_ERR_ORG);
    }
    if (ofs < 0) {
        return gfs_mngSetErrCode(GFS_ERR_SEEK);
    }
    if (ofs > nsct) {
        return gfs_mngSetErrCode(GFS_ERR_SEEK);
    }
    ofs = (FUNC_SEEK(func))(flow, ofs);
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return ret;
    }
    return ofs;
}


/*****************************************************************************
 *  ANZX|C^̎擾
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  ANZX|C^
 *m@\n
 *  ANZX|C^Ԃ
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_Tell(GfsHn gfs)
{
    GfsFileFunc *func;
    Sint32      ofs;
    GfsFlow     *flow;
    GfsDtsrc    *dts;
    Sint32      ret;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    flow = &GFS_FILE_FLOW(gfs);
    dts = &GFS_FLW_DTSRC(flow);
    func = &MNG_FUNCTBL(gfs_mng_ptr, GFS_DTS_FTYPE(dts));
    ofs = (FUNC_TELL(func))(flow);
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return ret;
    }
    return ofs;
}


/*****************************************************************************
 *  t@CĨ`FbN
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  TRUE        ANZX|C^t@Cȍ~ɂ
 *  FALSE       ̑
 *m@\n
 *  ANZX|C^t@CɒBǂׂB
 *mln
 *  
 *****************************************************************************/
Bool GFS_IsEof(GfsHn gfs)
{
    Sint32      pos, nsct;
        
    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    pos = GFS_Tell(gfs);
    GFS_GetFileSize(gfs, NULL, &nsct, NULL);
    gfs_mngSetErrCode(GFS_ERR_OK);
    /* t@C̏I[ɒBĂꍇ   */
    return (pos >= nsct)? TRUE: FALSE;
}


/*****************************************************************************
 *  oCgZN^ւ̕ϊ
 *ḿn
 *  gfs         t@Cnh
 *  nbyte       oCg
 *món
 *  Ȃ
 *m֐ln
 *  ZN^Pʂɕϊ
 *m@\n
 *  oCgZN^ւ̒Pʂ̕ϊsȂB
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_ByteToSct(GfsHn gfs, Sint32 nbyte)
{
    Sint32      sctsz;
    Sint32      ret;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    GFS_GetFileSize(gfs, &sctsz, NULL, NULL);
    if (sctsz == 0) {
        return 0;
    }
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return ret;
    }
    return GFS_BYTE_SCT(nbyte, sctsz);
}


/*****************************************************************************
 *  t@CTCY̎擾
 *ḿn
 *  gfs         t@CTCY
 *món
 *  sctsz       ZN^TCY
 *  nsct        ZN^
 *  lstlen      ŏIZN^Lf[^
 *m֐ln
 *  Ȃ
 *m@\n
 *  t@C̑傫Ɋւ擾B
 *mln
 *  
 *****************************************************************************/
void GFS_GetFileSize(GfsHn gfs, Sint32 *sctsz, Sint32 *nsct, Sint32 *lstlen)
{
    Sint32      atr;
    GfsFlow     *flow;
        
    if (gfs == NULL) {
        gfs_mngSetErrCode(GFS_ERR_HNDL);
    } else {
        flow = &GFS_FILE_FLOW(gfs);
        gfs_GetFinfo(&GFS_FLW_FINFO(flow), NULL, NULL,
                     sctsz, nsct, lstlen, NULL, &atr);
        /* FORM1,FORM2݂Ăꍇ̓ZN^TCYݒ肵Ȃ */
        if (IS_FORM1(atr)&&IS_FORM2(atr)) {
            *sctsz = 0;
        }
    }
    gfs_mngSetErrCode(GFS_ERR_OK);
}


/*****************************************************************************
 *  t@C̎擾
 *ḿn
 *  gfs         t@Cnh
 *món
 *  fid         t@Cʎq
 *  fn          t@Cԍ
 *  fsize       傫iPʁFoCgj
 *  atr         
 *m֐ln
 *  Ȃ
 *m@\n
 *  t@C擾B
 *mln
 *  
 *****************************************************************************/
void GFS_GetFileInfo(GfsHn gfs, Sint32 *fid, Sint32 *fn, Sint32 *fsize,
                     Sint32 *atr)
{
    Sint32      nsct;
    Sint32      lstlen;
    GfsFlow     *flow;

    if (gfs == NULL) {
        gfs_mngSetErrCode(GFS_ERR_HNDL);
    } else {
        flow = &GFS_FILE_FLOW(gfs);
        gfs_GetFinfo(&GFS_FLW_FINFO(flow), fid, NULL, NULL,
                     &nsct, &lstlen, fn, atr);
        if (atr != NULL) {
            *atr &= ~GFS_ATR_FTYPE_MASK;        /* t@Cʏ */
        }
        if (fsize != NULL) {
            *fsize = (nsct - 1) * GFS_MD1_SCTSIZ + lstlen;
        }
    }
    gfs_mngSetErrCode(GFS_ERR_OK);
}


/*****************************************************************************
 *  CDobt@̃ZN^̎擾
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  CDobt@̃ZN^
 *m@\n
 *  CDobt@ɓǂݍ܂ĂZN^擾
 *mln
 *  
 *****************************************************************************/
Sint32  GFS_GetNumCdbuf(GfsHn gfs)
{
    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    /* CDobt@ZN^o */
    return GFBF_GetNumData(gfs);
}


/*****************************************************************************
 *  t@C̈ꊇǂݍ
 *ḿn
 *  fid         t@Cʎq
 *  ofs         ǂݍ݊Jnʒu
 *  buf         ǂݍݗ̈
 *  bsize       ǂݍݗ̈TCY
 *món
 *  Ȃ
 *m֐ln
 *  ǂݍ݃oCgBG[͕̒lB
 *m@\n
 *  t@CʎqŎw肳ꂽt@CǂݍށB
 *  t@C̃I[vƃN[Y̊֐ōsȂB
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_Load(Sint32 fid, Sint32 ofs, void *buf, Sint32 bsize)
{
    GfsHn       gfs;
    Sint32      nsct;           /* JnʒuI[܂ł̃ZN^ */
    Sint32      bsct;
    Sint32      sctsiz1, sctsiz2;
    Sint32      readlen;
    Sint32      ap;
    GfsFinfo    *finfo;

    gfs = GFS_Open(fid);
    if (gfs == NULL) {
        return GFS_ERR_CODE(&MNG_ERROR(gfs_mng_ptr));
    }
    ap = GFS_Seek(gfs, ofs, GFS_SEEK_SET);
    if (ap < 0) {
        return gfs_mngSetErrCode(GFS_ERR_OFS);
    }
    finfo = &GFS_FLW_FINFO(&GFS_FILE_FLOW(gfs));
    sctsiz1 = sctsiz2 = GFS_FI_SCTSZ(finfo);
    /* Form1, Form2݂̏ꍇobt@TCY->ZN^ϊőlɂ */
    if (sctsiz1 == 0) {
        sctsiz1 = GFS_FM2_SCTSIZ;
        sctsiz2 = GFS_FM1_SCTSIZ;
    }
    nsct = GFS_FI_NSCT(finfo) - ofs;    /* t@C܂ł̃ZN^     */
    /* GFS_BUFSIZ_INFw肳ꂽt@C܂œǂݍ */
    if (bsize == GFS_BUFSIZ_INF) {
        bsize = nsct * sctsiz1;
    }
    /* obt@TCYɑΉZN^     */
    bsct = (bsize + sctsiz1 - 1) / sctsiz2;
    /* ǂݍރZN^                     */
    nsct = MIN(nsct, bsct);
    readlen = GFS_Fread(gfs, nsct, buf, bsize);
    GFS_Close(gfs);
    if (readlen >= 0) {
        gfs_mngSetErrCode(GFS_ERR_OK);
    }
    return readlen;
}
            

/*****************************************************************************
 *  f[^̓ǂݍ
 *ḿn
 *  gfs         t@Cnh
 *  nsct        ]ZN^
 *  buf         ǂݍݗ̈
 *  bsize       ǂݍݗ̈TCY
 *món
 *  Ȃ
 *m֐ln
 *  ǂݍ݃oCg
 *m@\n
 *  I[vꂽt@Cf[^ǂݍށB
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_Fread(GfsHn gfs, Sint32 nsct, void *buf, Sint32 bsize)
{
    Sint32      err, rpara_old, amode, ndata;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    err = GFS_NwFread(gfs, nsct, buf, bsize);
    if (err != GFS_ERR_OK) {
        return err;
    }
    /* ftHg̓ǂݍ݃p[^gp */
    rpara_old = GFS_SetReadPara(gfs, GFS_RPARA_DFL);
    err = gfs_waitRead(gfs);
    if (err < 0) {
        ndata = gfs_mngSetErrCode(err);
    } else {
        /* ]oCg擾 */
        GFS_NwGetStat(gfs, &amode, &ndata);
        err = gfs_mngSetErrCode(GFS_ERR_OK);
        if (err < 0) {
            return err;
        }
    }
    if (rpara_old >= 0) {
        GFS_SetReadPara(gfs, rpara_old);
    }

    return ndata;
}


/*****************************************************************************
 *  f[^̓ǂݍ݂҂
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  G[R[h
 *m@\n
 *  GFS_NwFreaď̓ǂݍ݊҂
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL Sint32 gfs_waitRead(GfsHn gfs)
{
    Sint32      err, atr, timer;
    GfsDtsrc    *dts;
    GfsTrans    *trn;

    dts = &GFS_FLW_DTSRC(&GFS_FILE_FLOW(gfs));
    trn = &GFS_FILE_TRANS(gfs);
    GFS_GetFileInfo(gfs, NULL, NULL, NULL, &atr);
    if (atr & GFS_ATR_CDDA) {
        timer = -1;
    } else {
        timer = 0;
    }
    while (1) {
        err = GFS_NwExecOne(gfs);
        if ((err == GFS_SVR_COMPLETED)||(err < 0)) {
            break;
        }
        /* ]ɏI */
        if ((GFS_TRN_STAT(trn) == GFTR_ST_END)&&
            ((GFS_DTS_FTYPE(dts) != CD_FILE)||
             (gfcf_fad < GFS_CDR_EFAD(dts))||
             (gfcf_stat != GFS_STAT_SEEK))) {
            /* nsct傫lGFS_NwCdRead                 */
            /* ]ɏIꍇ                           */
            /* Đ͈͂z̓Xe[^XCOMPLETEDɂ邽  */
            /* BUSYbreakȂ悤ɂ                        */
            break;
        }
        if ((GFS_TRN_WP(trn) == 0)&&(timer >= 0)) {
            timer++;
            if (timer > FREAD_TMOUT_COUNT) {
                return GFS_ERR_TMOUT;
            }
        }
    }
    return err;
}


/*****************************************************************************
 *  f[^ǂݍ݂̊Jn
 *ḿn
 *  gfs         t@Cnh
 *  nsct        ǂݍ݃ZN^
 *  buf         ǂݍݗ̈
 *  bsize       ǂݍݗ̈̑傫iPʁFoCgj
 *món
 *  Ȃ
 *m֐ln
 *  G[R[h
 *m@\n
 *  ǂݍ݃NGXgo^B
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_NwFread(GfsHn gfs, Sint32 nsct, void *buf, Sint32 bsize)
{
    Sint32      remain, atr;
    Bool        add_flag = FALSE;
    GfsFlow     *flow;
    GfsFinfo    *finfo;
    GfsTrans    *trn;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    flow = &GFS_FILE_FLOW(gfs);
    finfo = &GFS_FLW_FINFO(flow);
    trn = &GFS_FILE_TRANS(gfs);
    remain = GFS_FI_NSCT(finfo) - GFS_Tell(gfs);
    remain = MIN(remain, nsct);         /* ǂݍ݃ZN^ */
    if (remain < 0) {
        return gfs_mngSetErrCode(GFS_ERR_PARA);
    }
    if (GFS_FILE_AMODE(gfs) == GFS_NWSTAT_NOACT) {
        /* flow in^XNo^ */
        gfs_SetSct(flow, remain);
        add_flag = TRUE;
    }
    GFS_FILE_AMODE(gfs) = GFS_NWSTAT_FREAD; /* ANZX[h */
    GFS_GetFileInfo(gfs, NULL, NULL, NULL, &atr);
    if (atr & GFS_ATR_CDDA) {
        /* CDDAt@C͓]Ȃ */
        GFTR_SetTransPara(trn, 0);      /* ]ZN^ */
        GFTR_SetData(trn, NULL, 0, 1);  /* ]ݒ */
    } else if ((GFS_TRN_STAT(trn) == GFTR_ST_NOACT)||
               (GFS_TRN_STAT(trn) == GFTR_ST_END)) {
        /* trans^XNo^ */
        GFTR_SetTransPara(trn, remain); /* ]ZN^ */
        GFTR_SetData(trn, buf, bsize, 1); /* ]ݒ */
        GFTR_Start(trn);
        add_flag = TRUE;
    }
    if (add_flag == FALSE) {
        return gfs_mngSetErrCode(GFS_ERR_FBUSY);
    }
    gfs_svrAddHndl(gfs);                /* ANZXT[oւ̓o^ */
    GFS_FILE_ASTAT(gfs) = GFS_SVR_BUSY; /* ANZX */
    return gfs_mngSetErrCode(GFS_ERR_OK);
}


/*****************************************************************************
 *  CDobt@ւ̐ǂ݂̊Jn
 *ḿn
 *  gfs         t@Cnh
 *  nsct        ǂݍ݃ZN^
 *món
 *  Ȃ
 *m֐ln
 *  G[R[h
 *m@\n
 *  CDobt@ւ̐ǂ݃NGXgo^B
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_NwCdRead(GfsHn gfs, Sint32 nsct)
{
    Sint32      remain;
    GfsFlow     *flow;
    GfsFinfo    *finfo;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    flow = &GFS_FILE_FLOW(gfs);
    finfo = &GFS_FLW_FINFO(flow);
    if (GFS_FILE_AMODE(gfs) != GFS_NWSTAT_NOACT) {
        return gfs_mngSetErrCode(GFS_ERR_FBUSY);
    }
    /* flow in^XNo^ */
    remain = GFS_FI_NSCT(finfo) - GFS_Tell(gfs);
    remain = MIN(remain, nsct);         /* ǂݍ݃ZN^ */
    gfs_SetSct(flow, remain);
    GFS_FILE_AMODE(gfs) = GFS_NWSTAT_CDREAD; /* ANZX[h */
    GFS_FILE_ASTAT(gfs) = GFS_SVR_BUSY; /* tO */
    gfs_svrAddHndl(gfs);                /* ANZXT[oւ̓o^ */
    return gfs_mngSetErrCode(GFS_ERR_OK);
}


/*****************************************************************************
 *  ANZX슮`FbN
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  TRUE        
 *  FALSE       쒆
 *m@\n
 *  ANZX삪ׂ
 *mln
 *  vIG[ꍇA[vɂȂ̂邽TRUEԂ
 *****************************************************************************/
Bool GFS_NwIsComplete(GfsHn gfs)
{
    Sint32  ret;

    if (gfs == NULL) {
        gfs_mngSetErrCode(GFS_ERR_HNDL);
        return TRUE;
    }
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return TRUE;
    }
    return (GFS_FILE_ASTAT(gfs) == GFS_SVR_COMPLETED)? TRUE: FALSE;
}


/*****************************************************************************
 *  ANZX̒~
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  ݂̃ANZX|C^
 *m@\n
 *  ANZX~B
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_NwStop(GfsHn gfs)
{
    Sint32      ap, ec;
    Bool        wait_pause;
        
    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    GFS_FILE_AMODE(gfs) = GFS_NWSTAT_NOACT;
    GFS_FILE_ASTAT(gfs) = GFS_SVR_COMPLETED; /* I */
    gfs_svrRemoveHndl(gfs);             /* T[o폜 */
    if (gfs_getGmode(gfs) == GFS_GMODE_ERASE) {
        wait_pause = FALSE;
    } else {
        wait_pause = TRUE;
    }
    gfs_mngTermAccess(gfs, wait_pause);      /*  */
    ap = GFS_Tell(gfs);
    ec = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ec < 0) {
        return ec;
    }
    return ap;
}


/*****************************************************************************
 *  ANZXԂ̎擾
 *ḿn
 *  gfs         t@Cnh
 *món
 *  amode       ANZX[h
 *  ndata       ]f[^
 *m֐ln
 *  Ȃ
 *m@\n
 *  T[o֐̃ANZX[hƓ]f[^o͂B
 *  ]f[^̓ANZX[hA
 *      GFS_NWSTAT_FREAD̂ƂA]oCg
 *      GFS_NWSTAT_CDREAD̂ƂA]\ZN^
 *mln
 *  
 *****************************************************************************/
void GFS_NwGetStat(GfsHn gfs, Sint32 *amode, Sint32 *ndata)
{
    GfsTrans    *trn;
    Sint32      atr;

    if (gfs == NULL) {
        gfs_mngSetErrCode(GFS_ERR_HNDL);
    } else {
        trn = &GFS_FILE_TRANS(gfs);
        *amode = GFS_FILE_AMODE(gfs);
        GFS_GetFileInfo(gfs, NULL, NULL, NULL, &atr);
        if (atr & GFS_ATR_CDDA) {
            /* CDDAt@C͓]sȂȂ */
            *ndata = 0;
        } else if (GFS_FILE_AMODE(gfs) == GFS_NWSTAT_CDREAD) {
            /* CDobt@ZN^o */
            *ndata = GFBF_GetNumData(gfs);
        } else {
            /* ]oCgo */
            *ndata = GFS_TRN_WP(trn);
        }
    }
    gfs_mngSetErrCode(GFS_ERR_OK);
}


/*****************************************************************************
 *  [hG[̃Jo
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  
 *m@\n
 *  [hG[̃vCp
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL Sint32        gfs_recovRdErr(GfsHn gfs)
{
    Sint32      fstat;
    GfsDtsrc    *dtsrc;
    GfsFlow     *flow;

    flow = &GFS_FILE_FLOW(gfs);
    dtsrc = &GFS_FLW_DTSRC(flow);
    if (GFS_DTS_FTYPE(dtsrc) == CD_FILE) {
        fstat = GFCF_Recover(flow);
        if (fstat == GFS_FIN_PLAY) {
            GFS_FILE_ASTAT(gfs) = GFS_SVR_BUSY; /* Jo */
        }
    }
    return GFS_FILE_ASTAT(gfs);
}



/*****************************************************************************
 *  t@CPʂł̃ANZX̎s
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  
 *m@\n
 *  NGXgɑ΂ANZXsȂB
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_NwExecOne(GfsHn gfs)
{
    Sint32      tstat, ec;
    Bool        flag;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    if (GFS_FILE_ASTAT(gfs) != GFS_SVR_COMPLETED) {
        /* SCU-DMAgp̏ꍇɂ͓]I`FbNȂ    */
        if (gfs_use_scudma == TRUE) {
            GFTR_ExecSvr(gfs, &flag);
            /* A-BusANZXs̂߈ȍ~̏͂ȂȂ  */
            if (gfs_use_scudma == TRUE) {
                return GFS_FILE_ASTAT(gfs);
            }
        }
        if (GFS_FILE_ASTAT(gfs) == GFS_ERR_CDRD) {
            ec = gfs_recovRdErr(gfs);
            return ec;
        }
        ec = gfs_flowIn(gfs);
        if (ec < 0) {
            return ec;
        }
        if (GFS_FLW_STAT(&GFS_FILE_FLOW(gfs)) != GFS_FIN_NOACT) {
            tstat = gfs_transData(gfs);
            if (tstat == GFTR_ST_END) {
                /* ]flowin̏ԂJڂꍇ̂ */
                ec = gfs_flowIn(gfs);
                if (ec < 0) {
                    return ec;
                }
                if (gfs_isTaskDone(gfs)) {
                    GFS_FILE_AMODE(gfs) = GFS_NWSTAT_NOACT;
                    GFS_FILE_ASTAT(gfs) = GFS_SVR_COMPLETED;
                    gfs_svrRemoveHndl(gfs); /* T[o폜 */
                }
            }
        }
    }
    ec = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ec < 0) {
        return ec;
    }
    return GFS_FILE_ASTAT(gfs);
}


/*****************************************************************************
 *  t@C̃ANZX̎s
 *ḿn
 *  Ȃ
 *món
 *  now_gfs     ANZXt@C̃nh
 *m֐ln
 *  ANZXT[ȍ
 *m@\n
 *  NGXg֐ɑ΂t@CANZXsȂB
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_NwExecServer(GfsHn *now_gfs)
{
    GfsSvr      *svr;
    Sint32      stat, i;

    svr = &MNG_SVR(gfs_mng_ptr);
    for (i = 0; i < SVR_NFILE(svr); ++i) {
        stat = GFS_NwExecOne(SVR_ACFILE(svr, i));
        if (stat < 0) {
            break;
        }
        /* ̃t@Cɑ΂Đǂ݂݂ */
        if (stat == GFS_SVR_COMPLETED) {
            /* ҂s񂪋l߂ꂽ */
            --i;
        }
    }
    if (SVR_NFILE(svr) == 0) {
        *now_gfs = NULL;
        stat = GFS_SVR_COMPLETED;       /* I */
    } else {
        *now_gfs = SVR_ACFILE(svr, 0);  /* nh */
        if ((stat == GFS_ERR_PUINUSE)&&(i > 0)) {
            stat = GFS_SVR_BUSY;
        }
    }
    return stat;
}


/*****************************************************************************
 *  o[h̐ݒ
 *ḿn
 *  gfs         t@Cnh
 *  gmode       o[hiGFS_GMODE_ERASE, GFS_GMODE_RESIDENTj
 *món
 *  Ȃ
 *m֐ln
 *  ݒO̎o[h
 *m@\n
 *  o[hݒ肷B
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_SetGmode(GfsHn gfs, Sint32 gmode)
{
    Sint32 old_mode, atr;
    GfsFlow     *flow;
    GfsDtsrc    *dtsrc;
    Sint32      ret;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    /* CDDAt@Cɑ΂Ă͎o[hύXłȂ */
    GFS_GetFileInfo(gfs, NULL, NULL, NULL, &atr);
    if (atr & GFS_ATR_CDDA) {
        return GFS_ERR_PARA;
    }
    flow = &GFS_FILE_FLOW(gfs);
    dtsrc = &GFS_FLW_DTSRC(flow);
    old_mode = GFS_FLW_GMODE(flow);
    GFS_FLW_GMODE(flow) = gmode;
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return ret;
    }
    return old_mode;
}



/*****************************************************************************
 *  ][h̐ݒ
 *ḿn
 *  gfs         t@Cnh
 *  tmode       ][hiGFS_TMODE_SCU,GFS_TMODE_SDMA[01],GFS_TMODE_CPUj
 *món
 *  Ȃ
 *m֐ln
 *  ݒO̓][h
 *m@\n
 *  ][hݒ肷
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_SetTmode(GfsHn gfs, Sint32 tmode)
{
    GfsFlow     *flow;
    GfsDtsrc    *dtsrc;
    GfsTrans    *trans;
    Sint32      old_mode, atr;
    Sint32      ret;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    /* CDDAt@Cɑ΂Ă͓][hύXłȂ */
    GFS_GetFileInfo(gfs, NULL, NULL, NULL, &atr);
    if (atr & GFS_ATR_CDDA) {
        return GFS_ERR_PARA;
    }
    flow = &GFS_FILE_FLOW(gfs);
    dtsrc = &GFS_FLW_DTSRC(flow);
    trans = &GFS_FILE_TRANS(gfs);
    old_mode = GFTR_SetMode(trans, tmode);
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return ret;
    }
    return old_mode;
}


/*****************************************************************************
 *  CDobt@ւ̓ǂݍݗʂ̐ݒ
 *ḿn
 *  gfs         t@Cnh
 *  nsct        P̍őǂݍݗʁiPʁFZN^j
 *món
 *  Ȃ
 *m֐ln
 *  ݒO̓ǂݍݗ
 *m@\n
 *  P̓ǂݍݗʂݒ肷
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_SetReadPara(GfsHn gfs, Sint32 nsct)
{
    GfsFlow     *flow;
    Sint32      old_para, atr;
    Sint32      ret;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    /* CDDAt@Cɑ΂Ă͓ǂݍݗʂύXłȂ */
    GFS_GetFileInfo(gfs, NULL, NULL, NULL, &atr);
    if (atr & GFS_ATR_CDDA) {
        return GFS_ERR_PARA;
    }
    flow = &GFS_FILE_FLOW(gfs);
    old_para = GFS_FLW_SCTMAX(flow);
    GFS_FLW_SCTMAX(flow) = nsct;
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return ret;
    }
    return old_para;
}


/*****************************************************************************
 *  CDobt@̓]ʂ̐ݒ
 *ḿn
 *  gfs         t@Cnh
 *  tsize       P̓]ʁiPʁFZN^j
 *món
 *  Ȃ
 *m֐ln
 *  ݒO̓]
 *m@\n
 *  P̍ő]ʂݒ肷
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_SetTransPara(GfsHn gfs, Sint32 tsize)
{
    Sint32  old_para, atr;
    Sint32  ret;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    /* CDDAt@Cɑ΂Ă͓]ʂύXłȂ */
    GFS_GetFileInfo(gfs, NULL, NULL, NULL, &atr);
    if (atr & GFS_ATR_CDDA) {
        return GFS_ERR_PARA;
    }
    old_para = GFTR_SetTransMax(&GFS_FILE_TRANS(gfs), tsize);
    ret = gfs_mngSetErrCode(GFS_ERR_OK);
    if (ret < 0) {
        return ret;
    }
    return old_para;
}



/*****************************************************************************
 * ]֐̓o^
 *ḿn
 *  gfs         t@Cnh
 *  func        ]֐
 *  obj         ]֐̑
 *món
 *  Ȃ
 *m֐ln
 *  Ȃ
 *m@\n
 *  ]֐ݒ肷
 *mln
 *  
 *****************************************************************************/
void    GFS_SetTrFunc(GfsHn gfs, GfsTrFunc func)
{
    if (gfs == NULL) {
        gfs_mngSetErrCode(GFS_ERR_HNDL);
        return ;
    }
    GFTR_SetData(&(GFS_FILE_TRANS(gfs)), NULL, 
                     GFS_LONG_MAX/GFS_MD1_SCTSIZ, GFS_MD1_SCTSIZ);
    GFTR_SetMode(&(GFS_FILE_TRANS(gfs)), GFS_TMODE_STM);
    GFTR_SetTransFunc(gfs, (GfsTransFunc)func, gfs);
}


/*****************************************************************************
 * ]֐ɂ]Jn
 *ḿn
 *  gfs         t@Cnh
 *món
 *  dadr        1[h]Ƃ̓]AhXω
 *m֐ln
 *  ]AhX
 *m@\n
 *  ]֐ɂ]Jn
 *mln
 *  
 *****************************************************************************/
Uint32  *GFS_StartTrans(GfsHn gfs, Sint32 *dadr)
{
    GfsFlow     *flow;
    GfsDtsrc    *dtsrc;
    GfdpHn      dpk;

    if (gfs == NULL) {
        gfs_mngSetErrCode(GFS_ERR_HNDL);
        return (NULL);
    }
    flow = &GFS_FILE_FLOW(gfs);
    dtsrc = &GFS_FLW_DTSRC(flow);
    dpk = GFS_TRN_DPS(&(GFS_FILE_TRANS(gfs)));
    if (GFS_DTS_FTYPE(dtsrc) == CD_FILE) {
        GFCB_GetSctData(dpk, dtsrc);            /* ZN^f[^̎擾   */
    }
    *dadr = GFDP_ADLT(dpk);                     /* AhXω       */
    return (GFDP_DATA(dpk));                    /* ]AhX         */
}


/*****************************************************************************
 *  CD̃sbNAbv̈ړ
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  G[R[h
 *m@\n
 *  sbNAbvANZX|C^̈ʒuɈړB
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_CdMovePickup(GfsHn gfs)
{
    Sint32      ap, err;
    GfsFlow     *flow;
    GfsDtsrc    *dtsrc;

    if (gfs == NULL) {
        return gfs_mngSetErrCode(GFS_ERR_HNDL);
    }
    flow = &GFS_FILE_FLOW(gfs);
    dtsrc = &GFS_FLW_DTSRC(flow);
    if (GFS_DTS_FTYPE(dtsrc) == CD_FILE) {
        ap = GFS_Tell(gfs);
        err = GFCF_MovePickup(flow, ap);
        if (err != GFS_ERR_OK) {
            return gfs_mngSetErrCode(err);
        }
        MNG_PICKUP(gfs_mng_ptr) = gfs;
    }
    return gfs_mngSetErrCode(GFS_ERR_OK);
}


/*****************************************************************************
 *  G[֐̐ݒ
 *ḿn
 *  func        G[֐
 *  obj         func̑P
 *món
 *  Ȃ
 *m֐ln
 *  Ȃ
 *m@\n
 *  G[֐o^
 *mln
 *  
 *****************************************************************************/
void GFS_SetErrFunc(GfsErrFunc func, void *obj)
{
    GFS_ERR_FUNC(&MNG_ERROR(gfs_mng_ptr)) = func;
    GFS_ERR_OBJ(&MNG_ERROR(gfs_mng_ptr)) = obj;
    gfs_mngSetErrCode(GFS_ERR_OK);
}


/*****************************************************************************
 *  G[Ԃ̎擾
 *ḿn
 *  Ȃ
 *món
 *  stat        G[
 *m֐ln
 *  Ȃ
 *m@\n
 *  G[Ԃ擾
 *mln
 *  
 *****************************************************************************/
void GFS_GetErrStat(GfsErrStat *stat)
{
    *stat = MNG_ERROR(gfs_mng_ptr);
}


/*****************************************************************************
 *  gbNԍ̕ϊ
 *ḿn
 *  logtno  : _gbNԍ
 *món
 *  Ȃ
 *m֐ln
 *  gbNԍ
 *m@\n
 *  _gbNԍ畨gbNԍɕϊ
 *mln
 *  
 *****************************************************************************/
Sint32  GFS_ConvTno(Sint32 logtno)
{
    /* ffs   */
    if (GFS_IS_DDS() == TRUE) {
        logtno += GFS_DDS_TNO();
    }
    return logtno;
}


/*--- fer}l[W -----------------------------------------------------*/

/*****************************************************************************
 * [gfBNgւ̈ړ
 *ḿn
 *  dirtbl      fBNgǗ̈
 *món
 *  Ȃ
 *m֐ln
 *  fBNgBG[͕̒lB
 *m@\n
 *  Q[̃[gfBNgɈړ
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL Sint32        gfs_chgRoot(GfsDirTbl *dirtbl)
{
    Sint32      ndir;
    Sint32      fid;        /* [gfBNg̃t@Cʎq   */
    GfsDirMng   *mng;

    if (GFS_IS_DDS() == TRUE) {   /* ffs̏ꍇ     */
        if (dirtbl != NULL) {
            GFCD_SetCdbfs(TRUE);
        }
        ndir = GFDR_ChgRoot();
        if (ndir < 0) {
            return gfs_mngSetErrCode(GFS_ERR_CDBFS);
        }
        mng = &MNG_CURDIR(gfs_mng_ptr);
        DIRMNG_DIRID(mng) = NULL;
        DIRMNG_NDIR(mng) = DIRMNG_NFILE(mng) = 0;
        GFS_SetDir(NULL);
        if (dirtbl != NULL) {
            GFCD_SetCdbfs(FALSE);
        }
        fid = (Sint32)GFS_DDS_FID();
        ndir = GFS_LoadDir(fid, dirtbl);
    } else {                            /* ʏQ[̏ꍇ         */
        /* fBNgǗǂ邩 */
        if (dirtbl == NULL) {
            /* CDubNt@CVXeŃfBNgǗsȂ */
            ndir = GFDR_ChgRoot();
            if (ndir < 0) {
                return gfs_mngSetErrCode(GFS_ERR_CDBFS);
            }
        } else {
            /* GFSŃfBNgǗ */
            ndir = gfs_loadRootDir(dirtbl); /* [gfBNgǂݍ   */
            if (ndir <= 0) {
                return gfs_mngSetErrCode(ndir);
            }
        }
    }
    GFS_SetDir(dirtbl);         /* JgfBNg<-[g */
    gfs_mngSetErrCode(GFS_ERR_OK);
    return ndir;
}


/*****************************************************************************
 * ]֐̋]I
 *ḿn
 *  gfs         t@Cnh
 *  nsct        ZN^
 *món
 *  Ȃ
 *m֐ln
 *  0
 *m@\n
 *  ]֐̓]I
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL Sint32        gfs_aborttrans(GfsHn gfs, Sint32 nsct)
{
    return (0);
}


/*****************************************************************************
 *  t@C֐e[ȕ
 *ḿn
 *  Ȃ
 *món
 *  Ȃ
 *m֐ln
 *  Ȃ
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL void gfs_mngSetupFuncTbl(void)
{
    GfsFileFunc         *func;

    /* CDt@C֐̐ݒ */
    func = &MNG_FUNCTBL(gfs_mng_ptr, CD_FILE);
    FUNC_FLOWIN(func) = GFCF_FlowInBuf;
    FUNC_STOPIN(func) = GFCF_StopInBuf;
    FUNC_SEEK(func) = GFCF_Seek;
    FUNC_TELL(func) = GFCF_Tell;
#if defined(DEBUG_LIB)
    /* t@C֐̐ݒ     */
    func = &MNG_FUNCTBL(gfs_mng_ptr, MEM_FILE);
    FUNC_FLOWIN(func) = GFMF_FlowInBuf;
    FUNC_STOPIN(func) = GFMF_StopInBuf;
    FUNC_SEEK(func) = GFMF_Seek;
    FUNC_TELL(func) = GFMF_Tell;
    /* SCSIt@C֐̐ݒ */
    func = &MNG_FUNCTBL(gfs_mng_ptr, SCSI_FILE);
    FUNC_FLOWIN(func) = GFSF_FlowInBuf;
    FUNC_STOPIN(func) = GFSF_StopInBuf;
    FUNC_SEEK(func) = GFSF_Seek;
    FUNC_TELL(func) = GFSF_Tell;
#endif
}


/*****************************************************************************
 *  Ǘe[ȕ
 *ḿn
 *  open_max    I[vő吔
 *món
 *  Ȃ
 *m֐ln
 *  Ȃ
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL void gfs_mngInitWork(Sint32 open_max)
{
    Sint32      i;
    GfsFile     *fp;
    GfdpHn      dpk;

    MNG_OPENMAX(gfs_mng_ptr) = open_max;
    /* t@C֐̐ݒ */
    gfs_mngSetupFuncTbl();
    SVR_NFILE(&MNG_SVR(gfs_mng_ptr)) = 0;       /* L[̒͂O */
    MNG_PICKUP(gfs_mng_ptr) = MNG_TRANS(gfs_mng_ptr) = NULL;
    MNG_SFAD(gfs_mng_ptr) = MNG_EFAD(gfs_mng_ptr) = 0;
    GFS_ERR_FUNC(&MNG_ERROR(gfs_mng_ptr)) = NULL;
    MNG_FLAGS(gfs_mng_ptr) = 0;
    fp = MNG_FILE(gfs_mng_ptr);
    for (i = 0; i < open_max; i++) {
        GFS_FILE_USED(fp) = FALSE;
        ++fp;
    }
    dpk = &MNG_SRCPK(gfs_mng_ptr);
    GFDP_DATA(dpk) = NULL;
    GFDP_ADLT(dpk) = GFDP_LEN(dpk) =  GFDP_NSCT(dpk) = 0;
    GFDP_USE(dpk) = FALSE;
    dpk = &MNG_DSTPK(gfs_mng_ptr);
    GFDP_DATA(dpk) = NULL;
    GFDP_ADLT(dpk) = GFDP_LEN(dpk) =  GFDP_NSCT(dpk) = 0;
    GFDP_USE(dpk) = FALSE;
}


/*****************************************************************************
 *  t@C̃JEg
 *ḿn
 *  dirtbl      fBNgǗ̈
 *món
 *  Ȃ
 *m֐ln
 *  fBNgGg̐
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL Sint32 gfs_mngGetNumFile(GfsDirTbl *dirtbl)
{
    Sint32      i;
    Sint32      atr;

    for (i = 0; i < GFS_DIRTBL_NDIR(dirtbl); i++) {
        if (GFS_DIRTBL_TYPE(dirtbl) == GFS_DIR_ID) {
            /* t@Cʎqgp */
            atr = GFDR_GetAtrDirId(i, GFS_DIRTBL_DIRID(dirtbl));
        } else {
            /* t@Cgp */
            atr = GFDR_GetAtrDirName(i, GFS_DIRTBL_DIRNAME(dirtbl));
        }
        if (IS_ENDTBL(atr)) {
            break;
        }
    }
    if (i > GFS_DIRTBL_NDIR(dirtbl)) {
        return 0;
    }
    return i + 1;
}

 
/* gpĂȂt@Cnh̎擾 */
GfsFile *GFS_mngAllocGrp(void)
{
    Sint32      i;
    GfsFile     *gfs;

    /* gpĂȂnhT */
    gfs = MNG_FILE(gfs_mng_ptr);
    for (i = 0; i < MNG_OPENMAX(gfs_mng_ptr); i++) {
        if (GFS_FILE_USED(gfs) == FALSE) {
            break;
        }
        ++gfs;
    }
    /* ׂĎgpĂꍇ */
    if (i == MNG_OPENMAX(gfs_mng_ptr)) {
        gfs = NULL;
    } else {
        GFS_FILE_USED(gfs) = TRUE;      /* gptOݒ */
    }
    return gfs;
}


/* I[vO[v̉ */
GFS_LOCAL void gfs_mngFreeGrp(GfsFile *gfs)
{
    GFS_FILE_USED(gfs) = FALSE;         /* gptO */
}


/* t@CANZX */
GFS_LOCAL void gfs_mngTermAccess(GfsHn gfs, Bool wait_pause)
{
    GfsFileFunc *func;
    GfsFlow     *flow = &GFS_FILE_FLOW(gfs);
    Sint32      ftype;

    /* SCU-DMAlɓ]I҂      */
    if (MNG_TRANS(gfs_mng_ptr) == gfs) {        /* ] */
        MNG_TRANS(gfs_mng_ptr) = NULL;
        GFTR_Stop(gfs, GFTR_ALLSCT);    /* ]~ */
    }
    /* CD_FILENULL̏ꍇACD-DAĐ̏ꍇ̂Œ~Ȃ  */
    ftype = GFS_DTS_FTYPE(&GFS_FLW_DTSRC(flow));
    if ((MNG_PICKUP(gfs_mng_ptr) == gfs)||
        ((ftype != CD_FILE)&&(MNG_PICKUP(gfs_mng_ptr) == NULL))) {
        MNG_PICKUP(gfs_mng_ptr) = NULL;
        func = &MNG_FUNCTBL(gfs_mng_ptr, ftype);
        (FUNC_STOPIN(func))(flow, wait_pause);
        GFS_FLW_STAT(flow) = GFS_FIN_NOACT;
        GFS_FLW_SCTCNT(flow) = 0;
    }
}


/* G[֐̌Ăт */
GFS_LOCAL Sint32 gfs_mngSetErrCode(Sint32 code)
{
    GfsErrStat  *err;

    switch (gfcd_fatal_err) {
    case    GFCD_ERR_OK:        /* x̒ቺhߐ擪ɂ   */
        break;
#if !defined(DEBUG_LIB)
    case    GFCD_ERR_OPEN:
        code = GFS_ERR_CDOPEN;
        break;
    case    GFCD_ERR_NODISC:
        code = GFS_ERR_CDNODISC;
        break;
#endif
    case    GFCD_ERR_FATAL:
        code = GFS_ERR_FATAL;
        break;
    default:
        break;
    }
    err = &MNG_ERROR(gfs_mng_ptr);
    GFS_ERR_CODE(err) = code;
    /* G[֐o^Ăꍇ */
    if ((code != GFS_ERR_OK)&&(GFS_ERR_FUNC(err) != NULL)) {
        GFS_ERR_FUNC(err)(GFS_ERR_OBJ(err), code); /* G[֐s */
    }
    return code;
}


/*--- ANZXT[o -------------------------------------------------------*/

/* ANZXT[ǒ */
GFS_LOCAL Sint32 gfs_svrSearchHndl(GfsHn gfs)
{
    Sint32      i;
    GfsSvr      *svr;

    svr = &MNG_SVR(gfs_mng_ptr);
    /* T[ogfso^Ă邩T[` */
    for (i = 0; i < SVR_NFILE(svr); i++) {
        if (gfs == SVR_ACFILE(svr, i)) {
            break;
        }
    }
    if (i == SVR_NFILE(svr)) {          /* o^ĂȂꍇ */
        i = SVR_NOHNDL;
    }
    return i;
}


/* ANZXT[oւ̓o^ */
GFS_LOCAL void gfs_svrAddHndl(GfsHn gfs)
{
    GfsSvr      *svr;
    Sint32      i;
    
    i = gfs_svrSearchHndl(gfs);     /* nho^ς݂ǂׂ */
    /* ꍇo^ */
    if (i == SVR_NOHNDL) {
        svr = &MNG_SVR(gfs_mng_ptr);
        SVR_ACFILE(svr, SVR_NFILE(svr)) = gfs;
        ++SVR_NFILE(svr);
    }
}


/* ANZXT[o폜 */
GFS_LOCAL void gfs_svrRemoveHndl(GfsHn gfs)
{
    GfsSvr      *svr;
    Sint32      i, nfile;

    if (gfs == NULL) {
        return;
    }
    i = gfs_svrSearchHndl(gfs);         /* nho^ς݂ǂׂ */
    /* o^Ăꍇ */
    if (i != SVR_NOHNDL) {
        svr = &MNG_SVR(gfs_mng_ptr);
        --SVR_NFILE(svr);               /* o^炷 */
        nfile = SVR_NFILE(svr);
        for ( ; i < nfile; i++) {       /* ߂ */
            SVR_ACFILE(svr, i) = SVR_ACFILE(svr, i + 1);
        }
        SVR_ACFILE(svr, i) = NULL;
    }
}


/*--- ̑ -----------------------------------------------------*/

/*****************************************************************************
 *  t@Cnh̊ăTu֐
 *ḿn
 *  opngrp      蓖Ăt@CǗ\
 *  dirrec      fBNgR[h
 *món
 *  Ȃ
 *m֐ln
 *  蓖Ăꂽfer̈
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GfsHn GFS_OpenSub(GfsFile *gfs, GfsDirId *dirrec, Sint32 fid)
{
    GftrHn      gftr;
    Bool        ret;

    if (gfs == NULL) {
        return NULL;
    }
    gftr = GFTR_Setup(&GFS_FILE_TRANS(gfs));
#if defined(DEBUG_LIB)
    if (dirrec != NULL) {
        /* \[Xobt@̐ݒ */
        if (IS_MEMFILE(GFS_DIR_ATR(dirrec))) {
            /* t@C̏ꍇ */
            GFMF_Setup(&GFS_FILE_FLOW(gfs), dirrec, fid);
            ret = TRUE;
        } else if (IS_SCSIFILE(GFS_DIR_ATR(dirrec))) {
            /* SCSIt@C̏ꍇ */
            ret = GFSF_Setup(&GFS_FILE_FLOW(gfs), dirrec, fid);
        } else {
            /* bct@C̏ꍇ   */
            ret = GFCF_Setup(&GFS_FILE_FLOW(gfs), dirrec, fid);
        }
    } else {
        /* CDubNt@CVXegp */
        ret = GFCF_Setup(&GFS_FILE_FLOW(gfs), dirrec, fid);
    }
#else
    ret = GFCF_Setup(&GFS_FILE_FLOW(gfs), dirrec, fid);
#endif /* defined(DEBUG_LIB) */
    if (ret == FALSE) {
        return NULL;
    }
    GFS_FILE_AMODE(gfs) = GFS_NWSTAT_NOACT; /* ANZX[h */
    GFS_FILE_ASTAT(gfs) = GFS_SVR_COMPLETED; /* tO */
    return gfs;
}


/*--- fBNgTu֐ -------------------------------------------------*/

/*****************************************************************************
 *  {[fBXNv^̓ǂݍ
 *ḿn
 *  buf         ǂݍݗ̈
 *món
 *  
 *m֐ln
 *  
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL Sint32 gfs_loadVol(Uint8 *buf)
{
    GfsDirId    dirrec;
    GfsHn       gfs;
    Sint32      ret;
    GfsErrStat  stat;
    static const Sint8 pvd_id[] = {1, 'C', 'D', '0', '0', '1'};

    GFS_DIR_FAD(&dirrec) = PVD_FAD + GFCD_GetBaseFad();
    /* {[fBXNv^t@CƂĊJ */
    GFS_DIR_SIZE(&dirrec) = PVD_BYTSIZ; /* TCYݒ */
    GFS_DIR_FN(&dirrec) = 0;
    GFS_DIR_ATR(&dirrec) = 0;
    GFS_DIR_UNIT(&dirrec) = 0;
    GFS_DIR_GAP(&dirrec) = 0;
    gfs = GFS_mngAllocGrp();
    gfs = GFS_OpenSub(gfs, &dirrec, 0);
    if (gfs == NULL) {
        return GFS_ERR_CDRD;
    }
    ret = GFS_Fread(gfs, PVD_SCTSIZ, buf, PVD_BYTSIZ);
    if (ret != PVD_BYTSIZ) {
        return GFS_ERR_CDRD;
    }
    GFS_GetErrStat(&stat);
    ret = GFS_ERR_CODE(&stat);
    if (ret == GFS_ERR_OK) {
        /* Kiʎq̃`FbN */
        if (memcmp(buf, pvd_id, sizeof(pvd_id))) {
            ret = GFS_ERR_CDROM;
        }
    }
    GFS_Close(gfs);
    return ret;
}


/*****************************************************************************
 *  [gfBNg擾
 *ḿn
 *  dir         [gfBNgi[̈
 *món
 *  Ȃ
 *m֐ln
 *  G[R[h
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL Sint32 gfs_getRootDir(GfsDirId *dir)
{
    Sint32      ret;
    Uint8       *rec;                   /* fBNgR[ḧ */
    Sint32      size;

    if (!MNG_CDCON(gfs_mng_ptr)) {
        return GFS_ERR_CDNODISC;
    }
    /* {[Lqqǂݍ */
    ret = gfs_loadVol(MNG_SECTBUF(gfs_mng_ptr));
    if (ret != GFS_ERR_OK) {
        return ret;
    }
    rec = MNG_SECTBUF(gfs_mng_ptr) + ROOT_RECPOS;
    memcpy(&GFS_DIR_FAD(dir), DIRREC_EXT(rec), sizeof(Sint32)); /* FADݒ */
    LSN_TO_FAD(GFS_DIR_FAD(dir));
    if (GFS_DIR_FAD(dir) < ROOT_FAD_LOW_LIM) {
        return GFS_ERR_CDROM;
    }
    /* TCY擾 */
    memcpy(&size, DIRREC_LEN(rec), sizeof(Sint32));
    if (size <= 0) {
        return GFS_ERR_CDROM;
    }
    /* fBNgt@C̏ꍇɂ͋IɃZN^Pʂɂ   */
    GFS_DIR_SIZE(dir) = (size + GFS_MD1_SCTSIZ - 1) / 
                                         GFS_MD1_SCTSIZ * GFS_MD1_SCTSIZ;
    GFS_DIR_FN(dir) = 0;
    GFS_DIR_ATR(dir) = GFS_ATR_DIR;
    GFS_DIR_UNIT(dir) = 0;
    GFS_DIR_GAP(dir) = 0;
    return GFS_ERR_OK;
}


/*****************************************************************************
 *  [gfBNgR[h̓ǂݍ
 *ḿn
 *  dirtbl      fBNgR[hݒ̈
 *món
 *  
 *m֐ln
 *  
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL Sint32 gfs_loadRootDir(GfsDirTbl *dirtbl)
{
    GfsHn       gfs;
    Sint32      ndir, ret;
    GfsDirId    dir;

    ret = gfs_getRootDir(&dir);
    if (ret != GFS_ERR_OK) {
        gfs = NULL;
    } else {
        gfs = GFS_mngAllocGrp();
        gfs = GFS_OpenSub(gfs, &dir, 0);
    }
    /* CDڑĂ̂ɃI[vłȂG[ */
    if (MNG_CDCON(gfs_mng_ptr)&&(gfs == NULL)) {
        return ret;
    }
    /* fBNgR[hǂݍ */
    ndir = GFDR_SetupDirTbl(gfs, dirtbl, GFS_DIR_SIZE(&dir));
    if (gfs != NULL) {
        GFS_Close(gfs);
    }
    return ndir;
}


/*--- t@CANZX -----------------------------------------------------*/

/*****************************************************************************
 *  f[^\[Xobt@ɗ
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  ǂݍݏ GFS_FIN_START, GFS_FIN_PAUSE, GFS_FIN_END
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL Sint32 gfs_flowIn(GfsHn gfs)
{
    Sint32      fstat;
    GfsFileFunc *func;
    GfsFlow     *flow;

    flow = &GFS_FILE_FLOW(gfs);
    /* IĂ牽Ȃ */
    if (GFS_FLW_STAT(flow) == GFS_FIN_END) {
        return GFS_FLW_STAT(flow);
    }

    /* t@CnhɎgĂȂƂmF */
    if ((MNG_PICKUP(gfs_mng_ptr) != NULL)&&(MNG_PICKUP(gfs_mng_ptr) != gfs)) {
        return GFS_FIN_PUINUSE;
    }
    /* ǂݍ݊֐̎s */
    func = &MNG_FUNCTBL(gfs_mng_ptr, GFS_DTS_FTYPE(&GFS_FLW_DTSRC(flow)));
    fstat = (FUNC_FLOWIN(func))(flow);
    if (fstat == GFS_FIN_START) {       /* ǂݍ݊Jnꍇ */
        MNG_PICKUP(gfs_mng_ptr) = gfs;
    } else if (fstat == GFS_FIN_END) {  /* SĂ̓ǂݍ݂Iꍇ */
        if (MNG_PICKUP(gfs_mng_ptr) == gfs) {
            MNG_PICKUP(gfs_mng_ptr) = NULL;
            MNG_SFAD(gfs_mng_ptr) = MNG_EFAD(gfs_mng_ptr) = 0;
        }
    }
    GFS_FLW_STAT(flow) = fstat;
    return gfs_convFinStat(gfs, fstat);
}


/*****************************************************************************
 *  [Üւ̃f[^̓]
 *ḿn
 *  gfs         t@Cnh
 *món
 *  Ȃ
 *m֐ln
 *  ]
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GFS_LOCAL Sint32 gfs_transData(GfsHn gfs)
{
    Sint32      stat, atr, room;
    Bool        flag;
    GfsTrans    *trn = &GFS_FILE_TRANS(gfs);

    /* ̃t@C]ׂ */
    if ((MNG_TRANS(gfs_mng_ptr) != gfs)&&(MNG_TRANS(gfs_mng_ptr) != NULL)) {
        return GFS_SVR_BUSY;
    }
    GFS_GetFileInfo(gfs, NULL, NULL, NULL, &atr);
    if (atr & GFS_ATR_CDDA) {
        return GFTR_ST_END;
    }
    room = GFTR_GetLenRoom(&GFS_FILE_TRANS(gfs));
    if (room == 0) {
        stat = GFTR_Idle(gfs);
    } else {
        stat = GFTR_Exec(gfs, &flag);
    }
    /* ]I */
    if (stat == GFTR_ST_END) {
        if (MNG_TRANS(gfs_mng_ptr) == gfs) {
            MNG_TRANS(gfs_mng_ptr) = NULL;
        }
    } else if (MNG_TRANS(gfs_mng_ptr) == NULL) {
        MNG_TRANS(gfs_mng_ptr) = gfs;
    }
    return stat;
}




/*****************************************************************************
 *  t[AhX擾
 *ḿn
 *  fid         t@Cʎq
 *  ofs         ItZbg
 *món
 *  Ȃ
 *m֐ln
 *  t[AhX
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
Sint32 GFS_GetFad(Sint32 fid, Sint32 ofs)
{
    GfsDirId    dir;
    Sint32      unit;
    Sint32      ret;

    ret = GFS_GetDirInfo(fid, &dir);
    if (ret < 0) {
        return (ret);
    }
    unit = GFS_DIR_UNIT(&dir);
    if (unit == 0) {
        return GFS_DIR_FAD(&dir) + ofs;
    } else {
        return GFS_DIR_FAD(&dir) + (ofs / unit * (unit + GFS_DIR_GAP(&dir)));
    }
}



/* ǂݍ݃ZN^ݒ */
GFS_LOCAL void gfs_SetSct(GfsFlow *flow, Sint32 sct)
{
    GfsDtsrc    *dtsrc = &GFS_FLW_DTSRC(flow);

    if (GFS_DTS_FTYPE(dtsrc) == CD_FILE) {
        GFCF_SetSct(flow, sct);
    } else {
        GFS_FLW_SCT(flow) = sct;
        GFS_FLW_SCTCNT(flow) = 0;
    }
    GFS_FLW_STAT(flow) = GFS_FIN_NOACT;
}


/*****************************************************************************
 *  t@C̎擾
 *ḿn
 *  finfo       t@C
 *món
 *  fid         t@Cʎq
 *  sctsiz      ZN^TCY
 *  nsct        ZN^
 *  lastsiz     ŏIZN^Lf[^
 *  fno         t@Cԍ
 *  atr         
 *m֐ln
 *  
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
void gfs_GetFinfo(GfsFinfo *finfo, Sint32 *fid, Sint32 *fad,
                         Sint32 *sctsiz, Sint32 *nsct, Sint32 *lastsiz,
                         Sint32 *fno, Sint32 *atr)
{
    if (fid != NULL) {
        *fid = GFS_FI_FID(finfo);
    }
    if (fad != NULL) {
        *fad = GFS_FI_FAD(finfo);
    }
    if (sctsiz != NULL) {
        *sctsiz = GFS_FI_SCTSZ(finfo);
    }
    if (nsct != NULL) {
        *nsct = GFS_FI_NSCT(finfo);
    }
    if (lastsiz != NULL) {
        *lastsiz = GFS_FI_SCTSZ(finfo) - GFS_FI_LSTRM(finfo);
    }
    if (fno != NULL) {
        *fno = GFS_FI_FN(finfo);
    }
    if (atr != NULL) {
        *atr = GFS_FI_ATR(finfo);
    }
}


/* t@CN[Y֐ */
GFS_LOCAL void gfs_closeSub(GfsHn gfs)
{
    GfsFlow     *flow;
    GfsDtsrc    *dts;

    if (gfs == NULL) {
        return;
    }
    flow = &GFS_FILE_FLOW(gfs);
    dts = &GFS_FLW_DTSRC(flow);
    gfs_svrRemoveHndl(gfs);             /* ANZXT[o폜 */
    gfs_mngFreeGrp(gfs);
#if defined(DEBUG_LIB)
    if (GFS_DTS_FTYPE(dts) == CD_FILE) {
#endif
        GFCB_Close(dts);
#if defined(DEBUG_LIB)
    } else if (GFS_DTS_FTYPE(dts) == SCSI_FILE) {
        /* SCSIt@C̃N[Y */
        GFSF_Close(dts);
    }
#endif
}    



/* o[h̎擾 */
GFS_LOCAL Sint32 gfs_getGmode(GfsHn gfs)
{
    GfsFlow     *flow = &GFS_FILE_FLOW(gfs);

    return GFS_FLW_GMODE(flow);
}


/* 𒲂ׂ */
GFS_LOCAL Bool gfs_isTaskDone(GfsHn gfs)
{
    Sint32      atr;
    GfsFlow     *flow = &GFS_FILE_FLOW(gfs);
    GfsTrans    *tran = &GFS_FILE_TRANS(gfs);

    GFS_GetFileInfo(gfs, NULL, NULL, NULL, &atr);
    if ((GFS_FLW_STAT(flow) == GFS_FIN_END)&&
        ((GFBF_GetNumData(gfs) == 0)||(atr & GFS_ATR_CDDA))) {
        return TRUE;
    }
    return FALSE;
}


/* flow in̏ԂG[R[hɕϊ */
GFS_LOCAL Sint32 gfs_convFinStat(GfsHn gfs, Sint32 fstat)
{
    switch (fstat) {
    case GFS_FIN_FATAL:
        GFS_FILE_ASTAT(gfs) = GFS_ERR_FATAL;
        return gfs_mngSetErrCode(GFS_ERR_FATAL);
    case GFS_FIN_ERROR:
        GFS_FILE_ASTAT(gfs) = GFS_ERR_CDRD;
        return gfs_mngSetErrCode(GFS_ERR_CDRD);
    case GFS_FIN_OPEN:
        GFS_FILE_ASTAT(gfs) = GFS_ERR_CDOPEN;
        return gfs_mngSetErrCode(GFS_ERR_CDOPEN);
    case GFS_FIN_NODISC:
        GFS_FILE_ASTAT(gfs) = GFS_ERR_CDNODISC;
        return gfs_mngSetErrCode(GFS_ERR_CDNODISC);
    case GFS_FIN_PUINUSE:
        GFS_FILE_ASTAT(gfs) = GFS_ERR_PUINUSE;
        return gfs_mngSetErrCode(GFS_ERR_PUINUSE);
    case GFS_FIN_PAUSE:
        /* 풓[hŃobt@tɂȂG[ */
        if (gfs_getGmode(gfs) == GFS_GMODE_RESIDENT) {
            GFS_FILE_ASTAT(gfs) = GFS_ERR_BFUL;
            return gfs_mngSetErrCode(GFS_ERR_BFUL);
        }
        break;
    default:
        GFS_FILE_ASTAT(gfs) = GFS_SVR_BUSY;
        break;
    }
    return GFS_ERR_OK;
}

/* end of file */
