/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library:t@CVXe
 * Module :CDobt@
 * File   :gfs_cdb.c
 * Date   :1996-02-01
 * Version:2.10
 * Author :H.T.
 *
 *****************************************************************************/
/* SGL̏ꍇRpCIvVɂ`邱
 * #define USE_SGL
 */

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include    "sega_gfs.h"
#include    "gfs_def.h"
#include    "gfs_cdf.h"
#include    "gfs_cdb.h"
#include    "gfs_cdc.h"
#include    "gfs_trn.h"


/*****************************************************************************
 *      萔}N
 *****************************************************************************/
#define BUF_TOP         0               /* bcobt@擪 */

/* [hĩtB^[h   */
#define FMODE_SELECT_FN         0x01    /* t@CԍI\ */
#define FMODE_SELECT_CN         0x02    /* `lԍI\ */
#define FMODE_SELECT_SM         0x04    /* Tu[hI\ */
#define FMODE_SELECT_CI         0x08    /* coding information I\ */
#define FMODE_REV_SUBH          0x10    /* Tuwb_𔽓] */
#define FMODE_SELECT_FRNG       0x40    /* t[AhX͈͗L */
#define FMODE_INIT_FMODE        0x80    /* i */

#define CDB_ADDR_DLT    0

#define GFCB_NOSEL      0               /* [hw肵Ȃ   */

/*****************************************************************************
 *      񋓒萔
 *****************************************************************************/

/*****************************************************************************
 *      }N
 *****************************************************************************/

/*****************************************************************************
 *      f[^^̒`
 *****************************************************************************/

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/

/*****************************************************************************
 *      ϐ̐錾
 *****************************************************************************/

/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/

/*****************************************************************************
 *  CDobt@Ǘ\̂̏
 *ḿn
 *  flow        ǂݍ݊Ǘ\
 *món
 *  Ȃ
 *m֐ln
 *  TRUE
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
Bool GFCB_Setup(GfsFlow *flow)
{
    GfsFinfo    *finfo = &GFS_FLW_FINFO(flow);
    GfsDtsrc    *dts = &GFS_FLW_DTSRC(flow);
    Sint32      bufno, fltno;
    CdcSubh     subh;

    GFS_DTS_FTYPE(dts) = CD_FILE;
    GFS_CDR_FMODE(dts) = FMODE_SELECT_FN;
    /* i胂[hݒ */
    CDC_SUBH_FN(&subh) = GFS_FI_FN(finfo);
    CDC_SUBH_CN(&subh) = GFCB_NOSEL;
    CDC_SUBH_SMMSK(&subh) = GFCB_NOSEL;
    CDC_SUBH_SMVAL(&subh) = GFCB_NOSEL;
    CDC_SUBH_CIMSK(&subh) = 0;
    CDC_SUBH_CIVAL(&subh) = 0;
    GFS_CDR_SUBH(dts) = subh;
    GFS_CDR_PUID(dts) = GFCD_UID_NONE;
    GFS_CDR_SCTPOS(dts) = 0;
    GFS_CDR_FILEPOS(dts) = 0;
    GFS_CDR_SFAD(dts) = GFS_CDR_EFAD(dts) = 0;
    /* CDobt@抄蓖 */
    if (GFCD_AllocBuf(&bufno) != GFCD_ERR_OK) {
        return FALSE;
    }
    GFS_CDR_BUFNO(dts) = bufno;
    /* i芄蓖 */
    if (GFCD_AllocFilt(&fltno) != GFCD_ERR_OK) {
        GFCD_FreeBuf(bufno);
        return FALSE;
    }
    GFS_CDR_FLT(dts) = fltno;
    if (GFCD_SetFilt(fltno, GFS_CDR_FMODE(dts), &subh, 0, 0) != GFCD_ERR_OK) {
        return FALSE;
    }
    /* i̐ڑݒ */
    if (GFCD_SetFiltCon(fltno, bufno, CDC_NUL_SEL) != GFCD_ERR_OK) {
        return FALSE;
    }
    if (GFCD_WaitServer() != GFCD_ERR_OK) {
        return FALSE;
    }
    if (GFCB_DeleteAllData(dts) != GFCD_ERR_OK) {
        return FALSE;
    }
    return TRUE;
}


/* gp̉ */
void GFCB_Close(GfsDtsrc *dts)
{
    GFCD_FreeBuf(GFS_CDR_BUFNO(dts));
    GFCD_FreeFilt(GFS_CDR_FLT(dts));
}


/*--- bcobt@ -------------------------------------------------*/


/*****************************************************************************
 *  CDobt@̗LZN^擾
 *ḿn
 *  flow        ǂݍ݊Ǘ̈
 *  usct        ]vZN^
 *món
 *  asiz        ]\oCg
 *m֐ln
 *  ]\ZN^
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
Sint32 GFCB_GetLenData(GfsFlow *flow, Sint32 usct, Sint32 *asiz)
{
    Sint32      ret, nsct;
    Sint32      sctsiz, fsct, lastsiz;
    GfsDtsrc    *dts = &GFS_FLW_DTSRC(flow);

    ret = GFCD_GetLenData(GFS_CDR_BUFNO(dts), GFS_CDR_SCTPOS(dts),
                          usct, &nsct, asiz);
    if (ret != GFCD_ERR_OK) {
        return 0;
    }
    if (GFCD_WaitServer() != GFCD_ERR_OK) {
        return 0;
    }
    if (asiz != NULL) {
        GFCF_GetFileInfo(flow,
                         NULL, NULL, &sctsiz, &fsct, &lastsiz, NULL, NULL);
        /* ŏIZN^܂ޏꍇ */
        if ((GFCB_Tell(dts) + nsct >= fsct)&&(lastsiz != 0)&&(nsct > 0)) {
            *asiz -= sctsiz - lastsiz;
        }
    }
    return nsct;
}


/* CDobt@̋󂫃oCg擾 */
Sint32 GFCB_GetLenRoom(GfsDtsrc *dts)
{
/*    return GFCB_GetSctRoom() * GFCF_MD1_SCTSIZ;*/
    return 0;                           /* ݂łȂ */
}


/* i̐ݒ */
void GFCB_SetFilt(GfsDtsrc *dts, Sint32 fmode, CdcSubh *subh)
{
    Sint32 ret;

    GFS_CDR_FMODE(dts) = fmode;
    GFS_CDR_SUBH(dts) = *subh;
    ret = GFCD_SetFilt(GFS_CDR_FLT(dts), fmode, subh, 0, 0);
    if (ret != GFCD_ERR_OK) {
        return;
    }
    GFCD_WaitServer();
}


/* CDobt@S */
Sint32 GFCB_DeleteAllData(GfsDtsrc *dts)
{
    GFCD_DelSctData(GFS_CDR_BUFNO(dts), BUF_TOP, CDC_SNUM_END);
    return GFCD_WaitServer();
}


/* ANZX|C^擾 */
Sint32 GFCB_Tell(GfsDtsrc *dts)
{
    return GFS_CDR_FILEPOS(dts) + GFS_CDR_SCTPOS(dts);
}
 
 
/* ZN^擾     */
Sint32  gfcb_getSctNum(GfsDtsrc *dts)
{
    Sint32  nsct;
    Sint32  ret;

    /* obt@ɂZN^݂̂擾 */
    ret = GFCD_GetLenData(GFS_CDR_BUFNO(dts), BUF_TOP, GFTB_BUF_END, &nsct,
                              NULL);
    if (ret != GFCD_ERR_OK) {
        return -1;
    }
    if (GFCD_WaitServer() != GFCD_ERR_OK) {
        return -1;
    }
    if (nsct < 0) {
        nsct = 0;
    }
    return nsct;
}


/*****************************************************************************
 *  ANZX|C^ݒ
 *ḿn
 *  cdb         bcobt@nh
 *  off         ItZbg
 *  org         ړ̊(GFS_SEEK_~)
 *món
 *  Ȃ
 *m֐ln
 *  ANZX|C^
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
Sint32 GFCB_Seek(GfsFlow *flow, Sint32 off, Sint32 org)
{
    Sint32      nsct;
    Sint32      ret;
    GfsDtsrc    *dts = &GFS_FLW_DTSRC(flow);

    if (off < 0) {
        off = 0;
    }
    if (org == GFS_SEEK_CUR) {
        nsct = off;
        off = GFCB_Tell(dts) + nsct;
    } else {
        if (GFCB_Tell(dts) == off) {
            return off;
        }
        nsct = gfcb_getSctNum(dts);
        if (nsct < 0) {
            return -1;
        }
    }
    if (GFS_FLW_GMODE(flow) == GFS_GMODE_ERASE) { /* 폜[h */
        /* 폜[hł̓ANZX|C^ÕZN^f[^͍폜 */
        /* obt@ɓǂݍݍς݂̈ʒuɈړꍇ */
        if ((GFS_CDR_FILEPOS(dts) <= off)&&(off < GFCB_Tell(dts))) {
            nsct = off - GFS_CDR_FILEPOS(dts);
        }
        if (nsct > 0) {
            /* obt@f[^ */
            GFCD_DelSctData(GFS_CDR_BUFNO(dts), BUF_TOP, nsct);
            if (GFCD_WaitServer() != GFCD_ERR_OK) {
                return -1;
            }
        }
        GFS_CDR_FILEPOS(dts) = off;             /* obt@擪ʒu */
        GFS_CDR_SCTPOS(dts) = 0;                /* ]ʒu */
    } else if (GFS_FLW_GMODE(flow) == GFS_GMODE_RESIDENT) {    /* 풓[h */
        /* GFS_SEEK_CUȐꍇAnsctݒ肳ĂȂ   */
        if (org == GFS_SEEK_CUR) {
            nsct = gfcb_getSctNum(dts);
            if (nsct < 0) {
                return -1;
            }
        }
        /* bcobt@ɓǂݍ܂ĂȂʒuɈړꍇ */
        /* 1.obt@f[^OɃV[N */
        /* 2.obt@f[^ŘAłȂiPZN^ȏシԂ󂭁j*/
        if ((off < GFS_CDR_FILEPOS(dts)) ||
            (off > (GFS_CDR_FILEPOS(dts) + nsct + 1))) {
            /* bcobt@NA */
            if (GFCB_DeleteAllData(dts) != GFCD_ERR_OK) {
                return -1;
            }
            GFS_CDR_FILEPOS(dts) = off;
        }
        GFS_CDR_SCTPOS(dts) = off - GFS_CDR_FILEPOS(dts);
    }
    return GFCB_Tell(dts);
}
 
 

/*--- f[^] -----------------------------------------------------*/

/*****************************************************************************
 *  ]f[^pbN擾
 *ḿn
 *  flow
 *  nsct        ]vZN^
 *món
 *  Ȃ
 *m֐ln
 *  f[^pbNnh
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
GfdpHn GFCB_GetSrcPack(GfsFlow *flow, Sint32 usct)
{
    Sint32      len, ret, nsct;
    Sint32      sctsiz, fsct, lastsiz;
    GfsDtsrc    *dts = &GFS_FLW_DTSRC(flow);
    GfdpHn      dpk = &MNG_SRCPK(gfs_mng_ptr);

    /* gp̏ꍇ */
    if (GFDP_USE(dpk)) {
        return NULL;
    }

    /* ]TCY߂ */
    if (GFCD_GetLenData(GFS_CDR_BUFNO(dts), GFS_CDR_SCTPOS(dts),
                        usct, &nsct, &len) != GFCD_ERR_OK) {
        return NULL;
    }
    if (GFCD_WaitServer() != GFCD_ERR_OK) {
        return NULL;
    }
    if (len <= 0) {
        return NULL;
    }
    GFCF_GetFileInfo(flow, 
                     NULL, NULL, &sctsiz, &fsct, &lastsiz, NULL, NULL);
    /* ŏIZN^܂ޏꍇ */
    if ((GFCB_Tell(dts) + nsct >= fsct)&&(lastsiz != 0)&&(nsct > 0)) {
        len -= sctsiz - lastsiz;
    }
    GFDP_DATA(dpk) = CDC_GetDataPtr();  /* ]AhX     */
    GFDP_ADLT(dpk) = CDB_ADDR_DLT;      /* AhXZ   */
    GFDP_LEN(dpk) = len;                /* ]oCg     */
    GFDP_NSCT(dpk) = nsct;              /* ]ZN^     */
    GFDP_USE(dpk) = TRUE;               /* f[^pbNgp   */
    return dpk;
}


/* f[^pbN擾̃f[^v */
Bool GFCB_GetSctData(GfdpHn dpk, GfsDtsrc *dts)
{
    Sint32 ret;

    ret = GFCD_ReqData(GFS_CDR_BUFNO(dts), GFS_CDR_SCTPOS(dts),
                       GFDP_NSCT(dpk));
    if (ret != GFCD_ERR_OK) {
        return FALSE;
    }
    if (GFCD_WaitServer() != GFCD_ERR_OK) {
        return FALSE;
    }
    return TRUE;
}


/* ]f[^pbN擾 */
GfdpHn GFCB_GetDstPack(GfsDtsrc *dts, Sint32 len)
{
    return NULL;
}


/*  f[^pbNԊ */
void GFCB_RtnPk(GfsFlow *flow, GfdpHn dpk, Sint32 nsct)
{
    Sint32      txw;
    Sint32      seekpos;
    GfsDtsrc    *dts = &GFS_FLW_DTSRC(flow);

    GFCD_EndData(&txw);
    /* ]IĂ̂,ANZX|C^i߂  */
    if (nsct == GFTR_ALLSCT) {
        nsct = GFDP_NSCT(dpk);
    }
    GFCB_Seek(flow, nsct, GFS_SEEK_CUR);
    /* f[^pbNԊ */
    GFDP_USE(dpk) = FALSE;              /* f[^pbNgp */
}


/* sbNAbv̈ړ */
Sint32 GFCB_MovePickup(GfsDtsrc *dts, CdcPos *pos)
{
    return GFCD_MovePickup(pos, GFS_CDR_PUID(dts));
}


/* CDfoCXڑ */
Bool GFCB_SetCon(GfsDtsrc *dts)
{
    Sint32 ec;

    ec = GFCD_SetCon(GFS_CDR_FLT(dts), GFS_CDR_PUID(dts));
    if (ec != GFCD_ERR_OK) {
        return FALSE;
    }
    ec = GFCD_WaitServer();
    if (ec != GFCD_ERR_OK) {
        return FALSE;
    }
    return TRUE;
}


/* sbNAbv̐䌠mۂ */
Bool GFCB_GetPickup(GfsDtsrc *dts)
{
    Sint32      puid = GFCD_GetPickup();
    
    if (puid < GFCD_ERR_OK) {
        return FALSE;
    }
    GFS_CDR_PUID(dts) = puid;
    return TRUE;
}


/* sbNAbvmۂĂ邩ׂ */
Bool GFCB_IsPuOwner(GfsDtsrc *dts)
{
    return GFCD_IsPuOwner(GFS_CDR_PUID(dts));
}


/* sbNAbv */
void GFCB_UngetPickup(GfsDtsrc *dts)
{
    GFCD_UngetPickup(GFS_CDR_PUID(dts));
}

/* end of file */
