/******************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library:t@CVXe
 * Module :fBNg샂W[wb_
 * File   :gfs_dir.h
 * Date   :1996-02-01
 * Version:2.10
 * Author :H.T.
 *
 *****************************************************************************/

#if !defined(GFS_DIR_H)
#define     GFS_DIR_H

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
/*  */
#define GFS_ATR_FTYPE_MASK      0x06    /* t@Cʎ擾}XN */
#define GFS_ATR_CD_FILE         0x00    /* CD̃t@C */
#define GFS_ATR_MEM_FILE        0x04    /* t@C */
#define GFS_ATR_SCSI_FILE       0x02    /* SCSĨt@C */

/*****************************************************************************
 *      񋓒萔
 *****************************************************************************/

/*****************************************************************************
 *      }N
 *****************************************************************************/

/* CDt@C̔ */
#define IS_CDFILE(atr)  \
    ((((atr) & GFS_ATR_FTYPE_MASK) == GFS_ATR_CD_FILE)? TRUE: FALSE)

/* t@C̔ */
#define IS_MEMFILE(atr)    \
    ((((atr) & GFS_ATR_FTYPE_MASK) == GFS_ATR_MEM_FILE)? TRUE: FALSE)

/* SCSIt@C̔ */
#define IS_SCSIFILE(atr)        \
    ((((atr) & GFS_ATR_FTYPE_MASK) == GFS_ATR_SCSI_FILE)? TRUE: FALSE)


/*****************************************************************************
 *      f[^^̒`
 *****************************************************************************/

/*****************************************************************************
 *      ϐ̐錾
 *****************************************************************************/

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/

/* fBNge[uǂݍ */
Sint32 GFDR_SetupDirTbl(GfsHn gfs, GfsDirTbl *dirtbl, Sint32 nsct);

/* t@Ct@Cʎq擾 */
Sint32 GFDR_NameToId(GfsDirName *rectbl, Sint8 *fname, Sint32 max);

/* fBNgR[he[ȕ擾 */
GfsDirId *GFDR_GetInfoDirId(Sint32 fid, GfsDirId *rectbl);

/* fBNgR[he[ȕ擾 */
GfsDirName *GFDR_GetInfoDirName(Sint32 fid, GfsDirName *rectbl);

/* t@C̑擾 */
Sint32 GFDR_GetAtrDirId(Sint32 fid, GfsDirId *rectbl);

/* t@C擾 */
Sint32 GFDR_GetAtrDirName(Sint32 fid, GfsDirName *rectbl);

/* CDBFSŃ[gfBNgɈړ */
Sint32 GFDR_ChgRoot(void);

/* CDBFSŃJgfBNgύX */
Sint32 GFDR_ChgDir(Sint32 fid);

#endif /* !defined(GFS_DIR_H) */

/* end of file */
