/******************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library:t@CVXe
 * Module :]W[wb_
 * File   :gfs_trn.h
 * Date   :1996-02-01
 * Version:2.10
 * Author :H.T.
 *
 *************************************************************************** */

#if !defined(GFS_TRN_H)
#define GFS_TRN_H

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
/* RtnPk̈ */
#define GFTR_ALLSCT     -1      /* GetSrcPackŗvZN^APi߂ */

#define GFTR_NULLFUNC   ((GfsTransFunc)0)

/*****************************************************************************
 *      񋓒萔
 *****************************************************************************/
/* GFTR_Exec ̏ */
enum {
    GFTR_ST_NOACT = 0,                  /* ~     */
    GFTR_ST_STAT1,                      /* 1        */
    GFTR_ST_STAT2,                      /* 2        */
    GFTR_ST_STAT3,                      /* 3        */
    GFTR_ST_STAT4,                      /* 4        */
    GFTR_ST_STAT5,                      /* 5        */
    GFTR_ST_END,                        /* ]I */
    GFTR_ST_ERROR                       /* G[ */
    };


/*****************************************************************************
 *      ϐ̐錾
 *****************************************************************************/

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/
/* ]T[o   */
Sint32 GFTR_ExecSvr(GfsHn gfs, Bool *flag);

/* ]̐ݒ  */
GftrHn  GFTR_Setup(GfsTrans *gftr);

/* ][h̐ݒ */
Sint32 GFTR_SetMode(GftrHn gftr, Sint32 tmode);

/* ]Pʂ̐ݒ */
void GFTR_SetUnit(GftrHn gftr, Sint32 unit);

/* ]ZN^̐ݒ */
void GFTR_SetTransPara(GftrHn gftr, Sint32 tsct);

/* S]ZN^̎擾 */
Sint32 GFTR_GetTransPara(GftrHn gftr);

/* ݂܂łɓ]ꂽZN^̎擾 */
Sint32 GFTR_GetNumTrans(GftrHn gftr);

/* P̓]ɂő]ZN^̐ݒ */
Sint32 GFTR_SetTransMax(GftrHn gftr, Sint32 tmax);

/* ]Jn */
void GFTR_Start(GftrHn gftr);

/* ]ꎞ~ */
void GFTR_Pause(GftrHn gftr);

/* ]~ */
void GFTR_Stop(GfsHn gfs, Sint32 nsct);

/* ]̎s */
Sint32 GFTR_Exec(GfsHn gfs, Bool *flag);

/* zXgobt@t̋󑗂] */
Sint32 GFTR_Idle(GfsHn gfs);

/* ]oCgԂ */
Sint32 GFTR_GetLenData(GfsTrans *trn);

/* obt@̋󂫗eʂ߂ */
Sint32 GFTR_GetLenRoom(GfsTrans *trn);

/* ]f[^pbN̎擾 */
GfdpHn GFTR_GetDstPack(GfsTrans *trn, Sint32 len);

/* ]f[^pbNԊ */
void GFTR_RtnDstPk(GfsTrans *trn, GfdpHn dpk);

/* ]̈擾 */
void GFTR_GetData(GfsTrans *trn, Uint8 **data, Sint32 *bsize, Sint32 *unit);

/* f[^̈̐ݒ */
void GFTR_SetData(GfsTrans *trn, Uint8 *data, Sint32 bsize, Sint32 unit);

/* [U]֐̓o^ */
void GFTR_SetTransFunc(GfsHn gfs, GfsTransFunc func, void *obj);

#endif      /* !defined(GFS_TRN_H) */

/* end of file */
