/*-----------------------------------------------------------------------------
 *  FILE: sega_per.h
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      VXe^ytFCugpwb_t@CB
 *
 *  DESCRIPTION:
 *
 *      VXe^ytFCugpvOɃCN[h
 *      B
 *
 *  AUTHOR(S)
 *
 *      1994-05-19  N.T Ver.0.90
 *
 *  MOD HISTORY:
 *      1994-08-26  N.T Ver.1.02
 *      1994-11-25  N.T Ver.1.05
 *
 *-----------------------------------------------------------------------------
 */

#ifndef SEGA_PER_H
#define SEGA_PER_H

/********************************* per_xpt.h *********************************/
/*
 * GLOBAL DEFINES/MACROS DEFINES
 */
/**** WX^AhX *******************************************************/
#ifndef _DEB2
#define PER_REG_COMREG  ((volatile Uint8 *)0x2010001f)   /* R}hWX^          */
#define PER_REG_SR      ((volatile Uint8 *)0x20100061)   /* Xe[^XWX^        */
#define PER_REG_SF      ((volatile Uint8 *)0x20100063)   /* Xe[^XtO          */
#define PER_REG_IREG    ((volatile Uint8 *)0x20100001)   /* IREG                      */
#define PER_REG_OREG    ((volatile Uint8 *)0x20100021)   /* OREG                      */
#else
#define PER_REG_COMREG  ((volatile Uint8 *)0x0603001f)   /* R}hWX^          */
#define PER_REG_SR      ((volatile Uint8 *)0x06030061)   /* Xe[^XWX^        */
#define PER_REG_SF      ((volatile Uint8 *)0x06030063)   /* Xe[^XtO          */
#define PER_REG_IREG    ((volatile Uint8 *)0x06030001)   /* IREG                      */
#define PER_REG_OREG    ((volatile Uint8 *)0x06030021)   /* OREG                      */
#endif

/**** rbgʒu *************************************************************/
#define PER_B_SF        0x1                     /* Xe[^XtO          */

/**** ֐`}N *********************************************************/
#define PER_PokeByte(address,data)  (*(volatile Uint8 *)(address) = (Uint8)(data))
                                                    /* ޲ްڽڏ-*/
                                                    /*                   */
#define PER_PeekByte(address)   (*(volatile Uint8 *)(address))
                                                    /* ޲ްڽړǂ-*/
                                                    /*                   */

/*
 * TYPEDEFS
 */

/********************************* per_prt.h *********************************/
/*
 * GLOBAL DEFINES/MACROS DEFINES
 */
/* }`^bvID */
#define PER_MID_NCON_ONE    0xf0                /* ڑ or             */

/* }`^bvRlN^ */
#define PER_MCON_NCON_UNKNOWN   0x00            /* ڑ or UNKNOW          */

/* ytFID */
#define PER_ID_NCON_UNKNOWN 0xf0                /* ڑ or SMPC UNKNOWN    */
#define PER_ID_DGT      0x00                    /* fW^foCX          */
#define PER_ID_ANL      0x10                    /* AiOfoCX          */
#define PER_ID_PNT      0x20                    /* |CeBOfoCX    */
#define PER_ID_KBD      0x30                    /* L[{[h@@@          */
#define PER_ID_MD       0xe0                    /* KhCu              */

/* ytFTCY */
#define PER_SIZE_NCON_15    0x0f                /* ڑ or 15oCgfoCX*/
#define PER_SIZE_DGT    2                       /* fW^foCX          */
#define PER_SIZE_ANL    5                       /* AiOfoCX          */
#define PER_SIZE_PNT    3                       /* |CeBOfoCX    */
#define PER_SIZE_KBD    4                       /* L[{[h@@@          */
#define PER_SIZE_M3BP   1                       /* KhCu3{^pbh */
#define PER_SIZE_M6BP   2                       /* KhCu6{^pbh */

/* CgobN */
#define PER_KD_SYS      0                       /* VXef[^擾        */
#define PER_KD_PER      1                       /* ytFf[^擾    */
#define PER_KD_PERTIM   2                       /* ytFf[^擾{  */
                                                /* f[^擾            */
/* rbgʒu ****************************************************************/
/* fW^foCXf[^^	 */
#define	PER_LDGT_R   (1 <<  7)                  /* RIGHT                     */
#define	PER_LDGT_L   (1 <<  6)                  /* LEFT                      */
#define	PER_LDGT_D   (1 <<  5)                  /* DOWN                      */
#define	PER_LDGT_U   (1 <<  4)                  /* UP                        */
#define	PER_LDGT_S   (1 <<  3)                  /* START                     */
#define	PER_LDGT_A   (1 <<  2)                  /* A                         */
#define	PER_LDGT_C   (1 <<  1)                  /* C                         */
#define	PER_LDGT_B   (1 <<  0)                  /* B                         */
#define	PER_LDGT_TR  (1 <<  7)                  /* gK RIGHT              */
#define	PER_LDGT_X   (1 <<  6)                  /* X                         */
#define	PER_LDGT_Y   (1 <<  5)                  /* Y                         */
#define	PER_LDGT_Z   (1 <<  4)                  /* Z                         */
#define	PER_LDGT_TL  (1 <<  3)                  /* gK LEFT               */
/* |CeBOfoCXf[^^ */
/***** f[^ */
#define PER_LPNT_YO  (1 << 7)                   /* YI[ot[           */
#define PER_LPNT_XO  (1 << 6)                   /* XI[ot[           */
#define PER_LPNT_YS  (1 << 5)                   /* Y                   */
#define PER_LPNT_XS  (1 << 4)                   /* X                   */
#define PER_LPNT_CNT (1 << 3)                   /* CENTER                    */
#define PER_LPNT_MID (1 << 2)                   /* MIDDLE                    */
#define PER_LPNT_R   (1 << 1)                   /* RIGHT                     */
#define PER_LPNT_L   (1 << 0)                   /* LEFT                      */

/* L[{[hfoCXf[^^ */
/***** L[ */
#define PER_LKBD_CL  (1 << 6)                   /* Caps Lock                 */
#define PER_LKBD_NL  (1 << 5)                   /* Num Lock                  */
#define PER_LKBD_SL  (1 << 4)                   /* Scrool Lock               */
#define PER_LKBD_MK  (1 << 3)                   /* Make                      */
#define PER_LKBD_BR  (1 << 0)                   /* Break                     */

/* KhCu3{^pbhf[^^ */
#define	PER_LM3BP_R  PER_LDGT_R                 /* RIGHT                     */
#define	PER_LM3BP_L  PER_LDGT_L                 /* LEFT                      */
#define	PER_LM3BP_D  PER_LDGT_D                 /* DOWN                      */
#define	PER_LM3BP_U  PER_LDGT_U                 /* UP                        */
#define	PER_LM3BP_S  PER_LDGT_S                 /* START                     */
#define	PER_LM3BP_A  PER_LDGT_A                 /* A                         */
#define	PER_LM3BP_C  PER_LDGT_C                 /* C                         */
#define	PER_LM3BP_B  PER_LDGT_B                 /* B                         */

/* KhCu6{^pbhf[^^ */
#define	PER_LM6BP_R  PER_LDGT_R                 /* RIGHT                     */
#define	PER_LM6BP_L  PER_LDGT_L                 /* LEFT                      */
#define	PER_LM6BP_D  PER_LDGT_D                 /* DOWN                      */
#define	PER_LM6BP_U  PER_LDGT_U                 /* UP                        */
#define	PER_LM6BP_S  PER_LDGT_S                 /* START                     */
#define	PER_LM6BP_A  PER_LDGT_A                 /* A                         */
#define	PER_LM6BP_C  PER_LDGT_C                 /* C                         */
#define	PER_LM6BP_B  PER_LDGT_B                 /* B                         */
#define	PER_LM6BP_MD PER_LDGT_TR                /* MODE                      */
#define	PER_LM6BP_X  PER_LDGT_X                 /* X                         */
#define	PER_LM6BP_Y  PER_LDGT_Y                 /* Y                         */
#define	PER_LM6BP_Z  PER_LDGT_Z                 /* Z                         */

/* VXef[^o */
/* VXeXe[^X */
#define PER_SS_DOTSEL   (1 <<  6)               /* J[gbWR[h        */
#define PER_SS_SYSRES   (1 <<  1)               /* GAR[h              */
#define PER_SS_MSHNMI   (1 <<  3)               /* VXeXe[^X        */
#define PER_SS_SNDRES   (1 <<  0)               /* SMPC                */
#define PER_SS_CDRES    (1 << 14)               /* SMPCXe[^X            */

/* SMPC */
/***** }XN */
#define PER_MSK_LANGU   (0xf << 0)              /* }XN                */
#define PER_MSK_SE      (0x1 << 8)              /* SE                        */
#define PER_MSK_STEREO  (0x1 << 9)              /* STEREO or MONO            */
#define PER_MSK_HELP    (0x1 << 10)             /* HELP                      */
/*****  */
#define PER_ENGLISH     0x0                     /* English(p)             */
#define PER_DEUTSCH     0x1                     /* Deutsch(hCc)         */
#define PER_FRANCAIS    0x2                     /* francais(tX)      */
#define PER_ESPNOL      0x3                     /* Espnol(XyC)        */
#define PER_ITALIANO    0x4                     /* Italiano(C^A)      */
#define PER_JAPAN       0x5                     /* Japan({)             */

/* SMPCXe[^X */
#define PER_SS_RESET    (1 <<  6)               /* Zbg}XN        */
#define PER_SS_SETTIM   (1 <<  7)               /* ݒ              */

/* VXef[^o */
#define PER_GS_CC(data)         ((data)->cc)    /* J[gbWR[h        */
#define PER_GS_AC(data)         ((data)->ac)    /* GAR[h              */
#define PER_GS_SS(data)         ((data)->ss)    /* VXeXe[^X        */
#define PER_GS_SM(data)         ((data)->sm)    /* SMPC                */
#define PER_GS_SMPC_STAT(data)  ((data)->stat)  /* SMPCXe[^X            */

/* 萔 **********************************************************************/
#define PER_HOT_RES_ON  0x1                     /* zbgZbgON          */
#define PER_HOT_RES_OFF 0x0                     /* zbgZbgOFF         */

/* CgobNs      */
#define PER_INT_OK      0x0                     /*                       */
#define PER_INT_ERR     0x1                     /* G[                    */

/******************************************************************************
 *
 * NAME:    PER_GET_TIM             -   擾
 *
 ******************************************************************************
 */
#define PER_GET_TIM()  (per_get_time_adr)

/******************************************************************************
 *
 * NAME:    PER_GET_SYS             -   VXef[^擾
 *
 ******************************************************************************
 */
#define PER_GET_SYS()   ((per_set_sys_flg == OFF) ? NULL : &per_get_sys_data)


#ifndef _PER_HOT_ENA
/******************************************************************************
 *
 * NAME:    PER_GET_HOT_RES         -   zbgZbg擾
 *
 ******************************************************************************
 */
#define PER_GET_HOT_RES()  (per_hot_res)
#endif  /* _PER_HOT_ENA */

/*
 * TYPEDEFS
 */
typedef Uint8   PerId;                  /* ytFID                    */
typedef Uint8   PerSize;                /* ytFTCY                */
typedef Uint8   PerKind;                        /* CgobN          */
typedef Uint16  PerNum;                         /* KvytF        */
typedef Uint8   PerMulId;               /* }`^bvID                    */
typedef Uint8   PerMulCon;              /* }`^bvRlN^            */

typedef struct  {
    PerMulId    id;
    PerMulCon   con;
}PerMulInfo;                                    /* }`^bv          */

typedef struct  {                               /* VXeo              */
    Uint8   cc;                                 /* J[gbWR[h        */
    Uint8   ac;                                 /* GAR[h              */
    Uint16  ss;                                 /* VXeXe[^X        */
    Uint32  sm;                                 /* SMPC                */
    Uint8   stat;                               /* SMPCXe[^X            */
}PerGetSys;

typedef void PerGetPer;                         /* ytFf[^o    */

/*
 * EXTERNAL VARIABLE DECLARATIONS
 */
#ifndef _PER_HOT_ENA
extern Uint8 per_hot_res;                       /* zbgZbg        */
#endif  /* _PER_HOT_ENA */
extern Uint8 *per_get_time_adr;                 /* f[^擾擪AhX*/
extern PerGetSys per_get_sys_data;              /* VXef[^擾i[    */
#ifdef __GNUC__
extern volatile Uint8 per_set_sys_flg;          /* VXef[^ݒtO  */
#else
extern Uint8 per_set_sys_flg;                   /* VXef[^ݒtO  */
#endif
extern Uint8 per_time_out_flg;                  /* ^CAEgtO        */

/*
 * EXTERNAL FUNCTION PROTOTYPE  DECLARATIONS
 */
Uint32 PER_LInit(PerKind, PerNum, PerSize, Uint8 *, Uint8);
                                                /* CgobN        */
Uint32 PER_LGetPer(PerGetPer **, PerMulInfo **);/* ytFf[^擾    */
PerGetSys PER_GetSys(void);                     /* VXef[^擾        */
void PER_IntFunc(void);                         /* SMPC荞ݏ          */
/********************************* per_smp.h *********************************/
/*
 * GLOBAL DEFINESMACROS DEFINES
 */

/**** R}h ***************************************************************/
#define PER_SM_MSHON    0x00                    /* }X^SH ON               */
#define PER_SM_SSHON    0x02                    /* X[uSH ON             */
#define PER_SM_SSHOFF   0x03                    /* X[uSH OFF            */
#define PER_SM_SNDON    0x06                    /* TEhON                */
#define PER_SM_SNDOFF   0x07                    /* TEhOFF               */
#define PER_SM_CDON     0x08                    /* CD ON                     */
#define PER_SM_CDOFF    0x09                    /* CD OFF                    */
#define PER_SM_SYSRES   0x0d                    /* VXeS̃Zbg      */
#define PER_SM_NMIREQ   0x18                    /* NMINGXg             */
#define PER_SM_RESENA   0x19                    /* zbgZbgCl[u  */
#define PER_SM_RESDIS   0x1a                    /* zbgZbgfBZ[u*/
#define PER_SM_SETSM    0x17                    /* SMPCݒ            */
#define PER_SM_SETTIM   0x16                    /* ݒ                  */

/*****************************************************************************/
/*****************************************************************************/
/**** ᐅ}N ***********************************************************/
/*****************************************************************************/
/*****************************************************************************/

/******************************************************************************
 *
 * NAME:    PER_SMPC_WAIT() - SMPC҂ԏ
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      SMPC𐳂s邽߂́A҂ԂB
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      PER_SMPC_SET_IREG(),PER_SMPCCmdGo()̑OɕKs邱ƁB
 *
 ******************************************************************************
 */

#define PER_SMPC_WAIT()                        /* SMPC҂ԏ         */\
            do{                                                               \
                while((PER_PeekByte(PER_REG_SF) & PER_B_SF) == PER_B_SF);\
                                                /* SF"1"̊ԌJԂ      */\
                PER_PokeByte(PER_REG_SF, PER_B_SF);\
                                                /* SF<-"1"                  */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_GO_CMD() - SMPCR}hs
 *
 * PARAMETERS :
 *      (1) Uint8   smpc_cmd    - <i>   SMPC}N
 *
 * DESCRIPTION:
 *      擾SMPC}NSMPCCOMREGiR}hWX^jփZbgB
 *  iZbg邱ƂɂASMPCn[hCOMREGɏꂽR}hsj
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

#define PER_SMPC_GO_CMD(smpc_cmd)                 /* SMPCR}hs         */\
            do{                                                               \
             PER_PokeByte(PER_REG_COMREG, smpc_cmd);/* COMREGɃR}hWRITE*/\
             while(PER_PeekByte(PER_REG_SF) & PER_B_SF);\
                                                    /* SF"1"łȂȂ܂*/\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_STATS_GET()  - SMPCXe[^X擾
 *
 * PARAMETERS :
 *      (1) Uint8   stats_reg   - <o>   R}hsXe[^X
 *
 * DESCRIPTION:
 *      R}hs̃Xe[^X擾
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

#define PER_SMPC_STATS_GET(stats_reg)           /* SMPCXe[^X擾       */\
            do{                                                               \
                (stats_reg) = PER_PeekByte(PER_SR);                           \
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_SET_IREG()   - SMPC IREGZbg
 *
 * PARAMETERS :
 *      (1) Uint32  ireg_no     - <o>   IREGԍ
 *      (2) Uint8   ireg_prm    - <i>   IREGZbgl
 *
 * DESCRIPTION:
 *      w肳ꂽIREGԍAhXIREGlZbgB
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

#define PER_SMPC_SET_IREG(ireg_no, ireg_prm)    /* SMPC IREGZbg          */\
            do{                                                               \
                PER_PokeByte((PER_REG_IREG + ((ireg_no) * 2)), (ireg_prm));   \
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_NO_IREG()    - IREGݒ薳R}hs
 *
 ******************************************************************************
 */

#define PER_SMPC_NO_IREG(com)\
            do{                                                               \
                PER_SMPC_WAIT();                /* SMPC҂ԏ         */\
                PER_SMPC_GO_CMD(com);           /* SMPCR}hs         */\
            }while(FALSE)

/*****************************************************************************/
/*****************************************************************************/
/**** }N ***********************************************************/
/*****************************************************************************/
/*****************************************************************************/

/******************************************************************************
 *
 * NAME:    PER_SMPC_MSH_ON()     - }X^SH ON
 *
 ******************************************************************************
 */

#define PER_SMPC_MSH_ON()\
            do{                                                               \
              PER_SMPC_NO_IREG(PER_SM_MSHON);   /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_SSH_ON()     - X[uSH ON
 *
 ******************************************************************************
 */

#define PER_SMPC_SSH_ON()\
            do{                                                               \
              PER_SMPC_NO_IREG(PER_SM_SSHON);   /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_SSH_OFF()    - X[uSH OFF
 *
 ******************************************************************************
 */

#define PER_SMPC_SSH_OFF()\
            do{                                                               \
              PER_SMPC_NO_IREG(PER_SM_SSHOFF);  /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_SND_ON()     - TEhON
 *
 ******************************************************************************
 */

#define PER_SMPC_SND_ON()\
            do{                                                               \
                PER_SMPC_NO_IREG(PER_SM_SNDON);   /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_SND_OFF()    - TEhOFF
 *
 ******************************************************************************
 */

#define PER_SMPC_SND_OFF()\
            do{                                                               \
                PER_SMPC_NO_IREG(PER_SM_SNDOFF);  /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_CD_ON()      - CD ON
 *
 ******************************************************************************
 */

#define PER_SMPC_CD_ON()\
            do{                                                               \
                PER_SMPC_NO_IREG(PER_SM_CDON);    /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_CD_OFF()     - CD OFF
 *
 ******************************************************************************
 */

#define PER_SMPC_CD_OFF()\
            do{                                                               \
                PER_SMPC_NO_IREG(PER_SM_CDOFF);   /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_SYS_RES()    - VXeS̃Zbg
 *
 ******************************************************************************
 */

#define PER_SMPC_SYS_RES()\
            do{                                                               \
                PER_SMPC_NO_IREG(PER_SM_SYSRES);  /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_NMI_REQ()    - NMINGXg
 *
 ******************************************************************************
 */

#define PER_SMPC_NMI_REQ()\
            do{                                                               \
                PER_SMPC_NO_IREG(PER_SM_NMIREQ);  /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_RES_ENA()    - zbgZbgCl[u
 *
 ******************************************************************************
 */

#define PER_SMPC_RES_ENA()\
            do{                                                               \
                PER_SMPC_NO_IREG(PER_SM_RESENA);  /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_RES_DIS()    - zbgZbgfBZ[u
 *
 ******************************************************************************
 */

#define PER_SMPC_RES_DIS()\
            do{                                                               \
                PER_SMPC_NO_IREG(PER_SM_RESDIS);  /* IREGݒ薳R}hs */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_SET_SM()     - SMPCݒ
 *
 ******************************************************************************
 */

#define PER_SMPC_SET_SM(ireg)\
            do{                                                               \
                PER_SMPC_WAIT();                 /* SMPC҂ԏ         */\
                PER_SMPC_SET_IREG(0, (ireg) >> 24); /* IREG0Zbg          */\
                PER_SMPC_SET_IREG(1, (ireg) >> 16); /* IREG0Zbg          */\
                PER_SMPC_SET_IREG(2, (ireg) >>  8); /* IREG0Zbg          */\
                PER_SMPC_SET_IREG(3, (ireg) >>  0); /* IREG0Zbg          */\
                PER_SMPC_GO_CMD(PER_SM_SETSM);    /* SMPCR}hs         */\
            }while(FALSE)

/******************************************************************************
 *
 * NAME:    PER_SMPC_SET_TIM()    - ݒ
 *
 ******************************************************************************
 */

#define PER_SMPC_SET_TIM(ireg)\
            do{                                                               \
                PER_SMPC_WAIT();                 /* SMPC҂ԏ         */\
                PER_SMPC_SET_IREG(6, *(ireg));    /* IREG6Zbg              */\
                PER_SMPC_SET_IREG(5, *((ireg) + 1));/* IREG5Zbg              */\
                PER_SMPC_SET_IREG(4, *((ireg) + 2));/* IREG4Zbg              */\
                PER_SMPC_SET_IREG(3, *((ireg) + 3));/* IREG3Zbg              */\
                PER_SMPC_SET_IREG(2, *((ireg) + 4));/* IREG2Zbg              */\
                PER_SMPC_SET_IREG(1, *((ireg) + 5));/* IREG1Zbg              */\
                PER_SMPC_SET_IREG(0, *((ireg) + 6));/* IREG0Zbg              */\
                PER_SMPC_GO_CMD(PER_SM_SETTIM);   /* SMPCR}hs         */\
            }while(FALSE)

/*
 * STRUCTURE DECLARATIONS
 */

/*
 * TYPEDEFS
 */

/*
 * EXTERNAL VARIABLE DECLARATIONS
 */

/*
 * EXTERNAL FUNCTION PROTOTYPE  DECLARATIONS
 */

/********************************* persprt.h *********************************/
#if 0
    ȉ DISK Version 1994-11-11̒ǉ
    
    VXe^ytFCugpTvvOւ̑Ώ
        VXe^ytFCugpĂeCu
        TvvÔ߂ɍ̃VXe^ytFCuɂ́A
        ȑÕo[W̊֐A萔܂߂Ă܂BAÅ֐A萔
        A4thSTEPł͍폜܂B
        ȑÕo[W̊֐A萔͎gpȂłB
#endif
/*
 * GLOBAL DEFINES/MACROS DEFINES
 */
/* rbgʒu ****************************************************************/
/* fW^foCXf[^^	 */
#define	PER_DGT_U   (1 << 12)                   /* UP                        */
#define	PER_DGT_D   (1 << 13)                   /* DOWN                      */
#define	PER_DGT_R   (1 << 15)                   /* RIGHT                     */
#define	PER_DGT_L   (1 << 14)                   /* LEFT                      */
#define	PER_DGT_A   (1 << 10)                   /* A                         */
#define	PER_DGT_B   (1 << 8)                    /* B                         */
#define	PER_DGT_C   (1 << 9)                    /* C                         */
#define	PER_DGT_S   (1 << 11)                   /* START                     */
#define	PER_DGT_X   (1 << 6)                    /* X                         */
#define	PER_DGT_Y   (1 << 5)                    /* Y                         */
#define	PER_DGT_Z   (1 << 4)                    /* Z                         */
#define	PER_DGT_TR  (1 << 7)                    /* gK RIGHT              */
#define	PER_DGT_TL  (1 << 3)                    /* gK LEFT               */

/* |CeBOfoCXf[^^ */
/***** f[^ */
#define PER_PNT_R   (1 << 1)                    /* RIGHT                     */
#define PER_PNT_L   (1 << 0)                    /* LEFT                      */
#define PER_PNT_MID (1 << 2)                    /* MIDDLE                    */
#define PER_PNT_CNT (1 << 3)                    /* CENTER                    */
#define PER_PNT_XO  (1 << 6)                    /* XI[ot[           */
#define PER_PNT_YO  (1 << 7)                    /* YI[ot[           */

/* L[{[hfoCXf[^^ */
/***** L[ */
#define PER_KBD_CL  (1 << 6)                    /* Caps Lock                 */
#define PER_KBD_NL  (1 << 5)                    /* Num Lock                  */
#define PER_KBD_SL  (1 << 4)                    /* Scrool Lock               */
#define PER_KBD_MK  (1 << 3)                    /* Make                      */
#define PER_KBD_BR  (1 << 0)                    /* Break                     */

/* KhCu3{^pbhf[^^ */
#define	PER_M3BP_U  PER_DGT_U                   /* UP                        */
#define	PER_M3BP_D  PER_DGT_D                   /* DOWN                      */
#define	PER_M3BP_R  PER_DGT_R                   /* RIGHT                     */
#define	PER_M3BP_L  PER_DGT_L                   /* LEFT                      */
#define	PER_M3BP_A  PER_DGT_A                   /* A                         */
#define	PER_M3BP_B  PER_DGT_B                   /* B                         */
#define	PER_M3BP_C  PER_DGT_C                   /* C                         */
#define	PER_M3BP_S  PER_DGT_S                   /* START                     */

/* KhCu6{^pbhf[^^ */
#define	PER_M6BP_U  PER_DGT_U                    /* UP                        */
#define	PER_M6BP_D  PER_DGT_D                    /* DOWN                      */
#define	PER_M6BP_R  PER_DGT_R                    /* RIGHT                     */
#define	PER_M6BP_L  PER_DGT_L                    /* LEFT                      */
#define	PER_M6BP_A  PER_DGT_A                    /* A                         */
#define	PER_M6BP_B  PER_DGT_B                    /* B                         */
#define	PER_M6BP_C  PER_DGT_C                    /* C                         */
#define	PER_M6BP_S  PER_DGT_S                    /* START                     */
#define	PER_M6BP_X  PER_DGT_X                    /* X                         */
#define	PER_M6BP_Y  PER_DGT_Y                    /* Y                         */
#define	PER_M6BP_Z  PER_DGT_Z                    /* Z                         */
#define	PER_M6BP_MD PER_DGT_TR                   /* MODE                      */
/* ANZX}N ************************************************************/
/* fW^foCXf[^^ */
#define PER_DGT(data)   ((PerDgtInfo *)(data))

/* AiOfoCXf[^^  */
#define PER_ANL(data)   ((PerAnlInfo *)(data))

/* |CeBOfoCXf[^^ */
#define PER_PNT(data)   ((PerPntInfo *)(data))

/* L[{[hfoCXf[^^ */
#define PER_KBD(data)   ((PerKbdInfo *)(data))

/* KhCu3{^pbhf[^^ */
#define PER_M3BP(data)  ((PerM3bpInfo *)(data))

/* KhCu6{^pbhf[^^ */
#define PER_M6BP(data)  ((PerM6bpInfo *)(data))

/*
 * TYPEDEFS
 */
/* foCXf[^^ */
typedef Uint16  PerDgtData;                     /* fW^foCXf[^^  */
typedef Sint16  PerAnlN;                        /* AiOnΒlf[^^ */
typedef Uint16  PerPntBtnData;                  /* ߲èݸ޲ް^ */
typedef Sint16  PerPntN;                        /* ߲èݸnΒlf[^^*/
typedef Uint8   PerKbdSkey;                     /* ްޓL[f[^^   */
typedef Uint8   PerKbdKey;                      /* ްރL[f[^^       */

typedef struct  {                               /* AiOfoCXf[^^  */
    PerDgtData  dgt;                            /* fW^foCXf[^^  */
    PerAnlN     x;                              /* XΒl(0`255)         */
    PerAnlN     y;                              /* YΒl(0`255)         */
    PerAnlN     z;                              /* ZΒl(0`255)         */
}PerAnlData;

typedef struct  {                       /* |CeBOfoCXf[^^    */
    PerDgtData      dgt;                        /* fW^foCXf[^^  */
    PerPntBtnData   data;                       /* f[^                    */
    PerPntN     x;                              /* Xړ(-128`127)      */
    PerPntN     y;                              /* Yړ(-128`127)      */
}PerPntData;

typedef struct  {                           /* L[{[hfoCXf[^^    */
    PerDgtData  dgt;                            /* fW^foCXf[^^  */
    PerKbdSkey  skey;                           /* L[                  */
    PerKbdKey   key;                            /* L[                      */
}PerKbdData;

typedef Uint8   PerM3bpData;            /* KhCu3{^pbhf[^^ */
typedef Uint16  PerM6bpData;            /* KhCu6{^pbhf[^^ */

/* ytFf[^o */
typedef struct  {                               /* fW^foCX          */
    PerDgtData  data;                           /* ݃ytFf[^    */
    PerDgtData  push;                           /* ݃ytFf[^    */
    PerId       id;                             /* ytFID            */
}PerDgtInfo;

typedef struct  {                               /* AiOfoCX          */
    PerAnlData  data;                           /* ݃ytFf[^    */
    PerAnlData  push;                           /* ݃ytFf[^    */
    PerId       id;                             /* ytFID            */
}PerAnlInfo;

typedef struct  {                               /* |CeBOfoCX    */
    PerPntData  data;                           /* ݃ytFf[^    */
    PerPntData  push;                           /* ݃ytFf[^    */
    PerId       id;                             /* ytFID            */
}PerPntInfo;

typedef struct  {                               /* L[{[hfoCX        */
    PerKbdData  data;                           /* ݃ytFf[^    */
    PerKbdData  push;                           /* ݃ytFf[^    */
    PerId       id;                             /* ytFID            */
}PerKbdInfo;

typedef struct  {                               /* KhCu3{^pbh */
    PerM3bpData data;                           /* ݃ytFf[^    */
    PerM3bpData push;                           /* ݃ytFf[^    */
    PerId       id;                             /* ytFID            */
}PerM3bpInfo;

typedef struct  {                               /* KhCu6{^pbh */
    PerM6bpData data;                           /* ݃ytFf[^    */
    PerM6bpData push;                           /* ݃ytFf[^    */
    PerId       id;                             /* ytFID            */
}PerM6bpInfo;

/*
 * EXTERNAL VARIABLE DECLARATIONS
 */

/*
 * EXTERNAL FUNCTION PROTOTYPE  DECLARATIONS
 */
Uint32 PER_Init(PerKind , PerNum , PerId , PerSize , Uint32 *, Uint8 );
Uint32 PER_GetPer(PerGetPer **);

#endif  /* ifndef SEGA_PER_H */
/******************************* end of file *********************************/
