/*
 * :        VXe vO
 *
 * t@C:  sega_sys.h
 *
 * t:        1994/05/06  for BOOT 0.90,0.901,0.91  by T. S.
 *              1994/07/16  for BOOT 0.92x,0.95       by T. S.
 *              1994/07/29  for BOOT 0.96x,1.00       by T. S.
 *              1994/08/31  how to exec CD multi-player
 *              1994/09/21  for Ver.1.00 BOOT ROM
 *              1995/03/31  MPEG check service
 *              1995/09/26  Ver.2.01 : sega_sys.lib   by M. M.
 *              1995/12/06  Ver.2.04 : SYS_ExitC   by M. M.
 *              1996/01/31  Ver.2.10 : SYS_ExitC   by M. M.
 *
 * o[W:  Ver.2.10
 *
 * ړI:        BOOT ROM ̃T[rX[``܂B
 *
 *              (1) SCU 荞݃T[rX[`̓o^Q
 *              (2) SH2 荞݃xN^̓o^Q
 *              (3) VXeZ}tH̑  (BOOT ROM V0.90ȍ~)
 *              (4) SCU 荞݃}XN̑(BOOT ROM V0.90ȍ~)
 *              (5) VXeNbN̐ؑւ(BOOT ROM V0.92ȍ~)
 *              (6) SCU 荞݃[`Dx̕ύX(SCU2.1ȍ~)
 *              (7) CD  }`v[̋Ns(CDtfp)
 *              (8) p[INȂ (ROM V1.00ȍ~)
 *              (9) MPEG `FbN(A^)    (ROM V1.00ȍ~)
 *
 *              sega_sys.lib̊֐錾܂BiVer.2.01ȍ~j
 *
 * gp@:
 *
 *      void  Vfunc(void)
 *      {
 *           // ... s ... //
 *      }
 *
 *      extern void  Hihdr(void);
 *
 *      void  test()
 *      {
 *           void (*tmp)();
 *           Sint32 rep;
 *           Uint32 msk, clk, lval1;
 *           Uint8  p0;
 *           const Uint32 PriTab[32] = {
 *              0x00f0ffff, 0x00e0fffe, 0x00d0fffc, 0x00c0fff8,
 *              0x00b0fff0, 0x00a0ffe0, 0x0090ffc0, 0x0080ff80,
 *              0x0080ff80, 0x0070fe00, 0x0070fe00, 0x0070fe00,
 *              0x0070fe00, 0x0070fe00, 0x0070fe00, 0x0070fe00,
 *              0x0070fe00, 0x0070fe00, 0x0070fe00, 0x0070fe00,
 *              0x0070fe00, 0x0070fe00, 0x0070fe00, 0x0070fe00,
 *              0x0070fe00, 0x0070fe00, 0x0070fe00, 0x0070fe00,
 *              0x0070fe00, 0x0070fe00, 0x0070fe00, 0x0070fe00,
 *           };
 *
 *           SYS_SETUINT(0x40, Vfunc);  // Vfunc()  VB-In ݗpɓo^   //
 *           tmp = SYS_GETUINT(0x41);   // ݂ VB-Out [`o^Q  //
 *           SYS_SETUINT(0x41, 0);      // VB-Out [`̓o^       //
 *
 *           SYS_SETSINT(0x42, Hihdr);  // Hihdr()  HB-In xN^ɓo^     //
 *           tmp = SYS_GETSINT(0x6e);   // ݂ DIVU xN^o^Q      //
 *           SYS_SETSINT(0x6e, 0);      // DIVU xN^ď             //
 *
 *           rep = SYS_TASSEM(0x5);     // Z}tH 5 eXgAhZbg //
 *           SYS_CLRSEM(0x5);           // Z}tH 5 NA               //
 *
 *           SYS_SETSCUIM(0xfffffffe);  // VB-In ݂݂̂ɐݒ      //
 *           SYS_CHGSCUIM(0xfffffffc, 0); // VB-In, VB-Out ɕύX      //
 *           SYS_CHGSCUIM(0xffffffff, 2); // VB-Out  sɕύX          //
 *           msk = SYS_GETSCUIM;        // ݂ SCU ݃}XNlQ   //
 *
 *           SYS_CHGSYSCK(1);           // VXeNbNQWlɐؑւ  //
 *           clk = SYS_GETSYSCK;        // ݂ VXeNbNlQ   //
 *                                      //   0: 26 MHz       1: 28 MHz       //
 *                                      //     320/640 pix/H   352/704 pix/H //
 *
 *           SYS_CHGUIPR(PriTab);       // rbt荞݃[`DxύX  //
 *
 *           SYS_EXECDMP();             // bc}`v[Ns        //
 *
 *           p0 = SYS_PCLRMEM;          // p[INA擪oCg  //
 *           lval1 = *((Uint32*)&SYS_PCLRMEM+1); // ƌ㔼O[hQ //
 *
 *           rep = SYS_CHKMPEG(0);      // ͕K 0. mansys.txt ̎gp //
 *                                      // ɏ]Ă                  //
 *      }
 *
 *      // ... ʂ̃t@C ... //
 *      #pragma interrupt(Hihdr)
 *      void  Hihdr(void)
 *      {
 *           // ... s ... //
 *      }
 *
 */

#ifndef SEGA_SYS_H
#define SEGA_SYS_H

/***********************************************************************
 *      CN[ht@C
 ***********************************************************************/
#include "sega_xpt.h"

/*****************************************************************************
 *      萔}N
 *****************************************************************************/

/* o[W */
                    /*             1         2         3         4    */
                    /*    1234567890123456789012345678901234567890    */
                    /*    ++++++++++++++++++++++++++++++++            */
#define SYS_VERSION_STR ("SYS Version 2.10 1996-01-31")
#define SYS_VERSION_LEN         (32)

/***********************************************************************
 *      }N
 ***********************************************************************/
#define SYS_SETUINT(_Num_, _Hdr_) \
        ((**(volatile void(**)(Uint32, void*))0x6000300)((_Num_), (_Hdr_)))
#define SYS_GETUINT(_Num_) \
        ((void*)(**(void(*(**)(Uint32))(Uint32))0x6000304)(_Num_))

#define SYS_SETSINT(_Num_, _Hdr_) \
        ((**(volatile void(**)(Uint32, void*))0x6000310)((_Num_), (_Hdr_)))
#define SYS_GETSINT(_Num_) \
        ((void*)(**(void(*(**)(Uint32))(Uint32))0x6000314)(_Num_))

#define SYS_TASSEM(_Num_) \
        ((**(volatile Uint32(**)(Uint32))0x6000330)(_Num_))
#define SYS_CLRSEM(_Num_) \
        ((**(volatile void(**)(Uint32))0x6000334)(_Num_))

#define SYS_SETSCUIM(_MaskPat_) \
        ((**(volatile void(**)(Uint32))0x6000340)(_MaskPat_))
#define SYS_CHGSCUIM(_AndMask_, _OrMask_) \
        ((**(volatile void(**)(Uint32, Uint32))0x6000344)((_AndMask_), (_OrMask_)))
#define SYS_GETSCUIM \
        (*(volatile Uint32*)0x6000348)

#define SYS_CHGSYSCK(_CkMode_) \
        ((**(volatile void(**)(Uint32))0x6000320)(_CkMode_))
#define SYS_GETSYSCK \
        (*(volatile Uint32*)0x6000324)

#define SYS_CHGUIPR(_IprTab_) \
        ((**(volatile void(**)(Uint32*))0x6000280)(_IprTab_))

#define SYS_EXECDMP \
        (**(volatile void(**)(void))0x600026C)

#define SYS_PCLRMEM \
        (*(volatile Uint8*)0x6000210)

#define SYS_CHKMPEG(_dummy_) \
        ((**(volatile Sint32(**)(Sint32))0x6000274)(_dummy_))

/***********************************************************************
 *      ֐̐錾
 ***********************************************************************/
void SYS_CheckTrack(Sint32 tno);
void SYS_Exit(Sint32 code);

#endif
