/*-----------------------------------------------------------------------------
 *  FILE: mem_free.c
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      Cu\[Xt@CB
 *
 *  DESCRIPTION:
 *
 *      ǗB
 *
 *  INTERFACE:
 *
 *      < FUNCTIONS LIST >
 *          <3> MEM_Free()      -   Ǘ̈ݒ
 *
 *  CAVEATS:
 *
 *      ȂB
 *
 *  AUTHOR(S)
 *
 *      1994-07-06  N.T Ver.1.00
 *
 *  MOD HISTORY:
 *
 *      1995-12-06  H.O Ver.1.01
 *
 *-----------------------------------------------------------------------------
 */

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include <stdio.h>
#include "sega_xpt.h"

/*
 * USER SUPPLIED INCLUDE FILES
 */
#define	__MEM_LIB_SOURCE__
#include "sega_mem.h"

/*
 * GLOBAL DECLARATIONS
 */

/*
 * LOCAL DEFINES/MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * STATIC DECLARATIONS
 */

/*
 * STATIC FUNCTION PROTOTYPE DECLARATIONS
 */

/******************************************************************************
 *
 * NAME:    MEM_Free()              - ubN
 *
 * PARAMETERS :
 *      (1) void *mem_ptr           - <i>  ubNւ̃|C^
 *
 * DESCRIPTION:
 *      ubN܂D
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void MEM_Free(void *mem_ptr){
	MemHead	*list;								/* Xgp */
	MemHead	*free = (MemHead *)mem_ptr -1;		/* J̈ */
	if( ( list = MEM_empty_top ) == NULL ){		/* Xg̎擾 */
		MEM_empty_top = free;					/* 󂫃Xgꍇ */
		free->s.next = free;					/* vf1̏zXg */
	}
	else{
		while( !( (free > list) && (free < list->s.next) )){
		/* vfnƗvfn+1̊ԂɊJ̈悪݂ȂԂ̓[v */
			if(list >= list->s.next)			/* 󃊃Xǧq߂vfP̏ꍇ */
				if( (free > list)||(free < list->s.next) )	/* qڂɘAׂ */
					break;							/* qڂɘA */
			list = list->s.next;					/* ̗vf */
		}
		if( free+free->s.size == list->s.next ){	/* ̗vfƍ̂łꍇ */
			free->s.size += list->s.size;			/* TCY̕ύX */
			free->s.next = list->s.next->s.next;	/* qւ */
		}
		else{										/* ̂łȂꍇ */
			free->s.next = list->s.next;			/* 芸OɘA */
		}
		if( list+list->s.size == free ){			/* O̗vfƍ̂łꍇ */
			list->s.size += free->s.size;			/* TCY̕ύX */
			list->s.next = free->s.next;			/* qւ */
		}
		else{										/* ̂łȂꍇ */
			list->s.next = free;					/* qւ */
		}
		MEM_empty_top = list;						/* ㏈ */
	}
}
