/*******************************************************************
 *
 *                     T^[pbcCu
 *
 *                         MPEGCu
 *
 *             Copyright (c) 1993 CSK Research Institute Corp.
 *             Copyright (c) 1994 SEGA
 *
 *  Module : Î~ĐW[\[Xt@C
 *  File   : mpg_spc.c
 *  Date   : 1995-09-05
 *  Author : H.Take
 *
 *******************************************************************/

/*******************************************************************
 *      CN[ht@C
 *******************************************************************/
#include        "mpg_loc.h"

/*******************************************************************
 *      ֐`
 *******************************************************************/

/* MpgSp^̎̂MpgMv^ƓȂ̂ŁAMpgMv^ɂƂ֐ */
/* ^ϊɓnĂ */

/* MPEGÎ~nh̐ */
MpgSp   MPG_SpCreate(StmHn vstm)
{
    /* MPEGnh̐ */    
    return MPG_MvCreate(vstm, NULL);
}

/* MPEGÎ~nh̏ */
Sint32  MPG_SpDestroy(MpgSp mpgsp)
{
    /* MPEGnh̏ */
    return MPG_MvDestroy(mpgsp);
}

/* Î~̏o͐̐ݒ */
void    MPG_SpSetVideoDest(MpgSp mpgsp, Sint32 dst)
{
    /* o͐̐ݒ */
    MPG_MvSetVideoDest(mpgsp, dst);
    
    return;
}

/* Î~̏I̐ݒ */
void    MPG_SpSetTermCond(MpgSp mpgsp, Sint32 vcnd)
{
    /* I̐ݒ */
    MPG_MvSetTermCond(mpgsp, vcnd, MPG_IGNORE);
    
    return;
}

/* Î~̃`l̐ݒ */
void    MPG_SpSetChan(MpgSp mpgsp, Sint32 ch)
{
    /* rfI`l̐ݒ */
    MPG_MvSetVideoChan(mpgsp, ch);
    
    return;
}

/* Î~̃Xg[hc̐ݒ */
void    MPG_SpSetId(MpgSp mpgsp, Sint32 id)
{
    /* rfĨXg[hc̐ݒ */
    MPG_MvSetVideoId(mpgsp, id);
    
    return;
}

/* Î~Đ̊Jn */
Sint32  MPG_SpStart(MpgSp mpgsp)
{
    /* Đ̊Jn */
    return MPG_MvStart(mpgsp, CDC_MPSRCH_OFF);
}

/* Î~Đ̒~ */
Sint32  MPG_SpStop(MpgSp mpgsp)
{
    /* Đ̒~ */
    return MPG_MvStop(mpgsp);
}

/* Î~̃fR[h̎s */
Sint32  MPG_SpDecNext(MpgSp mpgsp, Sint32 bnk)
{
    Sint32      ret;

    /* rfĨfR[hs */
    ret = MPMVE_DecNext(mpgsp, bnk);

    return ret;
}

/* Î~̓Ԃ̎擾 */
Sint32  MPG_SpGetVideoStat(MpgSp mpgsp)
{
    return MPG_MvGetVideoStat(mpgsp);
}

/* Î~̃^CR[h̎擾 */
void    MPG_SpGetTimeCode(MpgSp mpgsp,
                          Sint32 *hh, Sint32 *mm, Sint32 *ss, Sint32 *pp)
{
    /* ^CR[h̎擾 */
    MPG_MvGetTimeCode(mpgsp, hh, mm, ss, pp);
    
    return;
}

/* Î~MPEGEBhE̐ڑ */
void    MPG_SpConnectWin(MpgSp mpgsp, MpgWn mpgwn, Sint32 bnk)
{
    MpgWn wnwk;

    MPSYS_SemaIn(FALSE);
    
    /* gpt[oN̐ݒ */
    MPG_WN_FBN(mpgwn) = bnk;
    
    wnwk = MPG_MV_MPGWN(mpgsp, bnk);
    if (wnwk == NULL) {
        MPG_MV_MPGWN(mpgsp, bnk) = mpgwn;
    } else {
        MPWIN_Connect(wnwk, mpgwn);
    }
    if (MPG_MV_ACTV(mpgsp) == ON) {
        MPG_SpOutput(mpgsp, bnk);
    }
    
    MPSYS_SemaOut(MPG_ERR_OK);

    return;
}

/* Î~MPEGEBhE̐؂藣 */
void    MPG_SpDisconnectWin(MpgSp mpgsp, MpgWn mpgwn, Sint32 bnk)
{
    MPSYS_SemaIn(FALSE);
    
    if (MPG_MV_ACTV(mpgsp) == ON) {
        MPG_WnDisp(mpgwn, OFF);
    }
    if (MPG_MV_MPGWN(mpgsp, bnk) == mpgwn) {
        MPG_MV_MPGWN(mpgsp, bnk) = NULL;
    } else {
        MPWIN_Disconnect(mpgwn);
    }
    
    MPSYS_SemaOut(MPG_ERR_OK);

    return;
}

/* Î~̏o */
Sint32  MPG_SpOutput(MpgSp mpgsp, Sint32 bnk)
{
    Sint32      ret;
    
    MPSYS_SemaIn(FALSE);

    /* rfȈo */
    ret = MPMVE_Output(mpgsp, CDC_MPSTV_UPDPIC, bnk);
    
    return MPSYS_SemaOut(ret);
}



