/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:ADPCM buffer management, decompression, PCM data copy
 * File		:pcm_adp.c
 * Date		:1994-10-14
 * Version	:1.00
 * Auther	:Y.T
 *
 ****************************************************************************/
#include <string.h>
#include <sega_adp.h>
#include "pcm_msub.h"

#ifdef ADPCM_FUNCTION

/* ADPCMeXg */
/* #define NEW_ADPCM_TEST */

#ifdef NEW_ADPCM_TEST
	Sint32 cnt_pcm_top = 0;

	void pcm_adp_break(void){}
	
#endif

/*******************************************************************
y@@\z
	Đ^`coblI[fBI (ATEhO[v)
y@z
	hn			()@nh
y߂lz
	Ȃ
y@lz
	TEhO[v̓Oobt@ŘAĂۏ؂͂ȂB

		+-------------------------------------------------------+
		|					Oobt@						|
		+-------------------------------------------------------+
											..... S------G, S--- 
		---G, S------G, .....					  <------>
												TEhO[v
*******************************************************************/
void pcm_AudioAdpcmSg(PcmHn hn)
{
	return;
}

#define PCM_CHECK_SAMPLE_FILE(st)	\
			if (st->info.sample_file != -1) {	\
				if (st->sample_write_file >= st->info.sample_file) {	\
					break;	\
				}	\
			}

#define PCM_SIZE_PAD	(PCM_SIZE_SECTOR - (PCM_SG_IN_SECTOR*ADP_SIZE_SG_CODE))

/*******************************************************************
y@@\z
	Đ^`coblI[fBI (ZN^oE_̃TEhO[v)
y@z
	hn			()@nh
y߂lz
	Ȃ
y@lz
	PWTEhO[vɂQOoCg̃pbhǂݔ΂B
	TEhO[v̓Oobt@ŘAĂۏ؂͂ȂB
*******************************************************************/
void pcm_AudioAdpcmSct(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmPara		*para 	= &work->para;
	PcmStatus	*st 	= &work->status;
	Sint8 		*addr_w1, *addr_w2;	/* PCMޯ̧݃AhX 			*/
	Sint32		size_w, size_w_t; 	/* PCMޯ̧݉\TCY [byte] 	*/
	Sint32		ring_bsize, 		/* ݸޯ̧̍݌ɃTCY [byte] 		*/
				ring_sg, 		/* ݸޯ̧̍݌ɻ޸ٰߐ[sect/1ch]	*/
				pcm_sg, 		/* PCMޯ̧̎󂯓껳޸ٰߐ[sect/1ch]*/
				copy_sg, 		/* sRs[޸ٰߐ [sect/1ch] 		*/
				size_1, size_2, 	/* Rs[TCY [byte/1ch] 				*/
				dsize_1, dsize_2,	/* Rs[TCY [dword/1ch] 			*/
				j;
	Sint32		flop32[ADP_SIZE_SG_CODE / 4];
	Sint32		buf32[ADP_SIZE_SG_DECO / 4];
	Sint8		*flop = (Sint8 *)flop32;
	Sint8		*buf = (Sint8 *)buf32;
	Sint8		*buf_r = buf + ADP_SIZE_SG_DECO_1;
	Sint8		*buf_l = buf;
	Sint8		*input_addr;		/* Oobt@ǂݎAhX 		*/
/*	Sint32 		sample_now; */


	/* CD-ROM XA : Oobt@ɂ EOF ȍ~̃S~͋Ȃ */
	ring_bsize = st->ring_write_offset - st->ring_read_offset;

	/* ݌ɗʂ޸ٰߐɊZ [sg/1ch] */
	ring_sg = (ring_bsize / PCM_SIZE_SECTOR) * PCM_SG_IN_SECTOR
			+ (ring_bsize % PCM_SIZE_SECTOR) / ADP_SIZE_SG_CODE;
	if (PCM_IS_STEREO(st)) {
		ring_sg >>= 1;
	}

	/* ADPCM ENCODER */
	if (st->info.sample_file != -1) {
		if (st->sample_write_file >= st->info.sample_file) {
			ring_sg = 0;
		}
	}

	pcm_GetPcmWrite(hn, &addr_w1, &addr_w2, 
						&size_w, &size_w_t);

	/* oblobt@󂯓\ȃTCYA޸ٰߐɊZB */
	pcm_sg = size_w_t / ADP_SIZE_SG_DECO;

	/* Rs[TCY [sg/1ch] */
	copy_sg = MIN(pcm_sg, ring_sg);

	/* 94.11.21 ^XN֐dlύX
	 *	ĐԂɊւ炸AP̃^XN֐ŏʂ͍őSTvB
	 *		copy_sg = MIN(copy_sg, PCM_4KSAMPEL_SG);
	 * 95.01.25 ^XN֐dlύX
	 *	P̃^XNŏʂ̏̓[U߂łB
	 */
	/* P̃^XNŏʂ̏[sg/1ch]	*/
	copy_sg = MIN(copy_sg, st->onetask_sg);

	if (copy_sg == 0) {
		return;
	}

	if (st->fill_silence) {
		VTV_PRINTF((VTV_s, "P:fill_silence OFF\n"));
	}

	st->fill_silence = PCM_OFF;	/* ݒς݃tOQ */

	/* `coblL̎s */
	
	if (PCM_IS_STEREO(st)) {
		for (j = 0; j < 2 * copy_sg; j++) {
			if (st->ring_read_addr + ADP_SIZE_SG_CODE > st->ring_end_addr){
				size_1 = st->ring_end_addr - st->ring_read_addr;
				size_2 = ADP_SIZE_SG_CODE - size_1;
				memcpy(flop, st->ring_read_addr, size_1);
				memcpy(flop + size_1, para->ring_addr, size_2);
				input_addr = flop;
			} else {
				input_addr = st->ring_read_addr;
			}
			ADP_DecStereo(input_addr, buf);/* Prf̃XeIL */
			pcm_GetPcmWrite(hn, &addr_w1, &addr_w2, &size_w, &size_w_t);
			size_1 = MIN(size_w, ADP_SIZE_SG_DECO_1);
			size_2 = ADP_SIZE_SG_DECO_1 - size_1;
			dsize_1 = size_1 >> 2;
			dsize_2 = size_2 >> 2;
			pcm_MemcpyDword((Uint32 *)addr_w2, (Uint32 *)buf_l, dsize_1);
			pcm_MemcpyDword((Uint32 *)addr_w1, (Uint32 *)buf_r, dsize_1);
			pcm_RenewPcmWrite(hn, size_1);
			if (size_2 != 0) {

#ifdef NEW_ADPCM_TEST
	cnt_pcm_top++;
	if (cnt_pcm_top == 5) {
		pcm_adp_break();
	}
#endif

				pcm_GetPcmWrite(hn, &addr_w1, &addr_w2, &size_w,&size_w_t);
				pcm_MemcpyDword((Uint32 *)addr_w2, 
								(Uint32 *)(buf_l + size_1), dsize_2);
				PCM_KILL_NOISE16(addr_w2, st->pcm_bsize);
				pcm_MemcpyDword((Uint32 *)addr_w1, 
								(Uint32 *)(buf_r + size_1), dsize_2);
				PCM_KILL_NOISE16(addr_w1, st->pcm_bsize);
				pcm_RenewPcmWrite(hn, size_2);
			}
			/* Oobt@ǂݎʒuXV */
			pcm_RenewRingRead(hn, ADP_SIZE_SG_CODE);
			PCM_CHECK_SAMPLE_FILE(st);
			st->cnt_sg++;
			if ((st->cnt_sg % PCM_SG_IN_SECTOR) == 0) {
				/* Oobt@ǂݎʒuXV */
				pcm_RenewRingRead(hn, PCM_SIZE_PAD);
				PCM_CHECK_SAMPLE_FILE(st);
			}
		}
	} else {
		/* monoral */
		for (j = 0; j < copy_sg; j++) {
			if (st->ring_read_addr + ADP_SIZE_SG_CODE > st->ring_end_addr){
				size_1 = st->ring_end_addr - st->ring_read_addr;
				size_2 = ADP_SIZE_SG_CODE - size_1;
				memcpy(flop, st->ring_read_addr, size_1);
				memcpy(flop + size_1, para->ring_addr, size_2);
				input_addr = flop;
			} else {
				input_addr = st->ring_read_addr;
			}
			ADP_DecMono(input_addr, buf);/* Prf̃mL */
			pcm_GetPcmWrite(hn, &addr_w1, &addr_w2, &size_w, &size_w_t);
			size_1 = MIN(size_w, ADP_SIZE_SG_DECO);
			size_2 = ADP_SIZE_SG_DECO - size_1;
			dsize_1 = size_1 >> 2;
			dsize_2 = size_2 >> 2;
			pcm_MemcpyDword((Uint32 *)addr_w1, (Uint32 *)buf, dsize_1);
			pcm_RenewPcmWrite(hn, size_1);
			if (size_2 != 0) {
				pcm_GetPcmWrite(hn, &addr_w1, &addr_w2, &size_w,&size_w_t);
				pcm_MemcpyDword((Uint32 *)addr_w1, 
								(Uint32 *)(buf + size_1), dsize_2);
				PCM_KILL_NOISE16(addr_w1, st->pcm_bsize);
				pcm_RenewPcmWrite(hn, size_2);
			}
			/* Oobt@ǂݎʒuXV */
			pcm_RenewRingRead(hn, ADP_SIZE_SG_CODE);
			PCM_CHECK_SAMPLE_FILE(st);
			st->cnt_sg++;
			if ((st->cnt_sg % PCM_SG_IN_SECTOR) == 0) {
				/* Oobt@ǂݎʒuXV */
				pcm_RenewRingRead(hn, PCM_SIZE_PAD);
				PCM_CHECK_SAMPLE_FILE(st);
			}
		}
	}

	return;
}

/*******************************************************************
y@@\z
	Đ^PI[fBITv
y@z
	hn			()@nh
y߂lz
	Ȃ
y@lz
	֐|C^ st->audio_process_fp ɐݒ肳ăR[
*******************************************************************/
void pcm_AudioProcessAdpcm(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
	PcmStatus	*st 	= &work->status;

	if (PCM_IS_ADPCM_SCT(st)) {
		/* `coblI[fBI (ZN^oE_̃TEhO[v) */
		pcm_AudioAdpcmSct(hn);
	} else if (PCM_IS_ADPCM_SG(st)) {
		/* `coblI[fBI (ATEhO[v) */
		pcm_AudioAdpcmSg(hn);
	}
}

/*******************************************************************
y@@\z
	Đ^PCM_SetInfo ADPCMΉ
y@z
	hn@	íj@VlpbNnh
y߂lz
	Ȃ
y@lz
	֐|C^ pcm_set_info_adpcm_fp ɐݒ肳ăR[
*******************************************************************/
void pcm_SetInfoAdpcm(PcmHn hn)
{
	PcmWork		*work 	= *(PcmWork **)hn;
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmPara		*para 	= &work->para;
#endif
	PcmStatus	*st 	= &work->status;
	PcmFilePara *filepara = &work->filepara;

	PCM_INFO_FILE_SIZE(&st->info) = -1;			/* gpȂ */
	PCM_INFO_SAMPLING_BIT(&st->info) = 16;		/* 16 [bit/sample] */
	PCM_INFO_CHANNEL(&st->info) = -1;			/* 擪ciĔf */
	PCM_INFO_SAMPLING_RATE(&st->info) = -1;		/* 擪ciĔf */
	PCM_INFO_SAMPLE_FILE(&st->info) = -1;		/* gpȂ */
	PCM_INFO_COMPRESSION_TYPE(&st->info) = -1;	/* gpȂ */
	if (PCM_IS_NO_HEADER(st)) {
		st->need_ci = PCM_ON;
	}
	filepara->data.stm.sect_bsize = 2324;

	/* I[fBI֐|C^̐ݒ */
	st->audio_process_fp = pcm_AudioProcessAdpcm;
}

/*******************************************************************
y@@\z													J֐
	Đ^`coblgp錾
	ADPCMɑΉ֐o^B
y@z
	Ȃ
y߂lz
	Ȃ
y@Ӂz
	PCM_Init ̌Å֐gpOɂPxR[B
y@lz
	̊֐gp΁u`coblLCuvNB
*******************************************************************/
void PCM_DeclareUseAdpcm(void)
{

	/* `obl`N */
	pcm_chunk_adpcm_fp = pcm_ChunkAdpcm;

	/* PCM_SetInfo ADPCMΉ */
	pcm_set_info_adpcm_fp = pcm_SetInfoAdpcm;
}

#endif /* ADPCM_FUNCTION */
