/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library: Xg[VXe
 * Module : [J֐(CDubN)
 * File   : stm_loc.c
 * Date   : 1995-02-01
 * Version: 2.10
 * Author : H.T
 *
 *****************************************************************************/
/* SGL̏ꍇRpCIvVɂ`邱
 * #define USE_SGL
 */

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include        <stdlib.h>

#if defined(USE_SGL)
    #include    "sgl_cd.h"
#else
    #include    "sega_stm.h"
#endif
#include        "stm_def.h"
#include        "gfs_def.h"
#include        "gfs_cdc.h"
#include        "gfs_cdf.h"
#include        "gfs_dir.h"
#include        "stm_loc.h"

/*****************************************************************************
 *      萔
 *****************************************************************************/
#define TIME_40MSEC     (12186*2)

/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/

/*************************************************
 * ݂FAD̎擾
 * ߂l:݂FAD
 *************************************************/
Sint32  STL_GetCurFad(void)
{
    CdcStat     stat;
    Sint32      ret;

    do {
        ret = CDC_GetCurStat(&stat);
    } while (ret != CDC_ERR_OK);
    return CDC_STAT_FAD(&stat);
}


/*************************************************
 * Đ͈͂̎擾
 * flow : ǂݍ݊Ǘ
 * sfad : JnFAD
 * efad : IFAD
 *************************************************/
void    STL_GetPlayArea(GfsFlow *flow, Sint32 *sfad, Sint32 *efad)
{
    Sint32      nsct;
    Sint32      atr;

    GFCF_GetFileInfo(flow, NULL, sfad, NULL, &nsct, NULL, NULL, &atr);
    if (IS_CDFILE(atr)) {       /* CDt@C̏ꍇ     */
        *efad = *sfad + nsct - 1;
    } else {                    /* SIMM, SCSȈꍇ     */
        *sfad = STM_LONG_MAX;
        *efad = STM_LONG_MAX;
    }
}

    

/*************************************************
 * Xg[O[vĐ
 * grp  : Xg[O[v
 * ߂l: G[R[h
 *************************************************/
Sint32  STL_FlowIn(StmGrpHn grp)
{
    Sint32      _sfad, sfad, efad;
    CdcPly      ply;
    Sint32      ret = STM_ERR_OK;

    /* [vXg[̊JnFAD擾  */
    sfad = STM_GRP_FAD(grp);                    /* JnFADݒ  */
    /* ŏIXg[̏IFAD擾    */
    STL_GetPlayArea(STM_FLOW(STM_GRP_LSTSTM(grp)), &_sfad, &efad);
    if (efad >= sfad) {
        /* p[^ݒ */
        CDC_PLY_STYPE(&ply) = CDC_PTYPE_FAD;
        CDC_PLY_SFAD(&ply) = sfad;
        CDC_PLY_ETYPE(&ply) = CDC_PTYPE_FAD;
        CDC_PLY_EFAS(&ply) = efad - sfad + 1;
        CDC_PLY_PMODE(&ply) = CDC_PM_DFL;
        ret = GFCD_Play(&ply, STM_GRP_PUID(grp));       /* ǂݍ     */
        if (ret == GFCD_ERR_OPEN) {
            ret = STM_ERR_CDOPEN;
        } else if (ret != GFCD_ERR_OK) {
            ret = STM_ERR_CDRD;
        } else {
            MNG_SFAD(stm_mng_ptr) = sfad;
            MNG_EFAD(stm_mng_ptr) = efad;
        }
    }
    return (ret);
}



/*************************************************
 * ǂݍݒ~
 * grp  : Xg[O[v
 *************************************************/
Sint32  STL_StopIn(StmGrpHn grp)
{
    CdcPos      pos;
    Sint32      ret;

    CDC_POS_PTYPE(&pos) = CDC_PTYPE_NOCHG;
    ret = GFCD_MovePickup(&pos, STM_GRP_PUID(grp));
    if (ret == GFCD_ERR_OPEN) {
        return (STM_ERR_CDOPEN);
    } else if (ret != GFCD_ERR_OK) {
        return (STM_ERR_CDRD);
    }
    MNG_SFAD(stm_mng_ptr) = -1;
    MNG_EFAD(stm_mng_ptr) = -1;
    return (ret);
}



/*************************************************
 * [hG[̃Jo
 * grp  : Xg[O[v
 *************************************************/
Sint32  STL_Recover(StmGrpHn grp)
{
    CdcPly      pinfo;
    Sint32      err;

    /* CdPlay𔭍s */
    CDC_PLY_STYPE(&pinfo) = CDC_PTYPE_NOCHG;
    CDC_PLY_ETYPE(&pinfo) = CDC_PTYPE_NOCHG;
    CDC_PLY_PMODE(&pinfo) = CDC_PM_NOCHG;
    err = GFCD_Play(&pinfo, STM_GRP_PUID(grp));
    if (err != GFCD_ERR_OK) {
        return STM_ERR_CDRD;
    } else {
        return STM_ERR_OK;
    }
}
    

/*************************************************
 * sbNAbv̈ړ(Đp)
 * fad  : ړFAD
 * ߂l:G[R[h
 *************************************************/
Sint32  STL_MovePlaypos(StmGrpHn grp, Sint32 fad)
{
    CdcPly      ply;
    Sint32      ret = STM_ERR_OK;

    /* ĐJnʒûݕύX     */
    CDC_PLY_STYPE(&ply) = CDC_PTYPE_FAD;
    CDC_PLY_SFAD(&ply) = fad;
    CDC_PLY_ETYPE(&ply) = CDC_PTYPE_NOCHG;      /* IʒuύXȂ   */
    CDC_PLY_PMODE(&ply) = CDC_PM_DFL;
    ret = GFCD_Play(&ply, STM_GRP_PUID(grp));
    if (ret == GFCD_ERR_OPEN) {
        ret = STM_ERR_CDOPEN;
    } else if (ret != GFCD_ERR_OK) {
        ret = STM_ERR_CDRD;
    } else {
        MNG_SFAD(stm_mng_ptr) = fad;
    }
    return (ret);
}
    

/*************************************************
 * ĐIʒu̕ύX
 * grp  : Xg[O[v
 * efad : Iʒu
 *************************************************/
Sint32  STL_ChgPlayEnd(StmGrpHn grp, Sint32 efad)
{
    CdcPly      ply;
    Sint32      ret = STM_ERR_OK;

    /* ĐJnʒûݕύX     */
    CDC_PLY_STYPE(&ply) = CDC_PTYPE_FAD;
    CDC_PLY_SFAD(&ply) = MNG_SFAD(stm_mng_ptr);
    CDC_PLY_ETYPE(&ply) = CDC_PTYPE_FAD;        /* IʒuύX     */
    CDC_PLY_EFAS(&ply) = efad - MNG_SFAD(stm_mng_ptr) + 1;
    CDC_PLY_PMODE(&ply) = CDC_PM_NOCHG;
    ret = GFCD_Play(&ply, STM_GRP_PUID(grp));
    if (ret == GFCD_ERR_OPEN) {
        ret = STM_ERR_CDOPEN;
    } else if (ret != GFCD_ERR_OK) {
        ret = STM_ERR_CDRD;
    } else {
        MNG_EFAD(stm_mng_ptr) = efad;
    }
    return (ret);
}
    

/*************************************************
 * ǂݍ݃ZN^̎擾
 * flow : ǂݍ݊Ǘ
 * sn   : ZN^ԍi擪ZN^͂Oj
 * sinfo: ZN^
 * ߂l: TRUE wZN^  FALSE wZN^Ȃ
 *************************************************/
Bool    STL_GetSctInfo(GfsFlow *flow, Sint32 sn, StmSct *sinfo)
{
    Sint32      nsct;
    CdcSct      info;

    /* ZN^̃`FbN       */
    nsct = GFCB_GetLenData(flow, STM_LONG_MAX, NULL);
    if (sn >= nsct) {    /* ZN^w肳ꂽZN^ԍɖȂ    */
        return (FALSE);
    }

    /* ZN^̎擾         */
    GFCD_GetSctInfo(GFS_CDR_BUFNO(&GFS_FLW_DTSRC(flow)), sn, &info);

    STM_SCT_FAD(sinfo) = CDC_SCT_FAD(&info);
    STM_SCT_FN(sinfo) = CDC_SCT_FN(&info);
    STM_SCT_CN(sinfo) = CDC_SCT_CN(&info);
    STM_SCT_SM(sinfo) = CDC_SCT_SM(&info);
    STM_SCT_CI(sinfo) = CDC_SCT_CI(&info);
    return (TRUE);
}


/*************************************************
 * ZN^̎f[^TCY̎擾
 * flow : ǂݍ݊Ǘ
 * spos : ZN^ʒu
 * ߂l: ZN^̎f[^TCY([h)
 *************************************************/
Sint32  STL_GetActSiz(GfsFlow *flow, Sint32 spos)
{
    Sint32      nword;
    Sint32      nsct;

    GFCD_GetLenData(GFS_CDR_BUFNO(&(GFS_FLW_DTSRC(flow))), 
                    GFS_CDR_SCTPOS(&(GFS_FLW_DTSRC(flow))) + spos, 1, 
                    &nsct, &nword);
    GFCD_WaitServer();
    return (nword / sizeof(Uint16));
}


/*************************************************
 * CDobt@f[^̏
 * flow : ǂݍ݊Ǘ
 * spos : ZN^ʒu
 * snum : ZN^
 *************************************************/
void    STL_DeleteSctData(GfsFlow *flow, Sint32 spos, Sint32 snum)
{
    Sint32      nsct;

    nsct = GFCB_GetLenData(flow, STM_LONG_MAX, NULL);
    if ((spos + snum) > nsct) {
        snum = nsct - spos;
    }
    if (snum > 0) {
        GFCD_DelSctData(GFS_CDR_BUFNO(&(GFS_FLW_DTSRC(flow))), spos, snum);
    }
}


/*************************************************
 * CSCT֐pCDobt@gpZN^̎擾
 * ߂l : gpZN^
 *************************************************/
Sint32  STL_CsctGetSctNum(GfsFlow *flow)
{
    Sint32      bufno;
    Sint32      nsct;
    Sint32      ret;

    bufno = GFS_CDR_BUFNO(&(GFS_FLW_DTSRC(flow)));
    /* ̊֐CSCT֐Ă΂̂ŒCDCĂ  */
    do {
        ret = CDC_GetSctNum(bufno, &nsct);
    } while (ret != CDC_ERR_OK);
    return (nsct);
}


/*************************************************
 * CSCT֐pCDobt@󂫃ZN^̎擾
 * ߂l : 󂫃ZN^
 *************************************************/
Sint32  STL_CsctGetFreeSctnum(void)
{
    Sint32      total, nblk, free;
    Sint32      ret;

    /* ̊֐CSCT֐Ă΂̂ŒCDCĂ  */
    do {
        ret = CDC_GetBufSiz(&total, &nblk, &free);
    } while (ret != CDC_ERR_OK);
    return (free);
}


/*************************************************
 * CSCTrbg̂҂
 *************************************************/
void    STL_WaitCsct(void)
{
    Sint32      i;
    Uint16      hirq;

    CDC_ClrHirqReq(~CDC_HIRQ_CSCT);
    for (i = 0; i < TIME_40MSEC; i++) {
        hirq = CDC_GetHirqReq();
        if ((hirq & CDC_HIRQ_CSCT) != 0) {
            break;
        }
    }
}


/* end of stm_loc.c     */









