/*****************************************************************************
 *      ff\tgt@C[_
 *
 *      Copyright (c) 1995 CSK Research Institute Corp.
 *      Copyright (c) 1995 SEGA
 *
 * Library:FLD
 * Module :I֐
 * File   :exit.c
 * Date   :1995-08-03
 * Version:1.10
 * Auther :T.K.
 *
 *****************************************************************************/

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#ifdef	__GNUC__
	#include <machine.h>
#else
	#include <machine2.h>
#endif

#include "sega_sys.h"
#include "sega_cdc.h"
#include "sega_gfs.h"
#include "sega_per.h"

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
/* iԍ */
#define FLT_READ        0       /* Ɨp */
#define FLT_DUMMY       23      /* [gfBNgւ̈ړp */

/* ^CAEgl */
#define TMOUT_HIRQREQ    2900000    /* HIRQREQ̃ftHg :  4s */
#define TMOUT_IPLTSK    15000000    /* IPǂݍ݃^XN    : 21s */

/* X^bN|C^ */
#define STACKPTR        0x06002000

/*****************************************************************************
 *      }N
 *****************************************************************************/
/* IP[hiA^j */
#define SYS_IPLGAMECD(dummy) \
            ((**(Sint32 (**)(Sint32))0x600029c)(dummy))

/* IP`FbNiA^j */
#define SYS_RUNGAMECD(dummy) \
            ((**(Sint32 (**)(Sint32))0x6000288)(dummy))

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/
static void restart(void);
static void execRestart(void);
static void initSaturn(void);
static Sint32 resetCd(void);
static Sint32 waitHirq(Sint32 flag);
static void chgDirRootDummy(void);
static void execIpChkRun(void);
static Sint32 setStackptr(Sint32 addr);

/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/

/*
 * I֐
 * []
 *      code : @\R[h
 *           0      : ċNiIP`FbN̎sj
 *           1      : }`v[̋N
 *           ̒l : [v
 *           ̑ : 0ƓiftHgj
 */
void exit(Sint32 code)
{
    switch(code) {
    case 1:     /* }`v[ɃWv */
        SYS_EXECDMP();
        break;
    default:
        if (code < 0) {
            for(;;);        /* ̒l̏ꍇ͖[v */
        }
        restart();
        break;
    }
}


/* ċNs֐ */
static void restart(void)
{
    /* 荞݋֎~ */
    set_imask(15);

    /* ċN̎s */
    execRestart();

    /*
     * }`v[̋N
     * iċNsƂ̂ݎsBj
     */
    SYS_EXECDMP();
}


/* ċNs֐ */
static void execRestart(void)
{
    Sint32  ret;
    Sint32  timer;

    /* ffsȊOȂ}`v[s */
    if (GFS_IS_DDS() == FALSE) {
        return;
    }

    /* }V̏ */
    initSaturn();

    /* CD̃\tgZbg */
    if (resetCd() != OK) {
        return;
    }

    /* IP[h̊Jn */
    ret = SYS_IPLGAMECD(0);
    if (ret != OK) {
        return;
    }

    /* IP`FbN */
    execIpChkRun();
}


/* }V̏ */
static void initSaturn(void)
{
    /* SMPC̏I҂X[uCPU̒~ */
    PER_SMPC_SSH_OFF();

    /* 26MHzɃNbN`FW */
    SYS_CHGSYSCK(0);
}


/* CD̃\tgZbg */
static Sint32 resetCd(void)
{
    /* \tgZbgI҂ */
    if (CDC_CdInit(1, 0, 0, 0) != CDC_ERR_OK) {
        return NG;
    }
    if (waitHirq(CDC_HIRQ_ESEL) != OK) {
        return NG;
    }

    /* `Iȃ[gfBNgւ̈ړ */
    chgDirRootDummy();

    return OK;
}


/* 荞ݗvWX^̃rbg1ɂȂ܂ő҂ */
static Sint32 waitHirq(Sint32 flag)
{
    Sint32  i;

    for (i = 0; i < TMOUT_HIRQREQ; i++) {
        if ((CDC_GetHirqReq() & flag) != 0) {
            return OK;
        }
    }
    return NG;
}


/* `Iȃ[gfBNgւ̈ړ */
static void chgDirRootDummy(void)
{
    CDC_ChgDir(FLT_DUMMY, CDC_NUL_FID);

    CDC_AbortFile();

    return;
}


/* IP`FbN */
/* iă^[Ȃ֐j */
static void execIpChkRun(void)
{
    /* X^bN|C^̕ۑ */
    static Sint32   savesp;

    register Sint32 timer;
    register Sint32 ret;

    /* X^bN̐ݒ */
    savesp = setStackptr(STACKPTR);

    timer = 0;
    while (TRUE) {
        ret = SYS_RUNGAMECD(0);
        if (ret < 0) {
            break;
        }
        if (timer++ > TMOUT_IPLTSK) {
            break;
        }
    }

    /* X^bN߂isvł邪Ô߁j */
    setStackptr(savesp);

    /* }`v[̋N */
    SYS_EXECDMP();
}


/*
 * X^bN̐ݒ
 * []
 *      addr : ݒ肷X^bN|C^
 * [֐l]
 *      ݒύXÕX^bN|C^̒lԂ
 */
/*	1995-10-02	N.K	*/
#ifdef	__GNUC__

static Sint32 setStackptr(Sint32 addr)
{
	asm("
          mov       r15, r0
          mov       r4, r15
	");
}

#else

#pragma inline_asm(setStackptr)
static Sint32 setStackptr(Sint32 addr)
{
          MOV.L       R15, R0
          MOV.L       R4, R15
}

#endif

/* end of file */
