/*----------------------------------------------------------------------*/
/*	rakUTvQ[[										*/
/*----------------------------------------------------------------------*/

#include	"sgl.h"
#include	"sega_scl.h"
#include	"sega_dbg.h"
#include	"sample.h"
#include	"game.h"



extern	SysPort		*PortData;
const SysDevice	*device;
trigger_t	pltrigger[2],pltriggerE[2];

Uint16	submode = 0, gameflg = 1;
trigger_t	*padbuf;
Uint16	playflg = 0, emptyflg = 0;
Uint16	pauseflg = 0;
/* Uint32	*padbuf = (Uint32*)0x00200000;	*/

	static sequence_t	action[] = {
		_obje1_act,
		_obje2_act,
		_shot1_1_act,
		_shot1_2_act,
		_shot2_1_act,
		_shot2_2_act,
	};

enum	__gamemodenumber__{
	GAME_SUB_INIT,
	GAME_SUB_DEMO,
	GAME_SUB_MAIN,
	GAME_SUB_END
};

static void _game_init( void ){
	game_init();
	playflg = 1;
	padbuf = ( trigger_t * )0x00200000;
	submode = GAME_SUB_DEMO;
}

static void _game_demo( void ){
	if( player_rotation() != 0 )
		submode = GAME_SUB_MAIN;
}

static void _game_main(void){
	int i;

	/* fpɃf[^ۑ	*/
	/*-----  `bNp
	if( pltriggerE[0] != 0 ){
		padbuf[n++] = pltriggerE[0];
	}						--------*/
	/* Rԕ̃f[^W	*/
	if( padbuf < (trigger_t*)0x00215180 ){
		*padbuf++ = pltrigger[0];
		*padbuf++ = pltrigger[1];
	}

	/* |[Y̏	*/
	if( ( ( pltriggerE[0] | pltriggerE[1] ) & TRG_START) != 0 ){
		if( pauseflg == 0 )
			pauseflg = 1;			/* |[Y		*/
		else
			pauseflg = 2;			/* |[Y	*/
	}

	if( pauseflg != 0 ){
		if( pauseflg == 1 ){
			DBG_SetCursol( 15, 12 );
			DBG_Printf( "* PAUSE *" );
		}
		else{
			pauseflg = 0;
			DBG_SetCursol( 15, 12 );
			DBG_Printf("         ");
		}
		_pause_act();
		return;
	}

	chg_angle();

	/* ANV[v	*/
	for( i = 0 ; i < 6 ; i++ )
		action[i]();

	disp_life();

	if( endflg != 0 )
		submode = GAME_SUB_END;

}

static void _game_end(void){
	/*	submode=GAME_SUB_INIT;	*/
	gameflg = 0;
}

/* C[`	*/
void game(){

	static sequence_t	sub[] = {
		_game_init,
		_game_demo,
		_game_main,
		_game_end,
	};

	/* Q[̃C[v	*/
	while( gameflg ){

		/* pbhf[^Rs[	*/
		device = PER_GetDeviceR( &PortData[0], 0 );
		pltriggerE[0] = pltrigger[0];
		pltrigger[0] = PER_GetTrigger( device );
		pltriggerE[0] = (pltrigger[0]) ^ (pltriggerE[0]);
		pltriggerE[0] = (pltrigger[0]) & (pltriggerE[0]);

		device = PER_GetDeviceR( &PortData[1], 0 );
		pltriggerE[1] = pltrigger[1];
		pltrigger[1] = PER_GetTrigger( device );
		pltriggerE[1] = (pltrigger[1]) ^ (pltriggerE[1]);
		pltriggerE[1] = (pltrigger[1]) & (pltriggerE[1]);

		/* sub[level[1]]();	*/
		sub[submode]();

		/* uuN҂	*/
		slSynch();
	}

	/* Q[I (gameflg = 0)ɗA
		   CV[PXɖ߂葱	*/
	gameflg = 1;
	submode = 0;
	level[0] = SQ_INIT;
}


/* fp	*/
void game_demo(void){
	int i;

	/* obt@ytFf[^𓾂	*/
	if(padbuf < (trigger_t*)0x00215180){
		pltrigger[0] = *padbuf++;
		pltrigger[1] = *padbuf++;
	}
	else
		emptyflg = 1;				/* f[^Ȃ	*/

	chg_angle();

	/* ANV[v	*/
	for( i = 0 ; i < 6 ; i++ )
		action[i]();
}
