/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994 SEGA
 *
 * Library:t@CVXe
 * Module :TvP
 * File   :smpgfs01.c
 * Date   :1996-02-01
 * Version:2.10
 * Author :M.S.
 *
 *      t@C̒Pȓǂݍ݁B
 *      gfssmp1a.abs̓t@CʎqŃANZXA
 *      gfssmp1b.abs̓t@CŃANZXB
 *
 *****************************************************************************/

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include <sega_gfs.h>

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
/* ɃI[vt@C̐ */
#define MAX_OPEN        1

/* [gfBNgɂt@C */
#define MAX_DIR         100

/* PZN^̑傫ioCgj */
#define SECT_SIZE       2048

/* ǂݍ݃ZN^ */
#define RD_SIZE         1

#if defined(DEBUG)
/* ANZXt@C */
#define FNAME           "SIZE10S.DAT"
#else
/* ANZXt@Cʎq */
#define FID             2
#endif

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/
GfsHn openFileByName(GfsDirTbl *dirtbl, Sint8 *fname);

/*****************************************************************************
 *      ϐ̒`
 *****************************************************************************/
/* CuƗ̈ */
Uint32 lib_work[GFS_WORK_SIZE(MAX_OPEN) / sizeof(Uint32)];

GfsDirTbl dirtbl;                       /* fBNgǗ̈ */

/* fBNgi[̈ */
#if defined(DEBUG)
GfsDirName dirname[MAX_DIR];            /* t@C܂񂾏 */
#else
GfsDirId dirid[MAX_DIR];                /* t@C܂܂Ȃ */
#endif

Uint32 buf[SECT_SIZE * RD_SIZE / sizeof(Uint32)];       /* ǂݍ݃f[^i[̈ */


/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/
Sint32 main()
{
    Sint32 ret;
    GfsHn gfs;                  /* t@Cnh */

    /* fBNgǗ̈setup */
#if defined(DEBUG)
    GFS_DIRTBL_TYPE(&dirtbl) = GFS_DIR_NAME;
    GFS_DIRTBL_DIRNAME(&dirtbl) = dirname;
#else
    GFS_DIRTBL_TYPE(&dirtbl) = GFS_DIR_ID;
    GFS_DIRTBL_DIRID(&dirtbl) = dirid;
#endif
    GFS_DIRTBL_NDIR(&dirtbl) = MAX_DIR;
    /* t@CVXȅ */
    ret = GFS_Init(MAX_OPEN, lib_work, &dirtbl);
    if (ret <= 2) {
        return 1;
    }
    /* t@CJ */
#if defined(DEBUG)
    gfs = openFileByName(&dirtbl, FNAME);
#else
    gfs = GFS_Open(FID);
#endif
    if (gfs == NULL) {
        return 2;
    }
    /* t@Cǂݍ */
    GFS_Fread(gfs, RD_SIZE, buf, SECT_SIZE * RD_SIZE);
    /* t@C */
    GFS_Close(gfs);
    return 0;
}


#if defined(DEBUG)
/* t@Cw肵ăt@CJ */
GfsHn openFileByName(GfsDirTbl *dirtbl, Sint8 *fname)
{
    Sint32 fid;

    /* t@Ct@Cʎq߂ */
    fid = GFS_NameToId(fname);
    return GFS_Open(fid);
}
#endif









