/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994 SEGA
 *
 * Library:\tgEFACu
 * Module :TvQ
 * File   :smpgfs02.c
 * Date   :1994-02-01
 * Version:2.10
 * Author :M.S.
 *
 *      t@CANZX܂B
 *
 *****************************************************************************/

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include <sega_gfs.h>

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
/* ɃI[vt@C̐ */
#define MAX_OPEN        3

/* [gfBNgɂt@C */
#define MAX_DIR         100

/* PZN^̑傫ioCgj */
#define SECT_SIZE       2048

/* ǂݍ݃ZN^ */
#define RD_SIZE1        2
#define RD_SIZE2        3
#define RD_SIZE3        4

/* ANZXt@C */
#define FNAME1          "SIZE10S.DAT"
#define FNAME2          "SIMM1.DAT"
#define FNAME3          "SIMM_DOS.DAT"

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/
GfsHn openFileByName(GfsDirTbl *dirtbl, Sint8 *fname);
void user(void);

/*****************************************************************************
 *      ϐ̒`
 *****************************************************************************/
GfsDirTbl dirtbl;                       /* fBNgǗ̈ */

/* fBNgi[̈ */
GfsDirName dir_name[MAX_DIR];           /* t@C܂񂾏 */

/* CuƗ̈ */
Uint32 lib_work[GFS_WORK_SIZE(MAX_OPEN) / sizeof(Uint32)];

Uint32 buf1[SECT_SIZE * RD_SIZE1 / sizeof(Uint32)];     /* ǂݍ݃f[^i[̈ */
Uint32 buf2[SECT_SIZE * RD_SIZE2 / sizeof(Uint32)];     /* ǂݍ݃f[^i[̈ */
Uint32 buf3[SECT_SIZE * RD_SIZE3 / sizeof(Uint32)];     /* ǂݍ݃f[^i[̈ */

/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/

Sint32 main()
{
    GfsHn gfs1;                 /* t@Cnh1 */
    GfsHn gfs2;                 /* t@Cnh2 */
    GfsHn gfs3;                 /* t@Cnh3 */
    GfsHn now_gfs;
    Sint32 stat, nfile;

    /* fBNgǗ̈setup */
    GFS_DIRTBL_TYPE(&dirtbl) = GFS_DIR_NAME;
    GFS_DIRTBL_NDIR(&dirtbl) = MAX_DIR;
    GFS_DIRTBL_DIRNAME(&dirtbl) = dir_name;
    /* t@CVXȅ */
    nfile = GFS_Init(MAX_OPEN, lib_work, &dirtbl);
    if (nfile <= 2) {
        return 1;
    }
    /* t@CJ */
    gfs1 = openFileByName(&dirtbl, FNAME1);
    if (gfs1 == NULL) {
        return 2;
    }
    gfs2 = openFileByName(&dirtbl, FNAME2);
    if (gfs2 == NULL) {
        return 3;
    }
    gfs3 = openFileByName(&dirtbl, FNAME3);
    if (gfs3 == NULL) {
        return 4;
    }
    /* t@Cǂݍ݊Jn */
    GFS_NwFread(gfs1, RD_SIZE1, buf1, SECT_SIZE * RD_SIZE1);
    GFS_NwFread(gfs2, RD_SIZE2, buf2, SECT_SIZE * RD_SIZE2);
    GFS_NwFread(gfs3, RD_SIZE3, buf3, SECT_SIZE * RD_SIZE3);
    for (;;) {
        stat = GFS_NwExecServer(&now_gfs);
        if (stat == GFS_SVR_COMPLETED) {
            break;
        }
        user();
    }
    /* t@C */
    GFS_Close(gfs1);
    GFS_Close(gfs2);
    GFS_Close(gfs3);
    return 0;
}


/* t@Cw肵ăt@CJ */
GfsHn openFileByName(GfsDirTbl *dirtbl, Sint8 *fname)
{
    Sint32 fid;

    /* t@Ct@Cʎq߂ */
    fid = GFS_NameToId(fname);
    return GFS_Open(fid);
}


void user(void)
{
    /* t@Cǂݍ݂ƕsčsȂLq */
    /* ̃Tvł͉sȂȂ */
}
