/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:sample program of STREAM PLAY MODE
 * File		:smppcm2.c
 * Date		:1995-03-31
 * Version	:1.16
 * Auther	:Y.T
 *
 * Comment	:
 *	Xg[VXegĂbc̃t@CĐTv
 *	t@C "SAMPLE1.AIF"
 *
 ****************************************************************************/

/*------------------------- svOIt -------------------------*/

/* VTV, MON gpfobO̎ɒ`B */
/* #define SMPPCM_DEBUG */

/*------------------------- sCN[ht -------------------------*/
#include <machine.h>
#include <string.h>
#define _SH
#include "sega_xpt.h"
#include "sega_sys.h"
#include "sega_int.h"
#include "sega_per.h"
#include "sega_cdc.h"
#include "sega_gfs.h"
#include "sega_stm.h"
#include "sega_snd.h"
#include "sega_pcm.h"

#if	1
	/*
	**1995-07-28	q
	**	SCL_VblankStart(), SCL_VBlankEnd() gĂ̂Œǉ
	*/
	#include	"sega_scl.h"
#endif

#ifdef SMPPCM_DEBUG
	#include "..\smppcmd\smppcmd.c"
	#define SMPPCMD_VblIn				smppcmd_VblIn
	#define SMPPCMD_Init				smppcmd_Init
	#define SMPPCMD_MON_Reset			smppcmd_MON_Reset
	#define SMPPCMD_PCM_Task			smppcmd_PCM_Task
#else
	#define SMPPCMD_VblIn()				
	#define SMPPCMD_Init(a)				
	#define SMPPCMD_MON_Reset()			
	#define SMPPCMD_PCM_Task			PCM_Task
	#define VTV_Printf(a)				
	#define VTV_PRINTF(a)				
	#define _VTV_Printf(a)				
	#define _VTV_PRINTF(a)				
#endif


/*--------------------------- s֐錾t ---------------------------*/

static void vblInit(void);
static void smpVblIn(void);
static void smpVblOut(void);


/*---------------------------- s萔t ----------------------------*/

/* EF[uq`l̓]AhXƃTv */
#define	PCM_ADDR	((void*)0x25a20000)
#define	PCM_SIZE	(4096L*2)				/* 2.. */

/* Oobt@̃TCY */
#define	RING_BUF_SIZE	(2048L*10)			/* 10.. */

/* f[^̓]ibcubNOobt@j */
#define TR_MODE_CD		PCM_TRMODE_SCU		/* rbt̂cl`				*/
#if 0
#define TR_MODE_CD		PCM_TRMODE_CPU		/* \tgEFA] 			*/
#define TR_MODE_CD		PCM_TRMODE_SDMA		/* cl`TCNX`[ 		*/
#endif

/*----------------------- sO[oϐt -----------------------*/

/* [Nobt@ */
static PcmWork g_movie_work;

/* Oobt@ */
Uint32 g_movie_buf[RING_BUF_SIZE / sizeof(Uint32)];

/* Đt@C */
static char filename[] = "SAMPLE1.AIF";


/*---------------------------- s֐t ----------------------------*/

void errGfsFunc(void *obj, Sint32 ec)
{
	VTV_PRINTF((VTV_s, "S:ErrGfs %X %X\n", obj, ec));
}

void errStmFunc(void *obj, Sint32 ec)
{
	VTV_PRINTF((VTV_s, "S:ErrStm %X %X\n", obj, ec));
}

void errPcmFunc(void *obj, Sint32 ec)
{
	VTV_PRINTF((VTV_s, "S:ErrPcm %X %X\n", obj, ec));
}


/*====================== uuN̏ ===========================*/

static void vblInit(void)
{
    set_imask(0);

	/* uuN̐ݒ */
	INT_ChgMsk(INT_MSK_NULL,INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT);
	INT_SetScuFunc(INT_SCU_VBLK_IN, smpVblIn);
	INT_SetScuFunc(INT_SCU_VBLK_OUT, smpVblOut);
	INT_ChgMsk(INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT,INT_MSK_NULL);
}

static void smpVblIn(void)
{
	/* oblCu VblIn [`R[ */
	PCM_VblIn();

	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankStart();
}

static void smpVblOut(void)
{
	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankEnd();
}


/*====================== TEh̏ ===========================*/
#define SDDRVS_TSK_SIZE			(0x6000)
#define BOOTSND_MAP_SIZE		(0x0100)
Sint32 sddrvs_tsk[SDDRVS_TSK_SIZE / 4];
Sint32 bootsnd_map[BOOTSND_MAP_SIZE / 4];

static Sint32 fileLoad(Sint8 *name, void *addr, Sint32 bsize)
{
	Sint32 		fid, i;

	for (i = 0; i < 10; i++) {
		fid = GFS_NameToId(name);
		if (fid >= 0) {
			GFS_Load(fid, 0, addr, bsize);
			return 0;
		}
	}
	return -1;
}

static void sndInit(void)
{
	SndIniDt 	snd_init;

	if (fileLoad("SDDRVS.TSK", (void *)sddrvs_tsk, SDDRVS_TSK_SIZE)) {
		return;
	}
	if (fileLoad("BOOTSND.MAP", (void *)bootsnd_map, BOOTSND_MAP_SIZE)) {
		return;
	}
	SND_INI_PRG_ADR(snd_init) 	= (Uint16 *)sddrvs_tsk;
	SND_INI_PRG_SZ(snd_init) 	= (Uint16 )SDDRVS_TSK_SIZE;
	SND_INI_ARA_ADR(snd_init) 	= (Uint16 *)bootsnd_map;
	SND_INI_ARA_SZ(snd_init) 	= (Uint16)BOOTSND_MAP_SIZE;
	SND_Init(&snd_init);
	SND_ChgMap(0);
}


/*====================== t@C̏ ===========================*/

/* [gfBNgɂt@C̍ő吔 */
#define MAX_DIR		100

/* ɊJt@C̍ő吔 */
#define OPEN_MAX	5

/* Xg[O[v̂hc */
static StmGrpHn grp_hd;

/* fBNgǗ̈ */
static GfsDirTbl	dir_tbl;

/* t@C܂񂾏 */
static GfsDirName dir_name[MAX_DIR];

/* fer̍Ɨ̈ */
GfsMng g_gfs_work;
Uint8 g_gfs_work2[GFS_WORK_SIZE(OPEN_MAX)-sizeof(GfsMng)];

static Uint8   stm_work[STM_WORK_SIZE(12, 24)];

static void fileInit(void)
{
	Sint32 file_num;

	/* GFS̏ */
	GFS_DIRTBL_TYPE(&dir_tbl) = GFS_DIR_NAME;
	GFS_DIRTBL_DIRNAME(&dir_tbl) = dir_name;
	GFS_DIRTBL_NDIR(&dir_tbl) = MAX_DIR;

    /* t@CVXȅ */
    file_num = GFS_Init(OPEN_MAX, &g_gfs_work, &dir_tbl);
	if (file_num < 0) {
		return;
	}

	/* G[֐̐ݒ */
	GFS_SetErrFunc(errGfsFunc, NULL);
}

static void stmInit(void)
{
	/* Xg[VXȅ */
	STM_Init(12, 24, stm_work);

	/* G[֐̐ݒ */
	STM_SetErrFunc(errStmFunc, NULL);

	/* Xg[O[ṽI[v */
	grp_hd = STM_OpenGrp();
	if (grp_hd == NULL) {
		return;
	}
	STM_SetLoop(grp_hd, STM_LOOP_DFL, STM_LOOP_ENDLESS);
	STM_SetExecGrp(grp_hd);
}

static StmHn stmOpen(char *fname)
{
    Sint32 fid;
	StmKey key;

    /* t@Ct@Cʎq߂ */
    fid = GFS_NameToId((Sint8 *)fname);
	STM_KEY_FN(&key) = STM_KEY_CN(&key) = STM_KEY_SMMSK(&key) = 
		STM_KEY_SMVAL(&key) = STM_KEY_CIMSK(&key) = STM_KEY_CIVAL(&key) =
		STM_KEY_NONE;
	return STM_OpenFid(grp_hd, fid, &key, STM_LOOP_NOREAD);
}

static void stmClose(StmHn fp)
{
	STM_Close(fp);
}

void main(void)
{
	PcmHn 			pcm;
	StmHn			stm;
	PcmCreatePara	para;
	Uint32			restart;

	/* uuN̐ݒ */
	vblInit();

	/* t@C */
	fileInit();

	/* TEh̐ݒ */
	sndInit();

	/* oblCȕ */
	PCM_Init();

	/* `coblgp錾 (ADPCMLײ؂ݸ܂) */
	PCM_DeclareUseAdpcm();

	/* oblCũG[nh̐ݒ */
	PCM_SetErrFunc(errPcmFunc, NULL);

	/* Xg[VXȅ */
	stmInit();

	restart = 1;

	for (;;) {
		if (restart) {
			/* Xg[I[v */
			if ((stm = stmOpen(filename)) == NULL) {
				return;
			}

			/* ö̃Zbg
			 *	Xg[VXe̎dl...
			 *	ŏ̓] STM_ExecServer ōsȂA͕svB
			*/
			STM_ResetTrBuf(stm);

			/* nh̍쐬 */
			PCM_PARA_WORK(&para) = (struct PcmWork *)&g_movie_work;
			PCM_PARA_RING_ADDR(&para) = (Sint8 *)g_movie_buf;
			PCM_PARA_RING_SIZE(&para) = RING_BUF_SIZE;
			PCM_PARA_PCM_ADDR(&para) = PCM_ADDR;
			PCM_PARA_PCM_SIZE(&para) = PCM_SIZE;
			pcm = PCM_CreateStmHandle(&para, stm);
			if (pcm == NULL) {
				return;
			}

			/* f[^̓]̐ݒibcubNOobt@j */
			/* PCM_SetTrModeCd(pcm, TR_MODE_CD); */

			/* Jn */
			PCM_Start(pcm);

			restart = 0;
		}

		/* T[o̎s */
		STM_ExecServer();

		/* Đ^XN */
		PCM_Task(pcm);

		/* [ȑI */
		if (PCM_GetPlayStatus(pcm) == PCM_STAT_PLAY_END) {

			/* nh̏ */
			PCM_DestroyStmHandle(pcm);

			/* Xg[̃N[Y*/
			stmClose(stm);

			restart = 1;
		}
	}
}
