/*
**PER_X.H
**	ytFCu̍h^eCu
**	
**	PER_OpenPort()
**		ytFCuB
**	PER_GetPort()
**		ytFf[^WB
**		i V-BLANK-OUT 荞݃nh̒ŃR[邱ƁBj
**	PER_GetDeviceA()
**		WytFf[^foCX𓾂BiΈʒuwj
**	PER_GetDeviceR()
**		WytFf[^foCX𓾂BiΈʒuwj
**	
**	SysPort
**		ytF
**	
**	
**	L̂R̒萔̒lKXύXAăRpCĎgpĂB
**	_MAX_PORT
**		r`stqm{̂ɂĂ[q̐
**		iʏ́A2 ɐݒ肵Ăj
**	_MAX_PERIPHERAL
**		P̒[qɐڑ\ȃytF̐
**		iʏ́A}`^[~iɑΉ邽߂ 6 ȏɐݒ肵Ăj
**	SZ_PERIPHERAL
**		P̃ytF̃f[^TCY̍ő
**	
**	SZ_BUFFER
**		ytFCugp郏[NGÃTCYłB
*/
#if	!defined( __PER_X_H )
	#define	__PER_X_H
	
	/****************************************
	*			include files				*
	****************************************/
	#include	"sega_xpt.h"
	#include	"sega_per.h"
	
	#include	"per_dev.h"
	#include	"per_dgt.h"
	#include	"per_anlg.h"
	#include	"per_poin.h"
	#include	"per_kbrd.h"
	#include	"per_md.h"
	#include	"per_trg.h"
	
	/****************************************
	*			define constants			*
	****************************************/
	#define	EXIT_SUCCESS	0
	
	#define	_MAX_PORT		2
	#define	_MAX_PERIPHERAL	6
	#define	SZ_PERIPHERAL	5
	#define	SZ_BUFFER		((_MAX_PORT*_MAX_PERIPHERAL*(SZ_PERIPHERAL+2)*2)+SZ_PERIPHERAL)
	
	#define	PID_GUN		0x0a
	
	#define	MID_GUN		0xa0
	
	#define	PER_LOCK	0x00000001
	
	/****************************************
	*		declare object types			*
	****************************************/
	typedef	Uint8	SysPeripheral[SZ_PERIPHERAL+2];
	
	typedef	struct	SysPort	{
		Uint8			id;
		Uint8			connectable;
		SysPeripheral	*peripheral;
	} SysPort;
	
	/****************************************
	*			declare functions			*
	****************************************/
	#if	!defined( __GNUC__ )
		#define	inline
	#endif
	
	static inline int	PER_GetPortID( SysPort	*port ){
		return	( int )( port->id >> 4 );
	}
	
	SysPort		*PER_OpenPort( void );
	void		PER_GetPort( SysPort	*port );
	const SysDevice	*PER_GetDeviceA( const SysPort	*port, Uint32	n );
	const SysDevice	*PER_GetDeviceR( const SysPort	*port, Uint32	n );
	
#endif

