/*-----------------------------------------------------------------------------
 *  FILE: snd_main.c
 *
 *      Copyright (c) by SEGA.
 *
 *  PURPOSE:
 *
 *      TEhI/FCu\[Xt@CB
 *
 *  DESCRIPTION:
 *
 *      TEhhCoƂ̃C^tF[XB
 *
 *  INTERFACE:
 *
 *      < FUNCTIONS LIST >
 *
 *  CAVEATS:
 *
 *      ȂB
 *
 *  AUTHOR(S)
 *
 *      1994-05-18  N.T Ver.0.90
 *
 *  MOD HISTORY:
 *
 *      1994-11-08  N.T Ver.1.09
 *      1994-12-30  N.T Ver.1.10
 *      1994-12-30  K.T Ver.1.10(+)
 *		1995-03-23	Y.K Ver.1.11
 *
 *-----------------------------------------------------------------------------
 */


/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include <string.h>
#include <machine.h>
#include "sega_xpt.h"
#include "sega_int.h"
#include "sega_per.h"
#include "sega_dma.h"

/*
 * USER SUPPLIED INCLUDE FILES
 */
#include "snd_main.h"

/*
 * GLOBAL DECLARATIONS
 */
Uint8 *snd_adr_sys_int_work;                 /*Ѳ̪ܰ擪ڽi[*/
Uint32 snd_msk_work_work;                    /* sound priority msk        */

/*
 * LOCAL DEFINES/MACROS
 */
#if 0
#define _DMA_SCU                                /* SCU DMA gp        */
#endif
/* 萔 */
/**** AhX ***************************************************************/
#if	0
/*
**1995-11-2
**	
*/
#define ADR_SCSP_REG    ((Uint8 *)0x25b00400)   /* SCSPʐ䃌WX^      */
#define ADR_SND_MEM     ((Uint8 *)0x25a00000)   /* TEh擪AhX*/
#define ADR_SND_VECTOR  ((Uint8 *)0x25a00000)   /* TEhxN^AhX    */
#else
#define ADR_SCSP_REG    ((volatile Uint8 *)0x25b00400)   /* SCSPʐ䃌WX^      */
#define ADR_SND_MEM     ((volatile Uint8 *)0x25a00000)   /* TEh擪AhX*/
#define ADR_SND_VECTOR  ((volatile Uint8 *)0x25a00000)   /* TEhxN^AhX    */
#endif
#define ADR_SYS_TBL     (ADR_SND_MEM + 0x400)   /* Ѳ̪̈           */

/**** VXeC^tF[Xe[uItZbg *******************************/
#define ADR_SYS_INFO    (0x00)                  /* яðٱڽ        */
#define ADR_HOST_INT    (0x04)                  /* νĲ̪ܰڽ        */
#define ADR_ARA_CRNT    (0x08)                /* ޴رϯCRNTܰ擪ڽ*/
#define ADR_SYS_INT_WORK    (0x12)            /* Ѳ̪ܰ擪ڽ     */
#define ADR_HARD_CHK_STAT   (0x18)            /* ʰݽði[ܰ    */

/**** VXee[uItZbg *****************************************/
#define ADR_PRG_ADR     (0x00)                  /* 68K۸ї̈擪ڽ   */
#define ADR_PRG_SIZE    (0x04)                  /* 68K۸ї̈滲        */
#define ADR_ARA_ADR     (0x08)                  /* ޴رϯߗ̈擪ڽ */

/**** zXgC^tF[X[NItZbg ***********************************/
#define ADR_COM_DATA    (0x00)                  /* R}h                  */
#define ADR_PRM_DATA    (0x02)                  /* p[^                */
#define ADR_SONG_STAT   (0x80)                  /* song status               */
#define ADR_TL_VL       (0x90)                  /* Total volume              */
#define ADR_TL_HZ_VL    (0x94)                  /* gшVolume        */
#define ADR_PCM         (0xa0)                  /* PCM                       */
#define ADR_SEQ         (0xb0)                  /* Sequence                  */
/**** zXgC^tF[X[N萔 *****************************************/
#define SIZE_COM_BLOCK      (0x10)              /* ۯ          */
#define MAX_NUM_COM_BLOCK   8                   /* ۯ              */

/**** TEhN ***********************************************************/
#define SCSP_REG_SET    0x0200                  /* SCSPWX^ݒl        */
#define MEM_CLR_SIZE    0xb000                  /* ظر           */

/**** TEhGA}bv(ݸܰޒP) *********************************/
#define ARA_MAP_SIZE        0x2                 /* ޴رϯ߻          */
/******** ItZbgl(ݸܰޒP) *****************************************/
#define ARA_MAP_0           0x0         /* ް,ްԍ,رJnڽ    */
#define ARA_MAP_4           0x1         /* ]ςޯ,ر              */
/******** rbgʒu *********************************************************/
#define B_END_MARK          31                  /* ްIޯ              */
#define B_DATA_ID           28                  /* ްʁ@@@@@@@    */
#define B_ID_NUM            24                  /* ްԍ                  */
#define B_START_ADR         0                   /* ıڽ                 */
#define B_LOAD_MARK         31                  /* ]ςޯ              */
#define B_AREA_SIZE         0                   /* ر                   */
/******** }XNrbg *******************************************************/
#define M_END_MARK         (0x1  << B_END_MARK) /* ްIޯ              */
#define M_DATA_ID          (0x7  << B_DATA_ID)  /* ްʁ@@@@@@@    */
#define M_ID_NUM           (0xf  << B_ID_NUM)   /* ްԍ                  */
#define M_START_ADR        (0xfffff << B_START_ADR) /* ıڽ             */
#define M_LOAD_MARK        (0x1  << B_LOAD_MARK)/* ]ςޯ              */
#define M_AREA_SIZE        (0xfffff << B_AREA_SIZE) /* ر               */

/**** R}h ***************************************************************/
#define COM_START_SEQ      0x01                 /* Sequence Start            */
#define COM_STOP_SEQ       0x02                 /* Sequence Stop             */
#define COM_PAUSE_SEQ      0x03                 /* Sequence Pause            */
#define COM_CONT_SEQ       0x04                 /* Sequence Continue         */
#define COM_SET_SEQ_VL     0x05                 /* Sequence Volume           */
#define COM_CHG_TEMPO      0x07                 /* Tempo Change              */
#define COM_CHG_MAP        0x08                 /* map Change                */
#define COM_CTRL_DIR_MIDI  0x09                 /* MIDI direct control       */
#define COM_START_VL_ANL   0x0a                 /* Volume analize start      */
#define COM_STOP_VL_ANL    0x0b                 /* Volume analize stop       */
#define COM_STOP_DSP       0x0c                 /* DSP stop                  */
#define COM_OFF_ALL_SOUND  0x0d                 /* Sound all OFF             */
#define COM_SET_SEQ_PAN    0x0e                 /* Sequence PAN              */
#define COM_SET_3D_SOUND	0x11				/* 3D sound paramator set	*/
#define COM_SET_QSOUND		0x12				/* Qsound paramator set		*/
#define COM_SET_3D_INIT		0x13				/* 3D sound position init	*/
#define COM_SET_CD_DA_LEV  0x80                 /* CD-DA Level               */
#define COM_SET_CD_DA_PAN  0x81                 /* CD-DA pan                 */
#define COM_SET_TL_VL      0x82                 /* Total Volume              */
#define COM_CHG_EFCT       0x83                 /* Effect Change             */
#define COM_START_PCM      0x85                 /* PCM start                 */
#define COM_STOP_PCM       0x86                 /* PCM stop                  */
#define COM_CHG_MIX        0x87                 /* Mixer change              */
#define COM_CHG_MIX_PRM    0x88                 /* Mixer parameter change    */
#define COM_CHK_HARD       0x89                 /* Hard check                */
#define COM_CHG_PCM_PRM    0x8a                 /* PCM parameter change      */

/* }N */
/**** Cg ***********************************************************/
#define POKE_B(adr, data)   (*((volatile Uint8 *)(adr)) = ((Uint8)(data)))   /* ޲  */
#define POKE_W(adr, data)   (*((volatile Uint16 *)(adr)) = ((Uint16)(data))) /* ܰ  */
#define POKE_L(adr, data)   (*((volatile Uint32 *)(adr)) = ((Uint32)(data))) /* ݸ  */
/**** [h ***********************************************************/
#define PEEK_B(adr)         (*((volatile Uint8 *)(adr)))                     /* ޲  */
#define PEEK_W(adr)         (*((volatile Uint16 *)(adr)))                    /* ܰ  */
#define PEEK_L(adr)         (*((volatile Uint32 *)(adr)))                    /* ݸ  */
/**** ݸܰ޳ؕϊ(Middle SCU̐ *******************************/
#define CHG_LONG(x)    (((x) * 2) + (0x4 - ( ((x) * 2) % 4) ))
/**** zXgC^tF[X[N}N ***************************************/
#define MAX_ADR_COM_DATA                        /* őްڽ     */\
    (adr_host_int_work + ADR_COM_DATA + (SIZE_COM_BLOCK * MAX_NUM_COM_BLOCK))
#define NOW_ADR_COM_DATA                        /* ݺްڽ     */\
    (adr_com_block + ADR_COM_DATA)
/**** TEhhCoR}hubNݒ֐}N *****************/
#define HOST_SET_INIT()\
    Uint32 msk;\
    do{\
        msk = get_imask();\
        set_imask(0xf);\
    }while(FALSE)
/**** TEhhCoR}hubNݒ֐^[}N *****************/
/* 1994/02/24 Start */
#if 0
#define HOST_SET_RETURN(ret)\
    do{\
        set_imask(msk);\
		intrflag = 0;
        return (ret);\
    }while(FALSE)
#endif

/* 荞ݎgp2dĂяoh~tO */
static Uint32 intrflag;
#define HOST_SET_RETURN(ret)\
    do{\
		intrflag=0;\
        return(ret);\
    }while(FALSE)

/*** TEhhCoւ̃ANZXEF[g}N */
#define _WAIT_() do{\
int i,j;for(i=0;i<32;i++) j=*(volatile int *)0;\
}while(0)
/* 1994/02/24 End */

/******************************************************************************
 *
 * NAME:    SET_COMMAND()       - R}hZbg
 *
 * PARAMETERS :
 *      (1) Uint16 set_com      - <i>   R}h
 *
 * DESCRIPTION:
 *      R}hC^tF[ẌɃZbg܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ނւWRITE16bitōsȂ܂B16bit̏8bitֺނĂ܂
 *
 ******************************************************************************
 */

#define SET_COMMAND(set_com)\
(POKE_W((adr_com_block + ADR_COM_DATA), (Uint16)(set_com) << 8)) /* R}hZbg   */

/******************************************************************************
 *
 * NAME:    SET_PRM()           - p[^Zbg
 *
 * PARAMETERS :
 *      (1) Uint32 no           - <i>   p[^ԍ
 *      (2) Uint8 set_prm       - <i>   p[^
 *
 * DESCRIPTION:
 *      p[^C^tF[ẌɃZbg܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

#define SET_PRM(no, set_prm)\
(POKE_B(adr_com_block + ADR_PRM_DATA + (no), (set_prm))) /* ҰZbg      */

/*
 * STATIC DECLARATIONS
 */ 
static volatile Uint8 *adr_sys_info_tbl;                 /* яðٱڽi[    */
static volatile Uint8 *adr_host_int_work;                /* νĲ̪ܰ擪ڽi[*/
static volatile Uint32 *adr_snd_area_crnt;             /* ޴رϯCRNTܰ擪ڽ*/
static volatile Uint16 *adr_song_stat;                   /* song status               */
static volatile Uint16 *adr_tl_vl;                       /* Total volume              */
static volatile Uint16 *adr_tl_hz_vl;                    /* gшVolume        */
static volatile Uint16 *adr_pcm;                         /* PCM                       */
static volatile Uint16 *adr_seq;                         /* Sequence                  */
static volatile Uint8  *adr_com_block;                   /* ݏݺۯ      */

/*
 * STATIC FUNCTION PROTOTYPE DECLARATIONS
 */
static void DmaClrZero(void *, Uint32);
static void GetSndMapInfo(void **, Uint32 **, Uint16, Uint16);
static Uint16 ChgPan(SndPan);
static void CopyMem(void *,void *,Uint32);
static Uint8 GetComBlockAdr(void);


/******************************************************************************
 *
 * NAME:    SND_Init()  - TEhVXeN
 *
 * PARAMETERS :
 *      (1) SndIniDt *sys_ini       - <i>   VXeNpf[^
 *
 * DESCRIPTION:
 *      VXeNpf[^ɏ]āATEhVXeNB
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void SND_Init(SndIniDt *sys_ini)
{
    /** BEGIN ****************************************************************/
#ifdef _DMA_SCU
    DMA_ScuInit();                              /* DMA SCU         */
#endif /* _DMA_SCU */

    PER_SMPC_SND_OFF();                         /* TEhOFF               */
    POKE_W(ADR_SCSP_REG, SCSP_REG_SET); 
                                                /* SCSPڼ޽ݒ         */
    DmaClrZero(ADR_SND_MEM, MEM_CLR_SIZE);      /* DMA[NA       */
    CopyMem(ADR_SND_VECTOR,
                   (void *)(SND_INI_PRG_ADR(*sys_ini)),
                   SND_INI_PRG_SZ(*sys_ini));   /* 68K۸ѓ]            */

    adr_sys_info_tbl = (Uint8 *)(ADR_SND_MEM + PEEK_L(ADR_SYS_TBL +
                                 ADR_SYS_INFO));
                                                /* яðٱڽ擾    */
    adr_host_int_work = (Uint8 *)(ADR_SND_MEM + PEEK_L(ADR_SYS_TBL +
                                  ADR_HOST_INT));
                                                /* νĲ̪ܰڽ擾    */
    snd_adr_sys_int_work = (Uint8 *)(ADR_SND_MEM + 
                 ((Uint32)PEEK_W(ADR_SYS_TBL + ADR_SYS_INT_WORK) << 16
                  | (Uint32)PEEK_W(ADR_SYS_TBL + ADR_SYS_INT_WORK + 2)));
                                                /* Ѳ̪ܰڽ擾   */
                                                
    adr_com_block = adr_host_int_work;  /* ݏݺۯڽ */
                                                
    adr_snd_area_crnt = (Uint32 *)(ADR_SND_MEM + 
                                  PEEK_L(ADR_SYS_TBL + ADR_ARA_CRNT));
                                                /* ޴رϯCRNTܰ擾   */
    adr_song_stat = (Uint16 *)(adr_host_int_work + ADR_SONG_STAT);
    adr_pcm = (Uint16 *)(adr_host_int_work + ADR_PCM);
    adr_seq = (Uint16 *)(adr_host_int_work + ADR_SEQ);
    adr_tl_vl = (Uint16 *)(adr_host_int_work + ADR_TL_VL);
    adr_tl_hz_vl = (Uint16 *)(adr_host_int_work + ADR_TL_HZ_VL);

    CopyMem((void *)
                    (PEEK_L(adr_sys_info_tbl + ADR_ARA_ADR) + ADR_SND_MEM),
                   (void *)(SND_INI_ARA_ADR(*sys_ini)),
                   CHG_LONG(SND_INI_ARA_SZ(*sys_ini))); /* ޴رϯߓ]  */
/* 1994/02/24 Start*/
    intrflag = 0;         /* 荞݃tȌ */
/* 1994/02/24 End */

    PER_SMPC_SND_ON();                          /* TEhON                */

}

/******************************************************************************
 *
 * NAME:    SND_MoveData()  - TEhf[^]
 *
 * PARAMETERS :
 *      (1) Uint16 *source      - <i>   TEhf[^]AhX
 *      (2) Uint32 size         - <i>   TEhf[^]TCY
 *      (3) Uint16 data_kind    - <i>   f[^
 *      (4) Uint16 data_no      - <i>   f[^ԍ
 *
 * DESCRIPTION:
 *      TEhf[^TEh֓]܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void SND_MoveData(Uint16 *source, Uint32 size,Uint16 data_kind, Uint16 data_no)
{
    void *adr;                                  /* ]AhX            */
    Uint32 *load_mark_adr;                      /* ]ς݃rbgݒڽ  */

    GetSndMapInfo(&adr, &load_mark_adr, data_kind, data_no);
                                                /* ޴رϯߏ擾      */

    CopyMem(adr, (void *)source, size);         /* ޴رϯߓ]         */
    POKE_L(load_mark_adr, (*load_mark_adr | M_LOAD_MARK));
                                                /* ]ςޯ             */
}

/******************************************************************************
 *
 * NAME:    SND_ChgMap()    - TEhGA}bvύX
 *
 * PARAMETERS :
 *      (1) SndAreaMap area_no  - <i>   TEhGA}bvԍ
 *
 * DESCRIPTION:
 *      TEhGA}bvύX܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_ChgMap(SndAreaMap area_no)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, area_no);                        /* p[^Zbg          */
    SET_COMMAND(COM_CHG_MAP);                   /* R}hZbg            */

    while(PEEK_W(adr_com_block + ADR_COM_DATA)) _WAIT_();
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, area_no);                        /* p[^Zbg          */
    SET_COMMAND(COM_CHG_MAP);                   /* R}hZbg            */
    while(PEEK_W(adr_com_block + ADR_COM_DATA)) _WAIT_();
    HOST_SET_RETURN(SND_RET_SET);
}
/******************************************************************************
 *
 * NAME:    SND_SetTlVl()   - S̉ʐݒ
 *
 * PARAMETERS :
 *      (1) SndTlVl vol         - <i>   S̉
 *
 * DESCRIPTION:
 *      S̉ʂݒ肵܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 

 SndRet SND_SetTlVl(SndTlVl vol)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, vol);                            /* p[^Zbg          */
    SET_COMMAND(COM_SET_TL_VL);                 /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_ChgEfct()   - GtFNgύX
 *
 * PARAMETERS :
 *      (1) SndEfctBnkNum efct_no <i>   Effect bank number
 *
 * DESCRIPTION:
 *      GtFNgύX܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_ChgEfct(SndEfctBnkNum efct_no)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, efct_no);                        /* p[^Zbg          */
    SET_COMMAND(COM_CHG_EFCT);                  /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_ChgMix()    - ~LTύX
 *
 * PARAMETERS :
 *      (1) SndToneBnkNum tone_no   <i>   F bank number
 *      (2) SndMixBnkNum mix_no     <i>   MIxer bank number
 *
 * DESCRIPTION:
 *      ~LTύX܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_ChgMix(SndToneBnkNum tone_no, SndMixBnkNum mix_no)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, tone_no);                        /* p[^Zbg          */
    SET_PRM(1, mix_no);                         /* p[^Zbg          */
    SET_COMMAND(COM_CHG_MIX);                   /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_ChgMixPrm()     - ~LTp[^ύX
 *
 * PARAMETERS :
 *      (1) SndEfctOut efct_out     <i>   Effect out select
 *      (2) SndLev level            <i>   Effect return Level
 *      (3) SndPan pan              <i>   Effect pan
 *
 * DESCRIPTION:
 *      ~LTp[^ύX܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_ChgMixPrm(SndEfctOut efct_out, SndLev level, SndPan pan)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, efct_out);                       /* p[^Zbg          */
    SET_PRM(1, ChgPan(pan) | (level << 5));     /* p[^Zbg          */
    SET_COMMAND(COM_CHG_MIX_PRM);               /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_ChkHard()       - n[hEFA`FbN
 *
 * PARAMETERS :
 *      (1) SndHardStat *stat       <o>   ʰð
 *      (2) SndHardPrm prm         <i>   ʰҰ
 *
 * DESCRIPTION:
 *      n[hEFA`FbN܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_ChkHard(SndHardStat *stat, SndHardPrm prm)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    *(Uint16 *)(ADR_SYS_TBL + ADR_HARD_CHK_STAT) = 0;
    SET_PRM(0, prm);                            /* p[^Zbg          */
    SET_COMMAND(COM_CHK_HARD);                  /* R}hZbg            */
    while((*stat = *(volatile Uint16 *)(ADR_SYS_TBL + ADR_HARD_CHK_STAT)) == 0) _WAIT_();
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_StopDsp()   - DSP~
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      DSP𒆎~܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_StopDsp(void)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_COMMAND(COM_STOP_DSP);                  /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_OffAllSound()       - STEhXbg~
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      STEhXbg~܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_OffAllSound(void)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_COMMAND(COM_OFF_ALL_SOUND);             /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_StartSeq()  - V[PXJn
 *
 * PARAMETERS :
 *      (1) SndSeqNum seq_no        -   <i>     Ǘԍ
 *      (2) SndSeqBnkNum seq_bk_no  -   <i>     Sequence bank number
 *      (3) SndSeqSongNum song_no   -   <i>     Sequence song number
 *      (4) SndSeqPri pri_lev       -   <i>     Priorty level
 *
 * DESCRIPTION:
 *      V[PXJn܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_StartSeq(SndSeqNum seq_no, SndSeqBnkNum seq_bk_no,
                    SndSeqSongNum song_no, SndSeqPri pri_lev)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, seq_no);                         /* p[^Zbg          */
    SET_PRM(1, seq_bk_no);                      /* p[^Zbg          */
    SET_PRM(2, song_no);                        /* p[^Zbg          */
    SET_PRM(3, pri_lev);                        /* p[^Zbg          */
    SET_COMMAND(COM_START_SEQ);                 /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_StopSeq()   - V[PX~
 *
 * PARAMETERS :
 *      (1) SndSeqNum seq_no    - <i>   Ǘԍ
 *
 * DESCRIPTION:
 *      V[PX𒆎~܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_StopSeq(SndSeqNum seq_no)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, seq_no);                         /* p[^Zbg          */
    SET_COMMAND(COM_STOP_SEQ);                  /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_PauseSeq()  - V[PXꎞf
 *
 * PARAMETERS :
 *      (1) SndSeqNum seq_no    - <i>   Ǘԍ
 *
 * DESCRIPTION:
 *      V[PXꎞf܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_PauseSeq(SndSeqNum seq_no)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, seq_no);                         /* p[^Zbg          */
    SET_COMMAND(COM_PAUSE_SEQ);                 /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_ContSeq()   - V[PXꎞf
 *
 * PARAMETERS :
 *      (1) SndSeqNum seq_no    - <i>   Ǘԍ
 *
 * DESCRIPTION:
 *      V[PẌꎞf܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_ContSeq(SndSeqNum seq_no)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, seq_no);                         /* p[^Zbg          */
    SET_COMMAND(COM_CONT_SEQ);                  /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_SetSeqVl()      - V[PXʐݒ
 *
 * PARAMETERS :
 *      (1) SndSeqNum seq_no        -   <i>     Ǘԍ
 *      (2) SndSeqVl seq_vl         -   <i>     Sequence Volume
 *      (3) SndFade fade            -   <i>     fade Rate
 *
 * DESCRIPTION:
 *      V[PX̉ʂݒ肵܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_SetSeqVl(SndSeqNum seq_no, SndSeqVl seq_vl, SndFade fade)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, seq_no);                         /* p[^Zbg          */
    SET_PRM(1, seq_vl);                         /* p[^Zbg          */
    SET_PRM(2, fade);                           /* p[^Zbg          */
    SET_COMMAND(COM_SET_SEQ_VL);                /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_ChgTempo()  - e|ύX
 *
 * PARAMETERS :
 *      (1) SndSeqNum seq_no    - <i>   Ǘԍ
 *      (2) SndTempo tempo      - <i>   Tempo
 *
 * DESCRIPTION:
 *      V[PX̃e|ύX܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_ChgTempo(SndSeqNum seq_no, SndTempo tempo)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, seq_no);                         /* p[^Zbg          */
    SET_PRM(2, tempo >> 8);                     /* p[^Zbg          */
    SET_PRM(3, tempo);                          /* p[^Zbg          */
    SET_COMMAND(COM_CHG_TEMPO);                 /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_CtrlDirMidi()   -   MIDI_CNgRg[
 *
 * PARAMETERS :
 *      (1) SndSeqNum seq_no    - <i>   Ǘԍ
 *      (2) SndSeqPri seq_pri   - <i>   Priorty Level
 *      (3) Uint8 md_com        - <i>   MIDI command
 *      (4) Uint8 ch            - <i>   MIDI channel
 *      (5) Uint8 dt1           - <i>   MIDI data1
 *      (6) Uint8 dt2           - <i>   MIDI data2
 *
 * DESCRIPTION:
 *      MIDI_CNgɃRg[܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_CtrlDirMidi(SndSeqNum seq_no, SndSeqPri seq_pri, Uint8 md_com,
                        Uint8 ch, Uint8 dt1, Uint8 dt2)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, (seq_pri << 3) | md_com);        /* p[^Zbg          */
    SET_PRM(1, (seq_no << 5) | ch);             /* p[^Zbg          */
    SET_PRM(2, dt1);                            /* p[^Zbg          */
    SET_PRM(3, dt2);                            /* p[^Zbg          */
    SET_COMMAND(COM_CTRL_DIR_MIDI);             /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_SetSeqPan()     -   V[PXPANݒ
 *
 * PARAMETERS :
 *      (1) SndSeqNum seq_no    - <i>   Ǘԍ
 *      (2) Uint8 ctrl_sw       - <i>   Control ON/OFF
 *      (3) Uint8 md_pan        - <i>   MIDI PAN data
 *
 * DESCRIPTION:
 *      V[PXPANݒ肵܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_SetSeqPan(SndSeqNum seq_no, Uint8 ctrl_sw, Uint8 md_pan)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, seq_no);                         /* p[^Zbg          */
    SET_PRM(1, (ctrl_sw | md_pan));             /* p[^Zbg          */
    SET_COMMAND(COM_SET_SEQ_PAN);             /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_StartPcm()  - PCMJn
 *
 * PARAMETERS :
 *      (1) SndPcmStartPrm *sprm    - <i>   PCMJnp[^|C^
 *      (2) SndPcmChgPrm *cprm      - <i>   PCMύXp[^|C^
 *
 * DESCRIPTION:
 *      PCMf[^Đ܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_StartPcm(SndPcmStartPrm *sprm, SndPcmChgPrm *cprm)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, SND_PRM_MODE(*sprm) | SND_PRM_NUM(*cprm));
    SET_PRM(1, (SND_PRM_LEV(*cprm) << 5) | ChgPan(SND_PRM_PAN(*cprm)));
    SET_PRM(2, SND_PRM_SADR(*sprm) >> 8);
    SET_PRM(3, SND_PRM_SADR(*sprm));
    SET_PRM(4, SND_PRM_SIZE(*sprm) >> 8);
    SET_PRM(5, SND_PRM_SIZE(*sprm));
    SET_PRM(6, SND_PRM_PICH(*cprm) >> 8);
    SET_PRM(7, SND_PRM_PICH(*cprm));
    SET_PRM(8, (SND_R_EFCT_IN(*cprm) << 3) | SND_R_EFCT_LEV(*cprm));
    SET_PRM(9, (SND_L_EFCT_IN(*cprm) << 3) | SND_L_EFCT_LEV(*cprm));
    SET_PRM(11, 0);
    SET_COMMAND(COM_START_PCM);                 /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_StopPcm()   - PCM~
 *
 * PARAMETERS :
 *      (1) SndPcmNum pcm_num       - <i>   Đ~PCMXg[Đԍ
 *
 * DESCRIPTION:
 *      PCM𒆎~܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_StopPcm(SndPcmNum pcm_num)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, pcm_num);                        /* p[^Zbg          */
    SET_COMMAND(COM_STOP_PCM);                  /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_ChgPcm()    - PCMύX
 *
 * PARAMETERS :
 *      (1) SndPcmChgPrm *cprm      - <i>   PCMύXp[^|C^
 *
 * DESCRIPTION:
 *      PCMf[^Đ܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_ChgPcm(SndPcmChgPrm *cprm)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, SND_PRM_NUM(*cprm));
    SET_PRM(1, (SND_PRM_LEV(*cprm) << 5) | ChgPan(SND_PRM_PAN(*cprm)));
    SET_PRM(2, SND_PRM_PICH(*cprm) >> 8);
    SET_PRM(3, SND_PRM_PICH(*cprm));
    SET_PRM(4, (SND_R_EFCT_IN(*cprm) << 3) | SND_R_EFCT_LEV(*cprm));
    SET_PRM(5, (SND_L_EFCT_IN(*cprm) << 3) | SND_L_EFCT_LEV(*cprm));
    SET_COMMAND(COM_CHG_PCM_PRM);               /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_StartVlAnl()    - ʉ͊Jn
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      ʉ͂s܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      gшʉʉ͂ꍇ́AGtFNgύXɂĐpDSPvO
 *      sĂB
 *
 ******************************************************************************
 */
 
 SndRet SND_StartVlAnl(void)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_COMMAND(COM_START_VL_ANL);              /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_StopVlAnl()     - ʉ͒~
 *
 * PARAMETERS :
 *      ȂB
 *
 * DESCRIPTION:
 *      ʉ͂𒆎~܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_StopVlAnl(void)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_COMMAND(COM_STOP_VL_ANL);               /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_SetCdDaLev()    - CD-DA Levelݒ
 *
 * PARAMETERS :
 *      (1) SndLev left         - <i>   o͂̉
 *      (2) SndLev right        - <i>   Eo͂̉
 *
 * DESCRIPTION:
 *      ݂̃XeIʂύX܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_SetCdDaLev(SndLev left, SndLev right)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, (left) * 2 << 4);                /* p[^Zbg          */
    SET_PRM(1, (right) * 2 << 4);               /* p[^Zbg          */
    SET_COMMAND(COM_SET_CD_DA_LEV);             /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_SetCdDaPan()    - CD-DA Panݒ
 *
 * PARAMETERS :
 *      (1) SndPan  left        - <i>   o͂PAN
 *      (2) SndPan  right       - <i>   Eo͂PAN
 *
 * DESCRIPTION:
 *      ݂̃XeIPANύX܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      (1) SndRet              - <o>   R}hs
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 SndRet SND_SetCdDaPan(SndPan left, SndPan right)
 {
/* 1994/02/24 Start */
#if 0
    HOST_SET_INIT();                            /* νĲ̪رݒ菉 */
#endif
    if(intrflag) return(SND_RET_NSET);
    intrflag = 1;
/* 1994/02/24 End */
    if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
    SET_PRM(0, ChgPan(left));                   /* p[^Zbg          */
    SET_PRM(1, ChgPan(right));                  /* p[^Zbg          */
    SET_COMMAND(COM_SET_CD_DA_PAN);             /* R}hZbg            */
    HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
 *
 * NAME:    SND_GetSeqStat()    - V[PXXe[^X擾
 *
 * PARAMETERS :
 *      (1) SndSeqStat *status  - <o>   V[PXXe[^X|C^
 *      (2) SndSeqNum seq_no    - <i>   Ǘԍ
 *
 * DESCRIPTION:
 *      V[PXXe[^X擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 void SND_GetSeqStat(SndSeqStat *status, SndSeqNum seq_no)
 {
    SND_SEQ_STAT_MODE(*status) = (PEEK_W(adr_song_stat + seq_no)) & 0xff00;
    SND_SEQ_STAT_STAT(*status) = (Uint8)(PEEK_W(adr_song_stat + seq_no));
}

/******************************************************************************
 *
 * NAME:    SND_GetSeqPlayPos() - ǗԍĐʒu擾
 *
 * PARAMETERS :
 *      (1) SndSeqPlayPos *pos  - <o>   ǗԍĐʒu
 *      (2) SndSeqNum seq_no    - <i>   Ǘԍ
 *
 * DESCRIPTION:
 *      ǗԍĐʒu擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 void SND_GetSeqPlayPos(SndSeqPlayPos *pos, SndSeqNum seq_no)
 {
    *pos = PEEK_W(adr_seq + seq_no);
}

/******************************************************************************
 *
 * NAME:    SND_GetPcmPlayAdr() - PCMsAhX擾
 *
 * PARAMETERS :
 *      (1) SndPcmPlayAdr *pcm_adr  - <o>   PCMsAhX
 *      (2) SndPcmNum num           - <i>   PCMĐԍ
 *
 * DESCRIPTION:
 *      PCMsAhX擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      ȂB
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 void SND_GetPcmPlayAdr(SndPcmPlayAdr *pcm_adr, SndPcmNum num)
 {
    SND_PCM_RADR(*pcm_adr) = (Uint8)(PEEK_W(adr_pcm + num) >> 8);
    SND_PCM_LADR(*pcm_adr) = (Uint8)PEEK_W(adr_pcm + num);
 }

/******************************************************************************
 *
 * NAME:    SND_GetAnlTlVl()    - ͑S̃XeIʎ擾
 *
 * PARAMETERS :
 *      (1) SndCdVlAnl *left    - <o>   o͂̑S͉̉
 *      (2) SndCdVlAnl *right   - <o>   Eo͂̑S͉̉
 *
 * DESCRIPTION:
 *      S̃XeI͉ʂ擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 void SND_GetAnlTlVl(SndCdVlAnl *left, SndCdVlAnl *right)
 {
    *left = (SndCdVlAnl)PEEK_W(adr_tl_vl);
    *right = (SndCdVlAnl)PEEK_W(adr_tl_vl + 1);
 }

/******************************************************************************
 *
 * NAME:    SND_GetAnlHzVl()    - ͎gшʃXeIʎ擾
 *
 * PARAMETERS :
 *      (1) SndCdHzSrVl *hz_vl - <o>   gшʃXeI͉
 *
 * DESCRIPTION:
 *      gшʃXeI͉ʂ擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
 
 void SND_GetAnlHzVl(SndCdHzSrVl *hz_vl)
 {
    SND_CD_LHIGH(*hz_vl) = (SndCdVlAnl)PEEK_W(adr_tl_hz_vl + 0);
    SND_CD_RHIGH(*hz_vl) = (SndCdVlAnl)PEEK_W(adr_tl_hz_vl + 1);
    SND_CD_LMID(*hz_vl) = (SndCdVlAnl)PEEK_W(adr_tl_hz_vl + 2);
    SND_CD_RMID(*hz_vl) = (SndCdVlAnl)PEEK_W(adr_tl_hz_vl + 3);
    SND_CD_LLOW(*hz_vl) = (SndCdVlAnl)PEEK_W(adr_tl_hz_vl + 4);
    SND_CD_RLOW(*hz_vl) = (SndCdVlAnl)PEEK_W(adr_tl_hz_vl + 5);
 }

/*****************************************************************************/
/**** 񋟊֐ ***********************************************************/
/*****************************************************************************/
/******************************************************************************
 *
 * NAME:    DmaClrZero()    - DMAɂ郁̃[NA
 *
 * PARAMETERS :
 *      (1) void *dst       - <i>   fBXeBl[VAhX
 *      (2) Uint32 cnt      - <i>   NAoCg
 *
 * DESCRIPTION:
 *      DMAgpă[NA܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

static void DmaClrZero(void *dst, Uint32 cnt)
{
    memset(dst, 0x00, cnt);
}

/******************************************************************************
 *
 * NAME:    GetSndMapInfo()     - TEhGA}bv擾
 *
 * PARAMETERS :
 *      (1) void **adr          - <o>   ]AhX
 *      (2) Uint32 **ladr        - <o>   ]ς݃rbgAhX
 *      (3) Uint16 data_kind    - <i>   f[^
 *      (4) Uint16 data_no      - <i>   f[^ԍ
 *
 * DESCRIPTION:
 *      TEhGA}bv̏擾܂B
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

static void GetSndMapInfo(void **adr, Uint32 **ladr, Uint16 data_kind, Uint16 data_no)
{
    Uint32 i = 0;
    Uint32 map0;

    map0 = PEEK_L(adr_snd_area_crnt + ARA_MAP_0);

    for(i = 1; (map0 & M_END_MARK) != M_END_MARK; i++){
        if((((map0 & M_DATA_ID) >> B_DATA_ID) == (Uint32)data_kind) &&
           (((map0 & M_ID_NUM) >> B_ID_NUM) == (Uint32)data_no)){
            *adr = (void *)(ADR_SND_MEM +
                       ((map0 & M_START_ADR) >> B_START_ADR)
              );
            *ladr = (Uint32 *)(adr_snd_area_crnt + ARA_MAP_SIZE * (i - 1) +
                     ARA_MAP_4);
            break;
        }
        map0 = PEEK_L(adr_snd_area_crnt + ARA_MAP_SIZE * i + ARA_MAP_0);
    }
}
/******************************************************************************
 *
 * NAME:    ChgPan()            - PANf[^ϊ
 *
 * PARAMETERS :
 *      (1) SndPan pan          - <i>   PAN
 *
 * DESCRIPTION:
 *      o^pPANɕϊ܂
 *
 * PRECONDITIONS:
 *      (1) Uint16              - <o>   ϊPAN
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */
static Uint16 ChgPan(SndPan pan)
{
    return(((pan) < 0) ? (~(pan) + 0x10 + 1) : (pan));
}

/******************************************************************************
 *
 * NAME:    CopyMem()           - Rs|
 *
 * PARAMETERS :
 *
 * DESCRIPTION:
 *
 * PRECONDITIONS:
 *
 * POSTCONDITIONS:
 *
 * CAVEATS:
 *
 ******************************************************************************
 */

static void CopyMem(void *dst, void *src, Uint32 cnt)
{
#ifndef _DMA_SCU
	memcpy(dst, src, cnt);
#else
                                                /*****************************/
    DMA_ScuMemCopy(dst, src, cnt);
    while(DMA_SCU_END != DMA_ScuResult());
#endif /* _DMA_SCU */
}

/******************************************************************************
 *
 * NAME:    GetComBlockAdr()            - R}hubN
 *
 * PARAMETERS :
 *
 * DESCRIPTION:
 *
 * PRECONDITIONS:
 *
 * POSTCONDITIONS:
 *      (1) Uint8               - <ret> R}hubN̋󂫏
 *
 * CAVEATS:
 *
 ******************************************************************************
 */

static Uint8 GetComBlockAdr(void)
{
    if(*NOW_ADR_COM_DATA){              /* ȑOۯς݂łȂ?*/
        /* R}hubNAhXݒ菈 ********************************/
        if(NOW_ADR_COM_DATA >= (MAX_ADR_COM_DATA - SIZE_COM_BLOCK)){
                                                    /* ől?            */
            return OFF;                             /* ۯ󂫖      */
        }else{
            adr_com_block += SIZE_COM_BLOCK;        /* ݺۯı*/
            while(NOW_ADR_COM_DATA < (MAX_ADR_COM_DATA - SIZE_COM_BLOCK)){
                if(*NOW_ADR_COM_DATA){
                    adr_com_block += SIZE_COM_BLOCK;
                }else{
                    return ON;                      /* ۯ󂫗L         */
                }
            }
            return OFF;                             /* ۯ󂫖         */
        }
    }else{
        adr_com_block = adr_host_int_work;  /* ۯ̐擪              */
        while(NOW_ADR_COM_DATA < (MAX_ADR_COM_DATA - SIZE_COM_BLOCK)){
            if(*NOW_ADR_COM_DATA){
                adr_com_block += SIZE_COM_BLOCK;
            }else{
                return ON;                          /* ۯ󂫗L         */
            }
        }
        return OFF;                                 /* ۯ󂫖         */
    }
}

/******************************************************************************
	NAME:    	SND_SetQSound()		-	QSOUND
	PARAMETERS :
		(1) Uint8 QCh		- <i>	QSOUND Channel
		(2) Uint8 QSt		- <i>	QSOUND Status
	DESCRIPTION:
		QSOUND status set
	PRECONDITIONS:
		None
	POSTCONDITIONS:
		(1) SndRet              - <o>   R}hs
	CAVEATS:
		None
******************************************************************************/

 SndRet SND_SetQSound(Uint8 QCh, Uint8 QSt)
 {
#if 0
	HOST_SET_INIT();				/* host i/f area set init. process */
#endif
	if(intrflag) return(SND_RET_NSET);
	intrflag = 1;
	if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
	SET_PRM(0, QCh);				/* paramater set          */
	SET_PRM(1, QSt);				/* paramater set          */
	SET_COMMAND(COM_SET_QSOUND);	/* command set            */
	HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
	NAME:    	SND_Set3D_Stat()		-	YAMAHA 3D SOUND
	PARAMETERS :
		(1) Uint8 Y3DDst		- <i>	YAMAHA 3D Distance
		(2) Uint8 Y3DAzm		- <i>	YAMAHA 3D Azimuth
		(3) Uint8 Y3DElv		- <i>	YAMAHA 3D Elevation
	DESCRIPTION:
		YAMAHA 3D status set
	PRECONDITIONS:
		None
	POSTCONDITIONS:
		(1) SndRet			- <o>   R}hs
	CAVEATS:
		None
******************************************************************************/

 SndRet SND_Set3D_Stat(Uint8 Y3DDst, Uint8 Y3DAzm, Uint8 Y3DElv)
 {
#if 0
	HOST_SET_INIT();				/* host i/f area set init. process */
#endif
	if(intrflag) return(SND_RET_NSET);
	intrflag = 1;
	if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
	SET_PRM(1, Y3DDst);				/* paramater set          */
	SET_PRM(2, Y3DAzm);				/* paramater set          */
	SET_PRM(3, Y3DElv);				/* paramater set          */
	SET_COMMAND(COM_SET_3D_SOUND);	/* command set            */
	HOST_SET_RETURN(SND_RET_SET);
}

/******************************************************************************
	NAME:    	SND_Set3D_Init()		-	YAMAHA 3D SOUND Initialize
	PARAMETERS :
		None
	DESCRIPTION:
		YAMAHA 3D Status Initialize
	PRECONDITIONS:
		None
	POSTCONDITIONS:
		(1) SndRet			- <o>   R}hs
	CAVEATS:
		None
******************************************************************************/

 SndRet SND_Set3D_Init()
 {
#if 0
	HOST_SET_INIT();				/* host i/f area set init. process */
#endif
	if(intrflag) return(SND_RET_NSET);
	intrflag = 1;
	if(GetComBlockAdr() == OFF) HOST_SET_RETURN(SND_RET_NSET);
	SET_COMMAND(COM_SET_3D_INIT);	/* command set            */
	HOST_SET_RETURN(SND_RET_SET);
}

