/*----------------------------------------------------------------------------
 *  model.dat -- XvCgTvP f`
 *  Copyright(c) 1994 SEGA
 *  Written by H.E on 1994-02-15 Ver.0.80
 *  Updated by H.E on 1994-02-15 Ver.0.80
 *
 *  XvCgRceXg\pf[^B
 *
 *----------------------------------------------------------------------------
 */

#define DRAW16	MATE_AUTO_SHADING | COLOR_0 | ECDSPD_DISABLE | COMPO_REP
#define COLOR16 RGB16_COLOR(15,15,15)
#define DRAWTX	MATE_TEXTURE | COLOR_0 | ECDSPD_DISABLE | COMPO_REP
#define COLORTX 0
#define DRAW8	MATE_SHADING_TBL | COLOR_4 | ECDSPD_DISABLE | COMPO_REP
#define COLOR8  0

#define SHADING_KIND  GOURAUD_SHADING
/* #define SHADING_KIND  FLAT_SHADING */

#define  WIDTH  0.1
#define  HEIGHT 0.6
#define  HEIGHT_MIN 0.5
#define  HEIGHT_MAX 0.9
#define  Y0     0.0
#define  X0     WIDTH
#define  Y1     0.0
#define  X1     WIDTH*(4.0/5.0)
#define  Y2     0.0
#define  X2     WIDTH*(3.0/5.0)
#define  Y3     0.0
#define  X3     WIDTH*(2.0/5.0)
#define  Y4     0.0
#define  X4     WIDTH*(1.0/5.0)
#define  Y5     0.0
#define  X5     0.0

typedef	struct ClustData   ClustData;
struct ClustData {
    MthXyz   rot;
    Fixed32  posY;
    Fixed32  movY;
};
#define   POS_Y_0  (HEIGHT_MIN+0.0)/5.0
#define   MOV_Y_0  0.0005
#define   POS_Y_1  (HEIGHT_MIN+0.1)/5.0
#define   MOV_Y_1  0.001
#define   POS_Y_2  (HEIGHT_MIN+0.2)/5.0
#define   MOV_Y_2  -0.0005
#define   POS_Y_3  (HEIGHT_MIN+0.3)/5.0
#define   MOV_Y_3  -0.001
#define   POS_Y_4  (HEIGHT_MIN+0.4)/5.0
#define   MOV_Y_4  -0.0015
#define   POS_Y_5  (HEIGHT_MIN+0.2)/5.0
#define   MOV_Y_5  0.0015

static ClustData clustData20 = {
       { MTH_FIXED( 120), MTH_FIXED(0), MTH_FIXED(-180)},
         MTH_FIXED(POS_Y_0), MTH_FIXED(MOV_Y_0),
};
static ClustData clustData30 = {
       { MTH_FIXED( 135), MTH_FIXED(0), MTH_FIXED(-165)},
         MTH_FIXED(POS_Y_0), MTH_FIXED(MOV_Y_0),
};
static ClustData clustData40 = {
       { MTH_FIXED( 150), MTH_FIXED(0), MTH_FIXED(-150)},
         MTH_FIXED(POS_Y_0), MTH_FIXED(MOV_Y_0),
};
static ClustData clustData50 = {
       { MTH_FIXED( 165), MTH_FIXED(0), MTH_FIXED(-135)},
         MTH_FIXED(POS_Y_0), MTH_FIXED(MOV_Y_0),
};
static ClustData clustData60 = {
       { MTH_FIXED(0), MTH_FIXED(0), MTH_FIXED(0)},
         MTH_FIXED(POS_Y_0), MTH_FIXED(MOV_Y_0),
};
static ClustData clustData21 = {
       { MTH_FIXED(  60), MTH_FIXED(0), MTH_FIXED(-120)},
         MTH_FIXED(POS_Y_1), MTH_FIXED(MOV_Y_1),
};
static ClustData clustData31 = {
       { MTH_FIXED(  75), MTH_FIXED(0), MTH_FIXED(-105)},
         MTH_FIXED(POS_Y_1), MTH_FIXED(MOV_Y_1),
};
static ClustData clustData41 = {
       { MTH_FIXED(  90), MTH_FIXED(0), MTH_FIXED( -90)},
         MTH_FIXED(POS_Y_1), MTH_FIXED(MOV_Y_1),
};
static ClustData clustData51 = {
       { MTH_FIXED( 105), MTH_FIXED(0), MTH_FIXED( -75)},
         MTH_FIXED(POS_Y_1), MTH_FIXED(MOV_Y_1),
};
static ClustData clustData61 = {
       { MTH_FIXED(0), MTH_FIXED(0), MTH_FIXED(0)},
         MTH_FIXED(POS_Y_1), MTH_FIXED(MOV_Y_1),
};
static ClustData clustData22 = {
       { MTH_FIXED(   0), MTH_FIXED(0), MTH_FIXED( -60)},
         MTH_FIXED(POS_Y_2), MTH_FIXED(MOV_Y_2),
};
static ClustData clustData32 = {
       { MTH_FIXED(  15), MTH_FIXED(0), MTH_FIXED( -45)},
         MTH_FIXED(POS_Y_2), MTH_FIXED(MOV_Y_2),
};
static ClustData clustData42 = {
       { MTH_FIXED(  30), MTH_FIXED(0), MTH_FIXED( -30)},
         MTH_FIXED(POS_Y_2), MTH_FIXED(MOV_Y_2),
};
static ClustData clustData52 = {
       { MTH_FIXED(  45), MTH_FIXED(0), MTH_FIXED( -15)},
         MTH_FIXED(POS_Y_2), MTH_FIXED(MOV_Y_2),
};
static ClustData clustData62 = {
       { MTH_FIXED(0), MTH_FIXED(0), MTH_FIXED(0)},
         MTH_FIXED(POS_Y_2), MTH_FIXED(MOV_Y_2),
};
static ClustData clustData23 = {
       { MTH_FIXED( -60), MTH_FIXED(0), MTH_FIXED(   0)},
         MTH_FIXED(POS_Y_3), MTH_FIXED(MOV_Y_3),
};
static ClustData clustData33 = {
       { MTH_FIXED( -45), MTH_FIXED(0), MTH_FIXED(  15)},
         MTH_FIXED(POS_Y_3), MTH_FIXED(MOV_Y_3),
};
static ClustData clustData43 = {
       { MTH_FIXED( -30), MTH_FIXED(0), MTH_FIXED(  30)},
         MTH_FIXED(POS_Y_3), MTH_FIXED(MOV_Y_3),
};
static ClustData clustData53 = {
       { MTH_FIXED( -15), MTH_FIXED(0), MTH_FIXED(  45)},
         MTH_FIXED(POS_Y_3), MTH_FIXED(MOV_Y_3),
};
static ClustData clustData63 = {
       { MTH_FIXED(0), MTH_FIXED(0), MTH_FIXED(0)},
         MTH_FIXED(POS_Y_3), MTH_FIXED(MOV_Y_3),
};
static ClustData clustData24 = {
       { MTH_FIXED(-120), MTH_FIXED(0), MTH_FIXED(  60)},
         MTH_FIXED(POS_Y_4), MTH_FIXED(MOV_Y_4),
};
static ClustData clustData34 = {
       { MTH_FIXED(-105), MTH_FIXED(0), MTH_FIXED(  75)},
         MTH_FIXED(POS_Y_4), MTH_FIXED(MOV_Y_4),
};
static ClustData clustData44 = {
       { MTH_FIXED( -90), MTH_FIXED(0), MTH_FIXED(  90)},
         MTH_FIXED(POS_Y_4), MTH_FIXED(MOV_Y_4),
};
static ClustData clustData54 = {
       { MTH_FIXED( -75), MTH_FIXED(0), MTH_FIXED( 105)},
         MTH_FIXED(POS_Y_4), MTH_FIXED(MOV_Y_4),
};
static ClustData clustData64 = {
       { MTH_FIXED(0), MTH_FIXED(0), MTH_FIXED(0)},
         MTH_FIXED(POS_Y_4), MTH_FIXED(MOV_Y_4),
};
static ClustData clustData25 = {
       { MTH_FIXED(-180), MTH_FIXED(0), MTH_FIXED( 120)},
         MTH_FIXED(POS_Y_5), MTH_FIXED(MOV_Y_5),
};
static ClustData clustData35 = {
       { MTH_FIXED(-165), MTH_FIXED(0), MTH_FIXED( 135)},
         MTH_FIXED(POS_Y_5), MTH_FIXED(MOV_Y_5),
};
static ClustData clustData45 = {
       { MTH_FIXED(-150), MTH_FIXED(0), MTH_FIXED( 150)},
         MTH_FIXED(POS_Y_5), MTH_FIXED(MOV_Y_5),
};
static ClustData clustData55 = {
       { MTH_FIXED(-135), MTH_FIXED(0), MTH_FIXED( 165)},
         MTH_FIXED(POS_Y_5), MTH_FIXED(MOV_Y_5),
};
static ClustData clustData65 = {
       { MTH_FIXED(0), MTH_FIXED(0), MTH_FIXED(0)},
         MTH_FIXED(POS_Y_5), MTH_FIXED(MOV_Y_5),
};

static Uint16  colorData[] = {
/* 0x00 */  0x0000,
/* 0x01 */  RGB16_COLOR( 1, 1, 1),
/* 0x02 */  RGB16_COLOR( 1, 1, 1),
/* 0x03 */  RGB16_COLOR( 2, 2, 2),
/* 0x04 */  RGB16_COLOR( 3, 3, 3),
/* 0x05 */  RGB16_COLOR( 4, 4, 4),
/* 0x06 */  RGB16_COLOR( 5, 5, 5),
/* 0x07 */  RGB16_COLOR( 6, 6, 6),
/* 0x08 */  RGB16_COLOR( 7, 7, 7),
/* 0x09 */  RGB16_COLOR( 8, 8, 8),
/* 0x0a */  RGB16_COLOR( 9, 9, 9),
/* 0x0b */  RGB16_COLOR(10,10,10),
/* 0x0c */  RGB16_COLOR(11,11,11),
/* 0x0d */  RGB16_COLOR(12,12,12),
/* 0x0e */  RGB16_COLOR(13,13,13),
/* 0x0f */  RGB16_COLOR(14,14,14),
/* 0x10 */  RGB16_COLOR(15,15,15),
/* 0x11 */  RGB16_COLOR(16,16,16),
/* 0x12 */  RGB16_COLOR(17,17,17),
/* 0x13 */  RGB16_COLOR(18,18,18),
/* 0x14 */  RGB16_COLOR(19,19,19),
/* 0x15 */  RGB16_COLOR(20,20,20),
/* 0x16 */  RGB16_COLOR(21,21,21),
/* 0x17 */  RGB16_COLOR(22,22,22),
/* 0x18 */  RGB16_COLOR(23,23,23),
/* 0x19 */  RGB16_COLOR(24,24,24),
/* 0x1a */  RGB16_COLOR(25,25,25),
/* 0x1b */  RGB16_COLOR(26,26,26),
/* 0x1c */  RGB16_COLOR(27,27,27),
/* 0x1d */  RGB16_COLOR(28,28,28),
/* 0x1e */  RGB16_COLOR(29,29,29),
/* 0x1f */  RGB16_COLOR(30,30,30),
/* 0x20 */  RGB16_COLOR(31,31,31),
/* 0x21 */  RGB16_COLOR(31, 0, 0),
/* 0x22 */  RGB16_COLOR( 0, 0, 0),
/* 0x23 */  RGB16_COLOR( 0, 0, 0),
/* 0x24 */  RGB16_COLOR( 0, 0, 0),
/* 0x25 */  RGB16_COLOR( 0, 0, 0),
/* 0x26 */  RGB16_COLOR( 0, 0, 0),
/* 0x27 */  RGB16_COLOR( 0, 0, 0),
/* 0x28 */  RGB16_COLOR( 0, 0, 0),
/* 0x29 */  RGB16_COLOR( 0, 0, 0),
/* 0x2a */  RGB16_COLOR( 0, 0, 0),
/* 0x2b */  RGB16_COLOR( 0, 0, 0),
/* 0x2c */  RGB16_COLOR( 0, 0, 0),
/* 0x2d */  RGB16_COLOR( 0, 0, 0),
/* 0x2e */  RGB16_COLOR( 0, 0, 0),
/* 0x2f */  RGB16_COLOR(31, 0, 0),
};

static Uint16 shdIdxTbl8White[] = {
  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,
 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32
};

static Uint16 *shdIdxTbl8[] = {
    /* 0 */  shdIdxTbl8White
};

/* IuWFNg6  _We[u */
static MthXyz Obj6VertPoint[21];
static MthXyz Obj6VertNormal[21];

/* IuWFNg6  ʂ̖@xNge[u */
static MthXyz Obj6SurfaceNormal[20];

/* IuWFNg6  ʒ`e[u */
static SprSurface Obj6Surface[] = {
	{	
		{
		0,4,5,1,
		},			/* ʂ\钸_ԍ  0 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		1,5,6,2,
		},			/* ʂ\钸_ԍ  1 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		2,6,7,3,
		},			/* ʂ\钸_ԍ  2 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		3,7,4,0,
		},			/* ʂ\钸_ԍ  3 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		4,8,9,5,
		},			/* ʂ\钸_ԍ  4 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		5,9,10,6,      
		},		 /* ʂ\钸_ԍ  5 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		6,10,11,7,     
		},		 /* ʂ\钸_ԍ  6 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		7,11,8,4,      
		},		 /* ʂ\钸_ԍ  7 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		8,12,13,9,
		},			/* ʂ\钸_ԍ  8 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		9,13,14,10,    
		},		 /* ʂ\钸_ԍ  9 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		10,14,15,11,   
		},		 /* ʂ\钸_ԍ 10 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		11,15,12,8,    
		},		 /* ʂ\钸_ԍ 11 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		12,16,17,13,   
		},		 /* ʂ\钸_ԍ 12 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		13,17,18,14,   
		},		 /* ʂ\钸_ԍ 13 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		14,18,19,15,   
		},		 /* ʂ\钸_ԍ 14 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		15,19,16,12,   
		},		 /* ʂ\钸_ԍ 15 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		16,20,17,16,   
		},		 /* ʂ\钸_ԍ 16 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		17,20,18,17,   
		},		 /* ʂ\钸_ԍ 17 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		18,20,19,18,   
		},		 /* ʂ\钸_ԍ 18 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
	{	
		{
		19,20,16,19,   
		},		 /* ʂ\钸_ԍ 19 */
		DRAW16 | ZSORT_MIN,
		COLOR16
	},
};
/* IuWFNg6  */
static SprObject3D Object6 = {
	6,                              /* IuWFNgԍ  */
	INBETWEEN_OBJECT |
	DISP_POLYGON |                  /* \tO */
	SHADING_KIND,
	21,				/* _ */
	20,				/* ʐ */
	(MthXyz *)&Obj6VertPoint,	/* _We[u */
	(MthXyz *)&Obj6VertNormal,	/* _̖@xNge[u */
	(SprSurface *)&Obj6Surface,	/* ʒ`e[u*/
	(MthXyz *)&Obj6SurfaceNormal,	/* ʂ̖@xNge[u */
        NULL,                           /* ʂ̑\_We[u  */
	NULL,                           /* VF[fBOCfbNXe[u*/
        MTH_FIXED(-4.0),                /* ʖ@xNǧvZ␳l      */
	NULL				/* IuWFNg */
};


static MthXyz ObjVertNormal[] = {
	{MTH_FIXED(-0.7071),MTH_FIXED( 0.0),MTH_FIXED( 0.7071)},
	{MTH_FIXED( 0.7071),MTH_FIXED( 0.0),MTH_FIXED( 0.7071)},
	{MTH_FIXED( 0.7071),MTH_FIXED( 0.0),MTH_FIXED(-0.7071)},
	{MTH_FIXED(-0.7071),MTH_FIXED( 0.0),MTH_FIXED(-0.7071)},
};

/* IuWFNgO _We[u */
static MthXyz Obj0VertPoint[] = {
	{MTH_FIXED(-X0),MTH_FIXED( Y0),MTH_FIXED( X0)},
	{MTH_FIXED( X0),MTH_FIXED( Y0),MTH_FIXED( X0)},
	{MTH_FIXED( X0),MTH_FIXED( Y0),MTH_FIXED(-X0)},
	{MTH_FIXED(-X0),MTH_FIXED( Y0),MTH_FIXED(-X0)},
};
/* IuWFNgO */
static SprObject3D Object0 = {
	0,                              /* IuWFNgԍ  */
	DISP_POLYGON |                  /* \tO */
	SHADING_KIND,
	4,				/* _ */
	0,				/* ʐ */
	(MthXyz *)&Obj0VertPoint,	/* _We[u */
	(MthXyz *)&ObjVertNormal,       /* _̖@xNge[u */
	NULL,				/* ʒ`e[u*/
	NULL,				/* ʂ̖@xNge[u */
	NULL,                           /* ʂ̑\_We[u  */
	NULL,                           /* VF[fBOCfbNXe[u*/
        MTH_FIXED(1.0),                 /* ʖ@xNǧvZ␳l      */
	NULL, 				/* IuWFNg */
};

/* IuWFNgP _We[u */
static MthXyz Obj1VertPoint[] = {
	{MTH_FIXED(-X1),MTH_FIXED( Y1),MTH_FIXED( X1)},
	{MTH_FIXED( X1),MTH_FIXED( Y1),MTH_FIXED( X1)},
	{MTH_FIXED( X1),MTH_FIXED( Y1),MTH_FIXED(-X1)},
	{MTH_FIXED(-X1),MTH_FIXED( Y1),MTH_FIXED(-X1)},
};
/* IuWFNgP */
static SprObject3D Object1 = {
	1,                              /* IuWFNgԍ  */
	DISP_POLYGON |                  /* \tO */
	GOURAUD_SHADING,
	4,				/* _ */
	0,				/* ʐ */
	(MthXyz *)&Obj1VertPoint,	/* _We[u */
	(MthXyz *)&ObjVertNormal,	/* _̖@xNge[u */
	NULL,				/* ʒ`e[u*/
	NULL,				/* ʂ̖@xNge[u */
	NULL,                           /* ʂ̑\_We[u  */
	NULL,                           /* VF[fBOCfbNXe[u*/
        MTH_FIXED(1.0),                 /* ʖ@xNǧvZ␳l      */
	NULL				/* IuWFNg */
};

/* IuWFNgQ _We[u */
static MthXyz Obj2VertPoint[] = {
	{MTH_FIXED(-X2),MTH_FIXED( Y2),MTH_FIXED( X2)},
	{MTH_FIXED( X2),MTH_FIXED( Y2),MTH_FIXED( X2)},
	{MTH_FIXED( X2),MTH_FIXED( Y2),MTH_FIXED(-X2)},
	{MTH_FIXED(-X2),MTH_FIXED( Y2),MTH_FIXED(-X2)},
};
/* IuWFNgQ */
static SprObject3D Object2 = {
	2,                              /* IuWFNgԍ  */
	DISP_POLYGON |                  /* \tO */
	SHADING_KIND,
	4,				/* _ */
	0,				/* ʐ */
	(MthXyz *)&Obj2VertPoint,	/* _We[u */
	(MthXyz *)&ObjVertNormal,	/* _̖@xNge[u */
	NULL,				/* ʒ`e[u*/
	NULL,				/* ʂ̖@xNge[u */
	NULL,                           /* ʂ̑\_We[u  */
	NULL,                           /* VF[fBOCfbNXe[u*/
        MTH_FIXED(1.0),                 /* ʖ@xNǧvZ␳l      */
	NULL				/* IuWFNg */
};

/* IuWFNg3  _We[u */
static MthXyz Obj3VertPoint[] = {
	{MTH_FIXED(-X3),MTH_FIXED( Y3),MTH_FIXED( X3)},
	{MTH_FIXED( X3),MTH_FIXED( Y3),MTH_FIXED( X3)},
	{MTH_FIXED( X3),MTH_FIXED( Y3),MTH_FIXED(-X3)},
	{MTH_FIXED(-X3),MTH_FIXED( Y3),MTH_FIXED(-X3)},
};
/* IuWFNg3  */
static SprObject3D Object3 = {
	3,                              /* IuWFNgԍ  */
	DISP_POLYGON |                  /* \tO */
	SHADING_KIND,
	4,				/* _ */
	0,				/* ʐ */
	(MthXyz *)&Obj3VertPoint,	/* _We[u */
	(MthXyz *)&ObjVertNormal,	/* _̖@xNge[u */
	NULL,				/* ʒ`e[u*/
	NULL,				/* ʂ̖@xNge[u */
	NULL,                           /* ʂ̑\_We[u  */
	NULL,                           /* VF[fBOCfbNXe[u*/
        MTH_FIXED(1.0),                 /* ʖ@xNǧvZ␳l      */
	NULL				/* IuWFNg */
};

/* IuWFNg4 _We[u */
static MthXyz Obj4VertPoint[] = {
	{MTH_FIXED(-X4),MTH_FIXED( Y4),MTH_FIXED( X4)},
	{MTH_FIXED( X4),MTH_FIXED( Y4),MTH_FIXED( X4)},
	{MTH_FIXED( X4),MTH_FIXED( Y4),MTH_FIXED(-X4)},
	{MTH_FIXED(-X4),MTH_FIXED( Y4),MTH_FIXED(-X4)},
};
/* IuWFNg4  */
static SprObject3D Object4 = {
	4,                              /* IuWFNgԍ  */
	DISP_POLYGON |                  /* \tO */
	SHADING_KIND,
	4,				/* _ */
	0,				/* ʐ */
	(MthXyz *)&Obj4VertPoint,	/* _We[u */
	(MthXyz *)&ObjVertNormal,	/* _̖@xNge[u */
	NULL,				/* ʒ`e[u*/
	NULL,				/* ʂ̖@xNge[u */
	NULL,                           /* ʂ̑\_We[u  */
	NULL,                           /* VF[fBOCfbNXe[u*/
        MTH_FIXED(10.0),                /* ʖ@xNǧvZ␳l      */
	NULL				/* IuWFNg */
};

/* IuWFNg5 _We[u */
static MthXyz Obj5VertPoint[] = {
	{MTH_FIXED(X5),MTH_FIXED( Y5),MTH_FIXED(X5)},
};
static MthXyz Obj5VertNormal[] = {
	{MTH_FIXED( 0.0),   MTH_FIXED( 1.0),MTH_FIXED( 0.0)},
};

/* IuWFNg5  */
static SprObject3D Object5 = {
	5,                              /* IuWFNgԍ  */
	DISP_POLYGON |                  /* \tO */
	SHADING_KIND,
	1,				/* _ */
	0,				/* ʐ */
	(MthXyz *)&Obj5VertPoint,	/* _We[u */
	(MthXyz *)&Obj5VertNormal,	/* _̖@xNge[u */
	NULL,				/* ʒ`e[u*/
	NULL,				/* ʂ̖@xNge[u */
	NULL,                           /* ʂ̑\_We[u  */
	NULL,                           /* VF[fBOCfbNXe[u*/
        MTH_FIXED(10.0),                /* ʖ@xNǧvZ␳l      */
	&Object6			/* IuWFNg */
};


/* RcIuWFNgԐڑ|S 0 */
Uint16 fromVertNo0[] = { 0, 1, 2, 3};
Uint16 toVertNo0[]   = { 0, 1, 2, 3};
struct SprInbetInf InbetInf0 = {
    4,				/* o_                            */
    &Object0,			/* ڑ_f[^oIuWFNg        */
    fromVertNo0,		/* o_ԍz                      */
    &Object6,			/* ڑ_f[^ݒIuWFNg            */
    toVertNo0,			/* ݒ蒸_ԍz                          */
    NULL,			/* RcIuWFNgԐڑ|S      */
};

/* RcIuWFNgԐڑ|S 1 */
Uint16 fromVertNo1[] = { 0, 1, 2, 3};
Uint16 toVertNo1[]   = { 4, 5, 6, 7};
struct SprInbetInf InbetInf1 = {
    4,				/* o_                            */
    &Object1,			/* ڑ_f[^oIuWFNg        */
    fromVertNo1,		/* o_ԍz                      */
    &Object6,			/* ڑ_f[^ݒIuWFNg            */
    toVertNo1,			/* ݒ蒸_ԍz                          */
    NULL,			/* RcIuWFNgԐڑ|S      */
};

/* RcIuWFNgԐڑ|S 2 */
Uint16 fromVertNo2[] = { 0, 1, 2, 3};
Uint16 toVertNo2[]   = { 8, 9,10,11};
struct SprInbetInf InbetInf2 = {
    4,				/* o_                            */
    &Object2,			/* ڑ_f[^oIuWFNg        */
    fromVertNo2,		/* o_ԍz                      */
    &Object6,			/* ڑ_f[^ݒIuWFNg            */
    toVertNo2,			/* ݒ蒸_ԍz                          */
    NULL,			/* RcIuWFNgԐڑ|S      */
};

/* RcIuWFNgԐڑ|S 3 */
Uint16 fromVertNo3[] = { 0, 1, 2, 3};
Uint16 toVertNo3[]   = {12,13,14,15};
struct SprInbetInf InbetInf3 = {
    4,				/* o_                            */
    &Object3,			/* ڑ_f[^oIuWFNg        */
    fromVertNo3,		/* o_ԍz                      */
    &Object6,			/* ڑ_f[^ݒIuWFNg            */
    toVertNo3,			/* ݒ蒸_ԍz                          */
    NULL,			/* RcIuWFNgԐڑ|S      */
};

/* RcIuWFNgԐڑ|S 4 */
Uint16 fromVertNo4[] = { 0, 1, 2, 3};
Uint16 toVertNo4[]   = {16,17,18,19};
struct SprInbetInf InbetInf4 = {
    4,				/* o_                            */
    &Object4,			/* ڑ_f[^oIuWFNg        */
    fromVertNo4,		/* o_ԍz                      */
    &Object6,			/* ڑ_f[^ݒIuWFNg            */
    toVertNo4,			/* ݒ蒸_ԍz                          */
    NULL,			/* RcIuWFNgԐڑ|S      */
};

/* RcIuWFNgԐڑ|S 5 */
Uint16 fromVertNo5[] = { 0};
Uint16 toVertNo5[]   = {20};
struct SprInbetInf InbetInf5 = {
    1,				/* o_                            */
    &Object5,			/* ڑ_f[^oIuWFNg        */
    fromVertNo5,		/* o_ԍz                      */
    &Object6,			/* ڑ_f[^ݒIuWFNg            */
    toVertNo5,			/* ݒ蒸_ԍz                          */
    NULL,			/* RcIuWFNgԐڑ|S      */
};


/* NX^ 65 */
SprCluster Cluster65 = {
	65,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
		MTH_FIXED(0.0),             /* [hWnɂw] */
		MTH_FIXED(0.0),             /* [hWnɂx] */
		MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
		MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
		MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
		MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object5,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	NULL,  		   	    /* qNX^ */
        &InbetInf5,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData65,               /* [UReLXgGA            */
};

/* NX^ 55 */
SprCluster Cluster55 = {
	55,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object4,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster65,	   	    /* qNX^ */
        &InbetInf4,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData55,               /* [UReLXgGA            */
};

/* NX^ 45 */
SprCluster Cluster45 = {
	45,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object3,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster55,  	   	    /* qNX^ */
        &InbetInf3,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData45,               /* [UReLXgGA            */
};

/* NX^ 35 */
SprCluster Cluster35 = {
        35,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object2,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster45,  		    /* qNX^ */
        &InbetInf2,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData35,               /* [UReLXgGA            */
};

/* NX^ 25 */
SprCluster Cluster25 = {
        25,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object1,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster35,  		    /* qNX^ */
        &InbetInf1,	 	    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData25,               /* [UReLXgGA            */
};

/* NX^ 15 */
SprCluster Cluster15 = {
        15,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(90.0),            /* [hWnɂy] */
	},
	{
	MTH_FIXED(-WIDTH),          /* [hWnɂ錴_̂wW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object0,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster25,  		    /* qNX^ */
	&InbetInf0,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        NULL,                       /* [UReLXgGA            */
};

/* NX^ 64 */
SprCluster Cluster64 = {
	64,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object5,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	NULL,  		   	    /* qNX^ */
        &InbetInf5,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData64,               /* [UReLXgGA            */
};

/* NX^ 54 */
SprCluster Cluster54 = {
	54,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object4,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster64,	   	    /* qNX^ */
        &InbetInf4,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData54,               /* [UReLXgGA            */
};

/* NX^ 44 */
SprCluster Cluster44 = {
	44,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object3,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster54,  	   	    /* qNX^ */
        &InbetInf3,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData44,               /* [UReLXgGA            */
};

/* NX^ 34 */
SprCluster Cluster34 = {
        34,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object2,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster44,  		    /* qNX^ */
        &InbetInf2,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData34,               /* [UReLXgGA            */
};

/* NX^ 24 */
SprCluster Cluster24 = {
        24,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object1,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster34,  		    /* qNX^ */
        &InbetInf1,	 	    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData24,               /* [UReLXgGA            */
};

/* NX^ 14 */
SprCluster Cluster14 = {
	14,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(-90.0),           /* [hWnɂy] */
	},
	{
	MTH_FIXED(WIDTH),           /* [hWnɂ錴_̂wW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object0,		    /* RcIuWFNg */
	&Cluster15,		    /* NX^ */
	&Cluster24,  		    /* qNX^ */
	&InbetInf0,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        NULL,                       /* [UReLXgGA            */
};

/* NX^ 63 */
SprCluster Cluster63 = {
	63,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object5,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	NULL,  		   	    /* qNX^ */
        &InbetInf5,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData63,               /* [UReLXgGA            */
};

/* NX^ 53 */
SprCluster Cluster53 = {
	53,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object4,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster63, 	   	    /* qNX^ */
        &InbetInf4,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData53,               /* [UReLXgGA            */
};

/* NX^ 43 */
SprCluster Cluster43 = {
	43,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object3,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster53,  	   	    /* qNX^ */
        &InbetInf3,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData43,               /* [UReLXgGA            */
};

/* NX^ 33 */
SprCluster Cluster33 = {
        33,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object2,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster43,  		    /* qNX^ */
        &InbetInf2,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData33,               /* [UReLXgGA            */
};

/* NX^ 23 */
SprCluster Cluster23 = {
        23,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object1,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster33,  		    /* qNX^ */
        &InbetInf1,	 	    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData23,               /* [UReLXgGA            */
};

/* NX^ 13 */
SprCluster Cluster13 = {
	13,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(-90.0),           /* [hWnɂw] */
	MTH_FIXED(90.0),            /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂xW */
	MTH_FIXED(-WIDTH),          /* [hWnɂ錴_̂yW */
	},
	&Object0,		    /* RcIuWFNg */
	&Cluster14,		    /* NX^ */
	&Cluster23,  		    /* qNX^ */
	&InbetInf0,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        NULL,                       /* [UReLXgGA            */
};

/* NX^ 62 */
SprCluster Cluster62 = {
	62,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object5,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	NULL,  		   	    /* qNX^ */
        &InbetInf5,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData62,               /* [UReLXgGA            */
};

/* NX^ 52 */
SprCluster Cluster52 = {
	52,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object4,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster62,	   	    /* qNX^ */
        &InbetInf4,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData52,               /* [UReLXgGA            */
};

/* NX^ 42 */
SprCluster Cluster42 = {
	42,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object3,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster52,  	   	    /* qNX^ */
        &InbetInf3,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData42,               /* [UReLXgGA            */
};

/* NX^ 32 */
SprCluster Cluster32 = {
        32,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object2,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster42,  		    /* qNX^ */
        &InbetInf2,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData32,               /* [UReLXgGA            */
};

/* NX^ 22 */
SprCluster Cluster22 = {
        22,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object1,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster32,  		    /* qNX^ */
        &InbetInf1,	 	    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData22,               /* [UReLXgGA            */
};

/* NX^ 12 */
SprCluster Cluster12 = {
	12,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(-180.0),          /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(-WIDTH),          /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object0,		    /* RcIuWFNg */
	&Cluster13,		    /* NX^ */
	&Cluster22,  		    /* qNX^ */
	&InbetInf0,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        NULL,                       /* [UReLXgGA            */
};

/* NX^ 61 */
SprCluster Cluster61 = {
	61,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object5,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	NULL,  		   	    /* qNX^ */
        &InbetInf5,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData61,               /* [UReLXgGA            */
};

/* NX^ 51 */
SprCluster Cluster51 = {
	51,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object4,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster61,	   	    /* qNX^ */
        &InbetInf4,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData51,               /* [UReLXgGA            */
};

/* NX^ 41 */
SprCluster Cluster41 = {
	41,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object3,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster51,  	   	    /* qNX^ */
        &InbetInf3,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData41,               /* [UReLXgGA            */
};

/* NX^ 31 */
SprCluster Cluster31 = {
        31,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object2,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster41,  		    /* qNX^ */
        &InbetInf2,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData31,               /* [UReLXgGA            */
};

/* NX^ 21 */
SprCluster Cluster21 = {
        21,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object1,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster31,  		    /* qNX^ */
        &InbetInf1,	 	    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData21,               /* [UReLXgGA            */
};

/* NX^ 11 */
SprCluster Cluster11 = {
	11,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(90.0),            /* [hWnɂw] */
	MTH_FIXED(90.0),            /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂xW */
	MTH_FIXED(WIDTH),           /* [hWnɂ錴_̂yW */
	},
	&Object0,		    /* RcIuWFNg */
	&Cluster12,		    /* NX^ */
	&Cluster21,  		    /* qNX^ */
	&InbetInf0,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        NULL,                       /* [UReLXgGA            */
};

/* NX^ 60 */
SprCluster Cluster60 = {
	60,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object5,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	NULL,  		   	    /* qNX^ */
        &InbetInf5,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData60,               /* [UReLXgGA            */
};

/* NX^ 50 */
SprCluster Cluster50 = {
	50,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object4,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster60,	   	    /* qNX^ */
        &InbetInf4,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData50,               /* [UReLXgGA            */
};

/* NX^ 40 */
SprCluster Cluster40 = {
	40,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object3,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster50,  	   	    /* qNX^ */
        &InbetInf3,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData40,               /* [UReLXgGA            */
};

/* NX^ 30 */
SprCluster Cluster30 = {
        30,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object2,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster40,  		    /* qNX^ */
        &InbetInf2,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData30,               /* [UReLXgGA            */
};

/* NX^ 20 */
SprCluster Cluster20 = {
        20,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(HEIGHT/5.0),      /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object1,		    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster30,  		    /* qNX^ */
        &InbetInf1,	 	    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        &clustData20,               /* [UReLXgGA            */
};

/* NX^ 10 */
SprCluster Cluster10 = {
	10,                         /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(WIDTH),           /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	&Object0,		    /* RcIuWFNg */
	&Cluster11,		    /* NX^ */
	&Cluster20,  		    /* qNX^ */
	&InbetInf0,		    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        NULL,                       /* [UReLXgGA            */
};

/* [gNX^ */
SprCluster RootCluster = {
	0,                          /* NX^ԍ  */
	ROT_SEQ_ZYX,		    /* ] */
	{
	MTH_FIXED(0.0),             /* [hWnɂw] */
	MTH_FIXED(0.0),             /* [hWnɂx] */
	MTH_FIXED(0.0),             /* [hWnɂy] */
	},
	{
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂wW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂xW */
	MTH_FIXED(0.0),             /* [hWnɂ錴_̂yW */
	},
	NULL,			    /* RcIuWFNg */
	NULL,			    /* NX^ */
	&Cluster10,  		    /* qNX^ */
        NULL, 			    /* RcIuWFNgԐڑ|S  */
        NULL,                       /* WϊJnOR[obN[`  */
        NULL,                       /* WϊIR[obN[`  */
        NULL,                       /* [UReLXgGA            */
};

#include "trape1.txc"

static SprTexture Texture[] = {
    {
/* character no.        */ 0,
/* color mode           */ COLOR_5,
/* color data           */ 0,
/* character width      */ 64,
/* character height     */ 32,
/* character pointer    */ (Uint8 *)trape1tex,
/* lookup table pointer */ NULL
    },
{
/*                      */ 0xffff,
/* stop data            */ COLOR_5,
/* color data           */ 0,
/*                      */ 0,
/*                      */ 0,
/*                      */ NULL,
/*                      */ NULL
    }
};


/*  end of file */
