/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994 SEGA
 *
 * Module : Xg[VXeTvvO1
 *          ([vĐpTvvO)
 * File   : smpstm1.c
 * Date   : 1994-10-01
 * Author : H.T
 *
 *****************************************************************************/

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include        <stdio.h>
#include        <stdlib.h>
#include        "sega_stm.h"

/*****************************************************************************
 *      萔}N
 *****************************************************************************/

/* t@C                   */
#define SMP_STM_FN1     "SMP_STM.FN1"
#define SMP_STM_FN2     "SMP_STM.FN2"
#define SMP_STM_FN3     "SMP_STM.FN3"

/* ǂݍ݃obt@TCY       */
#define FORM1_SCTSIZ    2048
#define FN1_UNITNUM     5
#define FN2_UNITNUM     10
#define FN3_UNITNUM     15
#define FN1_BUFSIZ      (FN1_UNITNUM * FORM1_SCTSIZ)
#define FN2_BUFSIZ      (FN2_UNITNUM * FORM1_SCTSIZ)
#define FN3_BUFSIZ      (FN3_UNITNUM * FORM1_SCTSIZ)

/* [v                   */
#define LOOP_MAX        3

/* Cup萔             */
#define FILE_NUM        30      /* PfBNg̍őt@C */
#define OPEN_MAX        24      /* ɈXg[^t@C     */
#define GRP_MAX         5       /* ɈO[v                 */

/*****************************************************************************
 *      ϐ̒`
 *****************************************************************************/
/* t@CVXeƗ̈     */
Uint32          WorkGfs[GFS_WORK_SIZE(OPEN_MAX)/sizeof(Uint32)];

/* Xg[VXeƗ̈   */
Uint32          WorkStm[STM_WORK_SIZE(OPEN_MAX, GRP_MAX)/sizeof(Uint32)];

/* fBNgǂݍݗ̈     */
GfsDirName      DirTbl[FILE_NUM];

/* ǂݍ݃obt@             */
Uint8           Fn1_Buf[FN1_BUFSIZ];
Uint8           Fn2_Buf[FN2_BUFSIZ];
Uint8           Fn3_Buf[FN3_BUFSIZ];


/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/
/*-------------------------------
 * 
 * ߂l : TRUE  
 *          FALSE s
 *-------------------------------*/
Bool    SMP_Init(void)
{
    GfsDirTbl   dir;
    Sint32      ndir;
    Bool        init;

   /* t@CVXe    */
    GFS_DIRTBL_TYPE(&dir) = GFS_DIR_NAME;
    GFS_DIRTBL_NDIR(&dir) = FILE_NUM;
    GFS_DIRTBL_DIRNAME(&dir) = DirTbl;
    ndir = GFS_Init(OPEN_MAX, WorkGfs, &dir);
    if (ndir < 0) {
        return (FALSE);
    }

    /* Xg[VXe */
    init = STM_Init(GRP_MAX, OPEN_MAX, WorkStm);
    if (init == FALSE) {
        return (FALSE);
    }
    return (TRUE);
}


/*-------------------------------
 * Xg[̃I[v
 * ߂l : Xg[nh
 *-------------------------------*/
StmHn   SMP_Open(StmGrpHn grp, Sint8 *fname, void *buf, Sint32 nunit)
{
    Sint32      fid;
    StmHn       stm;
    StmKey      key;

    /* t@Ct@Cʎqւ̕ϊ     */
    fid = GFS_NameToId(fname);
    if (fid < 0) {
        return (NULL);
    }

    /* Xg[L[̐ݒ                     */
    STM_KEY_CN(&key) = STM_KEY_SMMSK(&key) = STM_KEY_CIMSK(&key) = STM_KEY_NONE;

    /* Xg[I[v                       */
    stm = STM_OpenFid(grp, fid, &key, STM_LOOP_READ);
    if (stm == NULL) {
        return (NULL);
    }

    /* ǂݍݗ̈̐ݒ                       */
    STM_SetTrBuf(stm, buf, nunit, STM_UNIT_FORM1);

    return (stm);
}


/*-------------------------------
 * [U֐
 *-------------------------------*/
void    SMP_User(void)
{
    /* AvP[VƎ̏Ȃ     */
}



/*-------------------------------
 * ǂݍݗ̈̃`FbN
 *-------------------------------*/
void    SMP_ChkBuf(StmGrpHn grp, Sint32 nstm, StmHn stmtbl[], Sint32 rscnt[])
{
    Sint32      i;
    Sint32      lpcnt;
    Bool        bful;

    lpcnt = STM_GetLoopCnt(grp);

    /* ǂݍݗ̈悪ςɂȂ烊Zbg     */
    for (i = 0; i < nstm; i++) {
        bful = STM_IsTrBufFull(stmtbl[i]);
        if (bful == TRUE) {
            STM_ResetTrBuf(stmtbl[i]);
            rscnt[i]++;
        }
    }
}



/*-------------------------------
 * Xg[ǂݍݎs
 *-------------------------------*/
void    SMP_Exec(StmGrpHn grp)
{
    StmHn       stmtbl[OPEN_MAX];
    Sint32      stat;
    Sint32      nstm;
    Sint32      i;
    Sint32      rscnt[OPEN_MAX];

    /* [v񐔂̐ݒ                 */
    STM_SetLoop(grp, STM_LOOP_DFL, LOOP_MAX);

    /* sO[v̐ݒ               */
    STM_SetExecGrp(grp);

    /* O[vɑXg[̎擾 */
    nstm = STM_GetStmNum(grp);
    for (i = 0; i < nstm; i++) {
        stmtbl[i] = STM_GetStmHndl(grp, i);
        rscnt[i] = 0;
    }

    /* ǂݍݎs                     */
    while(1) {
        stat = STM_ExecServer();
        if (stat == STM_EXEC_COMPLETED) {
            break;
        }
        
        /* ǂݍݗ̈̃`FbN       */
        SMP_ChkBuf(grp, nstm, stmtbl, rscnt);

        /* [U֐   */
        SMP_User();
    }
}
        

/*-------------------------------
 * C
 *-------------------------------*/
void    main(void)
{
    Bool        init;
    StmGrpHn    grp;
    StmHn       stm1, stm2, stm3;

    /*            */
    init = SMP_Init();
    if (init == FALSE) {
        return;
    }

    /* nh擾     */
    grp = STM_OpenGrp();
    if (grp == NULL) {
        return;
    }
    stm1 = SMP_Open(grp, SMP_STM_FN1, Fn1_Buf, FN1_UNITNUM);
    if (stm1 == NULL) {
        return;
    }
    stm2 = SMP_Open(grp, SMP_STM_FN2, Fn2_Buf, FN2_UNITNUM);
    if (stm2 == NULL) {
        return;
    }
    stm3 = SMP_Open(grp, SMP_STM_FN3, Fn3_Buf, FN3_UNITNUM);
    if (stm3 == NULL) {
        return;
    }

    /* ǂݍݎs     */
    SMP_Exec(grp);
}

/* end of file */


