/*------------------------------------------------------------------------
 *  FILE: main.c
 *      $Author: $
 *      $Date: $
 *      $Locker: $
 *      $Revision: $
 *      $Source: $
 *      $State: $
 *
 *      Copyright (c) by SEGA Enterprises Ltd. 1994. All rights reserved.
 *
 *  PURPOSE:
 *		SEGA3D to 3D Table conversion program
 *
 *  DESCRIPTION:
 *		Main routine
 *
 *  INTERFACE
 *
 *
 *  CAVEATS
 *
 *
 *  AUTHOR(S):
 *		K. Hasuike	(ssdg)
 *
 *  MOD HISTORY:
 *      $Log: $
 * 
 * 
 *------------------------------------------------------------------------
 */

#define	MAIN
#include "s3dto3dt.h"

void main( argc, argv )
	Sint16	argc;
	Sint8	*argv[];
{
	Sint16	i;

	/* Rs[Cg\ */
	printf("SEGA3D to 3D_Table Converter Ver. 1.00\n");
	printf("Copyright (c) by SEGA Enterprises, Ltd. 1994. All right reserved.\n");

	/* R}hCp[^ǂݍ */
	for( i = 1; i < argc; i++ ){
		if( g_dirname == NULL )
			g_dirname = argv[i];
		else if ( g_outname == NULL )
			g_outname = argv[i];
		else
			printUsage();
	}
	if( g_dirname == NULL ) printUsage();
	if( g_outname == NULL ) printUsage();

	/* p[^̏lݒi.ctlǂݍ݊܂ށj*/
	val_init();

	/* ̓t@Cǂݍ݁iobjectj*/
	obj_read();

	/* ̓t@Cǂݍ݁imaterial->DRAW/COLOR쐬j*/
	mat_read();

	/* fLoop */
	g_obj_cnt = 0;

printf("SEGA3D FileName[%s]\n", g_s3dname);
	for ( i = g_u_obj_max-1; i > -1; i-- ){
printf("*** Model Read  %4d(Total %4d) *****\r", i, g_u_obj_max );
		/* ̓t@Cǂݍ݁imodelj*/
		mdl_read( i );

printf("*** Slip Read   %4d(Total %4d) *****\r", i, g_u_obj_max );
		/* ̓t@Cǂݍ݁islipsj*/
		slp_read( i );

printf("*** Model Write %4d(Total %4d) *****\r", i, g_u_obj_max );
		/* o̓t@Co */
		t3d_wrt( i );
/*printf(" g_nest_max %d\n",g_nest_max);*/

	}

	/* o̓t@CoiNX^j*/
printf("*** Cluster Write               *****\r" );
	cls_wrt();
printf("***          Finished           *****\n" );

}

void printUsage()
{
	printf("\n");
	printf("Usage: s3dto3dt <input/output directory path> <file_name>\n");
	printf("Release no.: 09\n");
	printf("\n");
	exit(-1);
}
