/*------------------------------------------------------------------------
 *  FILE: val_init.c
 *      $Author: $
 *      $Date: $
 *      $Locker: $
 *      $Revision: $
 *      $Source: $
 *      $State: $
 *
 *      Copyright (c) by SEGA Enterprises Ltd. 1994. All rights reserved.
 *
 *  PURPOSE:
 *		SEGA3D to 3DTable conversion program
 *
 *  DESCRIPTION:
 *		Initialize each parameter
 *
 *  INTERFACE
 *
 *
 *  CAVEATS
 *
 *
 *  AUTHOR(S):
 *		K. Hasuike	(ssdg)
 *
 *  MOD HISTORY:
 *      $Log: $
 * 
 * 
 *------------------------------------------------------------------------
 */

#include "s3dto3dt.h"

void
val_init()
{
	static	Sint8	string[] = "";
	static	Sint8	buf[80];
	Sint16	i;
	FILE	*fppi;
	FILE	*fppo;

/*printf("val_init started ***\n\n");*/
	/* IuWFNg */
	for ( i = 0; i < OBJ_MAX; i++ ){

	strcat(obj[i].u_obj_name,string);	/* IuWFNgŗL */
	strcat(obj[i].l_obj_name,string);	/* IuWFNgCu */
	obj[i].scale_x = 1.0;	/* w{i̒l|j */
	obj[i].scale_y = 1.0;	/* x{i̒l|j */
	obj[i].scale_z = 1.0;	/* y{i̒l|j */
	obj[i].rev_x = 0;	/* w]tOi 0:off, 1:on j*/
	obj[i].rev_y = 0;	/* x]tOi 0:off, 1:on j*/
	obj[i].rev_z = 0;	/* y]tOi 0:off, 1:on j*/
	obj[i].shade = -1;	/* VF[fBO */
				/* i -1:s, 0:no, 1:flat, 2:gouraud j */
	obj[i].mode = 0;	/* `惂[h */
				/* i 0:color, 1:auto, 2:index, 3:texture j */
	obj[i].p_type = 0;	/* ʎʃ^Cv */
				/* i 0:polygon, 1:polyline j */
	obj[i].tex_no = 0;	/* eNX`ԍ */
	obj[i].v_max = 0;	/* _ */
	obj[i].f_max = 0;	/* ʐ */

	}

	/* NX^ */
	for ( i = 0; i < CLS_MAX; i++ ){

	strcat(cls[i].u_cls_name,string);	/* NX^ŗL */
	cls[i].ang_seq = ANG_SEQ;	/* ] */
	cls[i].angle_x = 0.0;		/* w] */
	cls[i].angle_y = 0.0;		/* x] */
	cls[i].angle_z = 0.0;		/* y] */
	cls[i].point_x = 0.0;		/* wW */
	cls[i].point_y = 0.0;		/* xW */
	cls[i].point_z = 0.0;		/* yW */
	cls[i].nest = 0;		/* lXeBOEx */
	cls[i].object = NULL; 		/* IuWFNg\̂ւ̃|C^ */
	cls[i].c_child = NULL;		/* qNX^p|C^ */
	cls[i].c_next = NULL;		/* p|C^ */

	}

	/* eNX` */
	for ( i = 0; i < TEX_MAX; i++ ){

	txt[i].char_no = i;			/* LN^ԍ */
	strcat(txt[i].chr_nam,string);		/* LN^ */
	strcat(txt[i].clr_mod,"COLOR_5");	/* J[[h */
	txt[i].color = i;			/* J[       */
	txt[i].width = 96;			/* LN^ */
	txt[i].height = 96;			/* LN^ */
	strcat(txt[i].lup_ptr,"NULL");	/* bNAbve[u|C^ */

	}

	/* p[^ */
	strcpy(g_version,"1.00");	/* \tgCuo[W */
	strcpy(g_scale,"1");		/* S̃XP[ */
	g_face_rev = 1;		/* ]w莞̕\ʂ̔]i 0:Ȃ, 1: j*/
	g_n_calc  = 0;		/* @xNg̋vZi 0:Ȃ, 1: j*/
	g_clstr   = 0;		/* _~[̐eNX^i 0:Ȃ, 1: j*/
	g_s_drt   = 0;		/* _̕сi 0:cw, 1:ccw j*/
	g_ctr_c   = 0;		/* ʂ̒SWe[ui 0:Ȃ, 1: j*/
	strcpy(g_in_ext,"3d");		/* ̓t@C̊gq */
	strcpy(g_out_ext,"dat");	/* o̓t@C̊gq */
	g_dgt   = 0;		/* eNX`t@Ci 0:Ȃ, 1: j*/

	/* IvVp[^t@Cǂݍ */
	ctl_read();

	/* fBNgƓ̓t@C̘A */
	strcpy(g_s3dname,g_dirname);
	strcat(g_s3dname,"/");
	strcat(g_s3dname,g_outname);
	strcat(g_s3dname,".");
	strcat(g_s3dname,g_in_ext);
	/*printf("g_s3dname = %s\n",g_s3dname);*/

	/* fBNgƏo̓t@C̘A */
	strcpy(g_c_outname,g_dirname);
	strcat(g_c_outname,"/");
	strcat(g_c_outname,g_outname);
	strcat(g_c_outname,".");
	strcat(g_c_outname,g_out_ext);

	/* o̓t@CI[viVK[hj */
	fppo = fopen ( g_c_outname, "w" );
	if ( fppo != NULL ){

		/* rb`kd */
		strcpy(buf,"#define SCALE  ");
		strcat(buf,g_scale);
		strcat(buf,"\n");
		fputs(buf,fppo);

		/* o̓t@CN[Y */
		fclose ( fppo );
	}

}
