/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library:t@CVXe
 * Module :SCSIobt@Ǘ
 * File   :gfs_sfb.c
 * Date   :1996-02-01
 * Version:2.10
 * Author :H.T.
 *
 *****************************************************************************/
/* SGL̏ꍇRpCIvVɂ`邱
 * #define USE_SGL
 */

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include    "sega_gfs.h"
#include    "gfs_def.h"
#include    "gfs_sf.h"
#include    "gfs_scsi.h"
#include    "gfs_trn.h"

/*****************************************************************************
 *      萔}N
 *****************************************************************************/
#define GFSB_TPARA_DFL  1               /* SCSIł1ZN^] */

/*****************************************************************************
 *      񋓒萔
 *****************************************************************************/

/*****************************************************************************
 *      }N
 *****************************************************************************/

/*****************************************************************************
 *      f[^^̒`
 *****************************************************************************/

/*****************************************************************************
 *      ϐ̐錾
 *****************************************************************************/

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/

/* ANZXʒuwZN^̗Lf[^oCg擾 */
GFS_LOCAL Sint32 gfsb_getActSiz(GfsFlow *flow, Sint32 usct, Sint32 *len);

/*****************************************************************************
 *      ϐ̒`
 *****************************************************************************/

/* f[^pbNǗ     */
GfsDataPack gfsb_dtpk;


/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/
/* SCSIpf[^pbN̏ */
void GFSB_Init(void)
{
    GfdpHn      dpk = &gfsb_dtpk;
    
    GFDP_DATA(dpk) = NULL;
    GFDP_ADLT(dpk) = 0;
    GFDP_LEN(dpk) = 0;
    GFDP_NSCT(dpk) = 0;
    GFDP_USE(dpk) = FALSE;
}


/* SCSIt@Cobt@̐ݒ */
void GFSB_Setup(GfsFlow *flow, Sint32 fid)
{
    GfsDtsrc    *dts = &GFS_FLW_DTSRC(flow);

    GFS_DTS_FTYPE(dts) = SCSI_FILE;
    GFS_SCR_FID(dts) = fid;
    GFS_SCR_FILEPOS(dts) = GFS_SCR_SCTPOS(dts) = GFS_SCR_SCTNUM(dts) = 0;
}


/*****************************************************************************
 *  SCSIt@C̗LZN^߂
 *ḿn
 *  flow
 *  usct        ]vZN^
 *  nsct        ]\oCg
 *món
 *  
 *m֐ln
 *  ]\ZN^
 *m@\n
 *  
 *mln
 *  
 *****************************************************************************/
Sint32 GFSB_GetLenData(GfsFlow *flow, Sint32 usct, Sint32 *len)
{
    Sint32      nsct, lastsize, ap;
    GfsFinfo    *finfo = &GFS_FLW_FINFO(flow);
    GfsDtsrc    *dts = &GFS_FLW_DTSRC(flow);

    if (usct == GFTB_BUF_END) {
        usct = GFS_LONG_MAX;
    }
    nsct = GFS_SCR_SCTNUM(dts) - GFS_SCR_SCTPOS(dts);
    nsct = MIN(nsct, usct);
    if (len != NULL) {
        *len = nsct * SFM_SCTSIZE;
        ap = GFS_SCR_FILEPOS(dts) + GFS_SCR_SCTPOS(dts); 
        /* ŏIZN^܂ޏꍇ */
        if (ap > GFS_FI_NSCT(finfo)) {
            lastsize = GFS_FI_SIZE(finfo) % SFM_SCTSIZE;
            if ((*len != 0)&&(lastsize != 0)) {
                *len -= SFM_SCTSIZE - lastsize;
            }
        }
    }
    return nsct;
}


/* ]f[^pbN擾 */
GfdpHn GFSB_GetSrcPack(GfsFlow *flow, Sint32 usct)
{
    Sint32      len, nsct;
    GfsDtsrc    *dts = &GFS_FLW_DTSRC(flow);
    GfdpHn      dpk = &gfsb_dtpk;
    
    /* gp̏ꍇ */
    if (GFDP_USE(dpk)) {
        return NULL;
    }
    GFDP_DATA(dpk) = GFSD_GetBuf();
    GFDP_ADLT(dpk) = sizeof(Uint8);     /* AhXZ */
    nsct = gfsb_getActSiz(flow, usct, &len);
    /* SCSIobt@ɂPZN^ǂݍ */
    GFSD_Read(GFS_SCR_FID(dts), GFS_SCR_FILEPOS(dts) + GFS_SCR_SCTPOS(dts));
    GFDP_LEN(dpk) = len;
    GFDP_NSCT(dpk) = nsct;              /* ]ZN^ */
    GFDP_USE(dpk) = TRUE;               /* f[^pbNgp */
    return dpk;
}


/* f[^pbNԊ */
void GFSB_RtnPk(GfsFlow *flow, GfdpHn dtpk, Sint32 nsct)
{
    Sint32      seekpos;
    GfdpHn      dpk = &gfsb_dtpk;
    GfsDtsrc    *dts = &GFS_FLW_DTSRC(flow);

    /* gp̃f[^pbNϊ邱ƂmF */
    if (GFDP_USE(dpk)) {
        /* ]IĂꍇ,ANZX|C^i߂  */
        if (nsct == GFTR_ALLSCT) {
            nsct = GFDP_NSCT(dpk);
        }
        GFSF_Seek(flow, GFSF_Tell(flow) + nsct);
        /* f[^pbNԊ */
        GFDP_USE(dpk) = FALSE;          /* f[^pbNgp */
    }
}


/*---------------------------------------------------------------------------
 * J֐
 *---------------------------------------------------------------------------*/


/* ANZXʒuwZN^̗Lf[^oCg擾 */
GFS_LOCAL Sint32 gfsb_getActSiz(GfsFlow *flow, Sint32 usct, Sint32 *len)
{
    Sint32      nsct;
    GfsDtsrc    *dts = &GFS_FLW_DTSRC(flow);

    nsct = GFS_SCR_SCTNUM(dts) - GFS_SCR_SCTPOS(dts);
    nsct = MIN(nsct, usct);
    nsct = MIN(nsct, GFSB_TPARA_DFL);
    *len = nsct * SFM_SCTSIZE;
    return nsct;
}

/* end of file */
