/*------------------------------------------------------------------------------
 *  FILE:
 *      $Author: $Y.K
 *      $Date: $1994-05-10
 *      $Locker: $
 *      $Revision: $0.90
 *      $Source: $
 *      $State: $
 *
 *      Copyright (C) by SEGA Enterprises Ltd. 1994. All rights reserved.
 *
 *  PURPOSE:
 *		Cache Simulation program header file
 *		Cache Register Data Structure Definition File
 *
 *  DESCRIPTION:
 *
 *
 *  AUTHOR(S):
 *		Y.K
 *
 *  MOD HISTORY:
 *
 *
 *------------------------------------------------------------------------------*/

/****************************************************************************/
/*	WX^`															*/
/****************************************************************************/
#define CSH_CCR			(*(volatile Uint8 * )0xfffffe92)	/*	۰ڼ޽ڽ	*/

/****************************************************************************/
/*	萔`																*/
/****************************************************************************/
#define CSH_4WAY			((Uint16)0x0000)	/*	4ıèӰ	*/
#define CSH_2WAY			((Uint16)0x0008)	/*	2ıèӰ	*/
#define CSH_DISABLE			((Uint16)0x0000)	/*	ިӰ		*/
#define CSH_ENABLE			((Uint16)0x0001)	/*	ȰӰ			*/
#define CSH_CODE_ENABLE		((Uint16)0x0000)	/*	޲ȰӰ			*/
#define CSH_CODE_DISABLE	((Uint16)0x0002)	/*	ިӰ		*/
#define CSH_DATA_ENABLE		((Uint16)0x0000)	/*	ްȰӰ			*/
#define CSH_DATA_DISABLE	((Uint16)0x0004)	/*	ްިӰ		*/

/****************************************************************************/
/*	ᐅ֐錾i}Nj												*/
/****************************************************************************/
#define CSH_GET_CCR()			((Uint16)CSH_CCR)
#define CSH_SET_CCR(sw)			((Uint16)(CSH_CCR = (Uint8)(sw)))
#define CSH_SET_ENABLE(sw)		((Uint16)(CSH_CCR = (Uint8)((CSH_CCR & 0xfe)|(sw))))
#define CSH_SET_CODE_FILL(sw)	((Uint16)(CSH_CCR = (Uint8)((CSH_CCR & 0xfd)|(sw))))
#define CSH_SET_DATA_FILL(sw)	((Uint16)(CSH_CCR = (Uint8)((CSH_CCR & 0xfb)|(sw))))
#define CSH_SET_WAY_MODE(sw)	((Uint16)(CSH_CCR = (Uint8)((CSH_CCR & 0xf7)|(sw))))
#define CSH_SET_ACS_WAY(way)	((Uint16)(CSH_CCR = (Uint8)((CSH_CCR & 0x3f)|((way) << 6))))

/****************************************************************************/
/*	֐錾															*/
/****************************************************************************/
void CSH_Init(Uint16);
void CSH_AllClr(void);
void CSH_Purge(void *, Uint32);
