/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library: Xg[VXe
 * Module : Jpwb_t@C
 * File   : sega_stm.h
 * Date   : 1995-02-01
 * Version: 2.10
 * Auther : H.T
 *
 *****************************************************************************/
#if !defined(SEGA_STM_H)
#define     SEGA_STM_H

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include        "sega_gfs.h"

/* o[W   */
                            /*             1         2         3         4  */
                            /*    1234567890123456789012345678901234567890  */
                            /*    ++++++++++++++++++++++++++++++++          */
#if defined(USE_SGL)
    #define STM_VERSION_STR     ("STM_SGL Version 2.10 1996-02-01")
#else
    #define STM_VERSION_STR     ("STM_SBL Version 2.10 1996-02-01")
#endif
#define STM_VERSION_LEN 32

/*****************************************************************************
 *      萔}N
 *****************************************************************************/

#define STM_LONG_MAX    0x7fffffff

/* [vĐ̓ǂݍݎw           */
enum StmLoopRead {
    STM_LOOP_READ       = TRUE,         /* [vĐǂݍ݂   */
    STM_LOOP_NOREAD     = FALSE,        /* [vĐǂݍ݂Ȃ */
    STM_LOOP_END
};

/* [vXg[擪Xg[ɐݒ肷   */
#define STM_LOOP_DFL    ((StmHn)(0xffffffff))

/* 񃋁[v̎w                   */
#define STM_LOOP_ENDLESS        STM_LONG_MAX

/* Xg[ANZX(acstat)       */
enum StmAcStat {
    STM_EXEC_COMPLETED  = 0x100,        /* ANZXI                 */
    STM_EXEC_PAUSE      = 0x101,        /* ANZXꎞ~           */
    STM_EXEC_DOING      = 0x102,        /* ANZX                   */
    STM_EXEC_WAIT       = 0x103,        /* ]Q[g̊J҂     */
    STM_EXEC_TSKEND     = 0x104,        /* A             */
    STM_EXEC_END
};


/* ]jbgTCY           */
enum StmUnitSize {
    STM_UNIT_FORM1      = 2048,         /* MODE1,MODE2Form1ZN^TCY */
    STM_UNIT_FORM2      = 2324,         /* MODE2Form2ZN^TCY       */
    STM_UNIT_WORD       = 2,            /* [h                       */
    STM_UNIT_BYTE       = 1,            /* oCg                       */
    STM_UNIT_END
};


/* Xg[                       */
#define STM_KEY_NONE    (-1)            /* eXg[L[I𖳎   */

/* ǂݍ݃ZN^͈                   */
enum StmFad {
    STM_FAD_CDTOP       = 150,          /* fBXN擪FAD              */
    STM_FAD_CDEND       = STM_LONG_MAX  /* fBXNIǂޏꍇ̃ZN^*/
};


/* CDobt@ZN^ʒu                 */
enum StmSctPos {
    STM_CDBUF_TOP       = 0,            /* obt@擪             */
    STM_CDBUF_END       = 0xffff        /* SZN^                   */
};

/* I[vǂݍ݃Uu[hݒp   */
enum StmSctType {
    STM_SM_EOR          = CDC_SM_EOR,           /* R[hŌ̃ZN^ */
    STM_SM_VIDEO        = CDC_SM_VIDEO,         /* rfIZN^         */
    STM_SM_AUDIO        = CDC_SM_AUDIO,         /* I[fBIZN^     */
    STM_SM_DATA         = CDC_SM_DATA,          /* f[^ZN^         */
    STM_SM_TRIG         = CDC_SM_TRIG,          /* gK[rbg       */
    STM_SM_FORM         = CDC_SM_FORM,          /* tH[rbg       */
    STM_SM_RT           = CDC_SM_RT,            /* A^CZN^   */
    STM_SM_EOF          = CDC_SM_EOF,           /* t@CŌ̃ZN^ */
    STM_SM_END
};


/* ő]ZN^                     */
#define STM_TR_ALL      STM_LONG_MAX


/* ]Q[g                       */
enum StmGate {
    STM_GATE_OPEN       = 0x300,                /* J                 */
    STM_GATE_CLOSE      = 0x301,                /*                  */
    STM_GATE_END
};


/* ][h                   */
enum StmTrMode {
    STM_TR_SCU          = GFS_TMODE_SCU,        /* SCUɂDMA         */
    STM_TR_SDMA0        = GFS_TMODE_SDMA0,      /* CPUTCNX`[  */
    STM_TR_SDMA1        = GFS_TMODE_SDMA1,      /* CPUTCNX`[  */
    STM_TR_CPU          = GFS_TMODE_CPU,        /* \tgEGA]     */
    STM_TR_END
};


/* ֐ID                       */
enum StmFuncId {
    STM_INIT            = 0x300,        /* Xg[VXe     */
    STM_OPENGRP         = 0x301,        /* Xg[O[ṽI[v */
    STM_CLOSEGRP        = 0x302,        /* Xg[O[ṽN[Y */
    STM_GETSTMNUM       = 0x303,        /* Xg[̎擾           */
    STM_GETSTMHNDL      = 0x304,        /* Xg[nh̎擾     */
    STM_SETCDBUFFUNC    = 0x305,        /* obt@TCYĎ֐̓o^ */
    STM_OPENFID         = 0x306,        /* ʎqɂI[v         */
    STM_OPENFRANGE      = 0x307,        /* ZN^ʒuɂI[v     */
    STM_OPENRESI        = 0x308,        /* 풓Xg[̃I[v     */
    STM_CLOSE           = 0x309,        /* Xg[̃N[Y         */
    STM_SETKEY          = 0x310,        /* Xg[L[̐ݒ         */
    STM_GETINFO         = 0x311,        /* Xg[̎擾         */
    STM_SCTTOWORD       = 0x312,        /* ZN^烏[hւ̕ϊ */
    STM_WORDTOSCT       = 0x313,        /* [hZN^ւ̕ϊ */
    STM_SETALIAS        = 0x314,        /* GCAX̐ݒ             */
    STM_UNSETALIAS      = 0x315,        /* GCAX̉             */
    STM_SETTRBUF        = 0x316,        /* ]̈̐ݒ               */
    STM_SETTRFUNC       = 0x317,        /* ]֐̐ݒ               */
    STM_STARTTRANS      = 0x318,        /* ]֐ɂ]Jn     */
    STM_SETTRGATE       = 0x319,        /* ]Q[g̊J             */
    STM_SETTRPARA       = 0x320,        /* ő]ZN^̐ݒ       */
    STM_SETTRFAD        = 0x321,        /* ]JnFAD̐ݒ            */
    STM_SETTRMODE       = 0x322,        /* ][h̐ݒ             */
    STM_RESETTRBUF      = 0x323,        /* ]̈̃Zbg           */
    STM_GETNUMCDBUF     = 0x324,        /* CDobt@LZN^̎擾 */
    STM_GETSCTINFO      = 0x325,        /* ǂݍ݃ZN^̎擾     */
    STM_GETLENTRBUF     = 0x326,        /* ]̈̃f[^̎擾     */
    STM_ISTRBUFFULL     = 0x327,        /* ]̈t̃`FbN       */
    STM_ISTRANS         = 0x328,        /* ]̃`FbN             */
    STM_SETEXECGRP      = 0x329,        /* T[osO[v̎w     */
    STM_EXECSERVER      = 0x330,        /* T[o̎s                 */
    STM_MOVEPICKUP      = 0x331,        /* sbNAbv̈ړ           */
    STM_SETLOOP         = 0x332,        /* [vXg[̎w       */
    STM_GETLOOPCNT      = 0x333,        /* [vJE^̎擾         */
    STM_GETEXECSTAT     = 0x334,        /* sԂ̎擾               */
    STM_ISCOMPLETE      = 0x335,        /* sĨ`FbN           */
    STM_EXECTRANS       = 0x336,        /* Xg[f[^̓]       */
    STM_CONNECTCDBUF    = 0x337,        /* iCDobt@̐ڑ   */
    STM_MOVECDBUF       = 0x338,        /* CDobt@f[^̈ړ       */
    STM_ERASECDBUF      = 0x339,        /* CDobt@f[^̏       */
    STM_SETERRFUNC      = 0x340,        /* G[֐̓o^             */
    STM_GETERRSTAT      = 0x341,        /* G[Ԃ̎擾             */
    STM_FUNC_END
};


/* G[R[h         */
enum StmErrCode {
    STM_ERR_OK          = GFS_ERR_OK,           /* I             */
    STM_ERR_CDRD        = GFS_ERR_CDRD,         /* CD[hG[       */
    STM_ERR_CDNODISC    = GFS_ERR_CDNODISC,     /* CDZbgĂȂ */
    STM_ERR_FID         = GFS_ERR_FID,          /* t@Cʎqs   */
    STM_ERR_HNDL        = GFS_ERR_HNDL,         /* nhs       */
    STM_ERR_NUM         = GFS_ERR_NUM,          /* oCgȂǂ     */
    STM_ERR_PARA        = GFS_ERR_PARA,         /* p[^s     */
    STM_ERR_NOHNDL      = GFS_ERR_NOHNDL,       /* nhɋ󂫂Ȃ */
    STM_ERR_PUINUSE     = GFS_ERR_PUINUSE,      /* sbNAbv쒆   */
    STM_ERR_TMOUT       = GFS_ERR_TMOUT,        /* ^CAEg         */
    STM_ERR_CDOPEN      = GFS_ERR_CDOPEN,       /* gCJĂ   */
    STM_ERR_FATAL       = GFS_ERR_FATAL,        /* CDFATAL        */
    STM_ERR_END
};


/*****************************************************************************
 *      f[^^̒`
 *****************************************************************************/

/* Xg[nh           */
typedef struct stmobj {
    void            *grp;           /* Xg[O[v           */
    struct stmobj   *alias;         /* ۂɑ삷Xg[             */
    struct stmobj   *sfadlst;       /* JnFADXg                    */
    struct stmobj   *fltlst;        /* i̐ڑXg                   */
    GfsHn           gfs;            /* t@Cnh                     */
    GfsFlow         *flow;          /* ǂݍ݊Ǘ                         */
    Sint32          (*trfunc)(void *obj, struct stmobj *stm, Sint32 nsct);
                                    /* ]֐(StmTrFunc)                  */
    void            *obj;           /* ]֐̑   @@@@        */
    Uint32          *trsrc;         /* ]AhX                       */
    Sint32          adlt;           /* ]AhXω                 */
    Sint32          trfad;          /* ]JnFAD                          */
    Uint8           atr;            /* Agr[g                       */
    Uint8           svrstat;
} StmObj;

typedef StmObj      *StmHn;


/* ]֐     */
typedef Sint32  (*StmTrFunc)(void *obj, StmHn stm, Sint32 nsct);
#define STM_TR_NULLFUNC         ((StmTrFunc)0)

/* G[֐   */
typedef void    (*StmErrFunc)(void *obj, Sint32 ec);
#define STM_ERR_NULLFUNC        ((StmErrFunc)0)

/* obt@Ď֐  */
typedef void    (*StmCdbufFunc)(void *obj);
#define STM_CDBUF_NULLFUNC      ((StmCdbufFunc)0)
#define STM_CDBUF_REST          NULL

/* Xg[O[v           */
typedef struct {
    StmHn       sfadlst;        /* ǂݍ݊JnFADɂ郊Xg          */
    StmHn       fltlst;         /* iڑXg                     */
    StmHn       loopstm;        /* [vXg[                     */
    StmHn       lststm;         /* ŏIXg[                       */
    StmHn       nexttrns;       /* ̓]Xg[           */
    Sint32      fad;            /* ǂݍݎsAꎞ~FAD      */
    Sint32      acstat;         /* ANZX                         */
                                /* (COMPLETED, PAUSE, DOING, WAIT)      */
    StmHn       chkstm;         /* obt@TCYĎXg[         */
    Sint32      chksctnum;      /* obt@TCYĎ֐ĂтZN^ */
    StmCdbufFunc  chkfunc;      /* obt@TCYĎ֐               */
    void        *chkobj;        /* obt@TCYĎIuWFNg       */
    Sint32      loopmax;        /* [v                           */
    Sint32      loopcnt;        /* [vJE^                       */
    Sint32      puid;           /* sbNAbv[UID                 */
    Uint16      atr;            /* Agr[g                       */
    Uint8       svrstat;
} StmGrp;

typedef StmGrp  *StmGrpHn;

/* Xg[L[               */
typedef struct {
    Sint16      fn;             /* t@Cԍ                         */
    Sint16      cn;             /* `lԍ                         */
    Sint16      smmsk;          /* Tu[h}XNp^[             */
    Sint16      smval;          /* Tu[hrl                     */
    Sint16      cimsk;          /* R[fBO}XNp^[       */
    Sint16      cival;          /* R[fBOrl               */
} StmKey;

#define STM_KEY_FN(stmkey)      ((stmkey)->fn)
#define STM_KEY_CN(stmkey)      ((stmkey)->cn)
#define STM_KEY_SMMSK(stmkey)   ((stmkey)->smmsk)
#define STM_KEY_SMVAL(stmkey)   ((stmkey)->smval)
#define STM_KEY_CIMSK(stmkey)   ((stmkey)->cimsk)
#define STM_KEY_CIVAL(stmkey)   ((stmkey)->cival)


/* Xg[Đ͈           */
typedef struct {
    Sint32      sfad;           /* ĐJnFAD                          */
    Sint32      fasnum;         /* ĐZN^                         */
} StmFrange;

#define STM_FRANGE_SFAD(frange)         ((frange)->sfad)
#define STM_FRANGE_FASNUM(frange)       ((frange)->fasnum)


/* ZN^                   */
typedef struct {
    Sint32      fad;            /* t[AhX                     */
    Sint32      fn;             /* t@Cԍ                         */
    Sint32      cn;             /* `lԍ                         */
    Uint8       sm;             /* Tu[h                           */
    Uint8       ci;             /* R[fBO                     */
} StmSct;

#define STM_SCT_FAD(sct)        ((sct)->fad)
#define STM_SCT_FN(sct)         ((sct)->fn)
#define STM_SCT_CN(sct)         ((sct)->cn)
#define STM_SCT_SM(sct)         ((sct)->sm)
#define STM_SCT_CI(sct)         ((sct)->ci)


/* G[Ǘ                   */
typedef struct {
    Sint32      code;           /* G[R[h                         */
    Sint32      where;          /* G[ꏊ                       */
    StmErrFunc  func;           /* G[̌Ăт֐           */
    void        *obj;           /* Ăт֐̑               */
} StmErrStat;

#define STM_ERR_CODE(err)       ((err)->code)
#define STM_ERR_WHERE(err)      ((err)->where)
#define STM_ERR_FUNC(err)       ((err)->func)
#define STM_ERR_OBJ(err)        ((err)->obj)


/* Xg[VXeǗ       */
typedef struct {
    StmGrp      *stmgrptbl;     /* Xg[O[vė̈         */
    Sint32      stmgrpmax;      /* Xg[O[vő吔             */
    StmObj      *stmtbl;        /* Xg[ė̈                 */
    Sint32      stmmax;         /* Xg[ő吔                     */
    StmGrpHn    curgrp;         /* ݏXg[O[v         */
    Sint32      sfad;           /* ĐJnFAD                          */
    Sint32      efad;           /* ĐIFAD                          */
    StmErrStat  err;            /* G[Ǘ                           */
    Bool        svrexec;        /* STM_ExecServer                 */
} StmMng;


/*****************************************************************************
 *      }N
 *****************************************************************************/

/* Ɨ̈TCY̎擾                 */
#define STM_WORK_SIZE(grpmax, stmmax)   \
    (sizeof(StmMng) + sizeof(StmGrp) * (grpmax) + sizeof(StmObj) * (stmmax))

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/

/* Xg[VXe             */
Bool    STM_Init(Sint32 grpmax, Sint32 stmmax, void *work);

/* Xg[VXẽZbg         */
void    STM_Reset(void);

/* Xg[O[ṽI[v         */
StmGrpHn        STM_OpenGrp(void);

/* Xg[O[ṽN[Y         */
void    STM_CloseGrp(StmGrpHn grp);

/* Xg[̎擾                   */
Sint32  STM_GetStmNum(StmGrpHn grp);

/* Xg[nh̎擾             */
StmHn   STM_GetStmHndl(StmGrpHn grp, Sint32 nstm);

/* obt@TCYĎ֐̓o^         */
void    STM_SetCdbufFunc(StmGrpHn grp, StmHn stm, Sint32 nsct, 
                                       StmCdbufFunc func, void *obj);

/* ʎqɂt@C̃I[v       */
StmHn   STM_OpenFid(StmGrpHn grp, Sint32 fid, StmKey *key, Sint32 lpread);

/* ZN^ʒuɂt@C̃I[v   */
StmHn   STM_OpenFrange(StmGrpHn grp, StmFrange *frange, StmKey *key,
                                                           Sint32 lpread);

/* 풓Xg[̃I[v             */
StmHn   STM_OpenResi(StmGrpHn grp, Sint32 fid, StmKey *key, Sint32 fad);

/* Xg[̃N[Y                 */
void    STM_Close(StmHn stm);

/* Xg[L[̐ݒ                 */
void    STM_SetKey(StmHn stm, StmKey *stmkey);

/* Xg[̎擾                 */
StmGrpHn        STM_GetInfo(StmHn stm, Sint32 *fid, StmFrange *range, 
                                                Sint32 *bn, StmKey *stmkey);

/* ZN^烏[hւ̕ϊ         */
Sint32  STM_SctToWord(StmHn stm, Sint32 nsct);

/* [hZN^ւ̕ϊ         */
Sint32  STM_WordToSct(StmHn stm, Sint32 nword);

/* Xg[nh̃GCAXݒ   */
Bool    STM_SetAlias(StmHn alias, StmHn stm);

/* Xg[nh̃GCAX   */
void    STM_UnsetAlias(StmHn alias);

/* ]̈̐ݒ                       */
void    STM_SetTrBuf(StmHn stm, void *buffer, Sint32 nunit, Sint32 unitsize);

/* ]֐̐ݒ                       */
void    STM_SetTrFunc(StmHn stm, StmTrFunc func, void *obj);

/* ]֐ɂ]Jn             */
Uint32  *STM_StartTrans(StmHn stm, Sint32 *dadr);

/* ]Q[g̊J                     */
void    STM_SetTrGate(StmHn stm, Sint32 gate);

/* ő]ZN^̐ݒ               */
void    STM_SetTrPara(StmHn stm, Sint32 tsct);

/* ]JnFAD̐ݒ                    */
void    STM_SetTrFad(StmHn stm, Sint32 fad);

/* ][h̐ݒ                     */
void    STM_SetTrMode(StmHn stm, Sint32 tmode);

/* ]̈̃Zbg                   */
void    STM_ResetTrBuf(StmHn stm);

/* bcobt@LZN^̎擾       */
Sint32  STM_GetNumCdbuf(StmHn stm);

/* ǂݍ݃ZN^̎擾             */
Bool    STM_GetSctInfo(StmHn stm, Sint32 spos, StmSct *sinfo);

/* ]̈̃f[^([h)̎擾     */
Sint32  STM_GetLenTrBuf(StmHn stm);

/* ]̈t̃`FbN               */
Bool    STM_IsTrBufFull(StmHn stm);

/* Xg[f[^]̃`FbN     */
Bool    STM_IsTrans(StmHn stm);

/* T[osO[v̎w(A)   */
Bool    STM_NwSetExecGrp(StmGrpHn grp);

/* T[osO[v̎w(A)   */
Bool    STM_SetExecGrp(StmGrpHn grp);

/* T[o̎s                         */
Sint32  STM_ExecServer(void);

/* sbNAbv̈ړ                   */
void    STM_MovePickup(StmHn stm, Sint32 off);

/* [hG[̃Jo         */
Sint32  STM_Recover(void);

/* [vXg[̎w               */
Bool    STM_SetLoop(StmGrpHn grp, StmHn loopstm, Sint32 loopmax);

/* [vJE^̎擾                 */
Sint32  STM_GetLoopCnt(StmGrpHn grp);

/* sԂ̎擾                       */
Sint32  STM_GetExecStat(StmGrpHn grp, Sint32 *fad);

/* sĨ`FbN                   */
Bool    STM_IsComplete(StmHn stm);

/* Xg[f[^̓]               */
Bool    STM_ExecTrans(StmHn stm);

/* Xg[̐ڑ                     */
void    STM_ConnectCdbuf(StmHn keystm, StmHn bufstm);

/* CDobt@f[^̈ړ               */
void    STM_MoveCdbuf(StmHn src, Sint32 spos, Sint32 snum, StmHn dst);

/* CDobt@f[^̏               */
void    STM_EraseCdbuf(StmHn stm, Sint32 spos, Sint32 snum);

/* G[̌Ăт֐̓o^     */
void    STM_SetErrFunc(StmErrFunc func, void *obj);

/* G[Ԃ̎擾                     */
void    STM_GetErrStat(StmErrStat *stat);

#endif  /* SEGA_STM_H   */

/* end of sega_stm.h            */
