/*-----------------------------------------------------------------------------
 *  FILE: mem_init.c
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      Cu\[Xt@CB
 *
 *  DESCRIPTION:
 *
 *      ǗB
 *
 *  INTERFACE:
 *
 *      < FUNCTIONS LIST >
 *          <1> MEM_Init()      -   Ǘ̈ݒ
 *
 *  CAVEATS:
 *
 *      ȂB
 *
 *  AUTHOR(S)
 *
 *      1994-07-06  N.T Ver.1.00
 *
 *  MOD HISTORY:
 *
 *      1994-11/30  H.O Ver.1.10
 *
 *-----------------------------------------------------------------------------
 */

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include <stdio.h>
#include "sega_xpt.h"

/*
 * USER SUPPLIED INCLUDE FILES
 */
#define	__MEM_LIB_SOURCE__
#include "sega_mem.h"

/*
 * GLOBAL DECLARATIONS
 */

MemHead *MEM_empty_top = NULL;				/* 󂫃Z̐擪            */

/*
 * LOCAL DEFINES/MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * STATIC DECLARATIONS
 */

/*
 * STATIC FUNCTION PROTOTYPE DECLARATIONS
 */

/******************************************************************************
 *
 * NAME:    MEM_Init()              - Ǘ̈ݒ
 *
 * PARAMETERS :
 *      (1) Uint32 top_address      - <i>  Ǘ̈擪AhX
 *      (2) Uint32 mem_size         - <i>  Ǘ̈TCY
 *
 * DESCRIPTION:
 *      Ǘ̈ݒ肵܂.
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void MEM_Init(Uint32 top_address, Uint32 mem_size){
	MemHead	*top = (MemHead *)(top_address&(~0x03));	/* [͐؂̂ */
	Uint32	num =  (mem_size-(top_address&0x03))/sizeof( MemHead );	/* [͐؂̂ */
	MEM_empty_top = top;							/* 擪AhX̋L^ */
	top->s.next = top;								/* NXg̍\z */
	top->s.size = num;								/* wb_܂ރTCY */
}
