/*-----------------------------------------------------------------------------
 *  FILE: mem_mall.c
 *
 *      Copyright(c) 1994 SEGA.
 *
 *  PURPOSE:
 *
 *      Cu\[Xt@CB
 *
 *  DESCRIPTION:
 *
 *      ǗB
 *
 *  INTERFACE:
 *
 *      < FUNCTIONS LIST >
 *          <4> MEM_Malloc()    -   ubNm
 *
 *  CAVEATS:
 *
 *      ȂB
 *
 *  AUTHOR(S)
 *
 *      1994-07-06  N.T Ver.1.00
 *
 *  MOD HISTORY:
 *
 *      1994-11/30  H.O Ver.1.10
 *
 *-----------------------------------------------------------------------------
 */

/*
 * C VIRTUAL TYPES DEFINITIONS
 */
#include <stdio.h>
#include "sega_xpt.h"

/*
 * USER SUPPLIED INCLUDE FILES
 */
#define	__MEM_LIB_SOURCE__
#include "sega_mem.h"


/*
 * GLOBAL DECLARATIONS
 */

/*
 * LOCAL DEFINES/MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * STATIC DECLARATIONS
 */

/*
 * STATIC FUNCTION PROTOTYPE DECLARATIONS
 */

/******************************************************************************
 *
 * NAME:    MEM_Malloc()            - ubNm
 *
 * PARAMETERS :
 *      (1) Uint32 mem_size         - <i>  vubNTCY(oCgP)
 *
 * DESCRIPTION:
 *      vmۂ܂D
 *
 * PRECONDITIONS:
 *      ȂB
 *
 * POSTCONDITIONS:
 *      Ȃ
 *
 * CAVEATS:
 *      ȂB
 *
 ******************************************************************************
 */

void *MEM_Malloc(Uint32 mem_size)
{
	Uint32	req_size = ( ( mem_size + sizeof( MemHead ) -1 )/(sizeof( MemHead )) +1);
	/* 蓖ĂɕKvȃTCYBŌ+1̓wb_̕ */
	MemHead	*current,*prev,*last;
	if( ( prev = MEM_empty_top ) == NULL )			/* XĝƂ */
		return NULL;								/* c薳̏ꍇ */
	else{
		last = prev;									/* Xĝ܂ */
		for( current = prev->s.next ;; prev = current, current = prev->s.next ){
			if( current->s.size >= req_size ){			/* 傫̊mF */
				if( current->s.size == req_size ){		/* ҂̏ꍇ */
					/*	prev->s.next = current->s.next;		 Ö̗Ɍ̗̈q */
					if( prev == current )				/* Ō1̏ꍇ */
						prev = NULL;					/* c薳 */
					else								/* ܂cĂꍇ */
						prev->s.next = current->s.next;	/* OAĐ؂藣 */
				}
				else{									/* ]Tꍇ */
					current->s.size -= req_size;		/* ̈̑傫𒲐 */
					current += current->s.size;			/* |C^炷 */
					current->s.size = req_size;			/* V̈̑傫ݒ */
				}
				current->s.next = NULL;					/* Ă */
				MEM_empty_top = prev;					/* XĝƂ */
				return	(void *)( current +1 );			/* |C^Ԃ */
			}
			if( current == last )						/* S] */
				return	NULL;							/* Y */
		}
	}
}
