/*
 *     \tgEFACu
 *
 *     Copyright (c) 1995 SEGA
 *
 *  Library: MPEGCuiMPGj
 *  Module : MPEGCupwb_t@C
 *  File   : sega_mpg.h
 *  Date   : 1996-01-31
 *  Version: 1.24
 *  Author : H.T.
 *
 */

/* dCN[hւ̑Ή */
#ifndef SEGA_MPG_H
#define SEGA_MPG_H

/*******************************************************************
 *      CN[ht@C
 *******************************************************************/
#include        "sega_stm.h"

/*******************************************************************
 *      萔}N
 *******************************************************************/

/* o[W */
                    /*             1         2         3         4    */
                    /*    1234567890123456789012345678901234567890    */
                    /*    ++++++++++++++++++++++++++++++++            */
#define MPG_VERSION_STR ("MPG Version 1.24 1995-12-25")
#define MPG_VERSION_LEN         (32)

/* MPEGXg[̎w */
#define MPG_STM_CUR             (0x00)          /* Xg[ */
#define MPG_STM_NEXT            (0x01)          /* ̃Xg[ */
#define MPG_AVAILABLE_ID        (0x01)          /* Xg[IDL */
#define MPG_AVAILABLE_CH        (0x02)          /* `lԍL */

/* p[^̕ύXȂw */
#define MPG_NOCHG               CDC_PARA_NOCHG

/* CDobt@悪tĂȂƂ̎w */
#define MPG_NOCDB               CDC_PARA_NOCHG

/* p[^𖳎Ƃ̎w */
#define MPG_IGNORE              CDC_PARA_NOCHG

/* Đ[h */
#define MPG_PMODE_AV            (0)     /* AVĐ[h */
#define MPG_PMODE_A             (1)     /* rfIĐ[h */
#define MPG_PMODE_V             (2)     /* I[fBIĐ[h */

/* |[Y[h̎w */
#define MPG_PAUSE_ON            (0)     /* ꎞ~^R} */
#define MPG_PAUSE_OFF           (1)     /* ʏĐ */
#define MPG_PAUSE_SLOW          (2)     /* X[Đ */

/* t[Y[h̎w */
#define MPG_FREEZE_ON           (0)     /* t[Y^ăt[Y */
#define MPG_FREEZE_OFF          (1)     /* ʏĐ */
#define MPG_FREEZE_STRB         (2)     /* Xg{Đ */

/* Xg[̃Cw */
#define MPG_LAY_SYS             (0)     /* VXeC */
#define MPG_LAY_VIDEO           (1)     /* rfIC */
#define MPG_LAY_AUDIO           (1)     /* I[fBIC */

/* AVĐ̎w */
#define MPG_AV_SYNC             (0)     /* AVĐ */
#define MPG_AV_ASYNC            (1)     /* AVƗĐ */

/* \̑@ */
#define MPG_DSCN_NITL           (0x00)  /* NTSCmC^[X[h */
#define MPG_DSCN_ITL            (0x01)  /* NTSCC^[X[h */
#define MPG_DSCN_PLNITL         (0x02)  /* PALmC^[X[h */
#define MPG_DSCN_PLITL          (0x03)  /* PALC^[X[h */

/* MPEGrfI샂[h */
#define MPG_VMODE_MOVIE         (0x00)          /* Đ[h */
#define MPG_VMODE_SPIC          (0x01)          /* Î~Đ[h */
#define MPG_VMODE_SPIC_H        (0x03)          /* אÎ~Đ[h */

/* rfI̓ */
#define MPG_VSTAT_STOP          (0x00)          /* ~ */
#define MPG_VSTAT_PREP          (0x01)          /*  */
#define MPG_VSTAT_PLAY          (0x02)          /* Đ */
#define MPG_VSTAT_ERR           (0x06)          /* G[ */

/* I[fBI̓ */
#define MPG_ASTAT_STOP          (0x00)          /* ~ */
#define MPG_ASTAT_PREP          (0x01)          /*  */
#define MPG_ASTAT_PLAY          (0x02)          /* Đ */
#define MPG_ASTAT_ERR           (0x06)          /* G[ */

/* Î~̓ */
#define MPG_SSTAT_STOP          MPG_VSTAT_STOP  /* ~ */
#define MPG_SSTAT_PREP          MPG_VSTAT_PREP  /*  */
#define MPG_SSTAT_PLAY          MPG_VSTAT_PLAY  /* Đ */
#define MPG_SSTAT_ERR           MPG_VSTAT_ERR   /* G[ */

/* MPEGXg[̏I */
#define MPG_TCND_NONE           (0)             /* IȂ */
#define MPG_TCND_EOR            (1)             /* EORrbgo */
#define MPG_TCND_SEC            (2)             /* VXeGhR[ho */

/* MPEGrfȈo͐ */
#define MPG_OUTDST_DRCT         (0)             /* VDP2ڏo */
#define MPG_OUTDST_HOST         (1)             /* zXg]o */

/* MPEGrfĨfR[h^C~O */
#define MPG_DECTMG_VSYNC        (0)             /* VSYNCfR[h */
#define MPG_DECTMG_HOST         (1)             /* zXgfR[h */

/* rfIXg[̏[h */
#define MPG_VCLR_VBV_IP (0x02)  /* I܂PsN`X^[gVBVNA */
#define MPG_VCLR_ALL    (0x00)  /* t[obt@VBV𑦍ɃNA */

/* I[fBIXg[̏[h */
#define MPG_ACLR_NONE           (0x00)          /* NAȂ */
#define MPG_ACLR_ALL            (0x01)          /* ɂׂăNA */

/* fR[h̊Jn҂p[^ */
#define MPG_HDEC_PRE            (0)             /* fR[hJnO */
#define MPG_HDEC_EXE            (1)             /* fR[hJn҂ */

/* fBXvCEBhȄo͕@ */
#define MPG_OMODE_DRCT          (0)             /* ucoQւ̒ڏo */
#define MPG_OMODE_HOST          (1)     /* zXg̈ւ̓]ɂo */

/*******************************************************************
 *      񋓒萔
 *******************************************************************/

/* G[R[h */
enum MpgErrCode {
    MPG_ERR_OK       = OK,      /* I */
    
    MPG_ERR_CDINIT   = -1,      /* CDubN̏Ɏs */
    MPG_ERR_NOMC     = -2,      /* MPEGJ[gbWȂ */
    MPG_ERR_MPNG     = -3,      /* MPEG`FbNɎs */
    MPG_ERR_MPINIT   = -4,      /* MPEGfR[_̏Ɏs */
    MPG_ERR_TMOUT    = -5,      /* ^CAEg */
    MPG_ERR_PLAYING  = -6,      /* MPEGXg[Đ */
    MPG_ERR_MCON     = -7,      /* MPEGfR[_̐ڑɎs */
    MPG_ERR_RCV      = -8,      /* ɒ~s */
    MPG_ERR_CHG      = -9,      /* ؑ֏ɒ~s */
    MPG_ERR_ILLSTAT  = -10,     /* nhԂł͂Ȃ */
    MPG_ERR_ENTRYNG  = -11,     /* ̓̓o^Ɏs */
    MPG_ERR_ILLHDL   = -12,     /* sȃnhgp */
    MPG_ERR_CREATE   = -13,     /* nh̐Ɏs */
    MPG_ERR_GETTC    = -14,     /* ^CR[h̎擾Ɏs */
    MPG_ERR_DESTROY  = -15,     /* nh̏Ɏs */
    MPG_ERR_WAIT     = -16,     /* MPEGR}h̎sWAITɂȂ */
    MPG_ERR_NG       = -17      /* ُ̑̈I */
};

/*******************************************************************
 *      \̃ANZX}N
 *******************************************************************/

/* MPEGEBhE */
#define MPG_WN_CHLD(wn)                         ((wn)->chld)
#define MPG_WN_PARE(wn)                         ((wn)->pare)
#define MPG_WN_TRFUNC(wn)                       ((wn)->trfunc)
#define MPG_WN_BUF(wn)                          ((wn)->buf)
#define MPG_WN_USEFLG(wn)                       ((wn)->useflg)
#define MPG_WN_DISPSW(wn)                       ((wn)->dispsw)
#define MPG_WN_DZ_X(wn)                         ((wn)->dz.x)
#define MPG_WN_DZ_Y(wn)                         ((wn)->dz.y)
#define MPG_WN_DS_X(wn)                         ((wn)->ds.x)
#define MPG_WN_DS_Y(wn)                         ((wn)->ds.y)
#define MPG_WN_DL_X(wn)                         ((wn)->dl.x)
#define MPG_WN_DL_Y(wn)                         ((wn)->dl.y)
#define MPG_WN_RAT_X(wn)                        ((wn)->rat.x)
#define MPG_WN_RAT_Y(wn)                        ((wn)->rat.y)
#define MPG_WN_FZ_X(wn)                         ((wn)->fz.x)
#define MPG_WN_FZ_Y(wn)                         ((wn)->fz.y)
#define MPG_WN_DP_X(wn)                         ((wn)->dp.x)
#define MPG_WN_DP_Y(wn)                         ((wn)->dp.y)
#define MPG_WN_FP_X(wn)                         ((wn)->fp.x)
#define MPG_WN_FP_Y(wn)                         ((wn)->fp.y)
#define MPG_WN_FR_X(wn)                         ((wn)->fr.x)
#define MPG_WN_FR_Y(wn)                         ((wn)->fr.y)
#define MPG_WN_YCRAT_YR(wn)                     ((wn)->ycrat.yr)
#define MPG_WN_YCRAT_CR(wn)                     ((wn)->ycrat.cr)
#define MPG_WN_INTPOL_YH(wn)                    ((wn)->intpol.yh)
#define MPG_WN_INTPOL_YV(wn)                    ((wn)->intpol.yv)
#define MPG_WN_INTPOL_CH(wn)                    ((wn)->intpol.ch)
#define MPG_WN_INTPOL_CV(wn)                    ((wn)->intpol.cv)
#define MPG_WN_MOZ_H(wn)                        ((wn)->moz.h)
#define MPG_WN_MOZ_V(wn)                        ((wn)->moz.v)
#define MPG_WN_SOFTSW_H(wn)                     ((wn)->softsw.h)
#define MPG_WN_SOFTSW_V(wn)                     ((wn)->softsw.v)
#define MPG_WN_LUMI_YLVL(wn)                    ((wn)->lumi.ylvl)
#define MPG_WN_LUMI_BDR(wn)                     ((wn)->lumi.bdr)
#define MPG_WN_BCLR(wn)                         ((wn)->bclr)
#define MPG_WN_OMODE(wn)                        ((wn)->omode)
#define MPG_WN_FBN(wn)                          ((wn)->fbn)

/* MPEGnh */
#define MPG_MV_MPGWN(mv, i)                     ((mv)->mpgwn[i])
#define MPG_MV_NEXTMV(mv)                       ((mv)->nextmv)
#define MPG_MV_USEDFLAG(mv)                     ((mv)->used_flag)
#define MPG_MV_ISMVEND(mv)                      ((mv)->ismvend)
#define MPG_MV_TCFLAG(mv)                       ((mv)->tcflag)
#define MPG_MV_FTC(mv)                          ((mv)->ftc)
#define MPG_MV_VCH(mv)                          ((mv)->vch)
#define MPG_MV_ACH(mv)                          ((mv)->ach)
#define MPG_MV_PAUTIM(mv)                       ((mv)->pautim)
#define MPG_MV_FRZTIM(mv)                       ((mv)->frztim)
#define MPG_MV_PMODE(mv)                        ((mv)->pmode)
#define MPG_MV_ACTV(mv)                         ((mv)->actv)
#define MPG_MV_ACTA(mv)                         ((mv)->acta)
#define MPG_MV_VBNO(mv)                         ((mv)->vbno)
#define MPG_MV_ABNO(mv)                         ((mv)->abno)
#define MPG_MV_VCND(mv)                         ((mv)->vcnd)
#define MPG_MV_ACND(mv)                         ((mv)->acnd)
#define MPG_MV_VLAY(mv)                         ((mv)->vlay)
#define MPG_MV_ALAY(mv)                         ((mv)->alay)
#define MPG_MV_OUTDST(mv)                       ((mv)->outdst)
#define MPG_MV_DECTMG(mv)                       ((mv)->dectmg)
#define MPG_MV_AMUTE(mv)                        ((mv)->amute)
#define MPG_MV_VID(mv)                          ((mv)->vid)
#define MPG_MV_AID(mv)                          ((mv)->aid)
#define MPG_MV_CLRV(mv)                         ((mv)->clr_v)
#define MPG_MV_CLRA(mv)                         ((mv)->clr_a)

/* G[ */
#define MPG_ERR_FUNC(err)                       ((err)->func)
#define MPG_ERR_OBJ(err)                        ((err)->obj)
#define MPG_ERR_CODE(err)                       ((err)->code)

/*******************************************************************
 *      f[^^̐錾
 *******************************************************************/

/* EBhËʒu */
typedef struct {
    Sint16      x;                              /* W */
    Sint16      y;                              /* W */
} MpgPos;

/* EBhȆ傫 */
typedef struct {
    Sint16      x;                              /*  */
    Sint16      y;                              /*  */
} MpgSiz;

/* EBhE̔{ */
typedef struct {
    Sint16      x;                              /*  */
    Sint16      y;                              /*  */
} MpgRat;

/* xb{ */
typedef struct {
    Sint8       yr;                             /* PxM̔{ */
    Sint8       cr;                             /* FM̔{ */
} MpgYcrat;

/* ԃ[h */
typedef struct {
    Sint8       yh;             /* Px̐̕ԃXCb` */
    Sint8       yv;             /* Px̐̕ԃXCb` */
    Sint8       ch;             /* F̐̕ԃXCb` */
    Sint8       cv;             /* F̐̕ԃXCb` */
} MpgIntpol;

/* UCN */
typedef struct {
    Sint16      h;              /* ̃UCN̊ */
    Sint16      v;              /* ̃UCN̊ */
} MpgMoz;

/* ڂXCb` */
typedef struct {
    Sint8       h;              /* ̂ڂXCb` */
    Sint8       v;              /* ̂ڂXCb` */
} MpgSoftsw;

/* ~lbZXL[ */
typedef struct {
    Uint8       ylvl;           /* PxM̃x */
    Sint8       bdr;            /* MPEGf̋Eg傷邩ۂ */
} MpgLumi;

/* MPEGEBhE */
typedef struct MpgWin {
    struct MpgWin       *chld;  /* qMPEGEBhEւ̃|C^ */
    struct MpgWin       *pare;  /* eMPEGEBhEւ̃|C^ */
    Sint32      (*trfunc)(void *dst, void *src, Sint32 nbyte);
    /* 摜f[^̓]֐ */
    void        *buf;           /* 摜f[^̓]̈ */
    Bool        useflg;         /* gptO */
    Bool        dispsw;         /* \XCb` */
    MpgPos      dz;             /* fBXvCEBhE̕\ʒl */
    MpgSiz      ds;             /* fBXvCEBhE̕\TCY */
    MpgPos      dl;             /* fBXvCEBhE̕\Έʒu */
    MpgRat      rat;            /* t[obt@EBhE̔{ */
    MpgPos      fz;     /* t[obt@EBhËʒu(Y[|Cg) */
    MpgPos      dp;     /* fBXvCEBhEʒup[^ */
    MpgPos      fp;     /* t[obt@EBhEʒup[^ */
    MpgRat      fr;     /* t[obt@EBhEg嗦p[^ */
    MpgYcrat    ycrat;          /* xb{ */
    MpgIntpol   intpol;         /* ԃ[h */
    MpgMoz      moz;            /* UCN */
    MpgSoftsw   softsw;         /* ڂXCb` */
    MpgLumi     lumi;           /* ~lbZXL[ */
    Uint16      bclr;           /* {[_J[ */
    Sint8       omode;          /* 摜f[^̏o̓[h */
    Sint8       fbn;            /* gpt[oNԍ */
} MpgWin;

typedef MpgWin  *MpgWn;

/* MPEGnh */
typedef struct MpgMovie {
    MpgWn       mpgwn[4];               /* MPEGEBhE */
    struct MpgMovie     *nextmv;        /* ɍĐMPEG */
    Bool        used_flag;              /* gpۂ? */
    Bool        actv;                   /* rfIĐ쒆ۂ? */
    Bool        acta;                   /* I[fBIĐ쒆ۂ? */
    Bool        ismvend;                /* ĐI */
    Bool        tcflag;                 /* ΃^CR[htO */
    Sint32      ftc;                    /* ŏ̊G̃^CR[h */
    Sint16      vch;                    /* rfĨ`lԍ */
    Sint16      ach;                    /* I[fBĨ`lԍ */
    Sint16      pautim;                 /* |[Y^C~O */
    Sint16      frztim;                 /* t[Y^C~O */
    Sint8       pmode;                  /* Đ[h (AV, A_only, V_only) */
    Sint8       vbno;                   /* rfIobt@ԍ */
    Sint8       abno;                   /* I[fBIobt@ԍ */
    Sint8       vcnd;                   /* rfȈI */
    Sint8       acnd;                   /* I[fBȈI */
    Sint8       vlay;                   /* rfĨCw */
    Sint8       alay;                   /* I[fBĨCw */
    Sint8       outdst;                 /* o͐ */
    Sint8       dectmg;                 /* fR[h^C~O */
    Sint8       amute;                  /* I|fBĨ~[g */
    Sint8       vid;                    /* rfĨXg[ID */
    Sint8       aid;                    /* I[fBĨXg[ID */
    Sint8       clr_v;                  /* fR[hobt@̏@ */
    Sint8       clr_a;                  /* fR[hobt@̏@ */
} MpgMovie;

typedef MpgMovie *MpgMv;

/* MPEGÎ~nh */
typedef MpgMv MpgSp;

/* ]֐ */
typedef Sint32 (*MpgTrFunc)(void *dst, void *src, Sint32 nbyte);

/* G[֐ */
typedef void (*MpgErrFunc)(void *obj, Sint32 errcode);

/* G[ */
typedef struct {
    Sint32      code;
    MpgErrFunc  func;
    void        *obj;
} MpgErrStat;

/*******************************************************************
 *      ֐錾
 *******************************************************************/

/* mpg_sys.c */
Sint32  MPG_Init(Sint32 dscn);
void    MPG_CaptStat(void);
Sint32  MPG_SetVideoMode(Sint32 vmode);
Sint32  MPG_GetVideoMode(void);
Bool    MPG_IsDecReady(Sint32 decpic);
void    MPG_ResetHng(void);
Bool    MPG_CheckHng(void);
Sint32  MPG_GetReport(Sint32 *actst, Sint32 *vcnt, Sint32 *pict,
                      Sint32 *stat_a, Sint32 *stat_v);
Sint32  MPG_GetInt(Sint32 *mpint);
Sint32  MPG_ResetMp(Bool mpsw);
Sint32  MPG_GetErrStat(MpgErrStat *stat);
void    MPG_SetErrFunc(MpgErrFunc func, void *obj);

/* mpg_mve.c */
MpgMv   MPG_MvCreate(StmHn vstm, StmHn astm);
Sint32  MPG_MvDestroy(MpgMv mpgmv);
void    MPG_MvSetTermCond(MpgMv mpgmv, Sint32 vcnd, Sint32 acnd);
void    MPG_MvSetVideoDest(MpgMv mpgmv, Sint32 dst);
void    MPG_MvSetDecTim(MpgMv mpgmv, Sint32 tmg);
void    MPG_MvPause(MpgMv mpgmv, Sint32 cmd, Sint32 itvl);
void    MPG_MvFreeze(MpgMv mpgmv, Sint32 cmd, Sint32 itvl);
void    MPG_MvSetPan(MpgMv mpgmv, Bool lsw, Bool rsw);
Sint32  MPG_MvGetVideoStat(MpgMv mpgmv);
Sint32  MPG_MvGetAudioStat(MpgMv mpgmv);
void    MPG_MvConnectWin(MpgMv mpgmv, MpgWn mpgwn);
void    MPG_MvDisconnectWin(MpgMv mpgmv, MpgWn mpgwn);
Sint32  MPG_MvDecNext(MpgMv mpgmv);
Sint32  MPG_MvOutput(MpgMv mpgmv, Bool chkupic);
Sint32  MPG_MvChange(MpgMv mpgmv);
void    MPG_MvSetClearMode(MpgMv mpgmv, Sint32 vmode, Sint32 amode);
void    MPG_MvSetLay(MpgMv mpgmv, Sint32 vlay, Sint32 alay);

/* mpg_mve2.c */
void    MPG_MvSetVideoChan(MpgMv mpgmv, Sint32 vch);
void    MPG_MvSetAudioChan(MpgMv mpgmv, Sint32 ach);
void    MPG_MvSetVideoId(MpgMv mpgmv, Sint32 id);
void    MPG_MvSetAudioId(MpgMv mpgmv, Sint32 id);
Sint32  MPG_MvStart(MpgMv mpgmv, Bool picsch);
Sint32  MPG_MvStop(MpgMv mpgmv);
Sint32  MPG_MvStopVideo(MpgMv mpgmv);
Sint32  MPG_MvStopAudio(MpgMv mpgmv);
void    MPG_MvGetTimeCode(MpgMv mpgmv,
                          Sint32 *hh, Sint32 *mm, Sint32 *ss, Sint32 *pp);
Sint32  MPG_MvGetPlaytime(MpgMv mpgmv);
Sint32  MPG_MvEntryNext(MpgMv mpgmv, MpgMv nextmv);

/* mpg_spc.c */
MpgSp   MPG_SpCreate(StmHn vstm);
Sint32  MPG_SpDestroy(MpgSp mpgsp);
void    MPG_SpSetVideoDest(MpgSp mpgsp, Sint32 dst);
void    MPG_SpSetTermCond(MpgSp mpgsp, Sint32 vcnd);
void    MPG_SpSetChan(MpgSp mpgsp, Sint32 ch);
void    MPG_SpSetId(MpgSp mpgsp, Sint32 id);
Sint32  MPG_SpStart(MpgSp mpgsp);
Sint32  MPG_SpStop(MpgSp mpgsp);
Sint32  MPG_SpDecNext(MpgSp mpgsp, Sint32 bnk);
Sint32  MPG_SpGetVideoStat(MpgSp mpgsp);
void    MPG_SpGetTimeCode(MpgSp mpgsp,
                          Sint32 *hh, Sint32 *mm, Sint32 *ss, Sint32 *pp);
void    MPG_SpConnectWin(MpgSp mpgsp, MpgWn mpgwn, Sint32 bnk);
void    MPG_SpDisconnectWin(MpgSp mpgsp, MpgWn mpgwn, Sint32 bnk);
Sint32  MPG_SpOutput(MpgSp mpgsp, Sint32 bnk);

/* mpg_win.c */
MpgWn   MPG_WnCreate(Uint32 dzx, Uint32 dzy, Uint32 dsx, Uint32 dsy);
void    MPG_WnDestroy(MpgWn mpgwn);
void    MPG_WnSetOutputMode(MpgWn mpgwn, Sint32 omode, void *buf);
void    MPG_WnDisp(MpgWn mpgwn, Bool sw);
void    MPG_WnSetLoc(MpgWn mpgwn, Uint32 dzx, Uint32 dzy);
void    MPG_WnSetSize(MpgWn mpgwn, Uint32 dsx, Uint32 dsy);
void    MPG_WnSetDispOfst(MpgWn mpgwn, Sint32 dlx, Sint32 dly);
void    MPG_WnSetDispRatio(MpgWn mpgwn, Uint32 x_rat, Uint32 y_rat);
void    MPG_WnSetFrmLoc(MpgWn mpgwn, Uint32 fzx, Uint32 fzy);
Sint32  MPG_WnTrans(MpgWn mpgwn);
void    MPG_WnSetBcolor(MpgWn mpgwn, Uint16 clr);
void    MPG_WnSetYcRatio(MpgWn mpgwn, Uint32 y_rat, Uint32 c_rat);
void    MPG_WnSetIntpol(MpgWn mpgwn,
                        Bool sw_yh, Bool sw_yv, Bool sw_ch, Bool sw_cv);
void    MPG_WnSetMozaic(MpgWn mpgwn, Sint32 moz_h, Sint32 moz_v);
void    MPG_WnSetSoft(MpgWn mpgwn, Bool sof_h, Bool sof_v);
void    MPG_WnSetLumiKey(MpgWn mpgwn, Sint32 y_lvl, Bool bdr);
void    MPG_WnEntryTrFunc(MpgWn mpgwn, MpgTrFunc trfunc);

#endif  /* ifndef SEGA_MPG_H */
