/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:CuC^tF[X
 * File		:pcm_lib.c
 * Date		:1994-10-04
 * Version	:1.00
 * Auther	:Y.T
 *
 ****************************************************************************/
/*-------------------- sCN[ht@Ct --------------------*/
#include <sega_pcm.h>
#include "pcm_mem.h"
#include "pcm_lib.h"

#if	1
	/*
	**1995-07-27	q
	**	ق̃t@C̊֐QƂĂ̂Œǉ
	*/
	#include	"pcm_msub.h"
#endif

/*------------------------- s}N萔t -------------------------*/
/*------------------------- s}Nt -------------------------*/
/*-------------------------- sf[^^t --------------------------*/
/* v[h֐ */
typedef Sint32 (*PreloadFunc)(PcmHn pcm, Sint32 size);

/*-------------------------- s֐錾t --------------------------*/
static void memTask(PcmHn pcm);
static Sint32 memPreloadFile(PcmHn pcm, Sint32 size);
static void memSetLoadNum(PcmHn pcm, Sint32 load_sct);
static void memSetTrMode(PcmHn pcm, PcmTrMode mode);

/*-------------------------- sϐ`t --------------------------*/
/* PCM_STM ̏̃tO */
Bool PCM_lib_stm_init;

/*-------------------------- s֐`t --------------------------*/
/********************************************************************/
/* Cȕ 												*/
/* [֐l]															*/
/*    ɏłꍇ TRUE									*/
/*    ɏłȂꍇ FALSE								*/
/********************************************************************/
Bool PCM_Init(void)
{
	PCM_lib_stm_init = OFF;
	PCM_MeInit();
	return TRUE;
}

/********************************************************************/
/* CȕI 											*/
/********************************************************************/
void PCM_Finish(void)
{
	PCM_MeFinish();
}

/********************************************************************/
/* nh̍쐬ij											*/
/* []															*/
/*    para : 쐬p[^											*/
/* [֐l]															*/
/*    nhi쐬łȂꍇ NULL)							*/
/********************************************************************/
PcmHn PCM_CreateMemHandle(PcmCreatePara *para)
{
	PcmPara 	me_para;
	PcmHn   	pcm;

	/* 쐬p[^̃`FbN */
	PCMLIB_CHK_CREATE_PARA(para);

	/* Oobt@ */
	me_para.ring_addr = PCM_PARA_RING_ADDR(para);
	me_para.ring_size = PCM_PARA_RING_SIZE(para);

	/* gKTCY */
	me_para.start_trg_size 		= PCM_DEFAULT_SIZE_START_TRG;
	me_para.start_trg_sample 	= PCM_DEFAULT_SAMPLE_START_TRG;
	me_para.stop_trg_sample 	= PCM_DEFAULT_SAMPLE_STOP_TRG;

	/* TEhhCoR}hubNԍ */
	me_para.command_blk_no = PCMLIB_COMMAND_BLK_NO;

	/* oblXg[Đԍ */
	me_para.pcm_stream_no = PCMLIB_PCM_STREAM_NO;

	/* oblobt@ */
	me_para.pcm_addr = PCM_PARA_PCM_ADDR(para);
	me_para.pcm_size = PCM_PARA_PCM_SIZE(para);

	/* o`mƃ{[ */
	me_para.pcm_pan = PCMLIB_PCM_PAN;
	me_para.pcm_level = PCMLIB_PCM_LEVEL;

	/* nh̍쐬 */
	pcm = PCM_MeCreate((PcmWork *)PCM_PARA_WORK(para), &me_para);
	PCMLIB_FACCESS_TYPE(pcm) = PCMLIB_FACCESS_MEM;

	/* s֐̐ݒ */
	PCMLIB_SET_START_FUNC(pcm, PCM_MeStart);
	PCMLIB_SET_TASK_FUNC(pcm, memTask);
	PCMLIB_SET_PRELOAD_FILE_FUNC(pcm, memPreloadFile);
	PCMLIB_SET_SET_LOAD_NUM_FUNC(pcm, memSetLoadNum);
	PCMLIB_SET_SET_TRMODE_FUNC(pcm, memSetTrMode);
	return pcm;
}

/********************************************************************/
/* nh̏ij											*/
/* []															*/
/*    pcm  : nh												*/
/********************************************************************/
void PCM_DestroyMemHandle(PcmHn pcm)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	if (PCMLIB_FACCESS_TYPE(pcm) != PCMLIB_FACCESS_MEM) {
		PCM_MeSetErrCode(PCM_ERR_ILL_CREATE_MODE);
	}

	PCM_MeDestroy(pcm);
}


/********************************************************************/
/* Đ^XN														*/
/*   Đ͒Iɂ̊֐Ă									*/
/*   ĂԊԊu͂oblobt@̔̍ĐԈȉŒIɌĂ		*/
/*   Kvpx菭ȂƍĐ								*/
/*																	*/
/* []															*/
/*    pcm : nh												*/
/*     NULL w肳ꂽ͌݃I[vĂnh   	 */
/*     ׂĂ̍Đ									*/
/********************************************************************/
void memTask(PcmHn pcm)
{
	Sint32		ring_size;

	/* ^XN */
	PCM_MeTask(pcm);

	/* [vĐ */
	if (PCM_GetPlayStatus(pcm) == PCM_STAT_PLAY_END) {
		if (--PCM_HN_CNT_LOOP(pcm) > 0) {
			/* Đ̏ꍇ͏풓f[^A[vĐ̏ꍇA
			 * AvɑăOobt@ʕ񍐂sB
			 */
			ring_size = PCM_MeGetRingSize(pcm);
			PCM_MeReset(pcm);
			PCM_MeRenewRingWrite(pcm, ring_size);
			PCM_MeStart(pcm);
		}
	}
}

/********************************************************************/
/* Đ^XN 														*/
/* []															*/
/*    pcm  : nh												*/
/*    NULL ̏ꍇ͍ĐĂnhׂĂɍĐ^XNs	*/
/********************************************************************/
void PCM_Task(PcmHn pcm)
{
	int 	i;

	if (pcm == NULL) {
		for (i = 0; i < PCM_HN_MAX; i++) {
			pcm = PCM_MeGetHandle(i);
			if (pcm != NULL) {
				/* s֐̌ďo */
				PCMLIB_TASK_FUNC(pcm)(pcm);
			}
		}
	} else {
		/* s֐̌ďo */
		PCMLIB_TASK_FUNC(pcm)(pcm);
	}
}


/********************************************************************/
/* uuNhm֐ 											*/
/********************************************************************/
void PCM_VblIn(void)
{
	PCM_MeVblIn();
}


/********************************************************************/
/* ĐJn 														*/
/* []															*/
/*    pcm  : nh												*/
/********************************************************************/
void PCM_Start(PcmHn pcm)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	/* s֐̌ďo */
	PCMLIB_START_FUNC(pcm)(pcm);
}


/********************************************************************/
/* Đ~ 														*/
/* []															*/
/*    pcm  : nh												*/
/********************************************************************/
void PCM_Stop(PcmHn pcm)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	PCM_MeStop(pcm);
}


/********************************************************************/
/* ꎞ~															*/
/* []															*/
/*    pcm  : nh												*/
/*    cmd  : R}h											*/
/********************************************************************/
void PCM_Pause(PcmHn pcm, PcmPauseCmd cmd)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	PCM_MePause(pcm, cmd);
}



/********************************************************************/
/* Đ̎擾													*/
/* []															*/
/*    pcm  : nh												*/
/* [֐l]															*/
/*    JgiĐTvj								*/
/********************************************************************/
Sint32 PCM_GetTime(PcmHn pcm)
{
	Sint32	sample_now;

	/* nh`FbN */
	PCMLIB_CHK_HANDLE_RET(pcm, 0);

	PCM_MeGetTime(pcm, &sample_now);
	return sample_now;
}

/********************************************************************/
/* ^CXP[̎擾												*/
/* []															*/
/*    pcm : nh												*/
/* [֐l]															*/
/*    ^CXP[												*/
/*    m̏ꍇ͂OԂ										*/
/********************************************************************/
Sint32 PCM_GetTimeScale(PcmHn pcm)
{
	PcmStatus 	*st;

	/* nh`FbN */
	PCMLIB_CHK_HANDLE_RET(pcm, 0);

	st = PCM_MeGetStatus(pcm);
	switch (st->play) {
	case PCM_STAT_PLAY_ERR_STOP:
	case PCM_STAT_PLAY_CREATE:
	case PCM_STAT_PLAY_START:
		return 0;
	}
	return PCM_INFO_SAMPLING_RATE(&st->info);
}

/********************************************************************/
/* P̃^XNŏʂ̏̐ݒ 							*/
/* []															*/
/*    pcm     : nh											*/
/*    sample  : P̃^XNŏʂ̏[sample/1ch]			*/
/* [l]															*/
/*  EȂ΁AKɑ傫Ȑݒ肷B				*/
/*  EƐɍĐłȂȂ̂ŁA^XNR[	*/
/*    pxƍĐglāA]Tlɐݒ肷邱ƁB		*/
/*  EĐ̕ύX\A^XNׂ̈̂̕߂ɂ́AĐ	*/
/*    JnOɐݒ肷̂]܂B								*/
/********************************************************************/
void PCM_Set1TaskSample(PcmHn pcm, Sint32 sample)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);
	PCM_MeSet1TaskSample(pcm, sample);
}

/********************************************************************/
/* ĐJngKTCY̐ݒ 										*/
/* []															*/
/*    pcm     : nh											*/
/*    size    : Oobt@ւ̋[byte]						*/
/* [l]															*/
/*  Esize 傫f[^AĐJn̕KvƂȂB		*/
/*  EOobt@TCYłȂ΂ȂȂB					*/
/*  EĐt@CTCYłȂ΂ȂȂB					*/
/*  EĐJnOɐݒ肷B										*/
/* [ړI]															*/
/*    ĐCúAf[^̍ĐIɂĐ~s	*/
/*  ̂ŁAOobt@ւ̃f[^肵ĂłȂꍇAr	*/
/*  ōĐ~Ă܂ꍇB̐ݒ΂xS	*/
/*  シB													*/
/*    ̐ݒʂɉAJn̒xlȂ΂ȂȂB	*/
/********************************************************************/
void PCM_SetStartTrgSize(PcmHn pcm, Sint32 size)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);
	PCM_MeSetStartTrgSize(pcm, size);
}

/********************************************************************/
/* ĐJngKTv̐ݒ 									*/
/* []															*/
/*    pcm     : nh											*/
/*    sample  : oblobt@ւ̋[sample/1ch]				*/
/* [l]															*/
/*  Esample ȏ̋AĐJn̕KvƂȂB				*/
/*  EĐJnOɐݒ肷B										*/
/********************************************************************/
void PCM_SetStartTrgSample(PcmHn pcm, Sint32 sample)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);
	PCM_MeSetStartTrgSample(pcm, sample);
}

/********************************************************************/
/* Đ~gKTv̐ݒ 									*/
/* []															*/
/*    pcm     : nh											*/
/*    sample  : oblobt@̎c[sample/1ch]					*/
/* [l]															*/
/*  Esample ȉ̎cʂAĐ~̏ƂȂB					*/
/*  EĐJnOɐݒ肷B										*/
/* [ړI]															*/
/*  @^XNR[̕pxႢƒ~ɃmCYBǂĂ	*/
/*  pxłȂꍇɁAftHgl傫߂ɐݒ肷΁A	*/
/*  łB												*/
/********************************************************************/
void PCM_SetStopTrgSample(PcmHn pcm, Sint32 sample)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);
	PCM_MeSetStopTrgSample(pcm, sample);
}


/********************************************************************/
/* oblR}hubNԍ̐ݒ									*/
/* []															*/
/*    pcm  : nh												*/
/*    blk_no  : R}hubNԍiO`Vj						*/
/********************************************************************/
void PCM_SetPcmCmdBlockNo(PcmHn pcm, Sint32 blk_no)
{
	PcmPara *para;

	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	if (blk_no < 0 || blk_no > 7) {
		PCM_MeSetErrCode(PCM_ERR_ILLEGAL_PARA);
		return;
	}

	para = PCM_MeGetPara(pcm);
	para->command_blk_no = blk_no;
}


/********************************************************************/
/* Xg[Đԍ̐ݒ 										*/
/* []															*/
/*    pcm  : nh												*/
/*    stream_no  : Xg[ĐԍiO`Vj						*/
/********************************************************************/
void PCM_SetPcmStreamNo(PcmHn pcm, Sint32 stream_no)
{
	PcmPara *para;

	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	if (stream_no < 0 || stream_no > 7) {
		PCM_MeSetErrCode(PCM_ERR_ILLEGAL_PARA);
		return;
	}

	para = PCM_MeGetPara(pcm);
	para->pcm_stream_no = stream_no;
}



/********************************************************************/
/* Đo`m̐ݒ 												*/
/* []															*/
/*    pcm  : nh												*/
/*    pan  : o`m̒liO`RPj									*/
/********************************************************************/
void PCM_SetPan(PcmHn pcm, Sint32 pan)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	PCM_MeSetPan(pcm, pan);
}

/********************************************************************/
/* Đ{[̐ݒ 											*/
/* []															*/
/*    pcm  : nh												*/
/*    volume : {[iO`Vj									*/
/********************************************************************/
void PCM_SetVolume(PcmHn pcm, Sint32 volume)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	PCM_MeSetVolume(pcm, volume);
}

/********************************************************************/
/* oblĐp[^̕ύX	 									*/
/* []															*/
/*    pcm  : nh												*/
/********************************************************************/
void PCM_ChangePcmPara(PcmHn pcm)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	PCM_MeChangePcmPara(pcm);
}

/********************************************************************/
/* oblĐ̐ݒ 											*/
/* []															*/
/*    pcm  : nh												*/
/*    info : Đ												*/
/********************************************************************/
void PCM_SetInfo(PcmHn pcm, PcmInfo *info)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	PCM_MeSetInfo(pcm, info);
}

/********************************************************************/
/* |[Yp[NAhXATCY̐ݒ 						*/
/* []															*/
/*    addr : |[Yp[NAhX								*/
/*    size : |[Yp[NTCY								*/
/********************************************************************/
void PCM_SetPauseWork(Sint32 *addr, Sint32 size)
{
	PCM_MeSetPauseWork(addr, size);
}

/********************************************************************/
/* [v񐔂̎w 												*/
/* []															*/
/*    pcm       : nh											*/
/*    cnt_loop  : [v										*/
/********************************************************************/
void PCM_SetLoop(PcmHn pcm, Sint32 cnt_loop)
{
	PCM_MeSetLoop(pcm, cnt_loop);
}

/********************************************************************/
/* ɍĐnh̓o^ 										*/
/* []															*/
/*    pcm  : nh												*/
/********************************************************************/
void PCM_EntryNext(PcmHn pcm)
{
	PCM_MeEntryNext(pcm);
}

/********************************************************************/
/* nh̋؂ւ 											*/
/********************************************************************/
void PCM_Change(void)
{
	PcmChangeStatus status;
	PcmHn	before_pcm, next_pcm;
	int		i;

	before_pcm = NULL;
	next_pcm = PCM_MeGetEntryNext();
	for (i = 0; i < PCM_HN_MAX; i++) {
		before_pcm = PCM_MeGetHandle(i);
		if (before_pcm != next_pcm && before_pcm != NULL) {
			break;
		}
	}

	status = PCM_MeCheckChange();
	switch (status) {
	case PCM_CHANGE_OK_AT_ONCE:
		/* ؂ւ\ */
	case PCM_CHANGE_NO_DATA:
		/* f[^s */
		PCM_MeChange(before_pcm);
		break;
	case PCM_CHANGE_TOO_LARGE_HEADER:
		/* wb_傫 */
		PCM_MeSetErrCode(PCM_ERR_TOO_LARGE_HEADER);
		break;
	case PCM_CHANGE_NO_ENTRY:
	default:
		/* GgȂ */
		PCM_MeSetErrCode(PCM_ERR_CHANGE_NO_ENTRY);
		break;
	}
}


/********************************************************************/
/* nh̋؂ւԂ̎擾									*/
/********************************************************************/
PcmChangeStatus PCM_CheckChange(void)
{
	return PCM_MeCheckChange();
}


/********************************************************************/
/* bcobt@̍ő]ZN^ݒ肷						*/
/* []															*/
/*    pcm  : nh												*/
/*    load_sct : ő]ZN^									*/
/********************************************************************/
void PCM_SetLoadNum(PcmHn pcm, Sint32 load_sct)
{
#if	0
	/*
	**1995-07-27	q
	**	gĂȂ̂ō폜
	*/
	PcmPara *para;
#endif
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);
	if (load_sct <= 0) {
		PCM_MeSetErrCode(PCM_ERR_ILLEGAL_PARA);
		return;
	}

	/* s֐̌ďo */
	PCMLIB_SET_LOAD_NUM_FUNC(pcm)(pcm, load_sct);
}


/********************************************************************/
/* ĐXe[^X̎擾												*/
/* []															*/
/*    pcm  : nh												*/
/* [֐l]															*/
/*    ĐXe[^X												*/
/********************************************************************/
PcmPlayStatus PCM_GetPlayStatus(PcmHn pcm)
{
	PcmStatus 	*st;

	/* nh`FbN */
	PCMLIB_CHK_HANDLE_RET(pcm, PCM_STAT_PLAY_ERR_STOP);

	st = PCM_MeGetStatus(pcm);
	return st->play;
}

/********************************************************************/
/* G[̎擾													*/
/********************************************************************/
PcmErrCode PCM_GetErr(void)
{
	return PCM_MeGetErrCode();
}


/********************************************************************/
/* G[֐̓o^													*/
/* []															*/
/*    func : G[֐												*/
/*    obj  : o^IuWFNg										*/
/********************************************************************/
void PCM_SetErrFunc(PcmErrFunc func, void *obj)
{
	PCM_MeSetErrFunc(func, obj);
}

/********************************************************************/
/* ݃obt@AhXA݉\TCY̎擾				*/
/* []															*/
/*    pcm  : nh												*/
/* [o]															*/
/*    free_size  : A݉\oCg							*/
/*                 Ä̏݉\̃TCY					*/
/*    free_total : ݉\oCg							*/
/*                 sÄ킹݉\vTCY		*/
/* [֐l]															*/
/*     ݃obt@AhX										*/
/*     ݉\TCYO NULL 								*/
/********************************************************************/
Uint32 *PCM_GetWriteBuf(PcmHn pcm, Sint32 *free_size, Sint32 *free_total)
{
	Sint8 	*write_addr;

	/* nh`FbN */
	PCMLIB_CHK_HANDLE_RET(pcm, NULL);

	PCM_MeGetRingWrite(pcm, &write_addr, free_size, free_total);
	return (Uint32 *)write_addr;
}


/********************************************************************/
/* obt@ւ̏݃TCY̒ʒm									*/
/* []															*/
/*    pcm  : nh												*/
/*    write_size : obt@ɏ񂾃oCg						*/
/********************************************************************/
void PCM_NotifyWriteSize(PcmHn pcm, Sint32 write_size)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	if (write_size < 0) {
		PCM_MeSetErrCode(PCM_ERR_ILLEGAL_PARA);
		return;
	}

	PCM_MeRenewRingWrite(pcm, write_size);
}

/********************************************************************/
/* Ƀt@Cǂݍ										*/
/* []															*/
/*    pcm  : nh												*/
/*    size : ǂݍރoCg										*/
/*           Oobt@ǂݍ݃oCg菬			*/
/*           obt@TCYɂȂB									*/
/*           ǂݍރoCg̓ZN^PʁiQOSW̔{jɂȂB	*/
/* [֐l]															*/
/*    ۂɓǂݍ񂾃oCg										*/
/********************************************************************/
Sint32 PCM_PreloadFile(PcmHn pcm, Sint32 size)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE_RET(pcm, 0);
	if (size <= 0) {
		PCM_MeSetErrCode(PCM_ERR_ILLEGAL_PARA);
		return 0;
	}

	/* s֐̌ďo */
	return PCMLIB_PRELOAD_FILE_FUNC(pcm)(pcm, size);
}


/********************************************************************/
/* Đ̃t@Cǂݍݓo^֐							*/
/*   ۂ́AȂ_~[֐									*/
/* []															*/
/*    pcm  : nh												*/
/*    size : ǂݍރoCg										*/
/* [֐l]															*/
/*    OԂ														*/
/********************************************************************/
static Sint32 memPreloadFile(PcmHn pcm, Sint32 size)
{
	return 0;
}

static void memSetLoadNum(PcmHn pcm, Sint32 load_sct)
{
	return;
}

/********************************************************************/
/* ɃtBwb_ǂݍ									*/
/* []															*/
/*    pcm  : nh												*/
/* [֐l]															*/
/*    ۂɓǂݍ񂾃oCg										*/
/********************************************************************/
#if 0	/* Ή */
Sint32 PCM_PreloadHeader(PcmHn pcm)
{
	Sint32		load_size, header_size, read_size;
	PcmHeader	*header;

	/* nh`FbN */
	PCMLIB_CHK_HANDLE_RET(pcm, 0);

	load_size = PCMLIB_SECT_SIZE;
	if ((read_size = PCMLIB_PRELOAD_FILE_FUNC(pcm)(pcm, load_size)) <= 0) {
		return read_size;
	}
	header = PCM_MeGetHeader(pcm);
	header_size = header->size_header >> 4;
	load_size = header_size - load_size;
	load_size = ((load_size + PCMLIB_SECT_SIZE - 1) / PCMLIB_SECT_SIZE) * 
										PCMLIB_SECT_SIZE;
	read_size = PCMLIB_PRELOAD_FILE_FUNC(pcm)(pcm, load_size) + read_size;
	return read_size;
}
#endif
/********************************************************************/
/* f[^̓]̐ݒibcubNOobt@j 			*/
/* []															*/
/*    pcm   : [rnh										*/
/*    mode  : ]												*/
/*      PCM_TRMODE_CPU : \tgEFA]							*/
/*      PCM_TRMODE_SDMA : cl`TCNX`[					*/
/*      PCM_TRMODE_SCU  : rbt̂cl`							*/
/********************************************************************/
#if 0
void PCM_SetTrModePcm(PcmHn pcm, PcmTrMode mode)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	PCM_MeSetTrModePcm(pcm, mode);
}
#endif

/********************************************************************/
/* f[^̓]̐ݒiOobt@oblobt@j 		*/
/* []															*/
/*    pcm   : [rnh										*/
/*    mode  : ]												*/
/*      PCM_TRMODE_CPU : \tgEFA]							*/
/*      PCM_TRMODE_SDMA : cl`TCNX`[					*/
/*      PCM_TRMODE_SCU  : rbt̂cl`							*/
/********************************************************************/
void PCM_SetTrModeCd(PcmHn pcm, PcmTrMode mode)
{
	/* nh`FbN */
	PCMLIB_CHK_HANDLE(pcm);

	/* s֐̌ďo */
	PCMLIB_SET_TRMODE_FUNC(pcm)(pcm, mode);
}


static void memSetTrMode(PcmHn pcm, PcmTrMode mode)
{
	return;
}

/* ̃nhɂāAȂꍇ TRUE Ԃ */
Bool PCM_IsDeath(PcmHn pcm)
{
	PcmPlayStatus 	play_status;

	/* nh`FbN */
	PCMLIB_CHK_HANDLE_RET(pcm, TRUE);

	if (! PCM_MeIsCreate(pcm)) {
		return TRUE;
	}

	play_status = PCM_GetPlayStatus(pcm);
	switch (play_status) {
	case PCM_STAT_PLAY_END:			/* Đ 				*/
	case PCM_STAT_PLAY_ERR_STOP:	/* ُ~					*/
		return TRUE;
	default:
		return FALSE;
	}
}
