/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:ԊǗ
 * File		:pcm_time.h
 * Date		:1994-10-04
 * Version	:1.00
 * Auther	:Y.T
 *
 ****************************************************************************/
#if !defined(PCM_TIME_H)
#define PCM_TIME_H


/*******************************************************************
y@@\z
	VXevOgpāAVXeNbNlʂ
y@z
	Ȃ
y߂lz
	1		: 28MHz
	0		: 26MHz
*******************************************************************/
#define PCM_IS_26MHZ		(SYS_GETSYSCK == 0)

/*******************************************************************
y@@\z
	VDP2̉ʃXe[^XWX^āANTSC, PAL ʂ
y@z
	Ȃ
y߂lz
	1		: PAL
	0		: NTSC
*******************************************************************/
#define PCM_IS_PAL			(*(volatile Uint16 *)0x25f80004 & 0x0001)

/*******************************************************************
y@@\z
	VDP2̂suʃ[hWX^āAinterlace, non-interlace 
	ʂ
y@z
	Ȃ
y߂lz
	1		: interlace
	0		: non-interlace
*******************************************************************/
#define PCM_IS_INTERLACE	(*(volatile Uint16 *)0x25f80004 & 0x00c0)

/*******************************************************************
y@@\z
	uuN荞݂̎g𓾂[Hz]
y@z
	Ȃ
y߂lz
	uuN荞݂̎g
*******************************************************************/
/* ugB16bit EVtg [Hz] ɂȂlB(m؂) */
#define PCM_FREQ_VBL_NTSC_N	(0x3BD374)		/* 59.8261   *256*256[Hz] */
#define PCM_FREQ_VBL_NTSC_I	(0x3BF0A3)		/* 29.9700 *2*256*256[Hz] */
#define PCM_FREQ_VBL_PAL_N	(0x31EB8B)		/* 49.9201   *256*256[Hz] */
#define PCM_FREQ_VBL_PAL_I	(0x320000)		/* 25.0000 *2*256*256[Hz] */
#define PCM_FREQ_VBL_NTSC	(PCM_IS_INTERLACE ? 							\
								PCM_FREQ_VBL_NTSC_I : PCM_FREQ_VBL_NTSC_N)
#define PCM_FREQ_VBL_PAL	(PCM_IS_INTERLACE ? 							\
								PCM_FREQ_VBL_PAL_I : PCM_FREQ_VBL_PAL_N)
#define PCM_FREQ_VBL		(PCM_IS_PAL ? PCM_FREQ_VBL_PAL : PCM_FREQ_VBL_NTSC)

/*******************************************************************
y@@\z
	botNbNg𒲂ׂ[Hz]
y@z
	Ȃ
y߂lz
	botNbNg
*******************************************************************/
#define PCM_CLK_CPU_NTSC26	(26874100L)
#define PCM_CLK_CPU_NTSC28	(28636400L)
#define PCM_CLK_CPU_PAL26	(26687500L)
#define PCM_CLK_CPU_PAL28	(28437500L)
#define PCM_CLK_CPU_NTSC	(PCM_IS_26MHZ ? PCM_CLK_CPU_NTSC26 : PCM_CLK_CPU_NTSC28)
#define PCM_CLK_CPU_PAL		(PCM_IS_26MHZ ? PCM_CLK_CPU_PAL26 : PCM_CLK_CPU_PAL28)
#define PCM_CLK_CPU			(PCM_IS_PAL ? PCM_CLK_CPU_PAL : PCM_CLK_CPU_NTSC)

/* ^C}Cuݒl */
#define PCM_TIM_MODE		(2)		/* [h:l, 0:8, 1:32, 2:128 */

/* 4sha5nyuu migi shift */
#define PCM_ROUND_SHIFT_R(a, n)		((((a) >> ((n) - 1)) + 1) >> 1)

/*******************************************************************
y@@\z
	pcm_GetClock œNbNlb֊ZXP[l
y@z
	>> 7 ́Al 128 ł̂Z\B
	>> 8 ́A 256 ̂P̒lNbNlƂ銷Z\B
*******************************************************************/
/* #define PCM_CLOCK_SCALE		(PCM_CLK_CPU >> (7 + 8)) */
#define PCM_CLOCK_SCALE		(PCM_ROUND_SHIFT_R(PCM_CLK_CPU, 7 + 8))


extern Sint32 pcm_GetCount(void);
extern void pcm_InitClock(void);
extern Sint32 pcm_GetTimePcm(PcmHn hn);

#if	1
	/*
	**1995-07-27	q
	**	ق̃t@CQƂĂ̂Œǉ
	*/
	void	pcm_StartClock( PcmHn	hn );
#endif

#endif	/* PCM_TIME_H */
