
	include	SCSP.LIB

	global	DSPEGLFO

	external	get_EXPTB,get_EXPTBS

;		ready d7.w : Element
DSPEGLFO:
;@		rts
		subq.w	#1,d7			; loop size
		andi.w	#$1F,d7			;

		movea.l	DFL_INST_addr(a6),a0	; ul݃AhX

		lea	_DFL_ELMNT_wk(a6),a2
DSPEGLFO_loop:	move.b	DFL_wk_MSFC(a2),d0	;
		andi.w	#$0C,d0			;
		jmp	ELMNTJPTB(pc,d0.w)	;  MS   FC
ELMNTJPTB:	bra	DSPEGLFO_next		;  0    0
		bra	DSPEGLFO_next		;  0    1
		bra	ELMNT_LFO		;  1    0
;@		bra	ELMNT_EG		;  1    1
;		
;		   c-eilter df 	
;		
		global	ELMNT_EG
ELMNT_EG:	movea.l	DFL_dst_addr(a2),a1	; = desti. Element top
		move.b	DFL_EG_seg(a2),d3	; = 0 ` 7
		andi.w	#7,d3
		add.w	d3,d3			;
		move.w	d3,d0
		add.w	d0,d0			;
		jmp	ELEGJPTB(pc,d0.w)
ELEGJPTB:	bra	DFL_EG_0		; Segment# = 0
		bra	DFL_EG_1		;	   = 1
		bra	DFL_EG_2		;	   = 2
		bra	DFL_EG_3		;	   = 3
		bra	DFL_EG_4		;	   = 4
		bra	DFL_EG_5		;	   = 5
		bra	DFL_EG_6		;	   = 6
		bra	DFL_EG_7		;	   = 7

		global	DFL_EG_0
DFL_EG_0:	; <<< EG start ready >>>
		move.b	7(a1),d0		; = [HOLDL]
		lsl.w	#8,d0			; -$8000`+$7F00
		move.w	d0,(a0)			; <<< ul >>>
		addi.w	#$8000,d0		;
		move.w	d0,DFL_add_wk(a2)	; = $0000`$FF00
		move.b	6(a1),d0		; = [HOLDT]
		jsr	get_EXPTB(pc)		; return d0
		lsr.w	#2,d0			; / 4
		move.w	d0,DFL_hold_time(a2)	;
		addq.b	#1,DFL_EG_seg(a2)	; Seq#0 ---> Seg#1
		bra	DSPEGLFO_next		;
DFL_EG_1:	; <<< EG start Hold >>>
		subq.w	#_8msec,DFL_hold_time(a2)	;
		bcc	DSPEGLFO_next		;
		move.w	DFL_add_wk(a2),d4	; = $0000`$FF00
		;-------------------------------;
		global	set_next_seg
set_next_seg:	move.w	d4,DFL_add_wk(a2)	; = $0000`$FF00
		subi.w	#$8000,d4		; = -$8000`$7FFF
		move.w	d4,(a0)			; <<< ul >>>
		move.b	6(a1,d3.w),d0		; = [AR,DR,SR,RR]
		jsr	get_EXPTBS(pc)		; return d0.w }$3FFF
		move.w	d0,DFL_add_bs(a2)	; set rate
		move.b	7(a1,d3.w),d0		; = [AL,DL,SL,RL]
		lsl.w	#8,d0			; = -$8000`+$7F00
		addi.w	#$8000,d0		;
		move.w	d0,DFL_level(a2)	; set level : $0000`$FF00
		addq.b	#1,DFL_EG_seg(a2)	; Seq#1 ---> Seg#2
		bra	DSPEGLFO_next		;
		;-------------------------------;
		global	DFL_EG_6
DFL_EG_6:	; <<< EG Release >>>
		nop
		global	DFL_EG_2
DFL_EG_2:	; <<< EG Attack >>>
DFL_EG_3:	; <<< EG Decay >>>
DFL_EG_4:	; <<< EG Slope >>>
		move.w	DFL_level(a2),d4	; = level : $0000`$FF00
		move.w	DFL_add_wk(a2),d1	; = work  : $0000`$FFFF
		move.w	DFL_add_bs(a2),d0	; = rate  : }$3FFF
		bmi.s	DFL_EG_2A
		; <<< rate = + >>>
		add.w	d0,d1			; work + rate
		bcs.s	set_next_seg		;
		cmp.w	d1,d4			;
		bls.s	set_next_seg		; jump if work + rate  level
		bra.s	DFL_new_wk
DFL_EG_2A:	; <<< rate = - >>>
		neg.w	d0			; 0`$3FFF
		sub.w	d0,d1			; work + rate
		bcs.s	set_next_seg		;
		cmp.w	d1,d4			; level
		bcc.s	set_next_seg		; jump if work + rate  level
		;-------------------------------;
		global	DFL_new_wk
DFL_new_wk:	move.w	d1,DFL_add_wk(a2)	; set new work
		subi.w	#$8000,d1		; = -$8000`+$7FFF
		move.w	d1,(a0)			; <<< ul >>>
		bra.s	DSPEGLFO_next		;

DFL_EG_7:	; <<< EG Release Hold >>>
DFL_EG_5:	; <<< EG Slope Hold >>>
		bra.s	DSPEGLFO_next		;
;		
;		   c-eilter ken 	
;		
ELMNT_LFO:	moveq	#0,d0			;
		move.w	DFL_add_wk(a2),d0	;
		add.w	DFL_add_bs(a2),d0	;
		move.w	d0,DFL_add_wk(a2)	;
		andi.w	#$ff00,d0		;
		lsr.w	#7,d0			;
		move.w	SINETB(pc,d0.w),d0	;  ul -$8000`+$7FFF
		move.b	DFL_wk_AMP(a2),d1	; = 0`F
		andi.w	#$0F,d1			;
		beq.s	ELMNT_LFO_1
		cmpi.w	#$0F,d1
		beq.s	ELMNT_LFO_2
		lsr.w	d1,d0
		bra.s	ELMNT_LFO_1
ELMNT_LFO_2:	clr.w	d0
ELMNT_LFO_1:	move.w	d0,(a0)			; <<< ul >>>
;@		bra.s	DSPEGLFO_next		;
		;===============================;
DSPEGLFO_next:	lea	$10(a2),a2		;
		lea	2(a0),a0		;
		dbra	d7,DSPEGLFO_loop
		rts

; 
; 		TCg`                                              
;                                                                     
; U          |WOOOg`{Veeeg                          
; tH[}bg  PUrbgAQfbok                              
; ij    QTU|Cg                                      
; 
	global	SINETB
SINETB:	dc.w	-32767,-32757,-32728,-32678,-32609,-32521,-32412,-32285
	dc.w	-32137,-31971,-31785,-31580,-31356,-31113,-30852,-30571
	dc.w	-30273,-29956,-29621,-29268,-28898,-28510,-28150,-27683
	dc.w	-27245,-26790,-26319,-25832,-25329,-24811,-24279,-23731
	dc.w	-23170,-22594,-22005,-21403,-20787,-20159,-19519,-18868
	dc.w	-18204,-17530,-16846,-16151,-15446,-14732,-14010,-13279
	dc.w	-12539,-11793,-11039,-10278,-09512,-08739,-07962,-07179
	dc.w	-06393,-05602,-04808,-04011,-03212,-02410,-01608,-00804

	dc.w	+00000,+00804,+01608,+02410,+03212,+04011,+04808,+05602
	dc.w	+06393,+07179,+07962,+08739,+09512,+10278,+11039,+11793
	dc.w	+12539,+13279,+14010,+14732,+15446,+16151,+16846,+17530
	dc.w	+18204,+18868,+19519,+20159,+20787,+21403,+22005,+22594
	dc.w	+23170,+23731,+24279,+24811,+25329,+25832,+26319,+26790
	dc.w	+27245,+27683,+28150,+28510,+28898,+29268,+29621,+29956
	dc.w	+30273,+30571,+30852,+31113,+31356,+31580,+31785,+31971
	dc.w	+32137,+32285,+32412,+32521,+32609,+32678,+32728,+32757

	dc.w	+32767,+32757,+32728,+32678,+32609,+32521,+32412,+32285
	dc.w	+32137,+31971,+31785,+31580,+31356,+31113,+30852,+30571
	dc.w	+30273,+29956,+29621,+29268,+28898,+28510,+28150,+27683
	dc.w	+27245,+26790,+26319,+25832,+25329,+24811,+24279,+23731
	dc.w	+23170,+22594,+22005,+21403,+20787,+20159,+19519,+18868
	dc.w	+18204,+17530,+16846,+16151,+15446,+14732,+14010,+13279
	dc.w	+12539,+11793,+11039,+10278,+09512,+08739,+07962,+07179
	dc.w	+06393,+05602,+04808,+04011,+03212,+02410,+01608,+00804

	dc.w	-00000,-00804,-01608,-02410,-03212,-04011,-04808,-05602
	dc.w	-06393,-07179,-07962,-08739,-09512,-10278,-11039,-11793
	dc.w	-12539,-13279,-14010,-14732,-15446,-16151,-16846,-17530
	dc.w	-18204,-18868,-19519,-20159,-20787,-21403,-22005,-22594
	dc.w	-23170,-23731,-24279,-24811,-25329,-25832,-26319,-26790
	dc.w	-27245,-27683,-28150,-28510,-28898,-29268,-29621,-29956
	dc.w	-30273,-30571,-30852,-31113,-31356,-31580,-31785,-31971
	dc.w	-32137,-32285,-32412,-32521,-32609,-32678,-32728,-32757



;@;
;@;	cro lncpg` ( 7FFFH  ̗̈̂ݓł̐U  0010H
;@;     		bit format /  
;@;  		  16bit	     168 	  1.0 Hz = OCT = -8
;@;
;@SIN16_MOD:
;@	dc.w	$0000+$10,$000C+$10,$002E+$10,$0068+$10
;@	dc.w	$00B7+$10,$011E+$10,$019B+$10,$022F+$10
;@	dc.w	$02D8+$10,$0398+$10,$046D+$10,$0558+$10
;@	dc.w	$0657+$10,$076B+$10,$0893+$10,$09D0+$10
;@	dc.w	$0B1F+$10,$0C82+$10,$0DF7+$10,$0F7E+$10
;@	dc.w	$1116+$10,$12BF+$10,$1478+$10,$1641+$10
;@	dc.w	$1819+$10,$19FF+$10,$1BF3+$10,$1DF3+$10
;@	dc.w	$2000+$10,$2219+$10,$243B+$10,$2668+$10
;@	dc.w	$289E+$10,$2ADD+$10,$2D23+$10,$2F70+$10
;@	dc.w	$31C2+$10,$341A+$10,$3676+$10,$38D6+$10
;@	dc.w	$3B38+$10,$3D9B+$10,$4000+$10,$4264+$10
;@	dc.w	$44C8+$10,$472A+$10,$4989+$10,$4BE5+$10
;@	dc.w	$4E3D+$10,$5090+$10,$52DD+$10,$5523+$10
;@	dc.w	$5761+$10,$5997+$10,$5BC4+$10,$5DE7+$10
;@	dc.w	$5FFF+$10,$620C+$10,$640D+$10,$6600+$10
;@	dc.w	$67E6+$10,$69BE+$10,$6B87+$10,$6D40+$10
;@	dc.w	$6EE9+$10,$7082+$10,$7209+$10,$737E+$10
;@	dc.w	$74E0+$10,$7630+$10,$776C+$10,$7894+$10
;@	dc.w	$79A9+$10,$7AA8+$10,$7B92+$10,$7C68+$10
;@	dc.w	$7D27+$10,$7DD1+$10,$7E64+$10,$7EE1+$10
;@	dc.w	$7F48+$10,$7F98+$10,$7FD1+$10,$7FFF
;@	dc.w	$7FFF,    $7FFF,    $7FD1+$10,$7F98+$10
;@	dc.w	$7F48+$10,$7EE1+$10,$7E64+$10,$7DD1+$10
;@	dc.w	$7D27+$10,$7C68+$10,$7B92+$10,$7AA8+$10
;@	dc.w	$79A9+$10,$7894+$10,$776C+$10,$7630+$10
;@	dc.w	$74E0+$10,$737E+$10,$7209+$10,$7082+$10
;@	dc.w	$6EE9+$10,$6D40+$10,$6B87+$10,$69BE+$10
;@	dc.w	$67E6+$10,$6600+$10,$640D+$10,$620C+$10
;@	dc.w	$5FFF+$10,$5DE7+$10,$5BC4+$10,$5997+$10
;@	dc.w	$5761+$10,$5523+$10,$52DD+$10,$5090+$10
;@	dc.w	$4E3D+$10,$4BE5+$10,$4989+$10,$472A+$10
;@	dc.w	$44C8+$10,$4264+$10,$4000+$10,$3D9B+$10
;@	dc.w	$3B38+$10,$38D6+$10,$3676+$10,$341A+$10
;@	dc.w	$31C2+$10,$2F70+$10,$2D23+$10,$2ADD+$10
;@	dc.w	$289E+$10,$2668+$10,$243B+$10,$2219+$10
;@	dc.w	$2000+$10,$1DF3+$10,$1BF3+$10,$19FF+$10
;@	dc.w	$1819+$10,$1641+$10,$1478+$10,$12BF+$10
;@	dc.w	$1116+$10,$0F7E+$10,$0DF7+$10,$0C82+$10
;@	dc.w	$0B1F+$10,$09D0+$10,$0893+$10,$076B+$10
;@	dc.w	$0657+$10,$0558+$10,$046D+$10,$0398+$10
;@	dc.w	$02D8+$10,$022F+$10,$019B+$10,$011E+$10
;@	dc.w	$00B7+$10,$0068+$10,$002E+$10,$000C+$10
;@SIN16_MOD_e:
;@

