/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library: Xg[VXe
 * Module : [Jpwb_t@C
 * File   : stm_def.h
 * Date   : 1995-02-01
 * Version: 2.10
 * Author : H.T
 *
 *****************************************************************************/
#if     !defined(STM_DEF_H)
#define STM_DEF_H       1

#define STM_LOCAL

/*****************************************************************************
 *      萔}N
 *****************************************************************************/

/* T[o               */
enum SvrStat {
    SVR_UNUSE   = FALSE,                /* IuWFNggpłȂ     */
    SVR_USE     = TRUE,                 /* IuWFNggp           */
    SVR_END
};


/* Xg[̃Xe[^X       */
enum StmStat {
    STAT_NOREAD = 0x20,                 /* ANZXȂ             */
    STAT_DOING  = STM_EXEC_DOING,       /*                        */
    STAT_WAIT   = STM_EXEC_WAIT,        /* ]҂(Q[g, ̈t) */
    STAT_COMPLETED = STM_EXEC_COMPLETED,        /* ANZX         */
    STAT_END
};


/* Xg[Agr[g     */
enum StmAtr {
    STM_ATR_READ        = 0x01,         /* ǂݍ݃Xg[           */
    STM_ATR_RESI        = 0x02,         /* 풓Xg[               */
    STM_ATR_LOOPNOREAD  = 0x04,         /* [vǂݍ܂Ȃ         */
    STM_ATR_READEND     = 0x08,         /* ǂݍݍς                 */
    STM_ATR_TRSTART     = 0x10,         /* ]Jnݒς             */
    STM_ATR_TREND       = 0x20,         /* ]Iݒς             */
    STM_ATR_END
};


/* Xg[O[vAgr[g     */
enum StmGrpAtr {
    STMGRP_ATR_LOOPSPECIFY      = 0x01, /* [vXg[`ꂽ */
    STMGRP_ATR_PLAY             = 0x02, /* Đ                       */
    STMGRP_ATR_READ             = 0x04, /* ǂݍݒ                   */
    STMGRP_ATR_CHKBUF           = 0x08, /* obt@TCY`FbN       */
    STMGRP_ATR_PAUSE            = 0x10, /* |[Y                     */
    STMGRP_ATR_SEEK             = 0x20, /* V[N                     */
    STMGRP_ATR_ALRSTREND        = 0x40, /* 풓Xg[݂̂œ]I */
    STMGRP_ATR_END
};


#define FID_OPEN_FRANGE 0x3fffffff      /* ZN^ʒuI[vFID    */

#define TR_CONT         1               /* ]                       */

#define TMODE_DFL       STM_TR_CPU      /* ftHg][h         */

/*****************************************************************************
 *      f[^^̒`
 *****************************************************************************/

/* R}h֐                 */
typedef Bool    (*stmCmdFunc)(void *obj);

#define CMD_NULLFUNC    ((stmCmdFunc)0) /* NULL֐                     */

/* R}h                     */
typedef struct {
    stmCmdFunc  func;                   /* R}h               */
    void        *obj;                   /* IuWFNg           */
} StmCmd;

#define CMD_FUNC(cmd)   ((cmd)->func)
#define CMD_OBJ(cmd)    ((cmd)->obj)


#define MNG_GRP(mng, i)         ((mng)->stmgrptbl + i)
#define MNG_GRPTBL(mng)         ((mng)->stmgrptbl)
#define MNG_GRPMAX(mng)         ((mng)->stmgrpmax)
#define MNG_STM(mng, i)         ((mng)->stmtbl + i)
#define MNG_STMTBL(mng)         ((mng)->stmtbl)
#define MNG_STMMAX(mng)         ((mng)->stmmax)
#define MNG_CURGRP(mng)         ((mng)->curgrp)
#define MNG_SFAD(mng)           ((mng)->sfad)
#define MNG_EFAD(mng)           ((mng)->efad)
#define MNG_ERR(mng)            ((mng)->err)
#define MNG_SVREXEC(mng)        ((mng)->svrexec)

#define STM_GRP(stm)            ((stm)->grp)
#define STM_GRPHN(stm)          ((StmGrpHn)(STM_GRP(stm)))
#define STM_ALIAS(stm)          ((stm)->alias)
#define STM_SFADLST(stm)        ((stm)->sfadlst)
#define STM_FLTLST(stm)         ((stm)->fltlst)
#define STM_GFS(stm)            ((stm)->gfs)
#define STM_FLOW(stm)           ((stm)->flow)
#define STM_DTSRC(stm)          (&((stm)->flow->dtsrc))
#define STM_TRFUNC(stm)         ((stm)->trfunc)
#define STM_OBJ(stm)            ((stm)->obj)
#define STM_TRFAD(stm)          ((stm)->trfad)
#define STM_ATR(stm)            ((stm)->atr)
#define STM_SVRSTAT(stm)        ((stm)->svrstat)

#define STM_GRP_SFADLST(grp)    ((grp)->sfadlst)
#define STM_GRP_FLTLST(grp)     ((grp)->fltlst)
#define STM_GRP_LOOPSTM(grp)    ((grp)->loopstm)
#define STM_GRP_LSTSTM(grp)     ((grp)->lststm)
#define STM_GRP_NEXTTRNS(grp)   ((grp)->nexttrns)
#define STM_GRP_FAD(grp)        ((grp)->fad)
#define STM_GRP_ACSTAT(grp)     ((grp)->acstat)
#define STM_GRP_CHKSTM(grp)     ((grp)->chkstm)
#define STM_GRP_CHKSCTNUM(grp)  ((grp)->chksctnum)
#define STM_GRP_CHKFUNC(grp)    ((grp)->chkfunc)
#define STM_GRP_CHKOBJ(grp)     ((grp)->chkobj)
#define STM_GRP_LOOPMAX(grp)    ((grp)->loopmax)
#define STM_GRP_LOOPCNT(grp)    ((grp)->loopcnt)
#define STM_GRP_PUID(grp)       ((grp)->puid)
#define STM_GRP_ATR(grp)        ((grp)->atr)
#define STM_GRP_SVRSTAT(grp)    ((grp)->svrstat)


/*****************************************************************************
 *      }N
 *****************************************************************************/

/* CDt@C̔ */
#define STM_IS_CDFILE(stm)      \
    ((GFS_DTS_FTYPE(STM_DTSRC(stm)) == CD_FILE) ? TRUE: FALSE)

/* ǂݍ݃Xg[̔     */
#define IS_STM_READ(stm)        \
    (((STM_ATR(stm) & STM_ATR_READ) != 0) ? TRUE : FALSE)

/* 풓Xg[̔ */
#define IS_STM_RESI(stm) \
    (((STM_ATR(stm) & STM_ATR_RESI) != 0) ? TRUE : FALSE)

/* [vǂݍ܂Ȃ     */
#define IS_STM_LOOPNOREAD(stm) \
    (((STM_ATR(stm) & STM_ATR_LOOPNOREAD) != 0) ? TRUE : FALSE)

/* ǂݍݍς݂̔           */
#define IS_STM_READEND(stm) \
    (((STM_ATR(stm) & STM_ATR_READEND) != 0) ? TRUE : FALSE)

/* Đǂ̔         */
#define IS_PLAYING(grp) \
    (((STM_GRP_ATR(grp) & STMGRP_ATR_PLAY) != 0) ? TRUE : FALSE)

/* ǂݍݒǂ̔     */
#define IS_READING(grp) \
    (((STM_GRP_ATR(grp) & STMGRP_ATR_READ) != 0) ? TRUE : FALSE)

/* V[Nǂ̔       */
#define IS_SEEKING(grp) \
    (((STM_GRP_ATR(grp) & STMGRP_ATR_SEEK) != 0) ? TRUE : FALSE)

/* |[Yǂ̔       */
#define IS_PAUSING(grp) \
    (((STM_GRP_ATR(grp) & STMGRP_ATR_PAUSE) != 0) ? TRUE : FALSE)

/* [vXg[ݒ肳ꂽǂ̔   */
#define IS_LOOPSPECIFY(grp)     \
    (((STM_GRP_ATR(grp) & STMGRP_ATR_LOOPSPECIFY) != 0) ? TRUE : FALSE)

/* [vXg[wtO̐ݒ             */
#define SET_LOOPSPECIFY(grp)    (STM_GRP_ATR(grp) |= STMGRP_ATR_LOOPSPECIFY)

/* [vXg[wtỎ             */
#define CLR_LOOPSPECIFY(grp)    (STM_GRP_ATR(grp) &= ~STMGRP_ATR_LOOPSPECIFY)

/* G[ݒ肳Ă邩ǂ̔         */
#define IS_SET_ERRCODE(mng)     \
    ((STM_ERR_CODE(&MNG_ERR(mng)) != STM_ERR_OK) ? TRUE : FALSE)

/*****************************************************************************
 *      ϐ̐錾
 *****************************************************************************/

/* Xg[Ǘ̈   */
extern StmMng   *stm_mng_ptr;

/* R}ho^̈     */
extern StmCmd   stm_cmd_area;

/*****************************************************************************
 *      ֐̐錾
 *****************************************************************************/

/*--- STMMNG functions -------------------------------------------------*/

/* ŏIFAD̎擾                        */
extern Sint32   STMMNG_GetLstFad(StmGrpHn grp);

/* iڑXg̐ؒf               */
extern Bool     STMMNG_RemoveFlt(StmHn stm);

/* GFCD̃G[Xg[̃G[ɕϊݒ肷     */
extern void     STM_SetGfcdErr(Sint32 code);

/* ǂݍݏItO̐ݒ             */
extern void     STMSVR_SetReadEnd(StmGrpHn grp);

/* CDobt@ZN^̎擾           */
extern Sint32   STMSVR_GetNumCdbuf(StmHn stm);

/* ]̈                 */
extern void     STMTRN_ResetTrBuf(StmHn stm);

/* ]̈t̃`FbN               */
extern Bool     STMTRN_IsTrBufFull(StmHn stm);

/*--- STMERR functions -------------------------------------------------*/

/* ֐̐ݒ                       */
extern void     STMERR_SetFunc(Sint32 funcid);

/* G[R[h̐ݒ                   */
extern Bool     STMERR_SetCode(Sint32 code);

/* vIG[(OPEN, NODISC, FATAL)̃`FbN  */
extern Sint32   STMERR_CheckFatalErr(void);

/* G[֐̌Ăт                 */
extern void     STMERR_Exec(void);

#endif


