/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994,1995,1996 SEGA
 *
 * Library: Xg[VXe
 * Module : T[oW[
 * File   : stm_svr.c
 * Date   : 1995-02-01
 * Version: 2.10
 * Author : H.T
 *
 *****************************************************************************/
/* SGL̏ꍇRpCIvVɂ`邱
 * #define USE_SGL
 */

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include        <stdlib.h>
#include        <string.h>

#include        "sega_stm.h"
#include        "gfs_def.h"
#include        "gfs_cdc.h"
#include        "gfs_cdf.h"
#include        "gfs_cdb.h"
#include        "gfs_trn.h"
#include        "gfs_buf.h"
#include        "gfs_dir.h"
#include        "stm_loc.h"
#include        "stm_def.h"

/*****************************************************************************
 *      ϐ̒`
 *****************************************************************************/

/* R}ho^̈     */
StmCmd  stm_cmd_area;

/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/
/*--- STMMNG functions -------------------------------------------------*/

/*****************************************************
 * CDXg[Ȃǂ𒲂ׂ
 * grp  : Xg[O[v
 * ߂l : TRUE CDXg[͂Ȃ
 *****************************************************/
STM_LOCAL Bool  stmmng_isNoCdFile(StmGrpHn grp)
{
    StmHn       stm;

    /* 풓Xg[̓[vXg[ɂȂȂ       */
    if (STM_GRP_LOOPSTM(grp) != NULL) {
        return (FALSE);
    }
    for (stm = STM_GRP_SFADLST(grp); stm != NULL; stm = STM_SFADLST(stm)) {
        if (STM_IS_CDFILE(stm) == TRUE) {
            return (FALSE);
        }
    }
    return (TRUE);
}


/*****************************************************
 * SXg[풓Xg[ǂ𒲂ׂ
 * grp  : Xg[O[v
 * ߂l : TRUE ׂď풓Xg[
 *****************************************************/
STM_LOCAL Bool  stmmng_isAllResi(StmGrpHn grp)
{
    StmHn       stm;

    /* 풓Xg[̓[vXg[ɂȂȂ       */
    if (STM_GRP_LOOPSTM(grp) != NULL) {
        return (FALSE);
    }
    /* i肪ڑĂꍇ */
    if (STM_GRP_FLTLST(grp) != NULL) {
        return (FALSE);
    }
    for (stm = STM_GRP_SFADLST(grp); stm != NULL; stm = STM_SFADLST(stm)) {
        if (IS_STM_RESI(stm) == FALSE) {
            return (FALSE);
        }
    }
    return (TRUE);
}


/*************************************************
 * CSCTrbg֐̓o^
 * grp : sXg[O[v
 *************************************************/
STM_LOCAL void  stm_execCsct(void *grp)
{
    Sint32      nsct;

    STM_GRP_ATR((StmGrpHn)grp) |= STMGRP_ATR_READ;
    if (STM_GRP_CHKFUNC((StmGrpHn)grp) != STM_CDBUF_NULLFUNC) {
        if (STM_GRP_CHKSTM((StmGrpHn)grp) == STM_CDBUF_REST) {
            nsct = STL_CsctGetFreeSctnum();
            if (nsct < STM_GRP_CHKSCTNUM((StmGrpHn)grp)) {
                STM_GRP_ATR((StmGrpHn)grp) |= STMGRP_ATR_CHKBUF;
            }
        } else {
            nsct = STL_CsctGetSctNum(STM_FLOW(STM_GRP_CHKSTM((StmGrpHn)grp)));
            if (nsct >= STM_GRP_CHKSCTNUM((StmGrpHn)grp)) {
                STM_GRP_ATR((StmGrpHn)grp) |= STMGRP_ATR_CHKBUF;
            }
        }
    }
}


/*************************************************
 * Xe[^XɂG[̐ݒ
 * stat : hCũXe[^X
 *************************************************/
STM_LOCAL void  stm_setErr(Sint32 stat)
{
    Sint32      code = STM_ERR_OK;
    StmGrpHn    grp;

    if (stat == GFS_STAT_OPEN) {
        code = STM_ERR_CDOPEN;
    } else if (stat == GFS_STAT_NODISC) {
        grp = MNG_CURGRP(stm_mng_ptr);
        if ((grp == NULL)||(stmmng_isNoCdFile(grp) == FALSE)) {
            code = STM_ERR_CDNODISC;
        }
    } else if (stat == GFS_STAT_FATAL) {
        code = STM_ERR_FATAL;
    } else if (stat == GFS_STAT_ERROR) {
        code = STM_ERR_CDRD;
    }
    if (code != STM_ERR_OK) {
        STMERR_SetCode(code);
    }
}
        

/*--- stmtsk functions -------------------------------------------------*/

/*************************************************
 * T[osO[v̕ύX
 * grp    : ύX̃Xg[O[vnh
 * ߂l : TRUE        
            FALSE       
 *************************************************/
STM_LOCAL Bool  stmtsk_setExecGrp(void *_grp)
{
    StmGrpHn    grp, oldgrp;
    StmHn       stm;
    Sint32      fltno;
    Sint32      fad;
    Sint32      lst_fad;
    Sint32      puid;
    Sint32      stat;
    Sint32      ret;
    StmHn       next;
    Bool        result = TRUE;

    grp = (StmGrpHn)_grp;
    if (MNG_CURGRP(stm_mng_ptr) != grp) {
        oldgrp = MNG_CURGRP(stm_mng_ptr);
        /* ǂݍݒ̃Xg[O[v~     */
        if (oldgrp != NULL) {
            stat = GFCF_GetStat(&fad, NULL);
            stm_setErr(stat);                   /* G[R[h̐ݒ   */
            /* hCu~       */
            if ((IS_PLAYING(oldgrp) == TRUE)&&
                (IS_PAUSING(oldgrp) == FALSE)) {
                ret = STL_StopIn(oldgrp);
                if (ret != STM_ERR_OK) {
                    STMERR_SetCode(ret);
                }
                STM_GRP_ATR(oldgrp) |= STMGRP_ATR_PAUSE;
            }
            /* sbNAbv   */
            if (STM_GRP_PUID(oldgrp) >= 0) {
                GFCD_UngetPickup(STM_GRP_PUID(oldgrp));
                STM_GRP_PUID(oldgrp) = -1;
                GFCD_SetCsctFunc(GFCD_NULLFUNC, NULL);
            }
            /* O[v̏ꍇ   */
            if (STM_GRP_ACSTAT(oldgrp) != STM_EXEC_COMPLETED) {
                STM_GRP_ACSTAT(oldgrp) = STM_EXEC_PAUSE;  /* |[Yݒ */
                /* COMPLETED̏ꍇXe[^X͕ωȂ        */
            }
            /* ~                 */
            if (stat == GFS_STAT_NOACT) {
                next = STM_GRP_NEXTTRNS(oldgrp);
                if (next != NULL) {
                    GFTR_Stop(STM_GFS(next), GFTR_ALLSCT);
                    GFS_TRN_STAT(&GFS_FILE_TRANS(STM_GFS(next))) =
                                                              GFTR_ST_NOACT;
                                      /* END ԂɂȂȂ悤ɂ   */
                }
                if (IS_PAUSING(oldgrp) == TRUE) {
                    lst_fad = STMMNG_GetLstFad(oldgrp);
                    /* ǂݍ݂ĂȂꍇFADXV        */
                    fad = STL_GetCurFad();
                    if (STM_GRP_FAD(oldgrp) <= lst_fad) {
                        STM_GRP_FAD(oldgrp) = fad;
                    }
                }
                STM_GRP_ATR(oldgrp) &= ~(STMGRP_ATR_PLAY|STMGRP_ATR_READ|
                                         STMGRP_ATR_SEEK|STMGRP_ATR_PAUSE);
                oldgrp = NULL;
            }
        }

        /* VO[vݒ肷                     */
        if (oldgrp == NULL) {
            if (grp != NULL) {
                if (STM_GRP_PUID(grp) < 0) {
                    puid = GFCD_GetPickup();
                    if (puid >= GFCD_ERR_OK) {
                        STM_GRP_PUID(grp) = puid;
                    }
                    GFCD_SetCsctFunc(stm_execCsct, grp);
                }
                if (STM_GRP_PUID(grp) >= 0) {
                    /* CDfoCX̐ڑύX     */
                    stm = STM_GRP_FLTLST(grp);
                    if (stm != NULL) {
                        fltno = GFS_CDR_FLT(STM_DTSRC(stm));
                    } else {
                        fltno = CDC_NUL_SEL;
                    }
                    GFCD_SetCon(fltno, STM_GRP_PUID(grp));
                    ret = GFCD_WaitServer();
                    if (ret != GFCD_ERR_OK) {
                        STM_SetGfcdErr(ret);
                    }
                    STM_GRP_ATR(grp) &= ~(STMGRP_ATR_PLAY|STMGRP_ATR_READ|
                                          STMGRP_ATR_SEEK);
                } else {
                    STMERR_SetCode(STM_ERR_PUINUSE);
                }
            }
            MNG_CURGRP(stm_mng_ptr) = grp;
            result = TRUE;
        } else {
            result = FALSE;
        }
    }
    return (result);
}



/*--- STM functions ----------------------------------------------------*/

/*************************************************
 * T[osO[v̎w(7.1)
 * grp  : Xg[O[vnh
 *************************************************/
Bool    STM_NwSetExecGrp(StmGrpHn grp)
{
    if (CMD_FUNC(&stm_cmd_area) != CMD_NULLFUNC) {
        return (FALSE);
    }
    STMERR_SetFunc(STM_SETEXECGRP);
    CMD_FUNC(&stm_cmd_area) = stmtsk_setExecGrp;
    CMD_OBJ(&stm_cmd_area) = grp;
    STMERR_CheckFatalErr();
    return (TRUE);
}


/*************************************************
 * T[osO[v̎w(7.2)
 * grp  : Xg[O[vnh
 *************************************************/
Bool    STM_SetExecGrp(StmGrpHn grp)
{
    Bool        complete;
    Sint32      stat;

    complete = STM_NwSetExecGrp(grp);
    if (complete == FALSE) {
        return (FALSE);
    }
    do {
        stat = STM_ExecServer();
    } while (stat != STM_EXEC_TSKEND);
    return (TRUE);
}



/*************************************************
 * Xg[f[^]̎擾(6.3)
 * stm  : Xg[nh
 * ߂l : TRUE        ]
 *        : FALSE       ]ĂȂ
 *************************************************/
STM_LOCAL Bool  stmsvr_isTrans(StmHn stm)
{
    Bool        trans;

    if (GFS_TRN_DPS(&(GFS_FILE_TRANS(STM_GFS(stm)))) != NULL) {
        trans = TRUE;
    } else {
        trans = FALSE;
    }
    return (trans);
}


Bool    STM_IsTrans(StmHn stm)
{
    Bool        trans;

    STMERR_SetFunc(STM_ISTRANS);
    if (stm == NULL) {
        STMERR_SetCode(STM_ERR_HNDL);
        STMERR_Exec();
        return (FALSE);
    }
    stm = STM_ALIAS(stm);
    trans = stmsvr_isTrans(stm);
    STMERR_CheckFatalErr();
    return (trans);
}



/*************************************************
 * ǂݍ݃tỎ
 * grp  : Xg[O[vnh
 *************************************************/
STM_LOCAL void  stm_setReadFalse(StmGrpHn grp)
{
    Sint32      fad;
    StmHn       stm;
    Sint32      sfad, efad;

    fad = STM_GRP_FAD(grp);
    for (stm = STM_GRP_SFADLST(grp); stm != NULL; stm = STM_SFADLST(stm)) {
        /* Xg[̏IFAD擾    */
        STL_GetPlayArea(STM_FLOW(stm), &sfad, &efad);
        if (sfad > fad) {       /* JnZN^݈ʒuȍ~̏ꍇ    */
            GFS_FILE_ASTAT(STM_GFS(stm)) = GFS_SVR_COMPLETED;
            STM_ATR(stm) &= ~STM_ATR_READ;
        }
    }
}


/*************************************************
 * ]̈̏
 * grp  : Xg[O[vnh
 *************************************************/
STM_LOCAL void  stm_resetTrbuf(StmGrpHn grp)
{
    StmHn       stm;

    for (stm = STM_GRP_SFADLST(grp); stm != NULL; stm = STM_SFADLST(stm)) {
        GFS_Seek(STM_GFS(stm), 0, GFS_SEEK_SET);
        STMTRN_ResetTrBuf(stm);
    }
}


/*************************************************
 * ]tÕZbg
 * grp  : Xg[O[v
 *************************************************/
STM_LOCAL void  stm_resetTrflag(StmGrpHn grp)
{
    StmHn       stm;

    for (stm = STM_GRP_SFADLST(grp); stm != NULL; stm = STM_SFADLST(stm)) {
        STM_ATR(stm) &= ~STM_ATR_TRSTART;
        STM_ATR(stm) &= ~STM_ATR_TREND;
        if (IS_STM_RESI(stm) == TRUE) {
            GFS_Seek(STM_GFS(stm), 0, GFS_SEEK_SET);
        }
    }
}



/*************************************************
 * [vJnXg[̎w(7.5)
 * grp  : Xg[O[vnh
 * stm  : [vJnXg[
 * loopmax : [v(̏ꍇSTM_LOOP_ENDLESS)
 *************************************************/
STM_LOCAL Bool  stmsvr_setLoop(StmGrpHn grp, StmHn stm, Sint32 loopmax)
{
    Bool        ret = TRUE;

    if (STM_GRP_ACSTAT(grp) == STM_EXEC_COMPLETED) {
        stm_resetTrbuf(grp);
        stm_resetTrflag(grp);
    }
    if (stm == STM_LOOP_DFL) {
        /* ǂݍ݂̏IĂȂ擪̃Xg[T[`   */
        for (stm = STM_GRP_SFADLST(grp); stm != NULL; stm = STM_SFADLST(stm)) {
            if ((IS_STM_READEND(stm) == FALSE)&&(IS_STM_RESI(stm) == FALSE)) {
                break;
            }
        }
        STM_GRP_LOOPSTM(grp) = stm;
        CLR_LOOPSPECIFY(grp);
    } else if ((stm == NULL)||(IS_STM_RESI(stm) == FALSE)) {
        if (stm != NULL) {
            stm = STM_ALIAS(stm);
        }
        STM_GRP_LOOPSTM(grp) = stm;
        SET_LOOPSPECIFY(grp);
    } else {
        ret = FALSE;
    }
    STM_GRP_LOOPMAX(grp) = loopmax;
    STM_GRP_LOOPCNT(grp) = 0;
    return (ret);
}


Bool    STM_SetLoop(StmGrpHn grp, StmHn stm, Sint32 loopmax)
{
    Bool        ret;

    STMERR_SetFunc(STM_SETLOOP);
    if (grp == NULL) {
        STMERR_SetCode(STM_ERR_HNDL);
        STMERR_Exec();
        return FALSE;
    }
    if (loopmax < 0) {
        STMERR_SetCode(STM_ERR_NUM);
        STMERR_Exec();
        return FALSE;
    }
    ret = stmsvr_setLoop(grp, stm, loopmax);
    STMERR_CheckFatalErr();
    return ret;
}


/*************************************************
 * ǂݍ݃tO̐ݒ
 * grp  : Xg[O[vnh
 *************************************************/
STM_LOCAL void  stm_setReadTrue(StmGrpHn grp)
{
    Sint32      fad;
    StmHn       stm;
    Sint32      sfad, efad;

    fad = STM_GRP_FAD(grp);
    for (stm = STM_GRP_SFADLST(grp); stm != NULL; stm = STM_SFADLST(stm)) {
        /* Xg[̊JnFAD擾    */
        STL_GetPlayArea(STM_FLOW(stm), &sfad, &efad);
        /* JnZN^݈ʒuȍ~,܂͏풓Xg[̏ꍇ    */
        if (((sfad >= fad)&&(IS_STM_READEND(stm) == FALSE))||
            (IS_STM_RESI(stm) == TRUE)) {
            STM_ATR(stm) |= STM_ATR_READ;
            GFS_FILE_ASTAT(STM_GFS(stm)) = GFS_SVR_BUSY;
        }
    }
}



/*************************************************
 * ǂݍݏItO̐ݒ
 * grp  : Xg[O[vnh
 *************************************************/
void    STMSVR_SetReadEnd(StmGrpHn grp)
{
    Sint32      fad;
    StmHn       stm;
    Sint32      sfad, efad;
    Sint32      nsct;
    Sint32      loopmax, loopcnt;

    fad = STM_GRP_FAD(grp);
    for (stm = STM_GRP_FLTLST(grp); stm != NULL; stm = STM_FLTLST(stm)) {
        /* Xg[̊JnFAD擾    */
        STL_GetPlayArea(STM_FLOW(stm), &sfad, &efad);
        /* IZN^݈ʒuȑOłłɓǂݍ܂Ăꍇ */
        if ((efad < fad)&&(IS_STM_READ(stm) == TRUE)&&
            (IS_STM_LOOPNOREAD(stm) == TRUE)) {
            STM_ATR(stm) |= STM_ATR_READEND;
            STMMNG_RemoveFlt(stm);
            if (STM_GRP_LOOPSTM(grp) == stm) {
                loopmax = STM_GRP_LOOPMAX(grp);
                loopcnt = STM_GRP_LOOPCNT(grp);
                stmsvr_setLoop(grp, STM_LOOP_DFL, loopmax);
                STM_GRP_LOOPCNT(grp) = loopcnt;
            }
            if (STM_GRP_LSTSTM(grp) == stm) {
                STMMNG_ResetLstStm(grp);
            }
        }
    }
}


/*************************************************
 * Đ͈͂̃`FbN
 * grp  : Xg[O[v
 * fad  : ݂̍ĐFAD
 * ߂l:   ړFAD
 *           ړsp
 *************************************************/
STM_LOCAL Sint32        stm_checkArea(StmGrpHn grp, Sint32 fad)
{
    StmHn       stm;
    Sint32      sfad, efad;

    if (fad < STM_GRP_FAD(grp)) {
        fad = STM_GRP_FAD(grp);
    }
    for (stm = STM_GRP_SFADLST(grp); stm != NULL; stm = STM_SFADLST(stm)) {
        if (IS_STM_READEND(stm) == FALSE) {
            STL_GetPlayArea(STM_FLOW(stm), &sfad, &efad);
            /* ĐʒuL͈͓̏ꍇ               */
            if ((sfad <= fad)&&(efad >= fad)) {
                break;
            }
            /* ̃Xg[̊JnʒuɈړ       */
            if (sfad > fad) {
                return (sfad);
            }
        }
    }
    return (-1);                        /* ړKvȂ             */
}

        

/*************************************************
 * [vXg[FAD̎擾
 * grp  : Xg[O[v
 *************************************************/
STM_LOCAL Sint32        stm_getLoopFad(StmGrpHn grp)
{
    Sint32      sfad, efad;

    /* [vXg[̊JnFAD擾  */
    STL_GetPlayArea(STM_FLOW(STM_GRP_LOOPSTM(grp)), &sfad, &efad);
    return (sfad);
}


/*************************************************
 * Đp[^̎擾
 * grp  : Xg[O[v
 * fad  : ݂FAD
 * efad : Xg[O[v̏IFAD
 * seekpos : sbNAbv̈ړ
 * start : ĐJn邩ǂ
 * ߂l : TRUE ǂݍݏI  FALSE ǂݍݒ
 *************************************************/
STM_LOCAL Bool  stm_getReadParam(StmGrpHn grp, Sint32 fad, Sint32 efad,
                                 Sint32 stat, Sint32 *seekpos, Bool *start)
{
    Sint32      ret = FALSE;
    Sint32      cdstat;

    if (STM_GRP_LOOPCNT(grp) == STM_GRP_LOOPMAX(grp)) {
        if (STM_GRP_FAD(grp) > efad) {
            /* SĂ̓ǂݍ݂IĂꍇ         */
            *seekpos = -1;
            *start = FALSE;
            ret = TRUE;
            return (ret);
        } else if (stat == GFS_STAT_NOACT) {
            /* Đ͈͂z,Xg[ǉꂽꍇ    */
            cdstat = GFCF_GetStat(NULL, NULL);
            stm_setErr(cdstat);                 /* G[R[h̐ݒ   */
            /* ĐIĂꍇ           */
            if (fad > MNG_EFAD(stm_mng_ptr)) {
                STM_GRP_FAD(grp) = STL_GetCurFad();
                STM_GRP_LOOPCNT(grp)--;
            }
        }
    } else {
        if (((STM_GRP_FAD(grp) > efad)&&(IS_PLAYING(grp) == FALSE))||
            (STM_GRP_FLTLST(grp) == NULL)) {
            if (STM_GRP_LOOPSTM(grp) == NULL) {
                /* SĂ̓ǂݍ݂IĂꍇ             */
                *seekpos = -1;
                *start = FALSE;
                ret = TRUE;
                return (ret);
            }
            STM_GRP_FAD(grp) = stm_getLoopFad(grp);
            stm_resetTrflag(grp);
        }
    }
    /* ǂݍ݂JnĂȂꍇ     */
    if (IS_PLAYING(grp) == FALSE) {
        if (STM_GRP_PUID(grp) >= 0) {
            /* sbNAbvgpłꍇ     */
            *seekpos = stm_checkArea(grp, STM_GRP_FAD(grp));
            if (*seekpos >= 0) {
                STM_GRP_FAD(grp) = *seekpos;
            }

            *start = TRUE;                      /* ǂݍ݂Jn   */
            STM_GRP_ACSTAT(grp) = STM_EXEC_DOING;
            *seekpos = -1;
        } else {
            /* t@CVXegpɌĂ΂ꂽꍇȂ */
            *seekpos = -1;
            *start = FALSE;                     /* ǂݍ݂JnȂ */
        }
    } else if (IS_READING(grp) == TRUE) {
        if (fad <= efad) {
            cdstat = GFCF_GetStat(NULL, NULL);
            stm_setErr(cdstat);                 /* G[R[h̐ݒ   */
            /* ĐIĂꍇ   */
            if ((stat == GFS_STAT_NOACT)&&(fad > MNG_EFAD(stm_mng_ptr))) {
                /* ĐJn           */
                STM_GRP_FAD(grp) = fad;
                /* ĐI,ǂݍݏI        */
                STM_GRP_ATR(grp) &= ~(STMGRP_ATR_PLAY|STMGRP_ATR_READ|
                                      STMGRP_ATR_SEEK);
                *seekpos = -1;
            } else {
                /* ǂݍݒ           */
                STM_GRP_FAD(grp) = fad;
                if (IS_SEEKING(grp) == FALSE) {
                    *seekpos = stm_checkArea(grp, fad);
                    if (*seekpos >= 0) {
                        STM_GRP_ATR(grp) |= STMGRP_ATR_SEEK;
                    }
                } else {
                    if (stat != GFS_STAT_SEEK) {
                        STM_GRP_ATR(grp) &= ~STMGRP_ATR_SEEK;
                    }
                    *seekpos = -1;
                }
            }
            *start = FALSE;                     /* ǂݍ݂JnȂ */
        } else if (stat == GFS_STAT_NOACT) {
            /* ǂݍݏI             */
            STM_GRP_FAD(grp) = fad;
            /* ĐI,ǂݍݏI    */
            STM_GRP_ATR(grp) &= ~(STMGRP_ATR_PLAY|STMGRP_ATR_READ|
                                  STMGRP_ATR_SEEK);
            STMSVR_SetReadEnd(grp);     /* ǂݍݍς݃tO̐ݒ     */
            /* 풓Xg[̓Ǎ݂I,stm_transŃJEg   */
            if (stmmng_isAllResi(grp) == FALSE) {
                STM_GRP_LOOPCNT(grp)++;
            }
            *start = FALSE;
            *seekpos = -1;
            if ((STM_GRP_LOOPSTM(grp) == NULL)||
                (STM_GRP_LOOPCNT(grp) >= STM_GRP_LOOPMAX(grp))){
                ret = TRUE;
            }
        } else {
            /* ǂݍݏĨrW[       */
            *seekpos = -1;
            *start = FALSE;
        }
    } else {    /* ĐJñrW[       */
        *seekpos = -1;
        *start = FALSE;
    }
    return (ret);
}



/*************************************************
 * ĐR}h̔s
 * grp  : Xg[O[v
 * seekpos : sbNAbv̈ړ
 * efad : Xg[O[v̍ŏIFAD
 * start : ĐJn邩ǂ
 *************************************************/
STM_LOCAL Sint32        stm_putPlayCmd(StmGrpHn grp, Sint32 seekpos,
                                       Sint32 efad, Bool start)
{
    Sint32      ret = STM_ERR_OK;

    if (seekpos >= 0) {                 /* ̃Xg[Ɉړ */
        ret = STL_MovePlaypos(grp, seekpos);
        STM_GRP_FAD(grp) = seekpos;             /* ݂FAD            */
    } else if (STM_GRP_FAD(grp) <= efad) {
        /* ܂ǂݍݏԂɂȂĂȂꍇ   */
        if ((start == TRUE)&&(IS_PLAYING(grp) == FALSE)) {
            stm_setReadTrue(grp);               /* ǂݍ݃tO̐ݒ */
            ret = STL_FlowIn(grp);              /* ǂݍ݊Jn         */
            if (ret == STM_ERR_OK) {
                STM_GRP_ATR(grp) |= STMGRP_ATR_PLAY;
            }
        }
    }
    return (ret);
}



/*************************************************
 * Xg[ǂݍ
 * grp  : ĐXg[O[v
 * fad  : ݂FAD
 * efad : Xg[O[v̍ŏIFAD
 * stat : CDubN̏
 * ߂l : TRUE ǂݍݏI    FALSE ǂݍݒ
 *************************************************/
STM_LOCAL Bool  stm_read(StmGrpHn grp, Sint32 fad, Sint32 efad, Sint32 stat)
{
    Sint32      seekpos;
    Bool        start;
    Bool        ret;
    Sint32      err;

    /* SĂ̓ǂݍ݂Iꍇ                     */
    if (stmmng_isAllResi(grp) == TRUE) {
        /* Sď풓Xg[̏ꍇA]̂ݎs   */
        if (((STM_GRP_ACSTAT(grp) == STM_EXEC_PAUSE)||
            ((STM_GRP_ATR(grp) & STMGRP_ATR_ALRSTREND) != 0))&&
            (STM_GRP_SFADLST(grp) != NULL)&&
            (STM_GRP_LOOPCNT(grp) < STM_GRP_LOOPMAX(grp))) {
            stm_setReadTrue(grp);
            stm_resetTrflag(grp);
            STM_GRP_FAD(grp) = STM_FAD_CDEND;
            STM_GRP_ACSTAT(grp) = STM_EXEC_DOING;
            STM_GRP_ATR(grp) &= ~STMGRP_ATR_ALRSTREND;
        }
        return (TRUE);
    }

    /* Đp[^̎擾                             */
    ret = stm_getReadParam(grp, fad, efad, stat, &seekpos, &start);

    /* ĐR}h̔s                               */
    err = stm_putPlayCmd(grp, seekpos, efad, start);
    if (err != STM_ERR_OK) {
        STMERR_SetCode(err);
    }
    return (ret);
}



/*************************************************
 * CDobt@ZN^̎擾(5.1)
 * stm  : Xg[nh
 * ߂l: CDobt@̃ZN^
 *************************************************/
Sint32  STMSVR_GetNumCdbuf(StmHn stm)
{
    Sint32      nsct;
    Sint32      ret;
    
    if (STM_IS_CDFILE(stm)) {
        ret = GFCD_GetLenData(GFS_CDR_BUFNO(STM_DTSRC(stm)), 0, 
                              STM_LONG_MAX, &nsct, NULL);
        if (ret != GFCD_ERR_OK) {
            STM_SetGfcdErr(ret);
            return 0;
        }
        ret = GFCD_WaitServer();
        if (ret != GFCD_ERR_OK) {
            STM_SetGfcdErr(ret);
            return 0;
        }
    } else {
        nsct = GFBF_GetNumData(STM_GFS(stm));
    }
    return (nsct);
}


Sint32  STM_GetNumCdbuf(StmHn stm)
{
    Sint32      nsct;
    Sint32      ret;
    
    STMERR_SetFunc(STM_GETNUMCDBUF);
    if (stm == NULL) {
        STMERR_SetCode(STM_ERR_HNDL);
        STMERR_Exec();
        return STM_ERR_HNDL;
    }
    stm = STM_ALIAS(stm);
    nsct = STMSVR_GetNumCdbuf(stm);
    ret = STMERR_CheckFatalErr();
    if (ret < 0) {
        return ret;
    }
    return nsct;
}


/*************************************************
 * Xg[Ԃ̎擾
 * stm  : Xg[nh
 * sfad : Xg[̊JnFAD
 * efad : Xg[̏IFAD
 * nsct : CDobt@̃ZN^
 * ߂l: STAT_NOREAD          ANZXȂ
 *         STAT_DOING           
 *         STAT_WAIT            ]҂(Q[g, ̈t)
 *         STAT_COMPLETED       ANZX
 *************************************************/
STM_LOCAL Sint32        stm_getStat(StmHn stm, Sint32 sfad, Sint32 efad, Sint32 nsct)
{
    Sint32      fad;
    Sint32      trfad;
    Sint32      hirq;
    Sint32      stat;

    fad = STM_GRP_FAD(STM_GRPHN(stm));
    if ((IS_STM_READEND(stm) == TRUE)&&(nsct == 0)) {
        /* ANZXXg[ */
        return (STAT_COMPLETED);
    }
    if ((fad <= efad)&&(STM_IS_CDFILE(stm))) {          /* ǂݍݒ   */
        if ((IS_STM_READ(stm) == TRUE)||
            (IS_STM_LOOPNOREAD(stm) == FALSE)) {
            stat = GFCF_GetStat(NULL, &hirq);
            stm_setErr(stat);                   /* G[R[h̐ݒ   */
            if ((hirq & CDC_HIRQ_BFUL) == 0) {
                /* CDobt@ɋ󂫗̈悠     */
                return (STAT_DOING);
            } else if (nsct == 0) {     /* CDobt@̃f[^͑Sđ */
                return (STAT_WAIT);     /* Xg[̃f[^           */
            }
        } else {
            return (STAT_NOREAD);
        }
    } else if ((IS_STM_READ(stm) == TRUE)&&(nsct == 0)) {
        /* ǂݍ݊,CDobt@Ƀf[^Ȃ      */
        return (STAT_COMPLETED);        /* ]                     */
    }
    if (STM_TRFAD(stm) == STM_FAD_CDEND) {
        trfad = STMMNG_GetLstFad(STM_GRPHN(stm));
    } else {
        trfad = STM_TRFAD(stm);
    }
    /* ]Q[gĂ,]FAD,obt@t  */
    if ((!GFS_TRN_ACTIVE(&(GFS_FILE_TRANS(STM_GFS(stm)))))||
        ((fad >= sfad)&&(fad < trfad))||
        (STMTRN_IsTrBufFull(stm) == TRUE)) {
        return (STAT_WAIT);
    }
    return (STAT_DOING);                        /* ]               */
}



/*************************************************
 * Xg[f[^̓]
 * stm  : Xg[nh
 * ߂l : TRUE  ]
 *          FALSE ]łȂ
 *************************************************/
STM_LOCAL Bool  stmsvr_execTrans(StmHn stm)
{
    GfsHn       gfs;
    Bool        trans;

    gfs = STM_GFS(stm);
    if (((STM_TRFUNC(stm) != STM_TR_NULLFUNC)||
        (GFS_TRN_BUF(&GFS_FILE_TRANS(gfs)) != NULL))&&
        (GFTR_GetLenRoom(&GFS_FILE_TRANS(gfs)) > 0)) {
        GFTR_Exec(gfs, &trans);
    } else {
        trans = FALSE;
    }
    return (trans);
}



/*************************************************
 * obt@TCYĎ֐̎s
 * grp  : Xg[O[vnh
 *************************************************/
STM_LOCAL void  stm_execCdbufFunc(StmGrpHn grp)
{

    if ((STM_GRP_CHKFUNC(grp) != STM_CDBUF_NULLFUNC)&&
        ((STM_GRP_ATR(grp) & STMGRP_ATR_CHKBUF) != 0)) {
        STM_GRP_CHKFUNC(grp)(STM_GRP_CHKOBJ(grp));
        STM_GRP_ATR(grp) &= ~STMGRP_ATR_CHKBUF;
    }
}
    

/*************************************************
 * f[^̓]
 * grp  : Xg[O[v
 * first : ŏɓ]Xg[
 * cdstat : CD̃Xe[^X
 * bflag  : ̃Xg[̓]sȂȂꍇ  TRUE
 * stat   : ɓ]Xg[̃Xe[^X
 * ߂l : SXg[̓]ꍇ TRUE
 *************************************************/
STM_LOCAL Bool  stm_trans_sub(StmGrpHn grp, StmHn first, Uint8 cdstat, 
                                                Bool *bflag, Sint32 *stat)
{
    Sint32      i;
    StmHn       stm, _stm;
    Sint32      nsct;
    Sint32      sfad, efad;
    Sint32      trfad;
    Bool        req;
    Bool        complete = TRUE;
    Bool        set = FALSE;
    Uint8       atr;

    *bflag = FALSE;
    stm = STM_GRP_NEXTTRNS(grp);                /* ]Xg[       */
    if (STM_IS_CDFILE(stm)) {
        STL_GetPlayArea(STM_FLOW(stm), &sfad, &efad);
    } else {
        sfad = efad = STM_FAD_CDTOP;
    }
    atr = STM_ATR(stm);
    if (STM_TRFAD(stm) == STM_FAD_CDEND) {
        trfad = STMMNG_GetLstFad(grp);
    } else {
        trfad = STM_TRFAD(stm);
    }
    if (((atr & STM_ATR_TRSTART) == 0)&&(STM_GRP_FAD(grp) > sfad)&&
        (STM_GRP_FAD(grp) >= trfad)) {
        STM_ATR(stm) |= STM_ATR_TRSTART;
    }
    if (((atr & STM_ATR_TREND) == 0)&&(STM_GRP_FAD(grp) > efad)&&
        (STM_GRP_FAD(grp) >= trfad)) {
        STM_ATR(stm) |= STM_ATR_TREND;
    }
    if (((atr & STM_ATR_TREND) == 0)&&((STM_ATR(stm) & STM_ATR_TREND) != 0)) {
        /* Đ͈͂zCDobt@ɂ镪]   */
        nsct = GFBF_GetNumData(STM_GFS(stm));
        GFTR_SetTransPara(&(GFS_FILE_TRANS(STM_GFS(stm))), nsct);
    } else if (((atr & STM_ATR_TRSTART) == 0)&&
               ((STM_ATR(stm) & STM_ATR_TRSTART) != 0)) {
        /* Đ͈͂ɂȂ炷ׂẴf[^]           */
        GFTR_SetTransPara(&(GFS_FILE_TRANS(STM_GFS(stm))), STM_LONG_MAX);
    }
    stmsvr_execTrans(stm);                      /* ]s             */
    if (stmsvr_isTrans(stm) == TRUE) {
        /* ]̏ꍇ         */
        *bflag = TRUE;
        *stat = stm_getStat(stm, sfad, efad, 1);
                                                /* ]̓f[^ */
        return (FALSE);
    }
    /* ̓]Xg[̐ݒ         */
    _stm = stm;
    for (i = 0; (i < 2)&&(set != TRUE); i++) {
        for (stm = STM_SFADLST(stm); ; stm = STM_SFADLST(stm)) {
            /* ŌȂ擪ɖ߂       */
            if (stm == NULL) {
                stm = STM_GRP_SFADLST(grp);
            }
            if (stm == first) {
                *bflag = TRUE;
            }
            nsct = GFBF_GetNumData(STM_GFS(stm));
            if (STM_IS_CDFILE(stm)) {
                STL_GetPlayArea(STM_FLOW(stm), &sfad, &efad);
            } else {
                sfad = efad = STM_FAD_CDTOP;
            }
            *stat = stm_getStat(stm, sfad, efad, nsct);
            /* 1ڂ̓ANZX̃Xg[T      */
            /* 2ڂ͓]҂̃Xg[T        */
            if (((nsct > 0)||(cdstat == GFS_STAT_SEEK)||
                 (cdstat == GFS_STAT_READ))&&
                (((i == 0)&&(*stat == STAT_DOING))||
                 ((i == 1)&&(*stat == STAT_WAIT)))) {
                complete = FALSE;
                set = TRUE;
                break;
            }
            if ((*stat == STAT_DOING)||(*stat == STAT_WAIT)) {
                complete = FALSE;
            }
            if (stm == _stm) {
                break;
            }
        }
    }
    STM_GRP_NEXTTRNS(grp) = stm;
    if ((set == FALSE)&&(complete == FALSE)) {
        *stat = STAT_DOING;
    }
    return (complete);
}


/*************************************************
 * ANZX|C^̏
 * grp  : Xg[O[vnh
 *************************************************/
STM_LOCAL void  stm_resetAcp(StmGrpHn grp)
{
    StmHn       stm;

    for (stm = STM_GRP_SFADLST(grp); stm != NULL; stm = STM_SFADLST(stm)) {
        GFS_Seek(STM_GFS(stm), 0, GFS_SEEK_SET);
    }
}


/*************************************************
 * f[^̓]
 * grp  : Xg[O[v
 * cdstat : CD̃Xe[^X
 * ߂l : TRUE ]I  FALSE ]
 *************************************************/
STM_LOCAL Bool  stm_trans(StmGrpHn grp, Uint8 cdstat)
{
    StmHn       stm, first;
    Sint32      stat;
    Bool        bflag;
    Bool        ret;

    /* ]Xg[ݒ̏ꍇ             */
    if (STM_GRP_NEXTTRNS(grp) == NULL) {
        STM_GRP_NEXTTRNS(grp) = STM_GRP_SFADLST(grp);
    }
    first = STM_GRP_NEXTTRNS(grp);

    /* eXg[PxÂs݂       */
    /* ]܂͂P܂炨         */
    do {
        stm = STM_GRP_NEXTTRNS(grp);
        ret = stm_trans_sub(grp, first, cdstat, &bflag, &stat);
    } while(bflag == FALSE);

    /* WAIT <-> DOING̈ڍs     */
    if ((stat == STM_EXEC_WAIT)||(STM_GRP_ACSTAT(grp) == STM_EXEC_WAIT)) {
        STM_GRP_ACSTAT(grp) = stat;
    } else if (stmmng_isAllResi(grp) == TRUE) {
        /* 풓݂̂̏ꍇSĂ̓]I烋[vƂɂ     */
        if (STM_GRP_LOOPCNT(grp) < STM_GRP_LOOPMAX(grp)) {
            if (stat == STM_EXEC_COMPLETED) {
                STM_GRP_LOOPCNT(grp)++;
                STM_GRP_ATR(grp) |= STMGRP_ATR_ALRSTREND;
            }
            ret = FALSE;
        } else {
            STM_GRP_FAD(grp) = STM_FAD_CDTOP;
            STM_GRP_ATR(grp) |= STMGRP_ATR_ALRSTREND;
            ret = TRUE;
        }
    }
    return (ret);
}

    

/*************************************************
 * T[o̎s(7.3)
 * ߂l: STM_EXEC_COMPLETED   ANZXI
 *         STM_EXEC_PAUSE       ꎞ~
 *         STM_EXEC_DOING       ANZX
 *         STM_EXEC_WAIT        ]҂
 *************************************************/
Sint32  STM_ExecServer(void)
{
    StmGrpHn    grp;
    Sint32      fad, efad;
    Sint32      ret;
    Bool        read, trans;
    Bool        complete;
    Sint32      hirq;
    Sint32      stat;

    /* ̃^XNꍇ */
    if (CMD_FUNC(&stm_cmd_area) != CMD_NULLFUNC) {
        complete = CMD_FUNC(&stm_cmd_area)(CMD_OBJ(&stm_cmd_area));
        if (complete == TRUE) {
            CMD_FUNC(&stm_cmd_area) = CMD_NULLFUNC;
            return (STM_EXEC_TSKEND);
        }
        return (STM_ERR_WHERE(&MNG_ERR(stm_mng_ptr)));
    }

    /* Xg[ANZX       */
    STMERR_SetFunc(STM_EXECSERVER);
    grp = MNG_CURGRP(stm_mng_ptr);
    /* ̃Xg[ꍇ     */
    if ((grp != NULL)&&(STM_GRP_SFADLST(grp) != NULL)) {
        if (MNG_SVREXEC(stm_mng_ptr) == FALSE) {
            MNG_SVREXEC(stm_mng_ptr) = TRUE;
            /* SCU-DMAgp̏ꍇɂ͓]I`FbNȂ        */
            if (gfs_use_scudma == TRUE) {
                GFTR_ExecSvr(STM_GFS(STM_GRP_NEXTTRNS(grp)), &trans);
                /* A-BusANZXs̂߈ȍ~̏͂ȂȂ      */
                if (gfs_use_scudma == TRUE) {
                    MNG_SVREXEC(stm_mng_ptr) = FALSE;
                    stat = STMERR_CheckFatalErr();
                    if (stat < 0) {
                        return stat;
                    }
                    return STM_GRP_ACSTAT(grp);
                }
            }
            /* Xg[ANZX   */
            stm_execCdbufFunc(grp);     /* obt@TCYĎ֐̎s */
            stat = GFCF_GetStat(&fad, NULL);    /* ݂FAD擾        */
            stm_setErr(stat);                   /* G[R[h̐ݒ   */
            if (IS_SET_ERRCODE(stm_mng_ptr) == TRUE) {
                STMERR_Exec();
            } else {
                efad = STMMNG_GetLstFad(grp);   /* ŏIFAD̎擾        */
                read = stm_read(grp, fad, efad, stat);
                                                /* Xg[̓ǂݍ */
                trans = stm_trans(grp, stat);   /* Xg[̓]     */
                if ((read == TRUE)&&(trans == TRUE)) {
                    STM_GRP_ACSTAT(grp) = STM_EXEC_COMPLETED;
                    stm_resetAcp(grp);
                }
            }
            MNG_SVREXEC(stm_mng_ptr) = FALSE;
        }
        stat = STMERR_CheckFatalErr();
        if (stat < 0) {
            ret = stat;
        } else {
            ret = STM_GRP_ACSTAT(grp);
        }
    } else {                            /* ̃Xg[Ȃꍇ */
        ret = STM_EXEC_PAUSE;
    }
    return ret;
}



/*************************************************
 * sbNAbv̈ړ(7.4)
 * stm  : Xg[nh
 * off  : Xg[擪̃ItZbg
 *************************************************/
void    STM_MovePickup(StmHn stm, Sint32 off)
{
    StmGrpHn    grp;
    Sint32      sfad, efad;
    Sint32      ret;
    Sint32      stat;

    STMERR_SetFunc(STM_MOVEPICKUP);
    if (stm == NULL) {
        STMERR_SetCode(STM_ERR_HNDL);
        STMERR_Exec();
        return ;
    }
    stm = STM_ALIAS(stm);
    grp = STM_GRPHN(stm);
    if (MNG_CURGRP(stm_mng_ptr) == grp) {       /* O[v̏ꍇ */
        if (IS_PLAYING(grp) == TRUE) {
            ret = STL_StopIn(STM_GRPHN(stm));   /* ǂݍݒ~         */
            if (ret != STM_ERR_OK) {
                STMERR_SetCode(ret);
            }
            STM_GRP_ACSTAT(grp) = STM_EXEC_PAUSE; /* T[oɂĈړ */
        }
        stat = GFCF_GetStat(&sfad, NULL);       /* ݂FAD擾      */
        stm_setErr(stat);                       /* G[R[h̐ݒ   */
        if (IS_SET_ERRCODE(stm_mng_ptr) == TRUE) {
            STMERR_Exec();
            return;
        }
        if (sfad >= 0) {
            STM_GRP_FAD(grp) = sfad;            /* ݈ʒuݒ       */
        }
        /* ĐI,ǂݍݏI        */
        STM_GRP_ATR(grp) &= ~(STMGRP_ATR_PLAY|STMGRP_ATR_READ|STMGRP_ATR_SEEK);
    }
    STMSVR_SetReadEnd(grp);     /* ǂݍݍς݃tO̐ݒ             */
    stm_setReadFalse(grp);      /* ǂݍ݈ʒuȍ~̃tOFALSEɐݒ  */

    /* ړFAD擾  */
    STL_GetPlayArea(STM_FLOW(stm), &sfad, &efad);

    STM_GRP_FAD(grp) = sfad + off;
    STMERR_CheckFatalErr();
}


/*************************************************
 * [hG[̃Jo(9.3)
 * ߂l : STM_ERR_CDRD  Jos
 *          STM_ERR_OK    Jo
 *************************************************/
Sint32  STM_Recover(void)
{
    Sint32      ret;
    Sint32      ec;

    ret = STL_Recover(MNG_CURGRP(stm_mng_ptr));
    ec = STMERR_CheckFatalErr();
    if (ec < 0) {
        ret = ec;
    }
    return ret;
}


/*************************************************
 * ANZXĨ`FbN(7.8)
 * stm  : Xg[nh
 * ߂l : TRUE  Xg[ANZXI
 *          FALSE Xg[ANZXIĂȂ
 *************************************************/
Bool    STM_IsComplete(StmHn stm)
{
    Sint32      nsct;
    Sint32      stat;
    Sint32      sfad, efad;
    Uint16      hirq;

    STMERR_SetFunc(STM_ISCOMPLETE);
    if (stm == NULL) {
        STMERR_SetCode(STM_ERR_HNDL);
        STMERR_Exec();
        return (FALSE);
    }
    stm = STM_ALIAS(stm);
    nsct = STMSVR_GetNumCdbuf(stm);             /* obt@ZN^     */
    STL_GetPlayArea(STM_FLOW(stm), &sfad, &efad);
    stat = stm_getStat(stm, sfad, efad, nsct);  /* Xg[Xe[^X */
    STMERR_CheckFatalErr();
    if (stat == STAT_COMPLETED) {               /* ANZX̏ꍇ   */
        return (TRUE);
    }
    if ((stat == STAT_WAIT)&&
        (!GFS_TRN_ACTIVE(&(GFS_FILE_TRANS(STM_GFS(stm)))))) {
                                              /* EGCgԁAQ[g */
        return (TRUE);
    }
    return (FALSE);
}


/*************************************************
 * Xg[f[^̓](7.9)
 * stm  : Xg[nh
 * ߂l : TRUE  ]
 *          FALSE ]łȂ
 *************************************************/
Bool    STM_ExecTrans(StmHn stm)
{
    GfsHn       gfs;
    Sint32      tsct;
    GftrHn      gftr;
    Bool        trans;

    STMERR_SetFunc(STM_EXECTRANS);
    if (stm == NULL) {
        STMERR_SetCode(STM_ERR_HNDL);
        STMERR_Exec();
        return (FALSE);
    }
    if (MNG_SVREXEC(stm_mng_ptr) == FALSE) {
        MNG_SVREXEC(stm_mng_ptr) = TRUE;
        stm = STM_ALIAS(stm);
        /* SCU-DMAgp̏ꍇɂ͓]I`FbNȂ    */
        if (gfs_use_scudma == TRUE) {
            GFTR_ExecSvr(STM_GFS(stm), &trans);
            /* A-BusANZXs̂߈ȍ~̏͂ȂȂ  */
            if (gfs_use_scudma == TRUE) {
                MNG_SVREXEC(stm_mng_ptr) = FALSE;
                return (trans);
            }
        }
        gftr = &(GFS_FILE_TRANS(STM_GFS(stm)));
        tsct = GFTR_GetTransPara(gftr);
        GFTR_SetTransPara(gftr, STM_LONG_MAX);
        trans = stmsvr_execTrans(stm);
        GFTR_SetTransPara(gftr, tsct);
        MNG_SVREXEC(stm_mng_ptr) = FALSE;
    } else {
        trans = FALSE;
    }
    STMERR_CheckFatalErr();
    return (trans);
}



/* end of stm_svr.c     */
