/****************************************************************************/
/*  filename "smpdma0.c"                                                     */
/*  cl`TvvO                                                */
/*  Copyright(c) 1994 SEGA                                                  */
/*  Written by N.T on 1994-05-14 Ver.0.90                                   */
/*  Updated by N.T on 1994-05-14 Ver.0.90                                   */
/****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "sega_xpt.h"
#include "sega_csh.h"
#include "sega_dma.h"

static Sint8 *pbuf;                         /*  ʊi[obt@|C^    */

void SDMA_CpuAllStart(void);
void SDMA_CpuCst(Uint32 , Uint32 ,void *, void *, Uint32);
Uint32 SDMA_CpuResult(Uint32);
Uint32 hikaku(void *, void *, Uint32, Uint32, Sint8 *); /*  ʊmF֐    */
void rev(void *, void *, Uint32, Uint32);   /*  ]f[^j֐        */

void main(void)
{
    void *src, *dst;
    Uint32 cnt;
#if	0
	/*
	**1995-07-28	q
	**	gĂȂ̂ō폜
	*/
    Uint32 status;
    Uint32 *work;
#endif

    pbuf = (Sint8 *)0x06040000;             /*  ʊi[擪AhX        */

/*  BOOT to WORK    */
    DMA_CpuAllStop();                       /* S`lDMA~             */

    src = (void *)0x0000000;   /*  BOOT address    */
    dst = (void *)0x6050000;   /*  WORK address    */
    cnt = 0x200;

    SDMA_CpuCst(DMA_CPU_CH0 ,DMA_CPU_1 ,dst ,src ,cnt);
    src = (void *)0x0000200;   /*  BOOT address    */
    dst = (void *)0x6050200;   /*  WORK address    */
    cnt = 0x200;
    SDMA_CpuCst(DMA_CPU_CH1 ,DMA_CPU_1 ,dst ,src ,cnt);

    SDMA_CpuAllStart();                     /* S`lDMAJn              */
    while((SDMA_CpuResult(DMA_CPU_CH0) != DMA_CPU_END) ||
    	  (SDMA_CpuResult(DMA_CPU_CH1) != DMA_CPU_END));
    CSH_Purge((void *)0x6050000, 0x400);

    hikaku((void *)0x00000, (void *)0x6050000, 0x400, 1, "BOOT to WORK");

    for(;;);
}
/****************************************************************************/
/*  S`lDMAJn                                                       */
/****************************************************************************/
void SDMA_CpuAllStart(void)
{
    DmaCpuComPrm com_prm;                       /* ʓ]p[^        */
    com_prm.dme = DMA_CPU_ENA;                  /* DMAϽȰِݒ()    */
    com_prm.msk = DMA_CPU_M_DME;                /* }XNݒ(ײèӰ)  */
    DMA_CpuSetComPrm(&com_prm);                 /* DMAʓ]p[^ݒ */
}
/****************************************************************************/
/*  Xe[^X擾(`lw)                                            */
/****************************************************************************/
Uint32 SDMA_CpuResult(Uint32 ch)
{
    DmaCpuComStatus com_status;             /* ʃXe[^X                */
    DmaCpuStatus status;                    /* Xe[^X                    */
                                            /*********************************/
    DMA_CpuGetComStatus(&com_status);       /* ʃXe[^X擾            */
    if(com_status.ae == DMA_CPU_ADR_ERR){   /* ڽװꍇ        */
        return(DMA_CPU_FAIL);               /* ُI^[            */
    }
    status = DMA_CpuGetStatus(ch);          /* Xe[^X擾                */
    if(status == DMA_CPU_TE_MV){            /* 쒆łꍇ              */
        return(DMA_CPU_BUSY);               /* s^[              */
    }
    return(DMA_CPU_END);                    /* I^[            */
}
/****************************************************************************/
/*  `lAoCgw]֐                                          */
/*    ijDMA}X^Cl[u͕ێ                                       */
/****************************************************************************/
void SDMA_CpuCst(Uint32 ch, Uint32 byte ,void *dst, void *src, Uint32 cnt)
{
    DmaCpuComPrm com_prm;                       /* ʓ]p[^        */
    DmaCpuPrm prm;                              /* ]p[^            */
                                                /*****************************/
    DMA_CpuStop(ch);                            /* DMA]~               */
    com_prm.pr = DMA_CPU_FIX;                   /* D揇ʐݒ(׳)   */
    com_prm.msk = DMA_CPU_M_PR |                /* }XNݒ(ײèӰ)  */
                  DMA_CPU_M_AE |                /* (AhXG[tO)    */
                  DMA_CPU_M_NMIF;               /* (NMItO)               */

    DMA_CpuSetComPrm(&com_prm);                 /* DMAʓ]p[^ݒ */

    prm.sar = (Uint32)src;                      /* \[XAhXݒ        */
    prm.dar = (Uint32)dst;                      /* ިèȰݱڽݒ      */
    prm.tcr = cnt;                              /* gXt@JEgݒ  */
    prm.dm = DMA_CPU_AM_ADD;                    /* ިèȰݱڽӰސݒ  */
    prm.sm = DMA_CPU_AM_ADD;                    /* ڽӰސݒ          */
    switch(byte){
        case DMA_CPU_1:
            prm.ts = DMA_CPU_1;                 /* ݽ̧ސݒ            */
            break;
        case DMA_CPU_2:
            prm.ts = DMA_CPU_2;                 /* ݽ̧ސݒ            */
            break;
        case DMA_CPU_4:
            prm.ts = DMA_CPU_4;                 /* ݽ̧ސݒ            */
            break;
        case DMA_CPU_16:
            prm.ts = DMA_CPU_16;                /* ݽ̧ސݒ            */
            break;
    }
    prm.ar = DMA_CPU_AUTO;                      /* ظӰސݒ          */
    prm.ie = DMA_CPU_INT_DIS;                   /* ĲȰِݒ         */
    
    prm.msk = DMA_CPU_M_SAR |                   /* }XNݒ                */
              DMA_CPU_M_DAR |
              DMA_CPU_M_TCR |
              DMA_CPU_M_DM  |
              DMA_CPU_M_SM  |
              DMA_CPU_M_TS  |
              DMA_CPU_M_AR  |
              DMA_CPU_M_IE  |
              DMA_CPU_M_TE;                     /* ݽ̧ޯẴNAw*/

    DMA_CpuSetPrm(&prm, ch);                    /* DMA]p[^ݒ     */
    
    DMA_CpuStart(ch);                           /* DMA]Jn               */
}
/****************************************************************************/
/*  ʔr֐                                                            */
/****************************************************************************/
Uint32 hikaku(void *src, void *dst, Uint32 cnt, Uint32 size, Sint8 *msg)
{
#if	0
	/*
	**1995-07-28	q
	**	gĂȂ̂ō폜
	*/
    Uint32 i, p;
#else
	Uint32	i;
#endif
    
#if	0
	/*
	**1995-07-28	q
	**	long ȃIuWFNg %X ł͂Ȃ %lX
	**	|C^̂܂ܐƂĕ\悤ƂĂ̂
	**	( Uint32 ) ɃLXg
	*/
    sprintf(pbuf, "[[ \'%s\' %08X >> %08X : %08X Count, %01X Byte ",
     msg, src, dst, cnt, size);
#else
    sprintf(pbuf, "[[ \'%s\' %08lX >> %08lX : %08lX Count, %01lX Byte ",
     msg, ( Uint32 )src, ( Uint32 )dst, cnt, size);
#endif
    pbuf += strlen(pbuf);
    for(i = 0; i < cnt; i++) {
        switch(size) {
            case 1:
                if(*(Uint8 *)dst != *(Uint8 *)src) {
#if	0
	/*
	**1995-07-28	q
	**	long ȃIuWFNg %X ł͂Ȃ %lX
	**	|C^̂܂ܐƂĕ\悤ƂĂ̂
	**	( Uint32 ) ɃLXg
	*/
                    sprintf(pbuf, "Error %08X(%02X,%02X) ]] \n",
                     dst, *(Uint8 *)src, *(Uint8 *)dst);
#else
                    sprintf(pbuf, "Error %08lX(%02X,%02X) ]] \n",
                     ( Uint32 )dst, *(Uint8 *)src, *(Uint8 *)dst);
#endif
                    pbuf += strlen(pbuf);
                    return 1;
                }
		*(Uint32 *)0x6040200 = cnt;
                break;
            case 2:
                if(*(Uint16 *)dst != *(Uint16 *)src) {
#if	0
	/*
	**1995-07-28	q
	**	long ȃIuWFNg %X ł͂Ȃ %lX
	**	|C^̂܂ܐƂĕ\悤ƂĂ̂
	**	( Uint32 ) ɃLXg
	*/
                    sprintf(pbuf, "Error %08X(%04X,%04X) ]] \n",
                     dst, *(Uint16 *)src, *(Uint16 *)dst);
#else
                    sprintf(pbuf, "Error %08lX(%04X,%04X) ]] \n",
                     ( Uint32 )dst, *(Uint16 *)src, *(Uint16 *)dst);
#endif
                    pbuf += strlen(pbuf);
                    return 1;
                }
                break;
            case 4:
                if(*(Uint32 *)dst != *(Uint32 *)src) {
#if	0
	/*
	**1995-07-28	q
	**	long ȃIuWFNg %X ł͂Ȃ %lX
	**	|C^̂܂ܐƂĕ\悤ƂĂ̂
	**	( Uint32 ) ɃLXg
	*/
                    sprintf(pbuf, "Error %08X(%08X,%08X) ]] \n",
                     dst, *(Uint32 *)src, *(Uint32 *)dst);
#else
                    sprintf(pbuf, "Error %08lX(%08lX,%08lX) ]] \n",
                     ( Uint32 )dst, *(Uint32 *)src, *(Uint32 *)dst);
#endif
                    pbuf += strlen(pbuf);
                    return 1;
                }
                break;
            case 16:
                if((*(Uint32 *)dst != *(Uint32 *)src)
                 || (*((Uint32 *)dst + 1) != *((Uint32 *)src + 1))
                 || (*((Uint32 *)dst + 2) != *((Uint32 *)src + 2))
                 || (*((Uint32 *)dst + 3) != *((Uint32 *)src + 3))) {
#if	0
	/*
	**1995-07-28	q
	**	long ȃIuWFNg %X ł͂Ȃ %lX
	**	|C^̂܂ܐƂĕ\悤ƂĂ̂
	**	( Uint32 ) ɃLXg
	*/
                    sprintf(pbuf,
                     "Error %08X(%08X%08X%08X%08X,%08X%08X%08X%08X) ]] \n",
                      dst, *(Uint32 *)src, *(Uint32 *)((Uint32)src + 4),
                      *(Uint32 *)((Uint32)src + 8),
                      *(Uint32 *)((Uint32)src + 12),
                      *(Uint32 *)dst, *(Uint32 *)((Uint32)dst + 4),
                      *(Uint32 *)((Uint32)dst + 8),
                      *(Uint32 *)((Uint32)dst + 12));
#else
                    sprintf(pbuf,
                     "Error %08lX(%08lX%08lX%08lX%08lX,%08lX%08lX%08lX%08lX) ]] \n",
                      ( Uint32 )dst, *(Uint32 *)src, *(Uint32 *)((Uint32)src + 4),
                      *(Uint32 *)((Uint32)src + 8),
                      *(Uint32 *)((Uint32)src + 12),
                      *(Uint32 *)dst, *(Uint32 *)((Uint32)dst + 4),
                      *(Uint32 *)((Uint32)dst + 8),
                      *(Uint32 *)((Uint32)dst + 12));
#endif
                    pbuf += strlen(pbuf);
                    return 1;
                }
                i += 3;
                break;
            default:
                break;
        }
        dst = (void *)((Uint32)dst + size);
        src = (void *)((Uint32)src + size);
    }
    sprintf(pbuf, "OK ]] \n");
    pbuf += strlen(pbuf);
    return 0;
}

/****************************************************************************/
/*  ]ej֐                                                      */
/****************************************************************************/
void rev(void *src, void *dst, Uint32 cnt, Uint32 size)
{
    Uint32 i;
    
    for(i = 0; i < cnt; i++) {
        switch(size) {
            case 1:
                *(Uint8 *)dst = ~*(Uint8 *)src;
                break;
            case 2:
                *(Uint16 *)dst = ~*(Uint16 *)src;
                break;
            case 4:
                *(Uint32 *)dst = ~*(Uint32 *)src;
                break;
            case 16:
                *(Uint32 *)dst = ~*(Uint32 *)src;
                *((Uint32 *)dst + 1) = ~*((Uint32 *)src + 1);
                *((Uint32 *)dst + 2) = ~*((Uint32 *)src + 2);
                *((Uint32 *)dst + 3) = ~*((Uint32 *)src + 3);
                i += 3;
                break;
            default:
                break;
        }
        src = (void *)((Uint32)src + size);
        dst = (void *)((Uint32)dst + size);
    }
}

/****************************************************************************/
/*  End of File                                                             */
/****************************************************************************/
