/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:sample program of MEMORY PLAY MODE, MULTI PLAY, LOOP PLAY
 * File		:smppcm13.c
 * Date		:1995-03-31
 * Version	:1.16
 * Auther	:Y.T
 *
 * Comment	:
 *	ɂt@CĐTvB
 *	t@C 0x4000000, 0x4800000 ԒnɃ[hĂƁB
 *	Đłt@CTCY8la܂ŁB
 *
 ****************************************************************************/

/*------------------------- svOIt -------------------------*/

/* VTV, MON gpfobO̎ɒ`B */
/* #define SMPPCM_DEBUG */

/* [vĐs */
#define LOOP_PLAY		(0x7fffffff)

/*------------------------- sCN[ht -------------------------*/
#include <machine.h>
#define _SH
#include "sega_xpt.h"
#include "sega_sys.h"
#include "sega_int.h"
#include "sega_per.h"
#include "sega_cdc.h"
#include "sega_gfs.h"
#include "sega_stm.h"
#include "sega_snd.h"
#include "sega_pcm.h"


#ifdef SMPPCM_DEBUG
	#include "..\smppcmd\smppcmd.c"
	#define SMPPCMD_VblIn				smppcmd_VblIn
	#define SMPPCMD_Init				smppcmd_Init
	#define SMPPCMD_MON_Reset			smppcmd_MON_Reset
	#define SMPPCMD_PCM_Task			smppcmd_PCM_Task
#else
	#define SMPPCMD_VblIn()				
	#define SMPPCMD_Init(a)				
	#define SMPPCMD_MON_Reset()			
	#define SMPPCMD_PCM_Task			PCM_Task
	#define VTV_Printf(a)				
	#define VTV_PRINTF(a)				
	#define _VTV_Printf(a)				
	#define _VTV_PRINTF(a)				
#endif


/*--------------------------- s֐錾t ---------------------------*/

static void smpVblIn(void);
static void smpVblOut(void);


/*---------------------------- s萔t ----------------------------*/

/* EF[uq`l̓]AhXƃTv */
#define	PCM_ADDR_1	((void*)0x25a20000)
#define	PCM_ADDR_2	((void*)0x25a40000)
#define	PCM_SIZE	(4096L*2)				/* 2.. */

/* Oobt@̃TCY */
#define	RING_BUF_SIZE	(1024L*1024L*8)

/* Oobt@ */
#define	MOVIE_BUF_1		((Sint8 *)0x04000000)
#define	MOVIE_BUF_2		((Sint8 *)0x04800000)


/*----------------------- sO[oϐt -----------------------*/

/* [N */
static PcmWork g_movie_work_1;
static PcmWork g_movie_work_2;


/*---------------------------- s֐t ----------------------------*/

void errGfsFunc(void *obj, Sint32 ec)
{
	VTV_PRINTF((VTV_s, "S:ErrGfs %X %X\n", obj, ec));
}

void errPcmFunc(void *obj, Sint32 ec)
{
	VTV_PRINTF((VTV_s, "S:ErrPcm %X %X\n", obj, ec));
}


/*====================== uuN̏ ===========================*/

static void vblInit(void)
{
    set_imask(0);

	/* uuN̐ݒ */
	INT_ChgMsk(INT_MSK_NULL,INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT);
	INT_SetScuFunc(INT_SCU_VBLK_IN, smpVblIn);
	INT_SetScuFunc(INT_SCU_VBLK_OUT, smpVblOut);
	INT_ChgMsk(INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT,INT_MSK_NULL);
}

static void smpVblIn(void)
{
	/* oblCu VblIn [`R[ */
	PCM_VblIn();

	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	/*	SCL_VblankStart(); */
}

static void smpVblOut(void)
{
	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	/*	SCL_VblankEnd(); */
}


/*====================== TEh̏ ===========================*/
#define SDDRVS_TSK_SIZE			(0x6000)
#define BOOTSND_MAP_SIZE		(0x0100)
Sint32 sddrvs_tsk[SDDRVS_TSK_SIZE / 4];
Sint32 bootsnd_map[BOOTSND_MAP_SIZE / 4];

static Sint32 fileLoad(Sint8 *name, void *addr, Sint32 bsize)
{
	Sint32 		fid, i;

	for (i = 0; i < 10; i++) {
		fid = GFS_NameToId(name);
		if (fid >= 0) {
			GFS_Load(fid, 0, addr, bsize);
			return 0;
		}
	}
	return -1;
}

static void sndInit(void)
{
	SndIniDt 	snd_init;

	if (fileLoad("SDDRVS.TSK", (void *)sddrvs_tsk, SDDRVS_TSK_SIZE)) {
		return;
	}
	if (fileLoad("BOOTSND.MAP", (void *)bootsnd_map, BOOTSND_MAP_SIZE)) {
		return;
	}
	SND_INI_PRG_ADR(snd_init) 	= (Uint16 *)sddrvs_tsk;
	SND_INI_PRG_SZ(snd_init) 	= (Uint16 )SDDRVS_TSK_SIZE;
	SND_INI_ARA_ADR(snd_init) 	= (Uint16 *)bootsnd_map;
	SND_INI_ARA_SZ(snd_init) 	= (Uint16)BOOTSND_MAP_SIZE;
	SND_Init(&snd_init);
	SND_ChgMap(0);
}


/*====================== t@C̏ ===========================*/
/* [gfBNgɂt@C̍ő吔 */
#define MAX_DIR		100

/* ɊJt@C̍ő吔 */
#define OPEN_MAX	5

/* fBNgǗ̈ */
static GfsDirTbl	dir_tbl;

/* t@C܂񂾏 */
static GfsDirName dir_name[MAX_DIR];

/* fer̍Ɨ̈ */
static Uint8 gfs_work[GFS_WORK_SIZE(OPEN_MAX)];

static void fileInit(void)
{
	Sint32 file_num;

	/* GFS̏ */
	GFS_DIRTBL_TYPE(&dir_tbl) = GFS_DIR_NAME;
	GFS_DIRTBL_DIRNAME(&dir_tbl) = dir_name;
	GFS_DIRTBL_NDIR(&dir_tbl) = MAX_DIR;

    /* t@CVXȅ */
    file_num = GFS_Init(OPEN_MAX, gfs_work, &dir_tbl);
	if (file_num < 0) {
		return;
	}

	/* G[֐̐ݒ */
	GFS_SetErrFunc(errGfsFunc, NULL);
}


PcmHn createHandle(PcmCreatePara *para)
{
	PcmHn pcm;

	pcm = PCM_CreateMemHandle(para);
	if (pcm == NULL) {
		return NULL;
	}

	/* ̃t@C̃TCYݒ */
	PCM_NotifyWriteSize(pcm, RING_BUF_SIZE);

	return pcm;
}

PcmCreatePara g_para[2] = {
	{
		(struct PcmWork *)&g_movie_work_1, 
		MOVIE_BUF_1, 
		RING_BUF_SIZE, 
		PCM_ADDR_1, 
		PCM_SIZE
	}, {
		(struct PcmWork *)&g_movie_work_2, 
		MOVIE_BUF_2, 
		RING_BUF_SIZE, 
		PCM_ADDR_2, 
		PCM_SIZE
	}
};

/* [vĐ@\g */
void smp_LoopPlay(Sint32 cnt_loop)
{
	PcmHn 			pcm[2];

	pcm[0] = createHandle(&g_para[0]);
	PCM_SetPcmStreamNo(pcm[0], 0);

	pcm[1] = createHandle(&g_para[1]);
	PCM_SetPcmStreamNo(pcm[1], 1);

	/* [v񐔂̎w */
	PCM_SetLoop(pcm[0], cnt_loop);
	PCM_SetLoop(pcm[1], cnt_loop);

	/* Jn */
	PCM_Start(pcm[0]);
	PCM_Start(pcm[1]);

	while (1) {

		/* Đ^XN */
		PCM_Task(pcm[0]);
		PCM_Task(pcm[1]);

		/* I */
		if (PCM_GetPlayStatus(pcm[0]) == PCM_STAT_PLAY_END) {
			PCM_Stop(pcm[1]);
			break;
		}
		if (PCM_GetPlayStatus(pcm[1]) == PCM_STAT_PLAY_END) {
			PCM_Stop(pcm[0]);
			break;
		}
	}

	/* nh̏ */
	PCM_DestroyMemHandle(pcm[0]);
	PCM_DestroyMemHandle(pcm[1]);
}

/* P̍ĐɃnh蒼 */
void smp_RestartPlay(void)
{
	PcmHn 			pcm[2];
	Uint32			restart[2];

	restart[0] = restart[1] = 1;

	while (1) {
		if (restart[0]) {
			pcm[0] = createHandle(&g_para[0]);
			PCM_SetPcmStreamNo(pcm[0], 0);
			PCM_Start(pcm[0]);
			restart[0] = 0;
		}
		if (restart[1]) {
			pcm[1] = createHandle(&g_para[1]);
			PCM_SetPcmStreamNo(pcm[1], 1);
			PCM_Start(pcm[1]);
			restart[1] = 0;
		}

		/* Đ^XN */
		PCM_Task(pcm[0]);
		PCM_Task(pcm[1]);

		/* I */
		if (PCM_GetPlayStatus(pcm[0]) == PCM_STAT_PLAY_END) {
			/* nh̏ */
			PCM_DestroyMemHandle(pcm[0]);
			restart[0] = 1;
		}
		if (PCM_GetPlayStatus(pcm[1]) == PCM_STAT_PLAY_END) {
			/* nh̏ */
			PCM_DestroyMemHandle(pcm[1]);
			restart[1] = 1;
		}
	}
}

void main(void)
{
	/* uuN̐ݒ */
	vblInit();

	/* t@C */
	fileInit();

	/* TEh̐ݒ */
	sndInit();

	/* oblCȕ */
	PCM_Init();

	/* `coblgp錾 (ADPCMLײ؂ݸ܂) */
	PCM_DeclareUseAdpcm();

	/* oblCũG[nh̐ݒ */
	PCM_SetErrFunc(errPcmFunc, NULL);

	while (1) {
#ifdef LOOP_PLAY
		smp_LoopPlay(LOOP_PLAY);
#else 
		smp_RestartPlay();
#endif
	}
}
