/******************************************************************************
 *	\tgEFACu
 *
 *	Copyright (c) 1994,1995 SEGA
 *
 * Library	:oblE`coblĐCu
 * Module 	:sample program of MEMORY PLAY MODE
 * File		:smppcm3.c
 * Date		:1995-03-31
 * Version	:1.16
 * Auther	:Y.T
 *
 * Comment	:
 *	ɂt@CĐTvB
 *	t@C 0x4000000 ԒnɃ[hĂƁB
 *	Đłt@CTCY͂PUla܂ŁB
 *
 ****************************************************************************/

/*------------------------- svOIt -------------------------*/

/* VTV, MON gpfobO̎ɒ`B */
/* #define SMPPCM_DEBUG */

/* Oobt@@\̃eXg */
/* #define RING_BUF_TEST */

/*------------------------- sCN[ht -------------------------*/
#include <machine.h>
#define _SH
#include "sega_xpt.h"
#include "sega_sys.h"
#include "sega_int.h"
#include "sega_per.h"
#include "sega_cdc.h"
#include "sega_gfs.h"
#include "sega_stm.h"
#include "sega_snd.h"
#include "sega_pcm.h"

#if	1
	/*
	**1995-07-28	q
	**	SCL_VblankStart(), SCL_VBlankEnd() gĂ̂Œǉ
	*/
	#include	"sega_scl.h"
#endif

#ifdef SMPPCM_DEBUG
	#include "..\smppcmd\smppcmd.c"
	#define SMPPCMD_VblIn				smppcmd_VblIn
	#define SMPPCMD_Init				smppcmd_Init
	#define SMPPCMD_MON_Reset			smppcmd_MON_Reset
	#define SMPPCMD_PCM_Task			smppcmd_PCM_Task
#else
	#define SMPPCMD_VblIn()				
	#define SMPPCMD_Init(a)				
	#define SMPPCMD_MON_Reset()			
	#define SMPPCMD_PCM_Task			PCM_Task
	#define VTV_Printf(a)				
	#define VTV_PRINTF(a)				
	#define _VTV_Printf(a)				
	#define _VTV_PRINTF(a)				
#endif


/*--------------------------- s֐錾t ---------------------------*/

static void smpVblIn(void);
static void smpVblOut(void);


/*---------------------------- s萔t ----------------------------*/

/* EF[uq`l̓]AhXƃTv */
#define	PCM_ADDR	((void*)0x25a20000)
#define	PCM_SIZE	(4096L*2)				/* 2.. */

/* Oobt@̃TCY */
#define	RING_BUF_SIZE	(1024L*1024L*16)


/*----------------------- sO[oϐt -----------------------*/

/* [N */
static PcmWork g_movie_work;

/* Oobt@ */
static Sint8 *g_movie_buf = (Sint8 *)0x04000000;


#ifdef RING_BUF_TEST
	#define SIZE_SECTOR				(2048)
	#define SIZE_COPY_RING			(SIZE_SECTOR)
	#define SIZE_RING_BUF			(200*1024)

	Uint32 ring_buf[SIZE_RING_BUF / 4];
#endif

/*---------------------------- s֐t ----------------------------*/

void errGfsFunc(void *obj, Sint32 ec)
{
	VTV_PRINTF((VTV_s, "S:ErrGfs %X %X\n", obj, ec));
}

void errPcmFunc(void *obj, Sint32 ec)
{
	VTV_PRINTF((VTV_s, "S:ErrPcm %X %X\n", obj, ec));
}


/*====================== uuN̏ ===========================*/

static void vblInit(void)
{
    set_imask(0);

	/* uuN̐ݒ */
	INT_ChgMsk(INT_MSK_NULL,INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT);
	INT_SetScuFunc(INT_SCU_VBLK_IN, smpVblIn);
	INT_SetScuFunc(INT_SCU_VBLK_OUT, smpVblOut);
	INT_ChgMsk(INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT,INT_MSK_NULL);
}

static void smpVblIn(void)
{
	/* oblCu VblIn [`R[ */
	PCM_VblIn();

	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankStart();
}

static void smpVblOut(void)
{
	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankEnd();
}


/*====================== TEh̏ ===========================*/
#define SDDRVS_TSK_SIZE			(0x6000)
#define BOOTSND_MAP_SIZE		(0x0100)
Sint32 sddrvs_tsk[SDDRVS_TSK_SIZE / 4];
Sint32 bootsnd_map[BOOTSND_MAP_SIZE / 4];

static Sint32 fileLoad(Sint8 *name, void *addr, Sint32 bsize)
{
	Sint32 		fid, i;

	for (i = 0; i < 10; i++) {
		fid = GFS_NameToId(name);
		if (fid >= 0) {
			GFS_Load(fid, 0, addr, bsize);
			return 0;
		}
	}
	return -1;
}

static void sndInit(void)
{
	SndIniDt 	snd_init;

	if (fileLoad("SDDRVS.TSK", (void *)sddrvs_tsk, SDDRVS_TSK_SIZE)) {
		return;
	}
	if (fileLoad("BOOTSND.MAP", (void *)bootsnd_map, BOOTSND_MAP_SIZE)) {
		return;
	}
	SND_INI_PRG_ADR(snd_init) 	= (Uint16 *)sddrvs_tsk;
	SND_INI_PRG_SZ(snd_init) 	= (Uint16 )SDDRVS_TSK_SIZE;
	SND_INI_ARA_ADR(snd_init) 	= (Uint16 *)bootsnd_map;
	SND_INI_ARA_SZ(snd_init) 	= (Uint16)BOOTSND_MAP_SIZE;
	SND_Init(&snd_init);
	SND_ChgMap(0);
}


/*====================== t@C̏ ===========================*/
/* [gfBNgɂt@C̍ő吔 */
#define MAX_DIR		100

/* ɊJt@C̍ő吔 */
#define OPEN_MAX	5

/* fBNgǗ̈ */
static GfsDirTbl	dir_tbl;

/* t@C܂񂾏 */
static GfsDirName dir_name[MAX_DIR];

/* fer̍Ɨ̈ */
static Uint8 gfs_work[GFS_WORK_SIZE(OPEN_MAX)];

static void fileInit(void)
{
	Sint32 file_num;

	/* GFS̏ */
	GFS_DIRTBL_TYPE(&dir_tbl) = GFS_DIR_NAME;
	GFS_DIRTBL_DIRNAME(&dir_tbl) = dir_name;
	GFS_DIRTBL_NDIR(&dir_tbl) = MAX_DIR;

    /* t@CVXȅ */
    file_num = GFS_Init(OPEN_MAX, gfs_work, &dir_tbl);
	if (file_num < 0) {
		return;
	}

	/* G[֐̐ݒ */
	GFS_SetErrFunc(errGfsFunc, NULL);
}


void main(void)
{
	PcmHn 			pcm;
	Uint32			restart;
	PcmCreatePara	para;
#ifdef RING_BUF_TEST
	Uint32 			addr_write, addr_data1, addr_data2;
	Sint32 			size_write, size_write_total, size_copy;
#endif


	/* uuN̐ݒ */
	vblInit();

	/* t@C */
	fileInit();

	/* TEh̐ݒ */
	sndInit();

	/* oblCȕ */
	PCM_Init();

	/* `coblgp錾 (ADPCMLײ؂ݸ܂) */
	PCM_DeclareUseAdpcm();

	/* oblCũG[nh̐ݒ */
	PCM_SetErrFunc(errPcmFunc, NULL);

	restart = 1;

	for (;;) {
		if (restart) {

			/* nh̍쐬 */
			PCM_PARA_WORK(&para) = (struct PcmWork *)&g_movie_work;
			PCM_PARA_RING_ADDR(&para) = g_movie_buf;
			PCM_PARA_RING_SIZE(&para) = RING_BUF_SIZE;
			PCM_PARA_PCM_ADDR(&para) = PCM_ADDR;
			PCM_PARA_PCM_SIZE(&para) = PCM_SIZE;
#ifdef RING_BUF_TEST
			PCM_PARA_RING_ADDR(&para) = (Sint8 *)ring_buf;
			PCM_PARA_RING_SIZE(&para) = SIZE_RING_BUF;
			addr_data1 = (Uint32)g_movie_buf;
#endif
			pcm = PCM_CreateMemHandle(&para);
			if (pcm == NULL) {
				return;
			}

#ifndef RING_BUF_TEST
			/* ̃t@C̃TCYݒ */
			PCM_NotifyWriteSize(pcm, RING_BUF_SIZE);
#endif

			/* Jn */
			PCM_Start(pcm);

			restart = 0;
		}

#ifdef RING_BUF_TEST
		for (;;) {
			addr_write = (Uint32)PCM_GetWriteBuf(pcm, &size_write, &size_write_total);
			if (size_write == 0) {
				break;
			} else if (size_write < SIZE_COPY_RING) {
				size_copy = size_write;
			} else {
				size_copy = SIZE_COPY_RING;
			}
			memcpy((void *)addr_write, (void *)addr_data1, size_copy);

			#ifdef __PCMD
				debug_write_str("WRin");
				debug_write_data((Uint32)addr_write);
				debug_write_data((Uint32)addr_data1);
				debug_write_data((Uint32)size_copy);
			#endif
			
			PCM_NotifyWriteSize(pcm, size_copy);
			addr_data1 += size_copy;
		}
#endif

		/* Đ^XN */
		PCM_Task(pcm);

		/* I */
		if (PCM_GetPlayStatus(pcm) == PCM_STAT_PLAY_END) {

			/* nh̏ */
			PCM_DestroyMemHandle(pcm);

			restart = 1;
		}
	}
}
