/*
**PER_POIN.H
**	ytFCu̍h^eCui|CeBOfoCXpj
**	
**	PER_GetPointerXY()
**		W|CeBOfoCẌړʂ𓾂B
**	
**	SysDevPointer
**		T^[W|CeBOfoCX
*/
#if	!defined( __PER_POIN_H )
	#define	__PER_POIN_H
	
	/****************************************
	*			include files				*
	****************************************/
	#include	"sega_xpt.h"
	
	/****************************************
	*			define constants			*
	****************************************/
	/*	SysDevPointer.status	*/
	#define	PT_OVER_Y	0x80
	#define	PT_OVER_X	0x40
	#define	PT_SIGN_Y	0x20
	#define	PT_SIGN_X	0x10
	#define	PT_START	0x08
	#define	PT_MIDDLE	0x04
	#define	PT_RIGHT	0x02
	#define	PT_LEFT		0x01
	#define	PT_TRIGGER	0x0f
	
	/****************************************
	*		declare object types			*
	****************************************/
	/*
	**SysDevPointer
	**	.type
	**		T^[ytF^Cvi==TYPE_POINTERj
	**	.size
	**		ytFf[^TCY
	**	.status
	**		gKAړʂ̕Aړʂ̃I[o[t[B
	**	.dx
	**	.dy
	**		wẍړʂ̐Βli0`255j
	**	.expended[]
	**		gf[^
	*/
	typedef	struct	SysDevPointer	{
		Uint8	type;
		Uint8	size;
		Uint8	status;
		Uint8	dx;
		Uint8	dy;
		Uint8	expanded[1];
	} SysDevPointer;
	
	/****************************************
	*			declare functions			*
	****************************************/
	#if	!defined( __GNUC__ )
		#define	inline
	#endif
	
	static inline void	PER_GetPointerXY( const SysDevPointer	*this, int	*dx, int	*dy ){
		if( dx != NULL )
			*dx = ( int )( signed char )this->dx;
		if( dy != NULL )
			*dy = -( int )( signed char )this->dy;
	}
	
#endif

