/*
**PER_TRG.H
**	ytFCu̍h^eCuigKɂāj
**	
**	PER_DisguiseTrigger()
**		gKATCe[uɂĕϊB
**	
**	PER_GetTrigger()
**		w肳ꂽ^C~Oł̃gK𓾂B
**		iATCe[uw肳Ă΁Aɂĕϊj
**	PER_GetEdge()
**		w肳ꂽQ̃^C~O̊ԂŕωgK𓾂B
**	PER_GetPressEdge()
**		w肳ꂽQ̃^C~O̊ԂŉꂽgK𓾂B
**	PER_GetReleaseEdge()
**		w肳ꂽQ̃^C~O̊ԂŕꂽgK𓾂B
**	
**	PER_SetTriggerHandler()
**		w肳ꂽhcytFp̃gKnho^B
**	PER_GetTriggerHandler()
**		w肳ꂽhcytFp̃gKnh𓾂B
**	
**	assigment_t
**		gKϊe[uiATCe[uj
**	trigger_t
**		gK
**	trigger_handler_t
**		gKnhifoCXgKo߂̃nhj
*/
#if	!defined( __PER_TRG_H )
	#define	__PER_TRG_H
	
	/****************************************
	*			include files				*
	****************************************/
	#include	"sega_xpt.h"
	#include	"sega_per.h"
	
	/****************************************
	*			define constants			*
	****************************************/
	/*
	**trigger_t
	**	TRG_A       `{^
	**	TRG_B       a{^
	**	TRG_C       b{^
	**	TRG_X       w{^
	**	TRG_Y       x{^
	**	TRG_Z       y{^
	**	TRG_L       k{^
	**	TRG_R       q{^
	**	TRG_UP      
	**	TRG_DOWN    
	**	TRG_LEFT    
	**	TRG_RIGHT   
	**	TRG_START   X^[g{^
	**	
	**	W|CeBOfoCX  E  ̃{^ TRG_A
	**	W|CeBOfoCX̐^񒆂̃{^ TRG_C
	**	W|CeBOfoCX    ̃{^ TRG_B
	**	W|CeBOfoCXɂ TRG_START,A,B,C ȂB
	**	KhCuUapbh̃[h{^ TRG_R
	**	KhCuUapbhɂ TRG_L ͂ȂB
	**	KhCuRapbhɂ TRG_X,Y,Z,L,R ͂ȂB
	**	[VORg[[ɂ Y,Z ̃AiOo͂͂ȂB
	**	[VORg[[ɂ TRG_LEFT,RIGHT,L,R ͂ȂB
	**	
	**	TRG_MODE	KhCuU{^pbh̃[h{^
	**	TRG_RESET	\tgtFAZbg
	*/
	#define	TRG_B		PER_DGT_B
	#define	TRG_C		PER_DGT_C
	#define	TRG_A		PER_DGT_A
	#define	TRG_START	PER_DGT_S
	#define	TRG_UP		PER_DGT_U
	#define	TRG_DOWN	PER_DGT_D
	#define	TRG_LEFT	PER_DGT_L
	#define	TRG_RIGHT	PER_DGT_R
	#define	TRG_L		PER_DGT_TL
	#define	TRG_Z		PER_DGT_Z
	#define	TRG_Y		PER_DGT_Y
	#define	TRG_X		PER_DGT_X
	#define	TRG_R		PER_DGT_TR
	
	#define	TRG_MODE	TRG_R
	
	#define	TRG_RESET	(TRG_START|TRG_A|TRG_B|TRG_C)
	
	#define	TRIGGER_BIT	16
	
	/****************************************
	*		declare object types			*
	****************************************/
	typedef Uint16	trigger_t;
	
	/*
	**assignment_t
	**	ȍԂύXĂ͂ȂBȍԂ trigger_t p̒
	**	 'TRG_???' ̃rbgтƑΉĂB
	*/
	typedef	struct assignment_t	{
		trigger_t	reserved1[3];
		trigger_t	l;
		trigger_t	z;
		trigger_t	y;
		trigger_t	x;
		trigger_t	r;
		trigger_t	b;
		trigger_t	c;
		trigger_t	a;
		trigger_t	start;
		trigger_t	up;
		trigger_t	down;
		trigger_t	left;
		trigger_t	right;
	} assignment_t;
	
	typedef trigger_t	( *trigger_handler_t )( const SysDevice * );
	
	/****************************************
	*			declare functions			*
	****************************************/
	trigger_t	PER_DisguiseTrigger( const assignment_t	*assignment, trigger_t	trigger );
	
	void	PER_SetTriggerHandler( int	id, trigger_handler_t	handler );
	trigger_handler_t	PER_GetTriggerHandler( int	id );
	
	trigger_t	PER_GetTrigger( const SysDevice	*this );
	trigger_t	PER_GetEdge( trigger_t	t1, trigger_t	t2 );
	trigger_t	PER_GetPressEdge( trigger_t	prev, trigger_t	current );
	trigger_t	PER_GetReleaseEdge( trigger_t	prev, trigger_t	current );
	
#endif

