/****************************************
*			include files				*
****************************************/
#include	"per_x.h"

/*@*/
/************************************************************************
*																		*
*	ysynopsisz														*
*																		*
*		move_cursor( device, &x, &y );									*
*																		*
*		ytFfoCX̃f[^ɂăJ[\ړ	*
*		܂B														*
*																		*
*																		*
*	yparametersz														*
*																		*
*		const SysDevice	*device;										*
*		int		*x,*y;													*
*																		*
*		<device> ́AytFfoCX̃f[^					*
*		<x>, <y> ́AytFf[^ɂĕύX܂B		*
*																		*
*																		*
*	yreturn valuez													*
*																		*
*		Ȃ															*
*																		*
*																		*
*	yinfluence/reference objectsz										*
*																		*
*		_move_cursor	reference	J[\ړ֐̃e[u			*
*									hcCfbNXɂĎQƂ܂B*
*																		*
*																		*
************************************************************************/
void	move_cursor( const SysDevice	*device, int	*x, int	*y ){
	trigger_t	trigger = PER_GetTrigger( device );
	
	if( trigger & TRG_UP )
		(*y) -= 3;
	else if( trigger & TRG_DOWN )
		(*y) += 3;
	
	if( trigger & TRG_LEFT )
		(*x) -= 4;
	else if( trigger & TRG_RIGHT )
		(*x) += 4;
	
	if( *x < 0 )
		*x = 0;
	if( *y < 0 )
		*y = 0;
	
	if( *x >= 320 )
		*x = 320-1;
	if( *y >= 224 )
		*y = 224-1;
}

