/*****************************************************************************
 *      \tgEFACu
 *
 *      Copyright (c) 1994 SEGA
 *
 * Module : Xg[VXeTvvO2
 *          (ĐpTvvO)
 * File   : smpstm2.c
 * Date   : 1994-10-01
 * Author : H.T
 *
 *****************************************************************************/

/*****************************************************************************
 *      CN[ht@C
 *****************************************************************************/
#include        <stdio.h>
#include        <stdlib.h>
#include        "sega_stm.h"

/*****************************************************************************
 *      萔}N
 *****************************************************************************/

/* t@C̒             */
#define FNAME_LEN       16

/* oobt@TCY       */
#define FORM1_SCTSIZ    2048
#define BUF_UNITNUM     10
#define BUF_SIZE        (BUF_UNITNUM * FORM1_SCTSIZ)

/* Xg[             */
#define STM_NUM         5

/* ĐI                     */
#define PEND            (-1)

/* Cup萔             */
#define FILE_NUM        30      /* PfBNg̍őt@C */
#define OPEN_MAX        24      /* ɈXg[^t@C     */
#define GRP_MAX         5       /* ɈO[v                 */

/*****************************************************************************
 *      ϐ̒`
 *****************************************************************************/

/* t@CVXeƗ̈     */
Uint32          WorkGfs[GFS_WORK_SIZE(OPEN_MAX)/sizeof(Uint32)];

/* Xg[VXeƗ̈   */
Uint32          WorkStm[STM_WORK_SIZE(OPEN_MAX, GRP_MAX)/sizeof(Uint32)];

/* fBNgǂݍݗ̈     */
GfsDirName      DirTbl[FILE_NUM];

/* oobt@             */
Uint8           ReadBuf[BUF_SIZE];

/* t@C                   */
Sint8           MngTbl[STM_NUM][FNAME_LEN] = {  
                                                 "SMP_STM.1ST",
                                                 "SMP_STM.2ND",
                                                 "SMP_STM.3RD",
                                                 "SMP_STM.4TH",
                                                 "SMP_STM.5TH",
                                             };

/* Đԍ                   */
Sint32          PlayOrder[] = {0, 1, 2, 3, 4, 3, 2, 1, 0, 2, 1, 3, 4, PEND};


/*****************************************************************************
 *      ֐̒`
 *****************************************************************************/

/*-------------------------------
 * 
 * ߂l : TRUE  
 *          FALSE s
 *-------------------------------*/
Bool    SMP_Init(void)
{
    GfsDirTbl   dir;
    Sint32      ndir;
    Bool        init;

   /* t@CVXe    */
    GFS_DIRTBL_TYPE(&dir) = GFS_DIR_NAME;
    GFS_DIRTBL_NDIR(&dir) = FILE_NUM;
    GFS_DIRTBL_DIRNAME(&dir) = DirTbl;
    ndir = GFS_Init(OPEN_MAX, WorkGfs, &dir);
    if (ndir < 0) {
        return (FALSE);
    }

    /* Xg[VXe */
    init = STM_Init(GRP_MAX, OPEN_MAX, WorkStm);
    if (init == FALSE) {
        return (FALSE);
    }
    return (TRUE);
}


/*-------------------------------
 * Xg[̃I[v
 * ߂l : Xg[nh
 *-------------------------------*/
StmHn   SMP_Open(StmGrpHn grp, Sint8 *fname)
{
    Sint32      fid;
    StmHn       stm;
    StmKey      key;

    /* t@Ct@Cʎqւ̕ϊ     */
    fid = GFS_NameToId(fname);
    if (fid < 0) {
        return (NULL);
    }

    /* Xg[L[̐ݒ                     */
    STM_KEY_CN(&key) = STM_KEY_SMMSK(&key) = STM_KEY_CIMSK(&key) = STM_KEY_NONE;

    /* Xg[I[v                       */
    stm = STM_OpenFid(grp, fid, &key, STM_LOOP_NOREAD);
    if (stm == NULL) {
        return (NULL);
    }

    /* ö̐ݒ                       */
    STM_SetTrBuf(stm, ReadBuf, BUF_UNITNUM, STM_UNIT_FORM1);

    /* ]Q[g̐ݒ                         */
    STM_SetTrGate(stm, STM_GATE_CLOSE);

    return (stm);
}


/*-------------------------------
 * [U֐
 *-------------------------------*/
void    SMP_User(void)
{
    /* AvP[VƎ̏Ȃ     */
}


/*-------------------------------
 * Xg[ǂݍݎs
 *-------------------------------*/
void    SMP_Exec(StmGrpHn grp)
{
    Sint32      i;
    Bool        complete;
    StmHn       stm, next;

    /* [v񐔂̐ݒ                 */
    STM_SetLoop(grp, STM_LOOP_DFL, STM_LOOP_ENDLESS);

    /* sO[v̐ݒ               */
    STM_SetExecGrp(grp);

    /* ŏ̃Xg[̃I[v       */
    complete = TRUE;
    stm = SMP_Open(grp, MngTbl[PlayOrder[0]]);
    next = NULL;

    /* Xg[ANZXs           */
    i = 1;
    while (stm != NULL) {
        /* ÕXg[̃ANZXQ[gJ   */
        if (complete == TRUE) {
            STM_SetTrGate(stm, STM_GATE_OPEN);
        }

        STM_ExecServer();
        
        /* f[^̎on܂玟̃Xg[I[v     */
        if ((next == NULL)&&
            (STM_GetLenTrBuf(stm) > 0)&&(PlayOrder[i] != PEND)) {
            next = SMP_Open(grp, MngTbl[PlayOrder[i]]);
            i++;
        }

        /* öt̃`FbN   */
        if (STM_IsTrBufFull(stm) == TRUE) {
            STM_ResetTrBuf(stm);
        }

        /* ANZX̃`FbN       */
        if ((complete = STM_IsComplete(stm)) == TRUE) {
            STM_Close(stm);
            stm = next;
            next = NULL;
        }

        /* [U֐   */
        SMP_User();
    }
}
        

/*-------------------------------
 * C
 *-------------------------------*/
void    main(void)
{
    Bool        init;
    StmGrpHn    grp;

    /*            */
    init = SMP_Init();
    if (init == FALSE) {
        return;
    }

    /* nh擾     */
    grp = STM_OpenGrp();
    if (grp == NULL) {
        return;
    }

    /* ǂݍݎs     */
    SMP_Exec(grp);
}


/* end of file */
